
/*     - NVIDIA CORPORATION & AFFILIATES Confidential and Proprietary -
 *
 *  Copyright (C) 2010-2021, Mellanox Technologies Ltd. ALL RIGHTS RESERVED.
 *  Copyright (C) 2021-2024, NVIDIA CORPORATION & AFFILIATES. ALL RIGHTS RESERVED.
 *
 *  Except as specifically permitted herein, no portion of the information,
 *  including but not limited to object code and source code, may be reproduced,
 *  modified, distributed, republished or otherwise exploited in any form or by
 *  any means for any purpose without the prior written permission of Mellanox
 *  Technologies Ltd. Use of software subject to the terms and conditions
 *  detailed in the file "LICENSE.txt".
 *
 */


/***
         *** This file was generated at "2024-02-18 11:22:33"
         *** by:
         ***    > /mswg/release/tools/a-me/a-me-1.0.99/adabe_plugins/adb2c/adb2pack.py --input adb/internal_packets.adb --file-prefix internal_packets --copyright=copyrights
         ***/
#ifndef INTERNAL_PACKETS_LAYOUTS_H
#define INTERNAL_PACKETS_LAYOUTS_H


#ifdef __cplusplus
extern "C" {
#endif

#include "adb_to_c_utils.h"
/* Description -   */
/* Size in bytes - 8 */
struct pll_28nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Measurement of fctrl in ticks
Shell be set to 0 if not implemented */
	/* 0x0.0 - 0x0.9 */
	 u_int16_t f_ctrl_measure;
	/* Description - Number of varactors connected to the analog by algorithm 
configuration */
	/* 0x0.10 - 0x0.15 */
	 u_int8_t analog_algo_num_var;
	/* Description - fctrl value of the varactor algorithm */
	/* 0x0.16 - 0x0.25 */
	 u_int16_t algo_f_ctrl;
	/* Description - PLL Lock status causes */
	/* 0x0.28 - 0x0.29 */
	 u_int8_t lock_status;
	/* Description - PLL lock after the varactor calibration flow (locked by f_ctrl 
measure) */
	/* 0x0.30 - 0x0.30 */
	 u_int8_t lock_cal;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Number of varactors connected to the configurable voltage */
	/* 0x4.0 - 0x4.5 */
	 u_int8_t mid_var;
	/* Description - Number of varactors connected to the low voltage */
	/* 0x4.8 - 0x4.13 */
	 u_int8_t low_var;
	/* Description - Number of varactors connected to the high voltage */
	/* 0x4.16 - 0x4.21 */
	 u_int8_t high_var;
	/* Description - Number of varactors connected to the analog   */
	/* 0x4.24 - 0x4.29 */
	 u_int8_t analog_var;
};

/* Description -   */
/* Size in bytes - 8 */
struct pll_status_data {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - The frequency that the PLL is set to.
0 - SDR / QDR / 1GE for Ethernet / Gen1 (PCIe)
1 - FDR / Gen2 (PCIe)
2 - EDR / 25GE for Ethernet / Gen3 (PCIe)
3 - HDR / 26GE for Ethernet
4 - 10GE for Ethernet / Gen4 (PCIe)
5 - Gen5 (PCIe) */
	/* 0x0.0 - 0x0.2 */
	 u_int8_t pll_speed;
	/* Description - Clock is valid */
	/* 0x0.3 - 0x0.3 */
	 u_int8_t clock_valid;
	/* Description - Real time indication of PLL lock and a valid clock. */
	/* 0x0.4 - 0x0.4 */
	 u_int8_t plllock_clk_val;
	/* Description - 2 "sticky bits".
Bit 6 - Clock was valid and PLL lock was accomplished.
Bit 5 - Clock was not valid for some time or loss of lock. */
	/* 0x0.5 - 0x0.6 */
	 u_int8_t lock_clk_val_cause;
	/* Description - Clears the lock_status and lock_clk_val_cause fields. */
	/* 0x0.7 - 0x0.7 */
	 u_int8_t clear_cause;
	/* Description - Varactors calibration algorithm was executed if set to '1' */
	/* 0x0.8 - 0x0.8 */
	 u_int8_t ae;
	/* Description - Counter of lock losses
To clear, write '0'. */
	/* 0x0.9 - 0x0.24 */
	 u_int16_t lock_lost_counter;
	/* Description - Sensitivity of the lock loss indication that reflects the 
lock_lost_counter. */
	/* 0x0.25 - 0x0.28 */
	 u_int8_t lock_pulse;
	/* Description - If set, PLL is powered on (while working on specific speed, all 
other unused PLLs are powered off)
Note: For PCIe, several PLLs can work in parallel. */
	/* 0x0.29 - 0x0.29 */
	 u_int8_t pll_pwrup;
	/* Description - PLL Lock status indications. 2 "sticky bits".
Bit 31 - set to '1' in case of lock
Bit 30 - set to '1' in case of loss of lock */
	/* 0x0.30 - 0x0.31 */
	 u_int8_t lock_status;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Measurement of fctrl in ticks
Shell be set to 0 if not implemented */
	/* 0x4.0 - 0x4.9 */
	 u_int16_t fctrl_measure;
	/* Description - Number of varactors connected to the configurable voltage */
	/* 0x4.10 - 0x4.15 */
	 u_int8_t mid_var;
	/* Description - Number of varactors connected to the low voltage */
	/* 0x4.16 - 0x4.20 */
	 u_int8_t low_var;
	/* Description - Number of varactors connected to the high voltage */
	/* 0x4.21 - 0x4.25 */
	 u_int8_t high_var;
	/* Description - Number of varactors connected to the analog  (6-8 typical 
number) */
	/* 0x4.26 - 0x4.30 */
	 u_int8_t analog_var;
	/* Description - Real time indication of PLL lock. */
	/* 0x4.31 - 0x4.31 */
	 u_int8_t lock;
};

/* Description -   */
/* Size in bytes - 20 */
struct slrg_lane_measure_info {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - maximum measured FOM out of all the measurements for 
every eye.
NRZ have only composite eye value */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t comp_max;
	/* Description - maximum measured FOM out of all the measurements for 
every eye.
NRZ have only composite eye value */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t lower_max;
	/* Description - maximum measured FOM out of all the measurements for 
every eye.
NRZ have only composite eye value */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t mid_max;
	/* Description - maximum measured FOM out of all the measurements for 
every eye.
NRZ have only composite eye value */
	/* 0x0.24 - 0x0.31 */
	 u_int8_t upper_max;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - minimum measured FOM out of all the measurements for 
every eye.
NRZ have only composite eye value */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t comp_min;
	/* Description - minimum measured FOM out of all the measurements for 
every eye.
NRZ have only composite eye value */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t lower_min;
	/* Description - minimum measured FOM out of all the measurements for 
every eye.
NRZ have only composite eye value */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t mid_min;
	/* Description - minimum measured FOM out of all the measurements for 
every eye.
NRZ have only composite eye value */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t upper_min;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Standard deviation calculated in 0.1 units out of all the FOM 
measurements for every eye.
NRZ have only composite eye value */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t comp_std;
	/* Description - Standard deviation calculated in 0.1 units out of all the FOM 
measurements for every eye.
NRZ have only composite eye value */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t lower_std;
	/* Description - Standard deviation calculated in 0.1 units out of all the FOM 
measurements for every eye.
NRZ have only composite eye value */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t mid_std;
	/* Description - Standard deviation calculated in 0.1 units out of all the FOM 
measurements for every eye.
NRZ have only composite eye value */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t upper_std;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - average measured FOM in 0.1 units out of all the measure
ments for every eye.
NRZ have only composite eye value */
	/* 0xc.0 - 0xc.11 */
	 u_int16_t mid_avg;
	/* Description - average measured FOM in 0.1 units out of all the measure
ments for every eye.
NRZ have only composite eye value */
	/* 0xc.16 - 0xc.27 */
	 u_int16_t upper_avg;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - average measured FOM in 0.1 units out of all the measure
ments for every eye.
NRZ have only composite eye value */
	/* 0x10.0 - 0x10.11 */
	 u_int16_t comp_avg;
	/* Description - average measured FOM in 0.1 units out of all the measure
ments for every eye.
NRZ have only composite eye value */
	/* 0x10.16 - 0x10.27 */
	 u_int16_t lower_avg;
};

/* Description -   */
/* Size in bytes - 96 */
struct mpcnt_RAW_page_data {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Byte array of RAW data */
	/* 0x0.24 - 0x60.23 */
	 u_int8_t data[96];
};

/* Description -   */
/* Size in bytes - 72 */
struct pcie_lanes_counters {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t life_time_counter_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t life_time_counter_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Number of errors detected on logical lane 0 */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t error_counter_lane0;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Number of errors detected on logical lane 1 */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t error_counter_lane1;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Number of errors detected on logical lane 2 */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t error_counter_lane2;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Number of errors detected on logical lane 3 */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t error_counter_lane3;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Number of errors detected on logical lane 4 */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t error_counter_lane4;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Number of errors detected on logical lane 5 */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t error_counter_lane5;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Number of errors detected on logical lane 6 */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t error_counter_lane6;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Number of errors detected on logical lane 7 */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t error_counter_lane7;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - Number of errors detected on logical lane 8 */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t error_counter_lane8;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - Number of errors detected on logical lane 9 */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t error_counter_lane9;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - Number of errors detected on logical lane 10 */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t error_counter_lane10;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - Number of errors detected on logical lane 11 */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t error_counter_lane11;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - Number of errors detected on logical lane 12 */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t error_counter_lane12;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - Number of errors detected on logical lane 13 */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t error_counter_lane13;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - Number of errors detected on logical lane 14 */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t error_counter_lane14;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - Number of errors detected on logical lane 15 */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t error_counter_lane15;
};

/* Description -   */
/* Size in bytes - 84 */
struct pcie_perf_counters {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t life_time_counter_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t life_time_counter_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Number of transitions to recovery due to Framing errors and CRC (dlp and tlp) errors. */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t rx_errors;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Number of transitions to recovery due to EIEOS and TS errors. */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t tx_errors;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Number of transitions to recovery due to getting EIEOS */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t l0_to_recovery_eieos;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Number of transitions to recovery due to getting TS */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t l0_to_recovery_ts;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Number of transitions to recovery due to identifying framing errors at gen3/4. */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t l0_to_recovery_framing;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Number of transitions to recovery due to link retrain request from data link */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t l0_to_recovery_retrain;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Number of transitions to recovery due to identifying CRC DLLP errors */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t crc_error_dllp;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Number of transitions to recovery due to identifying CRC TLP errors */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t crc_error_tlp;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - The number of packets dropped due to lack of PCIe buffers or receive path from NIC port toward the hosts. */
	/* 0x28.0 - 0x2c.31 */
	 u_int64_t tx_overflow_buffer_pkt;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - The percentage of time within the last second that the NIC had outbound non-posted read requests but could not perform the operation due to insufficient non-posted credits.
Supported only when MCAM.pcie_outbound_stalled ==1. */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t outbound_stalled_reads;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - The percentage of time within the last second that the NIC had outbound posted writes requests but could not perform the operation due to insufficient posted credits.
Supported only when MCAM.pcie_outbound_stalled ==1. */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t outbound_stalled_writes;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - The number of events where outbound_stalled_reads was above a threshold.
The threshold is configured by outbound_stalled_reads_th in MPEGC.
Supported only when MCAM.pcie_outbound_stalled ==1. */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t outbound_stalled_reads_events;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - The number of events where outbound_stalled_writes was above a threshold.
The threshold is configured by outbound_stalled_writes_th in MPEGC.
Supported only when MCAM.pcie_outbound_stalled ==1. */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t outbound_stalled_writes_events;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - The number of packets marked due to lack of PCIe buffers or receive path from NIC port toward the hosts.
Supported only if MCAM.mark_tx_action_cqe or MCAM.mark_tx_action_cnp are set to '1'. */
	/* 0x40.0 - 0x44.31 */
	 u_int64_t tx_overflow_buffer_marked_pkt;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - Effective_BER = effective_ber_coef*10^(-effective_ber_magnitude) */
	/* 0x48.0 - 0x48.3 */
	 u_int8_t effective_ber_coef;
	/* Description - Effective_BER = effective_ber_coef*10^(-effective_ber_magnitude) */
	/* 0x48.8 - 0x48.15 */
	 u_int8_t effective_ber_magnitude;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - [Internal] BER timer since last cleared 
cleared by clr bit in MPCNT */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t time_since_last_clear_high;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description - [Internal] BER timer since last cleared 
cleared by clr bit in MPCNT */
	/* 0x50.0 - 0x50.31 */
	 u_int32_t time_since_last_clear_low;
};

/* Description -   */
/* Size in bytes - 4 */
struct pcie_physical_layer {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.0 */
	 u_int8_t eqlz_timeout_ph0;
	/* Description -  */
	/* 0x0.1 - 0x0.1 */
	 u_int8_t eqlz_timeout_ph1;
	/* Description -  */
	/* 0x0.2 - 0x0.2 */
	 u_int8_t eqlz_timeout_ph2;
	/* Description -  */
	/* 0x0.3 - 0x0.3 */
	 u_int8_t eqlz_timeout_ph3;
};

/* Description -   */
/* Size in bytes - 92 */
struct pcie_timers_states {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t life_time_counter_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t life_time_counter_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Time form start until FW boot image starts running in usec. 
Note: can't be cleared. */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t time_to_boot_image_start;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Time form start until FW pci_link image starts running in usec. */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t time_to_link_image;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Time it took FW to do calibration in usec. */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t calibration_time;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Time form start until FW handle first prest */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t time_to_first_perst;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Time form start until first transition to LTSSM.Detect_Q */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t time_to_detect_state;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Time form start until first transition to LTSSM.L0 */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t time_to_l0;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Time form start until crs is enabled */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t time_to_crs_en;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Time form start until FW plastic image starts running in usec. */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t time_to_plastic_image_start;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - Time form start until FW iron image starts running in usec. */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t time_to_iron_image_start;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - Number of persts arrived */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t perst_handler;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - Number of times LTSSM entered L1 flow */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t times_in_l1;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - Number of times LTSSM entered L23 flow */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t times_in_l23;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - Number of moves for DL_active to DL_down */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t dl_down;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - Number of configuration requests that FW handled in less then 1 usec */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t config_cycle1usec;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - Number of configuration requests that FW handled within 2 to 7 usec */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t config_cycle2to7usec;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - Number of configuration requests that FW handled within 8 to 15 usec */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t config_cycle8to15usec;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - Number of configuration requests that FW handled within 16 to 63 usec */
	/* 0x48.0 - 0x48.31 */
	 u_int32_t config_cycle16to63usec;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - Number of configuration requests that FW handled took more than 64 usec */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t config_cycle64usec;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description - Number of correctable error msg sent */
	/* 0x50.0 - 0x50.31 */
	 u_int32_t correctable_err_msg_sent;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description - Number of Non-Fatal error msg sent */
	/* 0x54.0 - 0x54.31 */
	 u_int32_t non_fatal_err_msg_sent;
/*---------------- DWORD[22] (Offset 0x58) ----------------*/
	/* Description - Number of Fatal error msg sent */
	/* 0x58.0 - 0x58.31 */
	 u_int32_t fatal_err_msg_sent;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_FERC_Properties {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Frame Error Count (FERC) represents the number of 
uncorrectable FEC frames measured. This is a post-FEC 
decoder error metric

FERC group capability mask:
Bit 0: ferc_min_media
Bit 1: ferc_min_host
Bit 2: ferc_max_media
Bit 3: ferc_max_host
bit 4: ferc_avg_media
bit 5: ferc_avg_host
bit 6: ferc_val_media
bit 7: ferc_val_host */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t ferc_cap;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_FERC_Samples {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - The minimum statistical value of the FERC in the host 
input. */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t ferc_min_host;
	/* Description - The minimum statistical value of the FERC in the media 
input. */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t ferc_min_media;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - The maximum statistical value of the FERC in the host 
input. */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t ferc_max_host;
	/* Description - The maximum statistical value of the FERC in the media 
input */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t ferc_max_media;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - The average statistical value of the FERC in the host input. */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t ferc_avg_host;
	/* Description - The average statistical value of the FERC in the media 
input. */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t ferc_avg_media;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - The sampled value of the FERC in the host input. */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t ferc_val_host;
	/* Description - The sampled value of the FERC in the media input. */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t ferc_val_media;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_Laser_Monitors_Properties {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Laser monitor group capability mask:
Bit 0: laser_age
Bit 1: tec_current
Bit 2: laser_frequency_error
Bit 3: laser_temp */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t laser_monitor_cap;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Thresholds for the Laser age is presented in percentage. */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t laser_age_high_warning;
	/* Description - Thresholds for the Laser age is presented in percentage. */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t laser_age_high_alarm;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Thresholds for the Thermo-electric Cooler (TEC) current.
presentd in precents. */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t tec_current_low_alarm;
	/* Description - Thresholds for the Thermo-electric Cooler (TEC) current.
presentd in precents. */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t tec_current_high_alarm;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Thresholds for the Thermo-electric Cooler (TEC) current.
presentd in precents. */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t tec_current_low_warning;
	/* Description - Thresholds for the Thermo-electric Cooler (TEC) current.
presentd in precents. */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t tec_current_high_warning;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Thresholds for the laser frequency error in unit sacle of 10 
MHz. */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t laser_frequency_error_high_warning;
	/* Description - Thresholds for the laser frequency error in unit sacle of 10 
MHz. */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t laser_frequency_error_high_alarm;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Thresholds for the laser temperature. 
In unit scale of 1/256 celsius degrees. */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t laser_temp_low_alarm;
	/* Description - Thresholds for the laser temperature. 
In unit scale of 1/256 celsius degrees. */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t laser_temp_high_alarm;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Thresholds for the laser temperature. 
In unit scale of 1/256 celsius degrees. */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t laser_temp_low_warning;
	/* Description - Thresholds for the laser temperature. 
In unit scale of 1/256 celsius degrees. */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t laser_temp_high_warning;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_Laser_Monitors_Samples {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Thermo-electric Cooler (TEC) current, Observes the 
amount of current flowing to the TEC of a cooled laser.
TEC current presentd in precents: 100/32767 %.
+32767 (100%) of the max current magnitude when heating
-32767 is -100% of the max current magnitude when cool
ing */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t tec_current;
	/* Description - Laser age is presented in percentage.
0% BOL, 100% EOL. */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t laser_age;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Laser frequency error for media lane <i>, observes the dif
ference between the target center frequency and the actual 
current center frequency.
The laser frequency error is in unit sacle of 10 MHz. */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t laser_frequency_error_lane1;
	/* Description - Laser frequency error for media lane <i>, observes the dif
ference between the target center frequency and the actual 
current center frequency.
The laser frequency error is in unit sacle of 10 MHz. */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t laser_frequency_error_lane0;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Laser frequency error for media lane <i>, observes the dif
ference between the target center frequency and the actual 
current center frequency.
The laser frequency error is in unit sacle of 10 MHz. */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t laser_frequency_error_lane3;
	/* Description - Laser frequency error for media lane <i>, observes the dif
ference between the target center frequency and the actual 
current center frequency.
The laser frequency error is in unit sacle of 10 MHz. */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t laser_frequency_error_lane2;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Laser frequency error for media lane <i>, observes the dif
ference between the target center frequency and the actual 
current center frequency.
The laser frequency error is in unit sacle of 10 MHz. */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t laser_frequency_error_lane5;
	/* Description - Laser frequency error for media lane <i>, observes the dif
ference between the target center frequency and the actual 
current center frequency.
The laser frequency error is in unit sacle of 10 MHz. */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t laser_frequency_error_lane4;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Laser frequency error for media lane <i>, observes the dif
ference between the target center frequency and the actual 
current center frequency.
The laser frequency error is in unit sacle of 10 MHz. */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t laser_frequency_error_lane7;
	/* Description - Laser frequency error for media lane <i>, observes the dif
ference between the target center frequency and the actual 
current center frequency.
The laser frequency error is in unit sacle of 10 MHz. */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t laser_frequency_error_lane6;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - The laser temperature for media lane <i>, observes the dif
ference between the target laser temperature for laser 
temperature.
The laser temperature value is in unit scale of 1/256 cel
sius degrees. */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t laser_temperature_lane1;
	/* Description - The laser temperature for media lane <i>, observes the dif
ference between the target laser temperature for laser 
temperature.
The laser temperature value is in unit scale of 1/256 cel
sius degrees. */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t laser_temperature_lane0;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - The laser temperature for media lane <i>, observes the dif
ference between the target laser temperature for laser 
temperature.
The laser temperature value is in unit scale of 1/256 cel
sius degrees. */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t laser_temperature_lane3;
	/* Description - The laser temperature for media lane <i>, observes the dif
ference between the target laser temperature for laser 
temperature.
The laser temperature value is in unit scale of 1/256 cel
sius degrees. */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t laser_temperature_lane2;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - The laser temperature for media lane <i>, observes the dif
ference between the target laser temperature for laser 
temperature.
The laser temperature value is in unit scale of 1/256 cel
sius degrees. */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t laser_temperature_lane5;
	/* Description - The laser temperature for media lane <i>, observes the dif
ference between the target laser temperature for laser 
temperature.
The laser temperature value is in unit scale of 1/256 cel
sius degrees. */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t laser_temperature_lane4;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - The laser temperature for media lane <i>, observes the dif
ference between the target laser temperature for laser 
temperature.
The laser temperature value is in unit scale of 1/256 cel
sius degrees. */
	/* 0x20.0 - 0x20.15 */
	 u_int16_t laser_temperature_lane7;
	/* Description - The laser temperature for media lane <i>, observes the dif
ference between the target laser temperature for laser 
temperature.
The laser temperature value is in unit scale of 1/256 cel
sius degrees. */
	/* 0x20.16 - 0x20.31 */
	 u_int16_t laser_temperature_lane6;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_Module_Status_Properties {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Module Status page capability mask:
Bit 0 - temperature monitoring implemented.
Bit 1 - voltage monitoring implemented.
Bit 2 - tx power monitoring implemented.
Bit 3 - rx power monitoring implemented.
Bit 4 - tx bias monitoring implemented. */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t module_status_cap;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Thresholds for internal temperature monitor: 1/256 degree Celsius increments */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t temp_low_alarm;
	/* Description - Thresholds for internal temperature monitor: 1/256 degree Celsius increments */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t temp_high_alarm;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Thresholds for internal temperature monitor: 1/256 degree Celsius increments */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t temp_low_warning;
	/* Description - Thresholds for internal temperature monitor: 1/256 degree Celsius increments */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t temp_high_warning;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Thresholds for internal supply voltage monitor: 100   V increments */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t voltage_low_alarm;
	/* Description - Thresholds for internal supply voltage monitor: 100   V increments */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t voltage_high_alarm;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Thresholds for internal supply voltage monitor: 100   V increments */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t voltage_low_warning;
	/* Description - Thresholds for internal supply voltage monitor: 100   V increments */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t voltage_high_warning;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Thresholds for Rx optical power monitor: 
0.1 uW increments Total measurement range of 0 to 6.5535 mW (~-40 dBm to +8.2 dBm for non-zero values)
measured in dBm or uW according to module_info_ext value */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t rx_power_low_alarm;
	/* Description - Thresholds for Rx optical power monitor: 
0.1 uW increments Total measurement range of 0 to 6.5535 mW (~-40 dBm to +8.2 dBm for non-zero values)
measured in dBm or uW according to module_info_ext value */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t rx_power_high_alarm;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Thresholds for Rx optical power monitor: 
0.1 uW increments Total measurement range of 0 to 6.5535 mW (~-40 dBm to +8.2 dBm for non-zero values)
measured in dBm or uW according to module_info_ext value */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t rx_power_low_warning;
	/* Description - Thresholds for Rx optical power monitor: 
0.1 uW increments Total measurement range of 0 to 6.5535 mW (~-40 dBm to +8.2 dBm for non-zero values)
measured in dBm or uW according to module_info_ext value */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t rx_power_high_warning;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Thresholds for Tx optical power monitor: 
in 0.1 uW increments Total measurement range of 0 to 6.5535 mW (or ~-40 dBm to +8.2 dBm for non-zero values) */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t tx_power_low_alarm;
	/* Description - Thresholds for Tx optical power monitor: 
in 0.1 uW increments Total measurement range of 0 to 6.5535 mW (or ~-40 dBm to +8.2 dBm for non-zero values) */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t tx_power_high_alarm;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Thresholds for Tx optical power monitor: 
in 0.1 uW increments Total measurement range of 0 to 6.5535 mW (or ~-40 dBm to +8.2 dBm for non-zero values) */
	/* 0x20.0 - 0x20.15 */
	 u_int16_t tx_power_low_warning;
	/* Description - Thresholds for Tx optical power monitor: 
in 0.1 uW increments Total measurement range of 0 to 6.5535 mW (or ~-40 dBm to +8.2 dBm for non-zero values) */
	/* 0x20.16 - 0x20.31 */
	 u_int16_t tx_power_high_warning;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Thresholds for Tx laser bias monitor: 2 uA increments */
	/* 0x24.0 - 0x24.15 */
	 u_int16_t tx_bias_low_alarm;
	/* Description - Thresholds for Tx laser bias monitor: 2 uA increments */
	/* 0x24.16 - 0x24.31 */
	 u_int16_t tx_bias_high_alarm;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - Thresholds for Tx laser bias monitor: 2 uA increments */
	/* 0x28.0 - 0x28.15 */
	 u_int16_t tx_bias_low_warning;
	/* Description - Thresholds for Tx laser bias monitor: 2 uA increments */
	/* 0x28.16 - 0x28.31 */
	 u_int16_t tx_bias_high_warning;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_Module_Status_Samples {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Internally measured supply voltage in 100uV */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t voltage;
	/* Description - module temperature in 1/256 C */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t temperature;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - RX measured power on lane <i>.
 measured in dBm or uW according to module_info_ext 
value */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t rx_power_lane1;
	/* Description - RX measured power on lane <i>.
 measured in dBm or uW according to module_info_ext 
value */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t rx_power_lane0;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - RX measured power on lane <i>.
 measured in dBm or uW according to module_info_ext 
value */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t rx_power_lane3;
	/* Description - RX measured power on lane <i>.
 measured in dBm or uW according to module_info_ext 
value */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t rx_power_lane2;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - RX measured power on lane <i>.
 measured in dBm or uW according to module_info_ext 
value */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t rx_power_lane5;
	/* Description - RX measured power on lane <i>.
 measured in dBm or uW according to module_info_ext 
value */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t rx_power_lane4;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - RX measured power on lane <i>.
 measured in dBm or uW according to module_info_ext 
value */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t rx_power_lane7;
	/* Description - RX measured power on lane <i>.
 measured in dBm or uW according to module_info_ext 
value */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t rx_power_lane6;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - TX measured power on lane <i>
measured in dBm or uW according to module_info_ext 
value */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t tx_power_lane1;
	/* Description - TX measured power on lane <i>
measured in dBm or uW according to module_info_ext 
value */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t tx_power_lane0;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - TX measured power on lane <i>
measured in dBm or uW according to module_info_ext 
value */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t tx_power_lane3;
	/* Description - TX measured power on lane <i>
measured in dBm or uW according to module_info_ext 
value */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t tx_power_lane2;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - TX measured power on lane <i>
measured in dBm or uW according to module_info_ext 
value */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t tx_power_lane5;
	/* Description - TX measured power on lane <i>
measured in dBm or uW according to module_info_ext 
value */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t tx_power_lane4;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - TX measured power on lane <i>
measured in dBm or uW according to module_info_ext 
value */
	/* 0x20.0 - 0x20.15 */
	 u_int16_t tx_power_lane7;
	/* Description - TX measured power on lane <i>
measured in dBm or uW according to module_info_ext 
value */
	/* 0x20.16 - 0x20.31 */
	 u_int16_t tx_power_lane6;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - TX measured bias current on lane <i> in 2uA */
	/* 0x24.0 - 0x24.15 */
	 u_int16_t tx_bias_lane1;
	/* Description - TX measured bias current on lane <i> in 2uA */
	/* 0x24.16 - 0x24.31 */
	 u_int16_t tx_bias_lane0;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - TX measured bias current on lane <i> in 2uA */
	/* 0x28.0 - 0x28.15 */
	 u_int16_t tx_bias_lane3;
	/* Description - TX measured bias current on lane <i> in 2uA */
	/* 0x28.16 - 0x28.31 */
	 u_int16_t tx_bias_lane2;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - TX measured bias current on lane <i> in 2uA */
	/* 0x2c.0 - 0x2c.15 */
	 u_int16_t tx_bias_lane5;
	/* Description - TX measured bias current on lane <i> in 2uA */
	/* 0x2c.16 - 0x2c.31 */
	 u_int16_t tx_bias_lane4;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - TX measured bias current on lane <i> in 2uA */
	/* 0x30.0 - 0x30.15 */
	 u_int16_t tx_bias_lane7;
	/* Description - TX measured bias current on lane <i> in 2uA */
	/* 0x30.16 - 0x30.31 */
	 u_int16_t tx_bias_lane6;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - DataPath state for lane <i>
1: DPDeactivated 
2: DPInit 
3: DPDeinit 
4: DPActivated 
5: DPTxTurnOn 
6: DPTxTurnOff 
7: DPInitialized */
	/* 0x34.1 - 0x34.4 */
	 u_int8_t dp_st_lane6;
	/* Description - DataPath state for lane <i>
1: DPDeactivated 
2: DPInit 
3: DPDeinit 
4: DPActivated 
5: DPTxTurnOn 
6: DPTxTurnOff 
7: DPInitialized */
	/* 0x34.5 - 0x34.8 */
	 u_int8_t dp_st_lane5;
	/* Description - DataPath state for lane <i>
1: DPDeactivated 
2: DPInit 
3: DPDeinit 
4: DPActivated 
5: DPTxTurnOn 
6: DPTxTurnOff 
7: DPInitialized */
	/* 0x34.9 - 0x34.12 */
	 u_int8_t dp_st_lane4;
	/* Description - DataPath state for lane <i>
1: DPDeactivated 
2: DPInit 
3: DPDeinit 
4: DPActivated 
5: DPTxTurnOn 
6: DPTxTurnOff 
7: DPInitialized */
	/* 0x34.13 - 0x34.16 */
	 u_int8_t dp_st_lane3;
	/* Description - DataPath state for lane <i>
1: DPDeactivated 
2: DPInit 
3: DPDeinit 
4: DPActivated 
5: DPTxTurnOn 
6: DPTxTurnOff 
7: DPInitialized */
	/* 0x34.17 - 0x34.20 */
	 u_int8_t dp_st_lane2;
	/* Description - DataPath state for lane <i>
1: DPDeactivated 
2: DPInit 
3: DPDeinit 
4: DPActivated 
5: DPTxTurnOn 
6: DPTxTurnOff 
7: DPInitialized */
	/* 0x34.21 - 0x34.24 */
	 u_int8_t dp_st_lane1;
	/* Description - DataPath state for lane <i>
1: DPDeactivated 
2: DPInit 
3: DPDeinit 
4: DPActivated 
5: DPTxTurnOn 
6: DPTxTurnOff 
7: DPInitialized */
	/* 0x34.25 - 0x34.28 */
	 u_int8_t dp_st_lane0;
	/* Description - Valid for CMIS modules only. Module state:
 0: reserved 
1: LowPwr_state 
2: PwrUp_state 
3: Ready_state 
4: PwrDn_state 
5: Fault_state */
	/* 0x34.29 - 0x34.31 */
	 u_int8_t module_st;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - DataPath state for lane <i>
1: DPDeactivated 
2: DPInit 
3: DPDeinit 
4: DPActivated 
5: DPTxTurnOn 
6: DPTxTurnOff 
7: DPInitialized */
	/* 0x38.28 - 0x38.31 */
	 u_int8_t dp_st_lane7;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_PAM4_Level_Transition_Properties {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Pam4 level transition group capability mask:
Bit 0: pam4_level_transition_media
Bit 1: pam4_level_transition_host */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t pam4_level_transition_cap;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Thresholds for the PAM4 level transition value on the 
media lanes. 
In unit scale of 1/256 dB. */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t pam4_level_transition_media_low_warning;
	/* Description - Thresholds for the PAM4 level transition value on the 
media lanes. 
In unit scale of 1/256 dB. */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t pam4_level_transition_media_low_alarm;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Thresholds for the PAM4 level transition value on the host 
lanes. 
In unit scale of 1/256 dB. */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t pam4_level_transition_host_low_warning;
	/* Description - Thresholds for the PAM4 level transition value on the host 
lanes. 
In unit scale of 1/256 dB. */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t pam4_level_transition_host_low_alarm;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_PAM4_Level_Transition_Samples {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Measures the electrical level noise in the media lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t pam4_level_transition_media_lane1;
	/* Description - Measures the electrical level noise in the media lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t pam4_level_transition_media_lane0;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Measures the electrical level noise in the media lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t pam4_level_transition_media_lane3;
	/* Description - Measures the electrical level noise in the media lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t pam4_level_transition_media_lane2;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Measures the electrical level noise in the media lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t pam4_level_transition_media_lane5;
	/* Description - Measures the electrical level noise in the media lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t pam4_level_transition_media_lane4;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Measures the electrical level noise in the media lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t pam4_level_transition_media_lane7;
	/* Description - Measures the electrical level noise in the media lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t pam4_level_transition_media_lane6;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Measures the electrical level noise in the host lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t pam4_level_transition_host_lane1;
	/* Description - Measures the electrical level noise in the host lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t pam4_level_transition_host_lane0;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Measures the electrical level noise in the host lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t pam4_level_transition_host_lane3;
	/* Description - Measures the electrical level noise in the host lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t pam4_level_transition_host_lane2;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Measures the electrical level noise in the host lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t pam4_level_transition_host_lane5;
	/* Description - Measures the electrical level noise in the host lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t pam4_level_transition_host_lane4;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Measures the electrical level noise in the host lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t pam4_level_transition_host_lane7;
	/* Description - Measures the electrical level noise in the host lane <i>. 
Defined as the minimum of three individual PAM level tran
sition values. PAM level transition is defined as the average 
of the peak histogram height divided by the minimum his
togram height.
Measured in units scale of 1/256 db. When the minimum 
histogram height is zero the PAM level transition value is 
encoded as FFFF (255.996 dB). */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t pam4_level_transition_host_lane6;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_Pre_FEC_BER_Properties {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Pre-FEC Bit Error Ratio represents the total number of bits 
that were corrected by the FEC during an interval divided 
by the total number of bits received in that

group capability mask:
Bit 0: pre_fec_ber_min_media
Bit 1: pre_fec_ber_min_host
Bit 2: pre_fec_ber_max_media
Bit 3: pre_fec_ber_max_host
bit 4: pre_fec_ber_avg_media
bit 5: pre_fec_ber_avg_host
bit 6: pre_fec_ber_val_media
bit 7: pre_fec_ber_val_host */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t pre_fec_ber_cap;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t pre_fec_ber_min_high_media_warning;
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t pre_fec_ber_min_high_media_alarm;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t pre_fec_ber_min_high_host_warning;
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t pre_fec_ber_min_high_host_alarm;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t pre_fec_ber_max_high_media_warning;
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t pre_fec_ber_max_high_media_alarm;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t pre_fec_ber_max_high_host_warning;
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t pre_fec_ber_max_high_host_alarm;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t pre_fec_ber_avg_high_media_warning;
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t pre_fec_ber_avg_high_media_alarm;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t pre_fec_ber_avg_high_host_warning;
	/* Description - Thresholds for the pre-FEC BER values. */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t pre_fec_ber_avg_high_host_alarm;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_Pre_FEC_BER_Samples {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - The minimum statistical value of the Pre-FEC BER in the 
host input. */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t pre_fec_ber_min_host;
	/* Description - The minimum statistical value of the Pre-FEC BER in the 
media input. */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t pre_fec_ber_min_media;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - The maximum statistical value of the Pre-FEC BER in the 
hostinput. */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t pre_fec_ber_max_host;
	/* Description - The maximum statistical value of the Pre-FEC BER in the 
media input. */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t pre_fec_ber_max_media;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - The average statistical value of the Pre-FEC BER in the 
host input. */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t pre_fec_ber_avg_host;
	/* Description - The average statistical value of the Pre-FEC BER in the 
media input. */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t pre_fec_ber_avg_media;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - The sampled value of the Pre-FEC BER in the host input. */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t pre_fec_ber_val_host;
	/* Description - The sampled value of the Pre-FEC BER in the media input. */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t pre_fec_ber_val_media;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_RAW_page_data {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Byte array of RAW data */
	/* 0x0.24 - 0xcc.23 */
	 u_int8_t data[204];
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_SNR_Properties {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - SNR group capability mask:
Bit 0: snr_media
Bit 1: snr_host */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t snr_cap;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Thresholds for the SNR value on the media lanes. 
In unit scale of 1/256 dB. */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t snr_media_low_warning;
	/* Description - Thresholds for the SNR value on the media lanes. 
In unit scale of 1/256 dB. */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t snr_media_low_alarm;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Thresholds for the SNR value on the media lanes. 
In unit scale of 1/256 dB. */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t snr_host_low_warning;
	/* Description - Thresholds for the SNR value on the media lanes. 
In unit scale of 1/256 dB. */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t snr_host_low_alarm;
};

/* Description -   */
/* Size in bytes - 204 */
struct pemi_SNR_Samples {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - SNR value on the media lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t snr_media_lane1;
	/* Description - SNR value on the media lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t snr_media_lane0;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - SNR value on the media lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t snr_media_lane3;
	/* Description - SNR value on the media lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t snr_media_lane2;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - SNR value on the media lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t snr_media_lane5;
	/* Description - SNR value on the media lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t snr_media_lane4;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - SNR value on the media lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t snr_media_lane7;
	/* Description - SNR value on the media lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t snr_media_lane6;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - SNR value on the host lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t snr_host_lane1;
	/* Description - SNR value on the host lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t snr_host_lane0;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - SNR value on the host lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t snr_host_lane3;
	/* Description - SNR value on the host lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t snr_host_lane2;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - SNR value on the host lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t snr_host_lane5;
	/* Description - SNR value on the host lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t snr_host_lane4;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - SNR value on the host lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t snr_host_lane7;
	/* Description - SNR value on the host lane <i>. In unit scale of 1/256 dB.
The SNR value represents the electrical signal-to-noise 
ratio on an optical lane, and is defined as the minimum of 
the three individual eye SNR values. */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t snr_host_lane6;
};

/* Description -   */
/* Size in bytes - 212 */
struct ppcnt_RAW_page_data {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Byte array of RAW data */
	/* 0x0.24 - 0xd4.23 */
	 u_int8_t data[212];
};

/* Description -   */
/* Size in bytes - 176 */
struct ppcnt_ib_long_portcntrs_attribute_grp_data {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t symbol_error_counter_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t symbol_error_counter_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t link_error_recovery_counter_high;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t link_error_recovery_counter_low;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t link_downed_counter_high;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t link_downed_counter_low;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t port_rcv_errors_high;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t port_rcv_errors_low;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t port_rcv_remote_physical_errors_high;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t port_rcv_remote_physical_errors_low;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t port_rcv_switch_relay_errors_high;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t port_rcv_switch_relay_errors_low;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t port_xmit_discards_high;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t port_xmit_discards_low;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t port_xmit_constraint_errors_high;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t port_xmit_constraint_errors_low;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t port_rcv_constraint_errors_high;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t port_rcv_constraint_errors_low;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x48.0 - 0x48.31 */
	 u_int32_t local_link_integrity_errors_high;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t local_link_integrity_errors_low;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x50.0 - 0x50.31 */
	 u_int32_t excessive_buffer_overrun_errors_high;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x54.0 - 0x54.31 */
	 u_int32_t excessive_buffer_overrun_errors_low;
/*---------------- DWORD[22] (Offset 0x58) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x58.0 - 0x58.31 */
	 u_int32_t vl_15_dropped_high;
/*---------------- DWORD[23] (Offset 0x5c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x5c.0 - 0x5c.31 */
	 u_int32_t vl_15_dropped_low;
/*---------------- DWORD[24] (Offset 0x60) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x60.0 - 0x60.31 */
	 u_int32_t port_xmit_data_high;
/*---------------- DWORD[25] (Offset 0x64) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x64.0 - 0x64.31 */
	 u_int32_t port_xmit_data_low;
/*---------------- DWORD[26] (Offset 0x68) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x68.0 - 0x68.31 */
	 u_int32_t port_rcv_data_high;
/*---------------- DWORD[27] (Offset 0x6c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x6c.0 - 0x6c.31 */
	 u_int32_t port_rcv_data_low;
/*---------------- DWORD[28] (Offset 0x70) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x70.0 - 0x70.31 */
	 u_int32_t port_xmit_pkts_high;
/*---------------- DWORD[29] (Offset 0x74) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x74.0 - 0x74.31 */
	 u_int32_t port_xmit_pkts_low;
/*---------------- DWORD[30] (Offset 0x78) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x78.0 - 0x78.31 */
	 u_int32_t port_rcv_pkts_high;
/*---------------- DWORD[31] (Offset 0x7c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x7c.0 - 0x7c.31 */
	 u_int32_t port_rcv_pkts_low;
/*---------------- DWORD[32] (Offset 0x80) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x80.0 - 0x80.31 */
	 u_int32_t port_xmit_wait_high;
/*---------------- DWORD[33] (Offset 0x84) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x84.0 - 0x84.31 */
	 u_int32_t port_xmit_wait_low;
/*---------------- DWORD[34] (Offset 0x88) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x88.0 - 0x88.31 */
	 u_int32_t qp1_dropped_high;
/*---------------- DWORD[35] (Offset 0x8c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x8c.0 - 0x8c.31 */
	 u_int32_t qp1_dropped_low;
/*---------------- DWORD[36] (Offset 0x90) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x90.0 - 0x90.31 */
	 u_int32_t port_unicast_xmit_pkts_high;
/*---------------- DWORD[37] (Offset 0x94) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x94.0 - 0x94.31 */
	 u_int32_t port_unicast_xmit_pkts_low;
/*---------------- DWORD[38] (Offset 0x98) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x98.0 - 0x98.31 */
	 u_int32_t port_multicast_xmit_pkts_high;
/*---------------- DWORD[39] (Offset 0x9c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0x9c.0 - 0x9c.31 */
	 u_int32_t port_multicast_xmit_pkts_low;
/*---------------- DWORD[40] (Offset 0xa0) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0xa0.0 - 0xa0.31 */
	 u_int32_t port_unicast_rcv_pkts_high;
/*---------------- DWORD[41] (Offset 0xa4) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0xa4.0 - 0xa4.31 */
	 u_int32_t port_unicast_rcv_pkts_low;
/*---------------- DWORD[42] (Offset 0xa8) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0xa8.0 - 0xa8.31 */
	 u_int32_t port_multicast_rcv_pkts_high;
/*---------------- DWORD[43] (Offset 0xac) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification */
	/* 0xac.0 - 0xac.31 */
	 u_int32_t port_multicast_rcv_pkts_low;
};

/* Description -   */
/* Size in bytes - 40 */
struct ppcnt_ib_portcntrs_attribute_grp_data {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t link_downed_counter;
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t link_error_recovery_counter;
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t symbol_error_counter;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t port_rcv_remote_physical_errors;
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t port_rcv_errors;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t port_xmit_discards;
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t port_rcv_switch_relay_errors;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0xc.0 - 0xc.3 */
	 u_int8_t excessive_buffer_overrun_errors;
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0xc.4 - 0xc.7 */
	 u_int8_t local_link_integrity_errors;
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t port_rcv_constraint_errors;
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0xc.24 - 0xc.31 */
	 u_int8_t port_xmit_constraint_errors;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t vl_15_dropped;
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t qp1_dropped;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t port_xmit_data;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t port_rcv_data;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t port_xmit_pkts;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t port_rcv_pkts;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - For counter description please refer to the InfiniBand specification
 */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t port_xmit_wait;
};

/* Description -   */
/* Size in bytes - 80 */
struct ppcnt_infiniband_general_counter {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Total number of data in Qword (8 Bytes), received on the port.
This counter takes into account the packet alignment.
Supported only when indicated by PCAM.

Note: xmit and rcv counters may count differently (L1 layer based for TX, L2 layer based for RX). */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t port_rcv_data_qword_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Total number of data in Qword (8 Bytes), received on the port.
This counter takes into account the packet alignment.
Supported only when indicated by PCAM.

Note: xmit and rcv counters may count differently (L1 layer based for TX, L2 layer based for RX). */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t port_rcv_data_qword_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Total number of data in Qword (8 Bytes), transmitted on the port.
This counter takes into account the packet alignment.
Supported only when indicated by PCAM.

Notes: 
1. xmit and rcv counters may count differently (L1 layer based for TX, L2 layer based for RX).
2. The counter is not supported for SDR speed. */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t port_xmit_data_qword_high;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Total number of data in Qword (8 Bytes), transmitted on the port.
This counter takes into account the packet alignment.
Supported only when indicated by PCAM.

Notes: 
1. xmit and rcv counters may count differently (L1 layer based for TX, L2 layer based for RX).
2. The counter is not supported for SDR speed. */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t port_xmit_data_qword_low;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - The total number of packets that were dropped since it contained errors. Reasons for this include:
1. dropped due to MPR mismatch.
Supported only when indicated by PCAM.
 */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t rq_general_error_high;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - The total number of packets that were dropped since it contained errors. Reasons for this include:
1. dropped due to MPR mismatch.
Supported only when indicated by PCAM.
 */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t rq_general_error_low;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - TBD */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t port_xmit_ebp_high;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - TBD */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t port_xmit_ebp_low;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - TBD */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t port_sw_hoq_lifetime_limit_discards_high;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - TBD */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t port_sw_hoq_lifetime_limit_discards_low;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - TBD */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t dqs2llu_xmit_wait_arb_global_high;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - TBD */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t dqs2llu_xmit_wait_arb_global_low;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - TBD */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t grxb_fecn_mark_high;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - TBD */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t grxb_fecn_mark_low;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - TBD */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t general_transmit_discard_external_contain_high;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - TBD */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t general_transmit_discard_external_contain_low;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description -  */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t general_receive_discard_external_contain_high;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description -  */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t general_receive_discard_external_contain_low;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - End poison packet counts each time poison packet is marked */
	/* 0x48.0 - 0x48.31 */
	 u_int32_t port_receive_poison_high;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - End poison packet counts each time poison packet is marked */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t port_receive_poison_low;
};

/* Description -   */
/* Size in bytes - 144 */
struct ppcnt_infiniband_packet_histograms {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Number of received packets of 8 bytes size */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t cnt_r8_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Number of received packets of 8 bytes size */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t cnt_r8_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Number of received packets of 16 bytes size */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t cnt_r16_high;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Number of received packets of 16 bytes size */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t cnt_r16_low;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Number of received packets of size between 16 to 24 bytes */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t cnt_r_16_24_high;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Number of received packets of size between 16 to 24 bytes */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t cnt_r_16_24_low;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Number of received packets of size between 25 to 32 bytes */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t cnt_r_25_32_high;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Number of received packets of size between 25 to 32 bytes */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t cnt_r_25_32_low;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Number of received packets of size between 33 to 64 bytes */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t cnt_r_33_64_high;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Number of received packets of size between 33 to 64 bytes */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t cnt_r_33_64_low;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - Number of received packets of size between 65 to 128 bytes */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t cnt_r_65_128_high;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - Number of received packets of size between 65 to 128 bytes */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t cnt_r_65_128_low;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - Number of received packets of size between 129 to 256 bytes */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t cnt_r_129_256_high;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - Number of received packets of size between 129 to 256 bytes */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t cnt_r_129_256_low;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - Number of received packets of size between 257 to 512 bytes */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t cnt_r_257_512_high;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - Number of received packets of size between 257 to 512 bytes */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t cnt_r_257_512_low;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - Number of received packets of size between 513 to MTU size bytes */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t cnt_r_513_mtu_high;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - Number of received packets of size between 513 to MTU size bytes */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t cnt_r_513_mtu_low;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - Number of transmitted  packets of 8 bytes size */
	/* 0x48.0 - 0x48.31 */
	 u_int32_t cnt_t8_high;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - Number of transmitted  packets of 8 bytes size */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t cnt_t8_low;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description - Number of transmitted  packets of 16 bytes size */
	/* 0x50.0 - 0x50.31 */
	 u_int32_t cnt_t16_high;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description - Number of transmitted  packets of 16 bytes size */
	/* 0x54.0 - 0x54.31 */
	 u_int32_t cnt_t16_low;
/*---------------- DWORD[22] (Offset 0x58) ----------------*/
	/* Description - Number of transmitted  packets of size between 16 to 24 bytes */
	/* 0x58.0 - 0x58.31 */
	 u_int32_t cnt_t_16_24_high;
/*---------------- DWORD[23] (Offset 0x5c) ----------------*/
	/* Description - Number of transmitted  packets of size between 16 to 24 bytes */
	/* 0x5c.0 - 0x5c.31 */
	 u_int32_t cnt_t_16_24_low;
/*---------------- DWORD[24] (Offset 0x60) ----------------*/
	/* Description - Number of transmitted  packets of size between 25 to 32 bytes */
	/* 0x60.0 - 0x60.31 */
	 u_int32_t cnt_t_25_32_high;
/*---------------- DWORD[25] (Offset 0x64) ----------------*/
	/* Description - Number of transmitted  packets of size between 25 to 32 bytes */
	/* 0x64.0 - 0x64.31 */
	 u_int32_t cnt_t_25_32_low;
/*---------------- DWORD[26] (Offset 0x68) ----------------*/
	/* Description - Number of transmitted  packets of size between 33 to 64 bytes */
	/* 0x68.0 - 0x68.31 */
	 u_int32_t cnt_t_33_64_high;
/*---------------- DWORD[27] (Offset 0x6c) ----------------*/
	/* Description - Number of transmitted  packets of size between 33 to 64 bytes */
	/* 0x6c.0 - 0x6c.31 */
	 u_int32_t cnt_t_33_64_low;
/*---------------- DWORD[28] (Offset 0x70) ----------------*/
	/* Description - Number of transmitted  packets of size between 65 to 128 bytes */
	/* 0x70.0 - 0x70.31 */
	 u_int32_t cnt_t_65_128_high;
/*---------------- DWORD[29] (Offset 0x74) ----------------*/
	/* Description - Number of transmitted  packets of size between 65 to 128 bytes */
	/* 0x74.0 - 0x74.31 */
	 u_int32_t cnt_t_65_128_low;
/*---------------- DWORD[30] (Offset 0x78) ----------------*/
	/* Description - Number of transmitted  packets of size between 129 to 256 bytes */
	/* 0x78.0 - 0x78.31 */
	 u_int32_t cnt_t_129_256_high;
/*---------------- DWORD[31] (Offset 0x7c) ----------------*/
	/* Description - Number of transmitted  packets of size between 129 to 256 bytes */
	/* 0x7c.0 - 0x7c.31 */
	 u_int32_t cnt_t_129_256_low;
/*---------------- DWORD[32] (Offset 0x80) ----------------*/
	/* Description - Number of transmitted  packets of size between 257 to 512 bytes */
	/* 0x80.0 - 0x80.31 */
	 u_int32_t cnt_t_257_512_high;
/*---------------- DWORD[33] (Offset 0x84) ----------------*/
	/* Description - Number of transmitted  packets of size between 257 to 512 bytes */
	/* 0x84.0 - 0x84.31 */
	 u_int32_t cnt_t_257_512_low;
/*---------------- DWORD[34] (Offset 0x88) ----------------*/
	/* Description - Number of transmitted  packets of size between 513 to MTU size bytes */
	/* 0x88.0 - 0x88.31 */
	 u_int32_t cnt_t_513_mtu_high;
/*---------------- DWORD[35] (Offset 0x8c) ----------------*/
	/* Description - Number of transmitted  packets of size between 513 to MTU size bytes */
	/* 0x8c.0 - 0x8c.31 */
	 u_int32_t cnt_t_513_mtu_low;
};

/* Description -   */
/* Size in bytes - 96 */
struct ppcnt_infiniband_packets_counter {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - The time passed since the last counters clear event in msec. */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t time_since_last_clear_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - The time passed since the last counters clear event in msec. */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t time_since_last_clear_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t port_unicast_xmit_pkts_high;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t port_unicast_xmit_pkts_low;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t port_unicast_rcv_pkts_high;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t port_unicast_rcv_pkts_low;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t sync_header_error_counter_high;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t sync_header_error_counter_low;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t port_local_physical_errors_high;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t port_local_physical_errors_low;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t port_malformed_packet_errors_high;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t port_malformed_packet_errors_low;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t port_buffer_overrun_errors_high;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t port_buffer_overrun_errors_low;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t port_dlid_mapping_errors_high;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t port_dlid_mapping_errors_low;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t port_vl_mapping_errors_high;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t port_vl_mapping_errors_low;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x48.0 - 0x48.31 */
	 u_int32_t port_looping_errors_high;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t port_looping_errors_low;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x50.0 - 0x50.31 */
	 u_int32_t port_inactive_discards_high;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x54.0 - 0x54.31 */
	 u_int32_t port_inactive_discards_low;
/*---------------- DWORD[22] (Offset 0x58) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x58.0 - 0x58.31 */
	 u_int32_t port_neighbor_mtu_discards_high;
/*---------------- DWORD[23] (Offset 0x5c) ----------------*/
	/* Description - For counter description please refer to the InfiniBand  Specification */
	/* 0x5c.0 - 0x5c.31 */
	 u_int32_t port_neighbor_mtu_discards_low;
};

/* Description -   */
/* Size in bytes - 80 */
struct ppcnt_infiniband_vl_counter {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - TBD */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t dqs2llu_xmit_wait_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - TBD */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t dqs2llu_xmit_wait_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - TBD */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t dqs2llu_xmit_wait_arb_high;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - TBD */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t dqs2llu_xmit_wait_arb_low;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - TBD */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t port_rcv_pkts_vl_high;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - TBD */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t port_rcv_pkts_vl_low;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - TBD */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t port_rcv_pkts_vl15_high;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - TBD */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t port_rcv_pkts_vl15_low;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - TBD */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t port_rcv_data_vl_high;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - TBD */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t port_rcv_data_vl_low;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - TBD */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t port_rcv_data_vl15_high;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - TBD */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t port_rcv_data_vl15_low;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - TBD */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t port_xmit_pkts_vl_high;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - TBD */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t port_xmit_pkts_vl_low;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - TBD */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t port_xmit_pkts_vl15_high;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - TBD */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t port_xmit_pkts_vl15_low;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - TBD */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t port_xmit_data_vl_high;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - TBD */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t port_xmit_data_vl_low;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - TBD */
	/* 0x48.0 - 0x48.31 */
	 u_int32_t port_xmit_data_vl15_high;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - TBD */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t port_xmit_data_vl15_low;
};

/* Description -   */
/* Size in bytes - 168 */
struct ppcnt_l1_general_counters {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - The total number of entries to QUIET state 
because of l1_desire request.

Notes:
1. Currently only "l1_entry_quiet_low" 16 Bits 
are mapped.
2. The counter will wrap around to 0 once it 
reaches to max 16b value. */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t l1_entry_quiet_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - The total number of entries to QUIET state 
because of l1_desire request.

Notes:
1. Currently only "l1_entry_quiet_low" 16 Bits 
are mapped.
2. The counter will wrap around to 0 once it 
reaches to max 16b value. */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t l1_entry_quiet_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - The total number of entries to QUIET state 
because of L1 force request.

Notes:
1. Currently only "l1_force_entry_low" 16 Bits 
are mapped.
2. The counter will wrap around to 0 once it 
reaches to max 16b value.
3. Please note that in GB100 and QM3 there is an open bug on this counter #3546097. */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t l1_force_entry_high;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - The total number of entries to QUIET state 
because of L1 force request.

Notes:
1. Currently only "l1_force_entry_low" 16 Bits 
are mapped.
2. The counter will wrap around to 0 once it 
reaches to max 16b value.
3. Please note that in GB100 and QM3 there is an open bug on this counter #3546097. */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t l1_force_entry_low;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to local port l1_desire request.

Notes:
1. Currently only "l1_exit_local_desired_low" 16 Bits are mapped.
2. The counter will wrap around to 0 once it reaches to max 17b value. */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t l1_exit_local_desired_high;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to local port l1_desire request.

Notes:
1. Currently only "l1_exit_local_desired_low" 16 Bits are mapped.
2. The counter will wrap around to 0 once it reaches to max 17b value. */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t l1_exit_local_desired_low;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to the local port Recalibration start trigger.

Notes:
1. Currently only "l1_exit_local_recal_low" 16 Bits are mapped.
2. The counter will wrap around to 0 once it reaches to max 16b value. */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t l1_exit_local_recal_high;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to the local port Recalibration start trigger.

Notes:
1. Currently only "l1_exit_local_recal_low" 16 Bits are mapped.
2. The counter will wrap around to 0 once it reaches to max 16b value. */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t l1_exit_local_recal_low;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to the local port Recalibration start trigger, while traffic is sent when the port reaches the LinkUp state.

Notes:
1. This counter is a subset of the "l1_exit_local_recal" counter.
2. Currently only "l1_exit_local_recal_with_traffic_low" 16 Bits are mapped.
3. The counter will wrap around to 0 once it reaches to max 16b value. */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t l1_exit_local_recal_with_traffic_high;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to the local port Recalibration start trigger, while traffic is sent when the port reaches the LinkUp state.

Notes:
1. This counter is a subset of the "l1_exit_local_recal" counter.
2. Currently only "l1_exit_local_recal_with_traffic_low" 16 Bits are mapped.
3. The counter will wrap around to 0 once it reaches to max 16b value. */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t l1_exit_local_recal_with_traffic_low;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to the local port Recalibration start trigger, while no traffic is sent when the port reaches the LinkUp state.
Note: this counter is a subset of the l1_exit_local_recal counter.

Notes:
1. This counter is a subset of the "l1_exit_local_recal" counter.
2. Currently only "l1_exit_local_recal_without_traffic_low" 16 Bits are mapped.
3. The counter will wrap around to 0 once it reaches to max 16b value. */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t l1_exit_local_recal_without_traffic_high;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to the local port Recalibration start trigger, while no traffic is sent when the port reaches the LinkUp state.
Note: this counter is a subset of the l1_exit_local_recal counter.

Notes:
1. This counter is a subset of the "l1_exit_local_recal" counter.
2. Currently only "l1_exit_local_recal_without_traffic_low" 16 Bits are mapped.
3. The counter will wrap around to 0 once it reaches to max 16b value. */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t l1_exit_local_recal_without_traffic_low;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to remote side request 
(Can be due to remote l1_desire or remote Recalibration command).

Notes:
1. Currently only "l1_exit_remote_low" 16bits are mapped.
2. The counter will wrap around to 0 once it reaches to max 16 Bits value. */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t l1_exit_remote_high;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to remote side request 
(Can be due to remote l1_desire or remote Recalibration command).

Notes:
1. Currently only "l1_exit_remote_low" 16bits are mapped.
2. The counter will wrap around to 0 once it reaches to max 16 Bits value. */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t l1_exit_remote_low;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to remote side requests, while the local port Recalibration period counter almost expired.

Notes:
1. Currently only "l1_exit_remote_probably_recal_low" 16 Bits are mapped.
2. The counter will wrap around to 0 once it reaches to max 16b value. */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t l1_exit_remote_probably_recal_high;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - The total number of exits from QUIET to WAKE mode due to remote side requests, while the local port Recalibration period counter almost expired.

Notes:
1. Currently only "l1_exit_remote_probably_recal_low" 16 Bits are mapped.
2. The counter will wrap around to 0 once it reaches to max 16b value. */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t l1_exit_remote_probably_recal_low;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - The total time in 1024 nsec resolution from LINKUP_TX_EMPTY state to L1 QUIET_ENTRY state, due to Local L1 desired signal. */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t local_full_bw_exit_high;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - The total time in 1024 nsec resolution from LINKUP_TX_EMPTY state to L1 QUIET_ENTRY state, due to Local L1 desired signal. */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t local_full_bw_exit_low;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - The total time in 1024 nsec resolution from LINKUP_TX_EMPTY state to L1 QUIET state and the UPHY reaches SLEEP3 (both Tx and Rx), due to Local L1 desired signal.
The counter represents the total time of the local_full_bw_exit counter with the additional response time from the Uphy. */
	/* 0x48.0 - 0x48.31 */
	 u_int32_t local_low_power_enter_high;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - The total time in 1024 nsec resolution from LINKUP_TX_EMPTY state to L1 QUIET state and the UPHY reaches SLEEP3 (both Tx and Rx), due to Local L1 desired signal.
The counter represents the total time of the local_full_bw_exit counter with the additional response time from the Uphy. */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t local_low_power_enter_low;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description - The total time in 1024 nsec resolution from remote L1 desire signal is asserted to L1 QUIET_ENTRY state.
The counter represents the total time since the local port detected that the remote port wanted to enter quiet mode until L1 QUIET_ENTRY state. */
	/* 0x50.0 - 0x50.31 */
	 u_int32_t remote_full_bw_exit_high;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description - The total time in 1024 nsec resolution from remote L1 desire signal is asserted to L1 QUIET_ENTRY state.
The counter represents the total time since the local port detected that the remote port wanted to enter quiet mode until L1 QUIET_ENTRY state. */
	/* 0x54.0 - 0x54.31 */
	 u_int32_t remote_full_bw_exit_low;
/*---------------- DWORD[22] (Offset 0x58) ----------------*/
	/* Description - The total time in 1024 nsec resolution from remote L1 desired signal is asserted to L1 QUIET state and the UPHY reaches SLEEP3 (both Tx and Rx).
The counter represents the total time of the remote_full_bw_exit counter with the additional response time from the Uphy. */
	/* 0x58.0 - 0x58.31 */
	 u_int32_t remote_low_power_enter_high;
/*---------------- DWORD[23] (Offset 0x5c) ----------------*/
	/* Description - The total time in 1024 nsec resolution from remote L1 desired signal is asserted to L1 QUIET state and the UPHY reaches SLEEP3 (both Tx and Rx).
The counter represents the total time of the remote_full_bw_exit counter with the additional response time from the Uphy. */
	/* 0x5c.0 - 0x5c.31 */
	 u_int32_t remote_low_power_enter_low;
/*---------------- DWORD[24] (Offset 0x60) ----------------*/
	/* Description - The total time in 1024 nsec resolution from local l1_desired is de-asserted or local Recalibration start trigger until High-Speed steady state.
The counter represents the total time spent in WAKE mode due to the local wake-up command. */
	/* 0x60.0 - 0x60.31 */
	 u_int32_t local_low_power_exit_high;
/*---------------- DWORD[25] (Offset 0x64) ----------------*/
	/* Description - The total time in 1024 nsec resolution from local l1_desired is de-asserted or local Recalibration start trigger until High-Speed steady state.
The counter represents the total time spent in WAKE mode due to the local wake-up command. */
	/* 0x64.0 - 0x64.31 */
	 u_int32_t local_low_power_exit_low;
/*---------------- DWORD[26] (Offset 0x68) ----------------*/
	/* Description - The total time in 1024 nsec resolution from local l1_desired is de-asserted until LinkUp state.
The counter represents the total time spent in WAKE mode and RECOVERY mode due to the local wake-up command.. */
	/* 0x68.0 - 0x68.31 */
	 u_int32_t local_full_bw_enter_high;
/*---------------- DWORD[27] (Offset 0x6c) ----------------*/
	/* Description - The total time in 1024 nsec resolution from local l1_desired is de-asserted until LinkUp state.
The counter represents the total time spent in WAKE mode and RECOVERY mode due to the local wake-up command.. */
	/* 0x6c.0 - 0x6c.31 */
	 u_int32_t local_full_bw_enter_low;
/*---------------- DWORD[28] (Offset 0x70) ----------------*/
	/* Description - The total time in 1024 nsec resolution from remote l1_desired is de-asserted (poke detected) until High-Speed steady state.
The counter represents the total time spent in WAKE mode due to the remote wake-up command. */
	/* 0x70.0 - 0x70.31 */
	 u_int32_t remote_low_power_exit_high;
/*---------------- DWORD[29] (Offset 0x74) ----------------*/
	/* Description - The total time in 1024 nsec resolution from remote l1_desired is de-asserted (poke detected) until High-Speed steady state.
The counter represents the total time spent in WAKE mode due to the remote wake-up command. */
	/* 0x74.0 - 0x74.31 */
	 u_int32_t remote_low_power_exit_low;
/*---------------- DWORD[30] (Offset 0x78) ----------------*/
	/* Description - The total time in 1024ns resolution from remote l1_desired is de-asserted until LinkUp state.
The counter represents the total time spent in WAKE mode and RECOVERY mode due to remote wake-up command. */
	/* 0x78.0 - 0x78.31 */
	 u_int32_t remote_full_bw_enter_high;
/*---------------- DWORD[31] (Offset 0x7c) ----------------*/
	/* Description - The total time in 1024ns resolution from remote l1_desired is de-asserted until LinkUp state.
The counter represents the total time spent in WAKE mode and RECOVERY mode due to remote wake-up command. */
	/* 0x7c.0 - 0x7c.31 */
	 u_int32_t remote_full_bw_enter_low;
/*---------------- DWORD[32] (Offset 0x80) ----------------*/
	/* Description - The total time in 1024 nsec resolution that the port is in LinkUp state. */
	/* 0x80.0 - 0x80.31 */
	 u_int32_t high_speed_steady_state_high;
/*---------------- DWORD[33] (Offset 0x84) ----------------*/
	/* Description - The total time in 1024 nsec resolution that the port is in LinkUp state. */
	/* 0x84.0 - 0x84.31 */
	 u_int32_t high_speed_steady_state_low;
/*---------------- DWORD[34] (Offset 0x88) ----------------*/
	/* Description - The total time in 1024 nsec resolution that the port is in L1 QUITE steady state. */
	/* 0x88.0 - 0x88.31 */
	 u_int32_t l1_steady_state_high;
/*---------------- DWORD[35] (Offset 0x8c) ----------------*/
	/* Description - The total time in 1024 nsec resolution that the port is in L1 QUITE steady state. */
	/* 0x8c.0 - 0x8c.31 */
	 u_int32_t l1_steady_state_low;
/*---------------- DWORD[36] (Offset 0x90) ----------------*/
	/* Description - The total time in 1024 nsec resolution that the port is not in LinkUp or L1 QUITE state.
The counter represents the total time spent on the transitions between LinkUp and L1 QUITE states. */
	/* 0x90.0 - 0x90.31 */
	 u_int32_t other_state_high;
/*---------------- DWORD[37] (Offset 0x94) ----------------*/
	/* Description - The total time in 1024 nsec resolution that the port is not in LinkUp or L1 QUITE state.
The counter represents the total time spent on the transitions between LinkUp and L1 QUITE states. */
	/* 0x94.0 - 0x94.31 */
	 u_int32_t other_state_low;
/*---------------- DWORD[38] (Offset 0x98) ----------------*/
	/* Description - The time passed since the last counters clear event in msec. */
	/* 0x98.0 - 0x98.31 */
	 u_int32_t time_since_last_clear_high;
/*---------------- DWORD[39] (Offset 0x9c) ----------------*/
	/* Description - The time passed since the last counters clear event in msec. */
	/* 0x9c.0 - 0x9c.31 */
	 u_int32_t time_since_last_clear_low;
/*---------------- DWORD[40] (Offset 0xa0) ----------------*/
	/* Description - The total number of entries to QUIET state.
Note:
1. This counter represents the sum of the fol lowing HW counters: l1_entry_quiet + l1_-
force_entry. */
	/* 0xa0.0 - 0xa0.31 */
	 u_int32_t l1_total_entries_high;
/*---------------- DWORD[41] (Offset 0xa4) ----------------*/
	/* Description - The total number of entries to QUIET state.
Note:
1. This counter represents the sum of the fol lowing HW counters: l1_entry_quiet + l1_-
force_entry. */
	/* 0xa4.0 - 0xa4.31 */
	 u_int32_t l1_total_entries_low;
};

/* Description -   */
/* Size in bytes - 48 */
struct ppcnt_packet_type_counter {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Number of received packets of Nvlink IB Gen1 */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t port_rcv_ibg1_nvl_pkts_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Number of received packets of Nvlink IB Gen1 */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t port_rcv_ibg1_nvl_pkts_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Number of received packets of non Nvlink */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t port_rcv_ibg1_non_nvl_pkts_high;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Number of received packets of non Nvlink */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t port_rcv_ibg1_non_nvl_pkts_low;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Number of received packets of IB Gen2 */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t port_rcv_ibg2_pkts_high;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Number of received packets of IB Gen2 */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t port_rcv_ibg2_pkts_low;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Number of transmitted packets of Nvlink IB Gen1 */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t port_xmit_ibg1_nvl_pkts_high;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Number of transmitted packets of Nvlink IB Gen1 */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t port_xmit_ibg1_nvl_pkts_low;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Number of transmitted packets of non Nvlink */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t port_xmit_ibg1_non_nvl_pkts_high;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Number of transmitted packets of non Nvlink */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t port_xmit_ibg1_non_nvl_pkts_low;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - Number of transmitted packets of IB Gen2 */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t port_xmit_ibg2_pkts_high;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - Number of transmitted packets of IB Gen2 */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t port_xmit_ibg2_pkts_low;
};

/* Description -   */
/* Size in bytes - 80 */
struct ppcnt_plr_counters {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Number of received PLR codewords

 */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t plr_rcv_codes_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Number of received PLR codewords

 */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t plr_rcv_codes_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - The total number of rejected codewords received */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t plr_rcv_code_err_high;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - The total number of rejected codewords received */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t plr_rcv_code_err_low;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - The number of uncorrectable codewords received
 */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t plr_rcv_uncorrectable_code_high;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - The number of uncorrectable codewords received
 */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t plr_rcv_uncorrectable_code_low;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Number of transmitted PLR codewords */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t plr_xmit_codes_high;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Number of transmitted PLR codewords */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t plr_xmit_codes_low;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - The total number of codewords retransmitted. */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t plr_xmit_retry_codes_high;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - The total number of codewords retransmitted. */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t plr_xmit_retry_codes_low;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - The total number of retransmitted event. 

 */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t plr_xmit_retry_events_high;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - The total number of retransmitted event. 

 */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t plr_xmit_retry_events_low;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - The number of sync events */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t plr_sync_events_high;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - The number of sync events */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t plr_sync_events_low;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - Recieved bandwidth loss due to codes retransmission. calculated in resolution of 
(plr_rcv_code_err / plr_rcv_codes) * 10^10

BW Loss % = (plr_codes_loss / 10^10 ) *100 */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t plr_codes_loss_high;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - Recieved bandwidth loss due to codes retransmission. calculated in resolution of 
(plr_rcv_code_err / plr_rcv_codes) * 10^10

BW Loss % = (plr_codes_loss / 10^10 ) *100 */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t plr_codes_loss_low;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - The maximum number of retransmitted events in t sec window
 */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t plr_xmit_retry_events_within_t_sec_max_high;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - The maximum number of retransmitted events in t sec window
 */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t plr_xmit_retry_events_within_t_sec_max_low;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - The time passed since the last counters clear 
event in msec. */
	/* 0x48.0 - 0x48.31 */
	 u_int32_t time_since_last_clear_high;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - The time passed since the last counters clear 
event in msec. */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t time_since_last_clear_low;
};

/* Description -   */
/* Size in bytes - 168 */
struct ppcnt_rs_fec_histograms_counters {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Value of RS-hist */
	/* 0x0.0 - 0xa4.31 */
	 u_int64_t hist[21];
};

/* Description -   */
/* Size in bytes - 140 */
struct ppcnt_usr_xsr_physical_layer {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - The time passed since the last counters clear event in msec.
[Internal] supported in USR */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t time_since_last_clear_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - The time passed since the last counters clear event in msec.
[Internal] supported in USR */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t time_since_last_clear_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane0)
[Internal] supported in USR - ZL FEC */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t fc_fec_corrected_blocks_lane0_high;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane0)
[Internal] supported in USR - ZL FEC */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t fc_fec_corrected_blocks_lane0_low;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane1)
[Internal] supported in USR - ZL FEC */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t fc_fec_corrected_blocks_lane1_high;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane1)
[Internal] supported in USR - ZL FEC */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t fc_fec_corrected_blocks_lane1_low;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane2)
[Internal] supported in USR - ZL FEC */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t fc_fec_corrected_blocks_lane2_high;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane2)
[Internal] supported in USR - ZL FEC */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t fc_fec_corrected_blocks_lane2_low;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane3)
[Internal] supported in USR - ZL FEC */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t fc_fec_corrected_blocks_lane3_high;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane3)
[Internal] supported in USR - ZL FEC */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t fc_fec_corrected_blocks_lane3_low;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane4)
[Internal] supported in USR - ZL FEC */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t fc_fec_corrected_blocks_lane4_high;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane4)
[Internal] supported in USR - ZL FEC */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t fc_fec_corrected_blocks_lane4_low;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane5)
[Internal] supported in USR - ZL FEC */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t fc_fec_corrected_blocks_lane5_high;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane5)
[Internal] supported in USR - ZL FEC */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t fc_fec_corrected_blocks_lane5_low;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane6)
[Internal] supported in USR - ZL FEC */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t fc_fec_corrected_blocks_lane6_high;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane6)
[Internal] supported in USR - ZL FEC */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t fc_fec_corrected_blocks_lane6_low;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane7)
[Internal] supported in USR - ZL FEC */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t fc_fec_corrected_blocks_lane7_high;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane7)
[Internal] supported in USR - ZL FEC */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t fc_fec_corrected_blocks_lane7_low;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane0)
[Internal] supported in USR - ZL FEC */
	/* 0x48.0 - 0x48.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane0_high;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane0)
[Internal] supported in USR - ZL FEC */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane0_low;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane1)
[Internal] supported in USR - ZL FEC */
	/* 0x50.0 - 0x50.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane1_high;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane1)
[Internal] supported in USR - ZL FEC */
	/* 0x54.0 - 0x54.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane1_low;
/*---------------- DWORD[22] (Offset 0x58) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane2)
[Internal] supported in USR - ZL FEC */
	/* 0x58.0 - 0x58.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane2_high;
/*---------------- DWORD[23] (Offset 0x5c) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane2)
[Internal] supported in USR - ZL FEC */
	/* 0x5c.0 - 0x5c.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane2_low;
/*---------------- DWORD[24] (Offset 0x60) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane3)
[Internal] supported in USR - ZL FEC */
	/* 0x60.0 - 0x60.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane3_high;
/*---------------- DWORD[25] (Offset 0x64) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane3)
[Internal] supported in USR - ZL FEC */
	/* 0x64.0 - 0x64.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane3_low;
/*---------------- DWORD[26] (Offset 0x68) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane4)
[Internal] supported in USR - ZL FEC */
	/* 0x68.0 - 0x68.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane4_high;
/*---------------- DWORD[27] (Offset 0x6c) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane4)
[Internal] supported in USR - ZL FEC */
	/* 0x6c.0 - 0x6c.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane4_low;
/*---------------- DWORD[28] (Offset 0x70) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane5)
[Internal] supported in USR - ZL FEC */
	/* 0x70.0 - 0x70.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane5_high;
/*---------------- DWORD[29] (Offset 0x74) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane5)
[Internal] supported in USR - ZL FEC */
	/* 0x74.0 - 0x74.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane5_low;
/*---------------- DWORD[30] (Offset 0x78) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane6)
[Internal] supported in USR - ZL FEC */
	/* 0x78.0 - 0x78.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane6_high;
/*---------------- DWORD[31] (Offset 0x7c) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane6)
[Internal] supported in USR - ZL FEC */
	/* 0x7c.0 - 0x7c.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane6_low;
/*---------------- DWORD[32] (Offset 0x80) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane7)
[Internal] supported in USR - ZL FEC */
	/* 0x80.0 - 0x80.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane7_high;
/*---------------- DWORD[33] (Offset 0x84) ----------------*/
	/* Description - Perf.PortExtendedSpeedsCounters(FECCorrectableBlockCounterLane7)
[Internal] supported in USR - ZL FEC */
	/* 0x84.0 - 0x84.31 */
	 u_int32_t fc_fec_uncorrectable_blocks_lane7_low;
/*---------------- DWORD[34] (Offset 0x88) ----------------*/
	/* Description - Perf.PortCounters(LinkDownedCounter)
[Internal] supported in USR */
	/* 0x88.0 - 0x88.31 */
	 u_int32_t link_down_events;
};

/* Description -   */
/* Size in bytes - 36 */
struct ppll_28nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Varactors calibration flow was executed */
	/* 0x0.0 - 0x0.0 */
	 u_int8_t ae;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Table  1080, "PPLL Status Data Layout for 28nm," on 
page  1347 */
	/* 0x4.0 - 0x20.31 */
	 struct pll_28nm pll_status[4];
};

/* Description -   */
/* Size in bytes - 36 */
struct ppll_data_set {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.24 - 0x24.23 */
	 u_int8_t data[36];
};

/* Description -   */
/* Size in bytes - 36 */
struct ppll_reg_16nm {
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Table  1084, "PPLL Status Data Layout for 16nm," on 
page  1348 */
	/* 0x4.0 - 0x20.31 */
	 struct pll_status_data pll_status[4];
};

/* Description -   */
/* Size in bytes - 8 */
struct ppll_reg_5nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Lockdet error measure counter */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t lockdet_error_count;
	/* Description - dlf2_phlock_det_status sticky version with no timeout */
	/* 0x0.23 - 0x0.23 */
	 u_int8_t dlf2_phlock_det_status_sticky;
	/* Description - Lockdet status */
	/* 0x0.24 - 0x0.24 */
	 u_int8_t lockdet_err_cnt_active_lock;
	/* Description - Lockdet flag (initial lock) */
	/* 0x0.25 - 0x0.25 */
	 u_int8_t lockdet_err_cnt_locked_sticky;
	/* Description - Lockdet error flag (nolock after lock) */
	/* 0x0.26 - 0x0.26 */
	 u_int8_t lockdet_err_cnt_unlocked_sticky;
	/* Description -  */
	/* 0x0.27 - 0x0.27 */
	 u_int8_t lockdet_cnt_based_lock;
	/* Description - Lockdet error state */
	/* 0x0.28 - 0x0.30 */
	 u_int8_t lockdet_err_state;
	/* Description - Lockdet error measure done */
	/* 0x0.31 - 0x0.31 */
	 u_int8_t lockdet_err_measure_done;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.4 */
	 u_int8_t lockdet_mode_retimer;
};

/* Description -   */
/* Size in bytes - 36 */
struct ppll_reg_7nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - 0x0: IDDQ
0x1: SLEEP
0x2: RCAL_DONE_WAIT1
0x3: RCAL_DONE_WAIT0
0x4: IDLE
0x5: CAL_DONE_WAIT1
0x6: CAL_DONE_WAIT0
0x7: ACTIVE
0x8: LOCK
0x9: SPEED_CHANGE */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t pll_ugl_state;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Lockdet status */
	/* 0x4.0 - 0x4.0 */
	 u_int8_t lockdet_err_cnt_active_lock;
	/* Description - Lockdet flag (initial lock) */
	/* 0x4.1 - 0x4.1 */
	 u_int8_t lockdet_err_cnt_locked_sticky;
	/* Description - Lockdet error flag (nolock after lock) */
	/* 0x4.2 - 0x4.2 */
	 u_int8_t lockdet_err_cnt_unlocked_sticky;
	/* Description -  */
	/* 0x4.3 - 0x4.3 */
	 u_int8_t lockdet_cnt_based_lock;
	/* Description - Lockdet error state */
	/* 0x4.4 - 0x4.6 */
	 u_int8_t lockdet_err_state;
	/* Description - Lockdet error measure done */
	/* 0x4.7 - 0x4.7 */
	 u_int8_t lockdet_err_measure_done;
	/* Description - Lockdet error counter */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t lokcdet_error_count;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Power-up Main */
	/* 0x8.0 - 0x8.4 */
	 u_int8_t pwr_up_state;
	/* Description - lockdet */
	/* 0x8.5 - 0x8.6 */
	 u_int8_t pll_lockdet_state;
	/* Description - Calibration Main */
	/* 0x8.8 - 0x8.13 */
	 u_int8_t cal_main_state;
	/* Description - Calibration Step */
	/* 0x8.14 - 0x8.15 */
	 u_int8_t cal_internal_state;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - DCO coarse */
	/* 0xc.0 - 0xc.6 */
	 u_int8_t dco_coarse_bin;
	/* Description -  */
	/* 0xc.12 - 0xc.12 */
	 u_int8_t cal_en;
	/* Description -  */
	/* 0xc.13 - 0xc.13 */
	 u_int8_t cal_done;
	/* Description -  */
	/* 0xc.16 - 0xc.22 */
	 u_int8_t dco_coarse;
	/* Description -  */
	/* 0xc.28 - 0xc.28 */
	 u_int8_t cal_valid_sticky;
	/* Description -  */
	/* 0xc.29 - 0xc.29 */
	 u_int8_t cal_abort;
	/* Description -  */
	/* 0xc.30 - 0xc.30 */
	 u_int8_t cal_abort_sticky;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Calibration error count value */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t cal_error_counter;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - slave FSM rcal_done status indicate calibration completed at 
least once for RCAL/TX-P/TX-N */
	/* 0x14.16 - 0x14.16 */
	 u_int8_t rcal_fsm_done;
	/* Description - TX-N valid status indicate calibration completed at least once */
	/* 0x14.17 - 0x14.17 */
	 u_int8_t rcal_tx_n_valid_sticky;
	/* Description - TX-P valid status indicate calibration completed at least once */
	/* 0x14.18 - 0x14.18 */
	 u_int8_t rcal_tx_p_valid_sticky;
	/* Description - RCAL valid status indicate calibration completed at least once */
	/* 0x14.19 - 0x14.19 */
	 u_int8_t rcal_done_valid_sticky;
	/* Description - lma_rcal_tx_n_code calibration value */
	/* 0x14.20 - 0x14.23 */
	 u_int8_t lma_rcal_tx_n_code;
	/* Description - lma_rcal_tx_p_code calibration value */
	/* 0x14.24 - 0x14.27 */
	 u_int8_t lma_rcal_tx_p_code;
	/* Description - lma_rcal_code calibration value */
	/* 0x14.28 - 0x14.31 */
	 u_int8_t lma_rcal_code;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - bandgap trim value */
	/* 0x18.0 - 0x18.3 */
	 u_int8_t bg_trim;
	/* Description - vref trim value */
	/* 0x18.4 - 0x18.7 */
	 u_int8_t vref_trim;
	/* Description - speedo vaues */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t speedo;
};

/* Description -   */
/* Size in bytes - 44 */
struct sllm_16nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Max number of error in a single clk90 flow */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t lm_clk90_fl_err_max;
	/* Description - 0 - keep default
1 - enable link maintenance
2 - disable link maintenance */
	/* 0x0.16 - 0x0.17 */
	 u_int8_t lm_en;
	/* Description - PIB gateway locked */
	/* 0x0.29 - 0x0.29 */
	 u_int8_t pib_gw_lock;
	/* Description - '1' if link maintenance was active at least once */
	/* 0x0.30 - 0x0.30 */
	 u_int8_t lm_was_active;
	/* Description - '1' if link maintenance is active */
	/* 0x0.31 - 0x0.31 */
	 u_int8_t lm_active;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Total number of error (accumulator) in a single clk90 flow */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t lm_clk90_fl_err_acc;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Count number of maintenance iteration for ib1 */
	/* 0x8.0 - 0x8.19 */
	 u_int32_t lm_counter_up;
	/* Description - Number of tries to run clk90 flow in ib3 */
	/* 0x8.22 - 0x8.31 */
	 u_int16_t ib3_max_lm_90_tries;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Count number of maintenance iteration for ib2 */
	/* 0xc.0 - 0xc.19 */
	 u_int32_t lm_counter_mid;
	/* Description - Number of tries to run clk90 flow in ib1 */
	/* 0xc.22 - 0xc.31 */
	 u_int16_t ib1_max_lm_90_tries;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Count number of maintenance iteration for ib3 */
	/* 0x10.0 - 0x10.19 */
	 u_int32_t lm_counter_dn;
};

/* Description -   */
/* Size in bytes - 36 */
struct sllm_7nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Enable CTLE Periodic EQ */
	/* 0x0.0 - 0x0.0 */
	 u_int8_t ctle_peq_en;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.4 - 0x4.7 */
	 u_int8_t peq_vref_iters;
	/* Description - PEQ train mode:
0x0: Do nothing (no eq training is done).
0x1: DFE adaptation
0x2: Local grid search over (hf_gain) tuple.
0x3:Local grid search over (mf_gain) tuple.
0x4:Local grid search over (hf_gain,mf_gain) tuple. */
	/* 0x4.20 - 0x4.23 */
	 u_int8_t peq_train_mode;
	/* Description -  */
	/* 0x4.28 - 0x4.28 */
	 u_int8_t dffe_peq_scout_skip;
	/* Description -  */
	/* 0x4.29 - 0x4.29 */
	 u_int8_t vref_peq_en;
	/* Description - Enable cdr_offset lgrid search in PEQ */
	/* 0x4.30 - 0x4.30 */
	 u_int8_t cdr_offset_peq_en;
	/* Description - Enable tsense in PEQ */
	/* 0x4.31 - 0x4.31 */
	 u_int8_t peq_tsense_en;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.3 */
	 u_int8_t peq_dffe_delay;
	/* Description -  */
	/* 0x8.4 - 0x8.7 */
	 u_int8_t peq_dffe_iters;
	/* Description -  */
	/* 0x8.16 - 0x8.16 */
	 u_int8_t dffe_peq_en;
	/* Description -  */
	/* 0x8.20 - 0x8.21 */
	 u_int8_t peq_adc_vref_step;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - last BER monitor measurement that triggered CTLE periodic 
EQ. 
BER = ber_mantissa * 10^(-ber_exp) */
	/* 0xc.0 - 0xc.7 */
	 u_int8_t ber_mon_exp;
	/* Description - last BER monitor measurement that triggered CTLE periodic 
EQ. 
BER = ber_mantissa * 10^(-ber_exp) */
	/* 0xc.8 - 0xc.11 */
	 u_int8_t ber_mon_mantissa;
	/* Description - number of CTLE periodic EQ done */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t ctle_peq_cnt;
};

/* Description -   */
/* Size in bytes - 44 */
struct sllm_data_set {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.24 - 0x2c.23 */
	 u_int8_t data[44];
};

/* Description -   */
/* Size in bytes - 44 */
struct sllm_usr {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Number of LM fixes */
	/* 0x0.0 - 0x0.5 */
	 u_int8_t lm_fixes_counter;
	/* Description - Number of times the LM flow searches for a better point on 
the offset scale */
	/* 0x0.8 - 0x0.13 */
	 u_int8_t lm_activation_counter;
	/* Description - LM catastrophic bit */
	/* 0x0.24 - 0x0.24 */
	 u_int8_t lm_catastrophic_bit;
	/* Description - Enable of LM over offset */
	/* 0x0.29 - 0x0.29 */
	 u_int8_t enable_offset_maintenance;
	/* Description - Enable of LM over phase */
	/* 0x0.30 - 0x0.30 */
	 u_int8_t enable_phase_maintenance;
	/* Description - Primary enable of LM flow */
	/* 0x0.31 - 0x0.31 */
	 u_int8_t enable_lm;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Fatal bit for USR tuning */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t link_tuning_error;
	/* Description - Optimal phase */
	/* 0x4.8 - 0x4.13 */
	 u_int8_t optimal_phase;
	/* Description - Which lane is undergoing maintenance. 
value 63 means no lane under maintenance. */
	/* 0x4.16 - 0x4.21 */
	 u_int8_t lane_under_maintenance;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Current correctable errors */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t lane_correctable_errors;
};

/* Description -   */
/* Size in bytes - 36 */
struct slreg_16nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Eye grade */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t eye_grade;
	/* Description -  */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t initial_error;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t post_error;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t initial_area;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t post_area;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t post_area_after_centering;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t gd_iter_num_area;
	/* Description -  */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t gd_iter_num_errors;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.9 */
	 u_int16_t initial_sel_enc_slave;
	/* Description -  */
	/* 0x18.10 - 0x18.19 */
	 u_int16_t post_sel_enc_slave;
	/* Description -  */
	/* 0x18.20 - 0x18.29 */
	 u_int16_t post_sel_enc_slave_centering;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.0 - 0x1c.9 */
	 u_int16_t rect_size;
	/* Description -  */
	/* 0x1c.10 - 0x1c.16 */
	 u_int8_t cur_phase_ib;
	/* Description -  */
	/* 0x1c.17 - 0x1c.29 */
	 u_int16_t ffe_gain;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.0 - 0x20.0 */
	 u_int8_t init_all_gains_bad_value;
	/* Description -  */
	/* 0x20.1 - 0x20.1 */
	 u_int8_t update_single_gain_bad_value;
	/* Description -  */
	/* 0x20.2 - 0x20.2 */
	 u_int8_t monotonic_flow_height_inconsistent;
	/* Description -  */
	/* 0x20.3 - 0x20.3 */
	 u_int8_t monotonic_reached_high_limit;
	/* Description -  */
	/* 0x20.4 - 0x20.4 */
	 u_int8_t monotonic_reached_low_limit;
	/* Description -  */
	/* 0x20.5 - 0x20.12 */
	 u_int8_t area_zero_event_counter;
	/* Description -  */
	/* 0x20.13 - 0x20.20 */
	 u_int8_t sel_enc_tune_area_failure;
};

/* Description -   */
/* Size in bytes - 36 */
struct slreg_7nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - start eom measurment */
	/* 0x0.17 - 0x0.17 */
	 u_int8_t eom_en;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - eom measurment result based on the eom_mode chosen.

for EOM_MODE_FOM only bits 7:0 are used

for EOM_MODE_BIST:
Bit0: CTLE VOS
Bit1: VGA VOS
Bit2: ADC VOS
Bit3: ADC GOS
Bit4: PHOS
Bit5: ADC VOS LATCH W/R
Bit6: ADC GOS LATCH W/R
Bit7: PHOS LATCH W/R
Bit8: EOM
Bit9: EOM2 */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t eom_status;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Select EOM Mode used when EOM requested through exter
nal interface between FOM and ATE BIST PASS/FAIL tests. 
0: EOM_MODE_FOM (MEAS)
1: EOM_MODE_BIST (BIST)
2: EOM_MODE_TXFIR 
3: EOM_MODE_SIGNAL_DET */
	/* 0x8.0 - 0x8.1 */
	 u_int8_t eom_mode;
	/* Description -  */
	/* 0x8.2 - 0x8.2 */
	 u_int8_t ber_grad_inv;
	/* Description - firmware time out from fom-loop. 
timeout = 2^(t+1)+(t+1)*4*nblks_max */
	/* 0x8.3 - 0x8.5 */
	 u_int8_t fom_timeout;
	/* Description - Index control for eye select */
	/* 0x8.10 - 0x8.12 */
	 u_int8_t eye_index;
	/* Description - For the debug modes selects between Vn/Vp */
	/* 0x8.13 - 0x8.13 */
	 u_int8_t eom_vsign;
	/* Description - FOM normalization enable for VN/VP modes. 
0: normalization disabled.
1: normalization enabled. */
	/* 0x8.14 - 0x8.14 */
	 u_int8_t fom_norm_en;
	/* Description - Start value of sth during FOM_MODE_BER */
	/* 0x8.15 - 0x8.15 */
	 u_int8_t sth_start_mode;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - FOM test mode enable
applicable only for EOM_MODE_BIST */
	/* 0xc.16 - 0xc.16 */
	 u_int8_t fom_test_mode;
	/* Description - Enable the VOS threshold test mode
applicable only for EOM_MODE_BIST */
	/* 0xc.17 - 0xc.17 */
	 u_int8_t vos_test_mode;
	/* Description - Enable the Latch W/R test mode
applicable only for EOM_MODE_BIST */
	/* 0xc.18 - 0xc.18 */
	 u_int8_t latch_test_mode;
	/* Description - VREF VOS threshold test enable
applicable only for EOM_MODE_BIST */
	/* 0xc.19 - 0xc.19 */
	 u_int8_t phos_test_en;
	/* Description - FOM test mode after restore enable
applicable only for EOM_MODE_BIST */
	/* 0xc.20 - 0xc.20 */
	 u_int8_t fom_retest_mode;
	/* Description - ADC GOS latches W/R test enable
applicable only for EOM_MODE_BIST */
	/* 0xc.24 - 0xc.24 */
	 u_int8_t latch_adc_gos_test_en;
	/* Description - ADC VOS latches W/R test enable
applicable only for EOM_MODE_BIST */
	/* 0xc.25 - 0xc.25 */
	 u_int8_t latch_adc_vos_test_en;
	/* Description - PHOS Latch W/R test enable
applicable only for EOM_MODE_BIST */
	/* 0xc.26 - 0xc.26 */
	 u_int8_t latch_phos_test_en;
	/* Description - CTLE VOS test enable
applicable only for EOM_MODE_BIST */
	/* 0xc.28 - 0xc.28 */
	 u_int8_t vos_ctle_test_en;
	/* Description - VGA VOS test enable
applicable only for EOM_MODE_BIST */
	/* 0xc.29 - 0xc.29 */
	 u_int8_t vos_vga_test_en;
	/* Description - ADC GOS threshold test enable
applicable only for EOM_MODE_BIST */
	/* 0xc.30 - 0xc.30 */
	 u_int8_t gos_adc_test_en;
	/* Description - ADC VOS threshold test enable
applicable only for EOM_MODE_BIST */
	/* 0xc.31 - 0xc.31 */
	 u_int8_t vos_adc_test_en;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - ADC GOS Threshold, pass = |value| < threshold. value range 
is -16 to 15 (4-bit logic_1c)
applicable only for EOM_MODE_BIST */
	/* 0x10.0 - 0x10.4 */
	 u_int8_t adc_gos_threshold;
	/* Description - ADC VOS Threshold, pass = |value| < threshold. value range 
is -128 to 127 (7-bit logic_1c)
applicable only for EOM_MODE_BIST */
	/* 0x10.8 - 0x10.15 */
	 u_int8_t adc_vos_threshold;
	/* Description - FOM VOS Threshold, pass = value >= threshold. value range 
is 0 to 127(8-bit logic)
applicable only for EOM_MODE_BIST */
	/* 0x10.16 - 0x10.23 */
	 u_int8_t fom_threshold;
	/* Description - PHOS Threshold, pass = |value| < threshold. value range is -
16 to 15(4-bit logic_2c)
applicable only for EOM_MODE_BIST */
	/* 0x10.24 - 0x10.28 */
	 u_int8_t phos_threshold;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - CTLE VOS Threshold, pass = |value| < threshold. value range 
is -32 to 31 (5-bit logic_1c)
applicable only for EOM_MODE_BIST */
	/* 0x14.16 - 0x14.21 */
	 u_int8_t ctle_vos_threshold;
	/* Description - VGA VOS Threshold, pass = |value| < threshold. value range 
is -32 to 31(5-bit logic_1c)
applicable only for EOM_MODE_BIST */
	/* 0x14.24 - 0x14.29 */
	 u_int8_t vga_vos_threshold;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Minumum number of errors during EOM search */
	/* 0x18.0 - 0x18.7 */
	 u_int8_t nerrs_min;
	/* Description - Max Number of blocks during measurement
Number of UI: 2^(nblks_max)*32*8*Nways */
	/* 0x18.12 - 0x18.15 */
	 u_int8_t nblks_max;
	/* Description - BER sampling mode
0x0: Inverse sampling returns (nerrs, nblks)
0x1: Direct sampling (nerrs_min = inf) returns nerrs in 
eom_status
0x2: Free running error counter (nerrs_min=inf, nblks_max = 
inf) returns nerrs in eom_status
0x3: reserved */
	/* 0x18.16 - 0x18.17 */
	 u_int8_t ber_mode;
	/* Description - 0x0: EOM_GRAD_NONE
0x1: EOM_Gradient_sign - (sk) 
0x2: EOM_Gradient
0x3: EOM_Gradient_PR1_INV_slicer_BER */
	/* 0x18.18 - 0x18.19 */
	 u_int8_t eom_grad;
	/* Description -  */
	/* 0x18.20 - 0x18.20 */
	 u_int8_t pam_eye_sel;
	/* Description -  */
	/* 0x18.25 - 0x18.25 */
	 u_int8_t eom_fmr_ovrd;
	/* Description - Eye-opening frame select
0x0: Select none - OFF
0x1: Select ADC symbols
0x2: Select FFE Y symbols
0x3: Select FFE X symbols
0x4:Select DFFE Y symbols
0x5:Select DFFE X symbols */
	/* 0x18.26 - 0x18.28 */
	 u_int8_t eom_fmr_sel;
	/* Description - FOM eye mode to search
0x0: FOM_MODE_EYEC
0x1: FOM_MODE_EYEO
0x2: FOM_MODE_EYEM
0x3: FOM_MODE_BER
0x4:FOM_MODE_EYEC_VN
0x5:FOM_MODE_EYEC_VP
0x6:FOM_MODE_EYEM_VN
0x7:FOM_MODE_EYEM_VP */
	/* 0x18.29 - 0x18.31 */
	 u_int8_t fom_mode;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Delta value from pre-computed Vp init */
	/* 0x1c.0 - 0x1c.10 */
	 u_int16_t ber_v;
	/* Description - Delta value from pre-computed Vn init, -16 to 15 */
	/* 0x1c.11 - 0x1c.15 */
	 u_int8_t ber_t;
	/* Description -  */
	/* 0x1c.18 - 0x1c.23 */
	 u_int8_t ber_eye_sel;
	/* Description - Eye-opening measurement range. Step-size= min(eth[k] - 
eth[k-1])/eyeo_range */
	/* 0x1c.24 - 0x1c.26 */
	 u_int8_t eyeo_range;
	/* Description - FOM eye xk eye select */
	/* 0x1c.29 - 0x1c.31 */
	 u_int8_t ber_xk_sel;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - main sampler margin control
may insert errors. */
	/* 0x20.0 - 0x20.4 */
	 u_int8_t margin_t;
	/* Description - main sampler margin control
may insert errors. */
	/* 0x20.8 - 0x20.13 */
	 u_int8_t margin_v;
	/* Description - main sampler margin control
may insert errors. */
	/* 0x20.15 - 0x20.15 */
	 u_int8_t margin_en;
};

/* Description -   */
/* Size in bytes - 72 */
struct slreg_data_set {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.24 - 0x48.23 */
	 u_int8_t data[72];
};

/* Description -   */
/* Size in bytes - 72 */
struct slreg_usr {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Grade value */
	/* 0x0.0 - 0x0.28 */
	 u_int32_t grade;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.5 */
	 u_int8_t optimal_phase;
	/* Description - eye symmetry correction command sent to transmitter */
	/* 0x4.8 - 0x4.17 */
	 u_int16_t eye_symmetry_command;
	/* Description -  */
	/* 0x4.20 - 0x4.31 */
	 u_int16_t phase_bounds;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t amp_phase1;
	/* Description -  */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t amp_phase0;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t amp_phase3;
	/* Description -  */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t amp_phase2;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t amp_phase5;
	/* Description -  */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t amp_phase4;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t amp_phase7;
	/* Description -  */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t amp_phase6;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t amp_phase9;
	/* Description -  */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t amp_phase8;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t amp_phase11;
	/* Description -  */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t amp_phase10;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.0 - 0x20.15 */
	 u_int16_t amp_phase13;
	/* Description -  */
	/* 0x20.16 - 0x20.31 */
	 u_int16_t amp_phase12;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description -  */
	/* 0x24.0 - 0x24.15 */
	 u_int16_t amp_phase15;
	/* Description -  */
	/* 0x24.16 - 0x24.31 */
	 u_int16_t amp_phase14;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.0 - 0x28.15 */
	 u_int16_t amp_phase17;
	/* Description -  */
	/* 0x28.16 - 0x28.31 */
	 u_int16_t amp_phase16;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description -  */
	/* 0x2c.0 - 0x2c.15 */
	 u_int16_t amp_phase19;
	/* Description -  */
	/* 0x2c.16 - 0x2c.31 */
	 u_int16_t amp_phase18;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description -  */
	/* 0x30.0 - 0x30.15 */
	 u_int16_t amp_phase21;
	/* Description -  */
	/* 0x30.16 - 0x30.31 */
	 u_int16_t amp_phase20;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description -  */
	/* 0x34.0 - 0x34.15 */
	 u_int16_t amp_phase23;
	/* Description -  */
	/* 0x34.16 - 0x34.31 */
	 u_int16_t amp_phase22;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description -  */
	/* 0x38.0 - 0x38.15 */
	 u_int16_t amp_phase25;
	/* Description -  */
	/* 0x38.16 - 0x38.31 */
	 u_int16_t amp_phase24;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description -  */
	/* 0x3c.0 - 0x3c.15 */
	 u_int16_t amp_phase27;
	/* Description -  */
	/* 0x3c.16 - 0x3c.31 */
	 u_int16_t amp_phase26;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description -  */
	/* 0x40.0 - 0x40.15 */
	 u_int16_t amp_phase29;
	/* Description -  */
	/* 0x40.16 - 0x40.31 */
	 u_int16_t amp_phase28;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description -  */
	/* 0x44.0 - 0x44.15 */
	 u_int16_t amp_phase31;
	/* Description -  */
	/* 0x44.16 - 0x44.31 */
	 u_int16_t amp_phase30;
};

/* Description -   */
/* Size in bytes - 36 */
struct slrg_16nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - The lane speed on which the grade was measured:
0 - SDR / PCIe Gen 1
1 - DDR / PCIe Gen 2
2 - QDR / PCIe Gen 3
3 - FDR10 (10GE / 40GE)
4 - FDR (56GE) / PCIe Gen 4
5 - EDR (25GE / 50GE / 100GE) / PCIe Gen 5
6 - HDR (50GE / 200GE / 400GE)
7- 9 - reserved
10 - 1GE
11 - 2.5GE (XAUI)
12 - 50GE-KR4
13 - 15 - reserved */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t grade_lane_speed;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - The grade that the lane received based on a specific configu
ration.
 */
	/* 0x4.0 - 0x4.23 */
	 u_int32_t grade;
	/* Description -  */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t grade_version;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Voltage offset from eye center to the negative side of the 
upper eye. Only applicable for PAM4 signal. */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t height_eo_neg_up;
	/* Description - Voltage offset from eye center to the positive side of the upper 
eye.
Only applicable for PAM4 signal. */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t height_eo_pos_up;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Voltage offset from eye center to the positive side of the mid
dle eye. */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t height_eo_pos_mid;
	/* Description - The offset from the eye center to the negative (left) side of the 
upper eye. Only applicable for PAM4 signal. */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t phase_eo_neg_up;
	/* Description - The offset from the eye center to the positive (right) side of the 
upper eye. Only applicable for PAM4 signal. */
	/* 0xc.24 - 0xc.31 */
	 u_int8_t phase_eo_pos_up;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - The offset from the eye center to the negative (left) side of the 
middle eye. */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t phase_eo_neg_mid;
	/* Description - The offset from the eye center to the positive (right) side of the 
middle eye. */
	/* 0x10.8 - 0x10.15 */
	 u_int8_t phase_eo_pos_mid;
	/* Description - Voltage offset from eye center to the negative side of the mid
dle eye. */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t height_eo_neg_mid;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Voltage offset from eye center to the negative side of the lower 
eye. Only applicable for PAM4 signal. */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t height_eo_neg_low;
	/* Description - Voltage offset from eye center to the positive side of the lower 
eye. Only applicable for PAM4 signal. */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t height_eo_pos_low;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - 0 - Reserved
1 - Reserved
2 - EO */
	/* 0x18.0 - 0x18.3 */
	 u_int8_t phase_grade_type;
	/* Description - 0 - BER Bath
1 - 1s ratio
2 - IET (Idle Error Traffic)
3 - XOR */
	/* 0x18.4 - 0x18.7 */
	 u_int8_t height_grade_type;
	/* Description - Determine the units of phase_eo_pos and phase_eo_neg:
0 - psec
1 - ticks */
	/* 0x18.8 - 0x18.9 */
	 u_int8_t phase_units;
	/* Description - Determine the units of height_eo_pos and height_eo_neg:
0 - mV after slicer (including A2D sample)
1 - mV before slicer */
	/* 0x18.10 - 0x18.11 */
	 u_int8_t offset_units;
	/* Description - The offset from the eye center to the negative (left) side of the 
lower eye. Only applicable for PAM4 signal. */
	/* 0x18.16 - 0x18.23 */
	 u_int8_t phase_eo_neg_low;
	/* Description - The offset from the eye center to the positive (right) side of the 
lower eye. Only applicable for PAM4 signal. */
	/* 0x18.24 - 0x18.31 */
	 u_int8_t phase_eo_pos_low;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - upper eye grade */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t up_eye_grade;
	/* Description - middle eye grade */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t mid_eye_grade;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - lower eye grade */
	/* 0x20.0 - 0x20.15 */
	 u_int16_t dn_eye_grade;
};

/* Description -   */
/* Size in bytes - 36 */
struct slrg_40nm_28nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - The lane speed on which the grade was measured:
0 - SDR
1 - DDR
2 - QDR
3 - FDR10 (10GE / 40GE)
4 - FDR (56GE)
5 - EDR (25GE / 50GE / 100GE)
6 - 9 - reserved
10 - 1GE
11 - 2.5GE (XAUI)
12 - 50GE-KR4
13 - 15 - reserved */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t grade_lane_speed;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.23 */
	 u_int32_t grade;
	/* Description -  */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t grade_version;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.23 */
	 u_int32_t height_grade;
	/* Description - 0 - BER Bath
1 - 1s ratio
2 - IET
3 - XOR
 */
	/* 0x8.24 - 0x8.27 */
	 u_int8_t height_grade_type;
	/* Description - Determine the units of phase_eo_pos and phase_eo_neg:
0 - psec
1 - ticks */
	/* 0x8.28 - 0x8.29 */
	 u_int8_t phase_units;
	/* Description - Determine the units of height_eo_pos and height_eo_neg:
0 - mV after slicer (including A2D sample)
1 - mV before slicer */
	/* 0x8.30 - 0x8.31 */
	 u_int8_t offset_units;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - N/A */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t height_dv;
	/* Description - When height_grade_type = EO holds height_eo_pos */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t height_dz;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t height_sigma;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Voltage offset from eye center to the negative side. */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t height_eo_neg;
	/* Description - Voltage offset from eye center to the positive side. */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t height_eo_pos;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.23 */
	 u_int32_t phase_grade;
	/* Description - 0 - Reserved
1 - Reserved
2 - EO */
	/* 0x18.24 - 0x18.27 */
	 u_int8_t phase_grade_type;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - The offset from the eye center to the negative side. */
	/* 0x1c.0 - 0x1c.7 */
	 u_int8_t phase_eo_neg;
	/* Description - The offset from the eye center to the positive side. */
	/* 0x1c.16 - 0x1c.23 */
	 u_int8_t phase_eo_pos;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Number of bit errors measured after the tuning has com
pleted (BER). The time window for the test is defined in PTAS 
"ber_test_time". */
	/* 0x20.0 - 0x20.15 */
	 u_int16_t test_errors_per_lane;
	/* Description - The number of space search steps performed during the lane 
tuning.
0 - N/A - no search was performed. */
	/* 0x20.16 - 0x20.31 */
	 u_int16_t ffe_set_tested;
};

/* Description -   */
/* Size in bytes - 24 */
struct slrg_7nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - 0 - composite eyes
1 - composite and all three eyes
2 - upper
3 - middle
4 - lower
Note: NRZ only '0' is valid */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t fom_measurment;
	/* Description - indication that eom measurements are valid */
	/* 0x0.16 - 0x0.16 */
	 u_int8_t meas_done;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - measured EOM status after FEQ.
valid only when SLRG.status is '1' */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t initial_fom;
	/* Description - fom mode:
FOM eye mode to search
0x0: FOM_MODE_EYEC
0x1: FOM_MODE_EYEO
0x2: FOM_MODE_EYEM
0x3: FOM_MODE_BER
0x4:FOM_MODE_EYEC_VN
0x5:FOM_MODE_EYEC_VP
0x6:FOM_MODE_EYEM_VN
0x7:FOM_MODE_EYEM_VP */
	/* 0x4.16 - 0x4.18 */
	 u_int8_t fom_mode;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - last measured EOM-FOM status of lower eye.
valid only if meas_done is '1' and eom_measurment is '1' or 
'4 */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t lower_eye;
	/* Description - last measured EOM-FOM status of middle eye.
valid only if meas_done is '1' and eom_measurment is '1' or 
'3' */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t mid_eye;
	/* Description - last measured EOM-FOM status of upper eye.
valid only if meas_done is '1' and eom_measurment is '1' or 
'2' */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t upper_eye;
	/* Description - last measured EOM-FOM status of composite eye.
valid only if meas_done is '1'and eom_measurment is '0' or 
'1' */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t last_fom;
};

/* Description -   */
/* Size in bytes - 164 */
struct slrg_7nm_testing {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Number of iterations to run FOM
0 - fw default */
	/* 0x0.0 - 0x0.9 */
	 u_int16_t iterations;
	/* Description - 0 - measure not preformed
1 - measuring in progress
2 - measuring done */
	/* 0x0.16 - 0x0.18 */
	 u_int8_t status;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - FOM measurements info for lane <i>
See Table 1068, "Lane Measure Info layout," on 
page 1337. */
	/* 0x4.0 - 0x14.31 */
	 struct slrg_lane_measure_info lane0_meas_info;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x28.31 */
	 struct slrg_lane_measure_info lane1_meas_info;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description -  */
	/* 0x2c.0 - 0x3c.31 */
	 struct slrg_lane_measure_info lane2_meas_info;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description -  */
	/* 0x40.0 - 0x50.31 */
	 struct slrg_lane_measure_info lane3_meas_info;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description -  */
	/* 0x54.0 - 0x64.31 */
	 struct slrg_lane_measure_info lane4_meas_info;
/*---------------- DWORD[26] (Offset 0x68) ----------------*/
	/* Description -  */
	/* 0x68.0 - 0x78.31 */
	 struct slrg_lane_measure_info lane5_meas_info;
/*---------------- DWORD[31] (Offset 0x7c) ----------------*/
	/* Description -  */
	/* 0x7c.0 - 0x8c.31 */
	 struct slrg_lane_measure_info lane6_meas_info;
/*---------------- DWORD[36] (Offset 0x90) ----------------*/
	/* Description -  */
	/* 0x90.0 - 0xa0.31 */
	 struct slrg_lane_measure_info lane7_meas_info;
};

/* Description -   */
/* Size in bytes - 164 */
struct slrg_data_set {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.24 - 0xa4.23 */
	 u_int8_t data[164];
};

/* Description -   */
/* Size in bytes - 40 */
struct slrip_16nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - input buffer select:
0 - IB0
1 - IB1
2 - IB2
3 - IB3
4 - Active up
5 - Active mid
6 - Active down
7 - Inactive */
	/* 0x0.29 - 0x0.31 */
	 u_int8_t ib_sel;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - 9 Taps for input buffer. */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t ffe_tap3;
	/* Description - 9 Taps for input buffer. */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t ffe_tap2;
	/* Description - 9 Taps for input buffer. */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t ffe_tap1;
	/* Description - 9 Taps for input buffer. */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t ffe_tap0;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - 9 Taps for input buffer. */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t ffe_tap7;
	/* Description - 9 Taps for input buffer. */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t ffe_tap6;
	/* Description - 9 Taps for input buffer. */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t ffe_tap5;
	/* Description - 9 Taps for input buffer. */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t ffe_tap4;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.8 */
	 u_int16_t ffe_tap_en;
	/* Description - Weight for the step multiplication for mixer offset 0. */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t sel_enc0;
	/* Description - 9 Taps for input buffer. */
	/* 0xc.24 - 0xc.31 */
	 u_int8_t ffe_tap8;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t mixer_offset1;
	/* Description -  */
	/* 0x10.8 - 0x10.15 */
	 u_int8_t mixer_offset0;
	/* Description - Weight for the step multiplication for eye scan. */
	/* 0x10.16 - 0x10.23 */
	 u_int8_t sel_enc2;
	/* Description - Weight for the step multiplication for mixer offset 1. */
	/* 0x10.24 - 0x10.31 */
	 u_int8_t sel_enc1;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Tuning value of mixer_offset0 (measurement 1) */
	/* 0x14.0 - 0x14.7 */
	 u_int8_t saved1_mixer_offset0;
	/* Description - Tuning value of sel_enc0 (measurement 1) */
	/* 0x14.8 - 0x14.15 */
	 u_int8_t saved1_sel_enc0;
	/* Description - Tuning value of mixer_offset0 (measurement 0) */
	/* 0x14.16 - 0x14.23 */
	 u_int8_t saved0_mixer_offset0;
	/* Description - Tuning value of sel_enc0 (measurement 0) */
	/* 0x14.24 - 0x14.31 */
	 u_int8_t saved0_sel_enc0;
};

/* Description -   */
/* Size in bytes - 88 */
struct slrip_5nm {
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.5 */
	 u_int8_t hf_gain;
	/* Description -  */
	/* 0x8.8 - 0x8.10 */
	 u_int8_t dc_gain;
	/* Description -  */
	/* 0x8.13 - 0x8.14 */
	 u_int8_t mf_pol;
	/* Description -  */
	/* 0x8.17 - 0x8.18 */
	 u_int8_t mf_gain;
	/* Description -  */
	/* 0x8.21 - 0x8.22 */
	 u_int8_t lf_pol;
	/* Description -  */
	/* 0x8.25 - 0x8.26 */
	 u_int8_t lf_gain;
	/* Description -  */
	/* 0x8.28 - 0x8.31 */
	 u_int8_t tah_amp_gain;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.4 */
	 u_int8_t ffe_fm5;
	/* Description -  */
	/* 0xc.7 - 0xc.12 */
	 u_int8_t ffe_fm4;
	/* Description -  */
	/* 0xc.15 - 0xc.22 */
	 u_int8_t ffe_fm3;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t ffe_fm2;
	/* Description -  */
	/* 0x10.10 - 0x10.18 */
	 u_int16_t ffe_fm1;
	/* Description -  */
	/* 0x10.21 - 0x10.28 */
	 u_int8_t ffe_f1;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.7 */
	 u_int8_t ffe_f2;
	/* Description -  */
	/* 0x14.10 - 0x14.16 */
	 u_int8_t ffe_f3;
	/* Description -  */
	/* 0x14.19 - 0x14.25 */
	 u_int8_t ffe_f4;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.6 */
	 u_int8_t ffe_f5;
	/* Description -  */
	/* 0x18.9 - 0x18.14 */
	 u_int8_t ffe_f6;
	/* Description -  */
	/* 0x18.17 - 0x18.22 */
	 u_int8_t ffe_f7;
	/* Description -  */
	/* 0x18.25 - 0x18.30 */
	 u_int8_t ffe_f8;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.0 - 0x1c.5 */
	 u_int8_t ffe_f9;
	/* Description -  */
	/* 0x1c.8 - 0x1c.12 */
	 u_int8_t ffe_f10;
	/* Description -  */
	/* 0x1c.15 - 0x1c.19 */
	 u_int8_t ffe_f11;
	/* Description -  */
	/* 0x1c.22 - 0x1c.26 */
	 u_int8_t ffe_f12;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.0 - 0x20.5 */
	 u_int8_t dffe_dsel0;
	/* Description -  */
	/* 0x20.6 - 0x20.9 */
	 u_int8_t dffe_coef0;
	/* Description -  */
	/* 0x20.11 - 0x20.16 */
	 u_int8_t dffe_dsel1;
	/* Description -  */
	/* 0x20.17 - 0x20.20 */
	 u_int8_t dffe_coef1;
	/* Description -  */
	/* 0x20.22 - 0x20.27 */
	 u_int8_t dffe_dsel2;
	/* Description -  */
	/* 0x20.28 - 0x20.31 */
	 u_int8_t dffe_coef2;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description -  */
	/* 0x24.0 - 0x24.5 */
	 u_int8_t dffe_dsel3;
	/* Description -  */
	/* 0x24.6 - 0x24.9 */
	 u_int8_t dffe_coef3;
	/* Description -  */
	/* 0x24.11 - 0x24.16 */
	 u_int8_t dffe_dsel4;
	/* Description -  */
	/* 0x24.17 - 0x24.20 */
	 u_int8_t dffe_coef4;
	/* Description -  */
	/* 0x24.22 - 0x24.27 */
	 u_int8_t dffe_dsel5;
	/* Description -  */
	/* 0x24.28 - 0x24.31 */
	 u_int8_t dffe_coef5;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.0 - 0x28.5 */
	 u_int8_t dffe_dsel6;
	/* Description -  */
	/* 0x28.6 - 0x28.9 */
	 u_int8_t dffe_coef6;
	/* Description -  */
	/* 0x28.11 - 0x28.16 */
	 u_int8_t dffe_dsel7;
	/* Description -  */
	/* 0x28.17 - 0x28.20 */
	 u_int8_t dffe_coef7;
	/* Description -  */
	/* 0x28.22 - 0x28.27 */
	 u_int8_t dffe_dsel8;
	/* Description -  */
	/* 0x28.28 - 0x28.31 */
	 u_int8_t dffe_coef8;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description -  */
	/* 0x2c.0 - 0x2c.5 */
	 u_int8_t dffe_dsel9;
	/* Description -  */
	/* 0x2c.6 - 0x2c.9 */
	 u_int8_t dffe_coef9;
	/* Description -  */
	/* 0x2c.11 - 0x2c.16 */
	 u_int8_t dffe_dsel10;
	/* Description -  */
	/* 0x2c.17 - 0x2c.20 */
	 u_int8_t dffe_coef10;
	/* Description -  */
	/* 0x2c.22 - 0x2c.27 */
	 u_int8_t dffe_dsel11;
	/* Description -  */
	/* 0x2c.28 - 0x2c.31 */
	 u_int8_t dffe_coef11;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description -  */
	/* 0x30.0 - 0x30.5 */
	 u_int8_t dffe_dsel12;
	/* Description -  */
	/* 0x30.6 - 0x30.9 */
	 u_int8_t dffe_coef12;
	/* Description -  */
	/* 0x30.11 - 0x30.16 */
	 u_int8_t dffe_dsel13;
	/* Description -  */
	/* 0x30.17 - 0x30.20 */
	 u_int8_t dffe_coef13;
	/* Description -  */
	/* 0x30.22 - 0x30.27 */
	 u_int8_t dffe_dsel14;
	/* Description -  */
	/* 0x30.28 - 0x30.31 */
	 u_int8_t dffe_coef14;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description -  */
	/* 0x34.0 - 0x34.5 */
	 u_int8_t dffe_dsel15;
	/* Description -  */
	/* 0x34.6 - 0x34.9 */
	 u_int8_t dffe_coef15;
	/* Description -  */
	/* 0x34.11 - 0x34.20 */
	 u_int16_t fb_slicer_th0;
	/* Description -  */
	/* 0x34.22 - 0x34.31 */
	 u_int16_t fb_slicer_th1;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description -  */
	/* 0x38.0 - 0x38.9 */
	 u_int16_t fb_slicer_th2;
	/* Description -  */
	/* 0x38.11 - 0x38.20 */
	 u_int16_t fb_slicer_th3;
	/* Description -  */
	/* 0x38.22 - 0x38.31 */
	 u_int16_t fb_slicer_th4;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description -  */
	/* 0x3c.0 - 0x3c.9 */
	 u_int16_t fb_slicer_th5;
	/* Description -  */
	/* 0x3c.11 - 0x3c.20 */
	 u_int16_t fb_slicer_th6;
	/* Description -  */
	/* 0x3c.22 - 0x3c.31 */
	 u_int16_t fb_slicer_th7;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description -  */
	/* 0x40.0 - 0x40.9 */
	 u_int16_t fb_slicer_th8;
	/* Description -  */
	/* 0x40.11 - 0x40.20 */
	 u_int16_t fb_slicer_th9;
	/* Description -  */
	/* 0x40.22 - 0x40.31 */
	 u_int16_t fb_slicer_th10;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description -  */
	/* 0x44.0 - 0x44.9 */
	 u_int16_t fb_slicer_th11;
	/* Description -  */
	/* 0x44.11 - 0x44.20 */
	 u_int16_t fb_slicer_th12;
	/* Description -  */
	/* 0x44.22 - 0x44.31 */
	 u_int16_t ff_slicer_th0;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description -  */
	/* 0x48.0 - 0x48.9 */
	 u_int16_t ff_slicer_th1;
	/* Description -  */
	/* 0x48.11 - 0x48.20 */
	 u_int16_t ff_slicer_th2;
	/* Description -  */
	/* 0x48.22 - 0x48.31 */
	 u_int16_t ff_slicer_th3;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description -  */
	/* 0x4c.0 - 0x4c.9 */
	 u_int16_t ff_slicer_th4;
	/* Description -  */
	/* 0x4c.11 - 0x4c.20 */
	 u_int16_t ff_slicer_th5;
	/* Description -  */
	/* 0x4c.22 - 0x4c.31 */
	 u_int16_t ff_slicer_th6;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description -  */
	/* 0x50.0 - 0x50.9 */
	 u_int16_t ff_slicer_th7;
	/* Description -  */
	/* 0x50.11 - 0x50.20 */
	 u_int16_t ff_slicer_th8;
	/* Description -  */
	/* 0x50.22 - 0x50.31 */
	 u_int16_t ff_slicer_th9;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description -  */
	/* 0x54.0 - 0x54.9 */
	 u_int16_t ff_slicer_th10;
	/* Description -  */
	/* 0x54.11 - 0x54.20 */
	 u_int16_t ff_slicer_th11;
	/* Description -  */
	/* 0x54.22 - 0x54.31 */
	 u_int16_t ff_slicer_th12;
};

/* Description -   */
/* Size in bytes - 88 */
struct slrip_7nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - 0x0: Do nothing (no eq training is done).
0x1: Partial grid search over (hf_gain, dc_gain, preset) tuple.
0x2: Full grid search over (hf_gain, dc_gain, mf_gain, mf_pole, 
lf_gain, lf_pole) tuple.
0x3: Some (TBD) variant of stochastic hill climbing.
0x4: DFE only adaptation. Only for simulation purpose at this 
time. */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t feq_train_mode;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - RX-TERM attenuation mode */
	/* 0x4.0 - 0x4.1 */
	 u_int8_t term_attn_override_ctrl;
	/* Description - CTLE dc_gain mode */
	/* 0x4.2 - 0x4.3 */
	 u_int8_t dc_gain_override_ctrl;
	/* Description - CTLE lf_gain mode */
	/* 0x4.4 - 0x4.5 */
	 u_int8_t lf_gain_override_ctrl;
	/* Description - CTLE lf_pole mode */
	/* 0x4.6 - 0x4.7 */
	 u_int8_t lf_pole_override_ctrl;
	/* Description - CTLE mf_gain mode */
	/* 0x4.8 - 0x4.9 */
	 u_int8_t mf_gain_override_ctrl;
	/* Description - CTLE mf_pole mode */
	/* 0x4.10 - 0x4.11 */
	 u_int8_t mf_pole_override_ctrl;
	/* Description - CTLE hf_gain mode */
	/* 0x4.12 - 0x4.13 */
	 u_int8_t hf_gain_override_ctrl;
	/* Description - VGA mode */
	/* 0x4.14 - 0x4.15 */
	 u_int8_t vga_gain_override_ctrl;
	/* Description - dffe override mode */
	/* 0x4.20 - 0x4.21 */
	 u_int8_t dffe_override_ctrl;
	/* Description - VREF Range mode */
	/* 0x4.24 - 0x4.25 */
	 u_int8_t vref_val_mode_ctrl;
	/* Description - RX-TERM lpf mode */
	/* 0x4.28 - 0x4.29 */
	 u_int8_t term_lpf_override_ctrl;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Error Slicer Threshold, VAR_MODE_AUTO or VAR_
MODE_OVRD.
PAM4 PR1: 0b0111_0111
PAM2 PR1: 0b0000_0101
PAM2 PR0 2-tap DFE: 0b1111_1111
PAM2 PR0 1-tap DFE: 0b1010_1010
PAM2 PR0 0-tap DFE: 0b1000_1000
No Adaptation: 0b00000000 */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t eth_override_ctrl;
	/* Description - ffe pre taps override ctrl:
0 - Forced off
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x8.10 - 0x8.11 */
	 u_int8_t fm3_override_ctrl;
	/* Description - ffe pre taps override ctrl:
0 - Forced off
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x8.12 - 0x8.13 */
	 u_int8_t fm2_override_ctrl;
	/* Description - ffe pre taps override ctrl:
0 - Forced off
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x8.14 - 0x8.15 */
	 u_int8_t fm1_override_ctrl;
	/* Description - ffe post taps override ctrl:
0 - Forced off
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x8.16 - 0x8.17 */
	 u_int8_t f8_override_ctrl;
	/* Description - ffe post taps override ctrl:
0 - Forced off
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x8.18 - 0x8.19 */
	 u_int8_t f7_override_ctrl;
	/* Description - ffe post taps override ctrl:
0 - Forced off
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x8.20 - 0x8.21 */
	 u_int8_t f6_override_ctrl;
	/* Description - ffe post taps override ctrl:
0 - Forced off
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x8.22 - 0x8.23 */
	 u_int8_t f5_override_ctrl;
	/* Description - ffe post taps override ctrl:
0 - Forced off
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x8.24 - 0x8.25 */
	 u_int8_t f4_override_ctrl;
	/* Description - ffe post taps override ctrl:
0 - Forced off
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x8.26 - 0x8.27 */
	 u_int8_t f3_override_ctrl;
	/* Description - ffe post taps override ctrl:
0 - Forced off
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x8.28 - 0x8.29 */
	 u_int8_t f2_override_ctrl;
	/* Description - ffe post taps override ctrl:
0 - Forced off
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x8.30 - 0x8.31 */
	 u_int8_t f1_override_ctrl;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - CTLE mf_gain value */
	/* 0xc.0 - 0xc.2 */
	 u_int8_t dc_gain;
	/* Description - CTLE mf_pole value */
	/* 0xc.4 - 0xc.7 */
	 u_int8_t hf_gain;
	/* Description - termination attenuation */
	/* 0xc.8 - 0xc.9 */
	 u_int8_t term_attn_ctrl;
	/* Description - RX-TERM lpf enable */
	/* 0xc.12 - 0xc.12 */
	 u_int8_t term_lpf_en;
	/* Description - CTLE lf_gain value */
	/* 0xc.16 - 0xc.18 */
	 u_int8_t lf_gain;
	/* Description - CTLE lf_pole value */
	/* 0xc.20 - 0xc.22 */
	 u_int8_t lf_pole;
	/* Description - CTLE mf_gain value */
	/* 0xc.24 - 0xc.26 */
	 u_int8_t mf_gain;
	/* Description - CTLE mf_pole value */
	/* 0xc.28 - 0xc.30 */
	 u_int8_t mf_pole;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - VGA gain value */
	/* 0x10.0 - 0x10.2 */
	 u_int8_t vga_gain;
	/* Description - ADC vref value */
	/* 0x10.8 - 0x10.13 */
	 u_int8_t adc_vref_val;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - ffe pre tap values */
	/* 0x14.11 - 0x14.15 */
	 u_int8_t ffe_fm3;
	/* Description - ffe pre tap values */
	/* 0x14.17 - 0x14.23 */
	 u_int8_t ffe_fm2;
	/* Description - ffe pre tap values */
	/* 0x14.24 - 0x14.31 */
	 u_int8_t ffe_fm1;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - ffe post tap values */
	/* 0x18.0 - 0x18.7 */
	 u_int8_t ffe_f1;
	/* Description - ffe post tap values */
	/* 0x18.8 - 0x18.14 */
	 u_int8_t ffe_f2;
	/* Description - ffe post tap values */
	/* 0x18.16 - 0x18.21 */
	 u_int8_t ffe_f3;
	/* Description - ffe post tap values */
	/* 0x18.24 - 0x18.29 */
	 u_int8_t ffe_f4;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - ffe post tap values */
	/* 0x1c.0 - 0x1c.5 */
	 u_int8_t ffe_f5;
	/* Description - ffe post tap values */
	/* 0x1c.8 - 0x1c.12 */
	 u_int8_t ffe_f6;
	/* Description - ffe post tap values */
	/* 0x1c.16 - 0x1c.20 */
	 u_int8_t ffe_f7;
	/* Description - ffe post tap values */
	/* 0x1c.24 - 0x1c.27 */
	 u_int8_t ffe_f8;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - dffe co-efficient 0 */
	/* 0x20.0 - 0x20.3 */
	 u_int8_t dffe_coef0;
	/* Description - dffe mux0 sel */
	/* 0x20.4 - 0x20.6 */
	 u_int8_t dffe_dsel0;
	/* Description - dffe co-efficient 1 */
	/* 0x20.8 - 0x20.11 */
	 u_int8_t dffe_coef1;
	/* Description - dffe mux1 sel */
	/* 0x20.12 - 0x20.14 */
	 u_int8_t dffe_dsel1;
	/* Description - dffe co-efficient 2 */
	/* 0x20.16 - 0x20.19 */
	 u_int8_t dffe_coef2;
	/* Description - dffe mux2 sel */
	/* 0x20.20 - 0x20.22 */
	 u_int8_t dffe_dsel2;
	/* Description - dffe co-efficient 3 */
	/* 0x20.24 - 0x20.27 */
	 u_int8_t dffe_coef3;
	/* Description - dffe mux3 sel */
	/* 0x20.28 - 0x20.30 */
	 u_int8_t dffe_dsel3;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - dffe co-efficient 4 */
	/* 0x24.0 - 0x24.3 */
	 u_int8_t dffe_coef4;
	/* Description - dffe mux4 sel */
	/* 0x24.4 - 0x24.6 */
	 u_int8_t dffe_dsel4;
	/* Description - dffe co-efficient 5 */
	/* 0x24.8 - 0x24.11 */
	 u_int8_t dffe_coef5;
	/* Description - dffe mux5 sel */
	/* 0x24.12 - 0x24.14 */
	 u_int8_t dffe_dsel5;
	/* Description - dffe co-efficient 6 */
	/* 0x24.16 - 0x24.19 */
	 u_int8_t dffe_coef6;
	/* Description - dffe mux6 sel */
	/* 0x24.20 - 0x24.22 */
	 u_int8_t dffe_dsel6;
	/* Description - dffe co-efficient 7 */
	/* 0x24.24 - 0x24.27 */
	 u_int8_t dffe_coef7;
	/* Description - dffe mux7 sel */
	/* 0x24.28 - 0x24.30 */
	 u_int8_t dffe_dsel7;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - dffe co-efficient 8 */
	/* 0x28.0 - 0x28.3 */
	 u_int8_t dffe_coef8;
	/* Description - dffe mux8 sel */
	/* 0x28.4 - 0x28.8 */
	 u_int8_t dffe_dsel8;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description -  */
	/* 0x2c.0 - 0x2c.10 */
	 u_int16_t th0;
	/* Description -  */
	/* 0x2c.16 - 0x2c.26 */
	 u_int16_t th1;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description -  */
	/* 0x30.0 - 0x30.10 */
	 u_int16_t th2;
	/* Description -  */
	/* 0x30.16 - 0x30.26 */
	 u_int16_t th3;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description -  */
	/* 0x34.0 - 0x34.10 */
	 u_int16_t th4;
	/* Description -  */
	/* 0x34.16 - 0x34.26 */
	 u_int16_t th5;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description -  */
	/* 0x38.0 - 0x38.10 */
	 u_int16_t th6;
	/* Description -  */
	/* 0x38.16 - 0x38.26 */
	 u_int16_t th7;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description -  */
	/* 0x3c.0 - 0x3c.10 */
	 u_int16_t th8;
	/* Description -  */
	/* 0x3c.16 - 0x3c.26 */
	 u_int16_t th9;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description -  */
	/* 0x40.0 - 0x40.10 */
	 u_int16_t th10;
	/* Description -  */
	/* 0x40.16 - 0x40.26 */
	 u_int16_t th11;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description -  */
	/* 0x44.0 - 0x44.10 */
	 u_int16_t th12;
	/* Description -  */
	/* 0x44.16 - 0x44.26 */
	 u_int16_t th13;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description -  */
	/* 0x48.0 - 0x48.10 */
	 u_int16_t th14;
	/* Description -  */
	/* 0x48.16 - 0x48.26 */
	 u_int16_t th15;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description -  */
	/* 0x4c.0 - 0x4c.10 */
	 u_int16_t th16;
	/* Description -  */
	/* 0x4c.16 - 0x4c.26 */
	 u_int16_t th17;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description -  */
	/* 0x50.0 - 0x50.10 */
	 u_int16_t th18;
	/* Description -  */
	/* 0x50.16 - 0x50.26 */
	 u_int16_t th19;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description -  */
	/* 0x54.0 - 0x54.10 */
	 u_int16_t th20;
	/* Description -  */
	/* 0x54.16 - 0x54.26 */
	 u_int16_t th21;
};

/* Description -   */
/* Size in bytes - 88 */
struct slrip_data_set {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.24 - 0x58.23 */
	 u_int8_t data[88];
};

/* Description -   */
/* Size in bytes - 28 */
struct slrp_16nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Datapath select, indicates the input buffer that will not be 
active in the data path.
0 - Up
1 - Mid
2 - Down
3 - None 
Note: for a change, need to return to default settings, and only 
after that the new selection will take a place.
Note: PCIe uses NRZ thus, only the middle input buffer is 
used. All options of 0-2 should trigger the same result (same 
as '1'- Mid). */
	/* 0x0.0 - 0x0.1 */
	 u_int8_t dp_sel;
	/* Description -  */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t sel_enc;
	/* Description -  */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t mixer_offset_down;
	/* Description -  */
	/* 0x0.24 - 0x0.31 */
	 u_int8_t mixer_offset_up;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.3 */
	 u_int8_t sel_ref_out_mixer_biasgen_eo;
	/* Description -  */
	/* 0x4.4 - 0x4.7 */
	 u_int8_t sel_ref_out_mixer_biasgen_down;
	/* Description -  */
	/* 0x4.8 - 0x4.11 */
	 u_int8_t sel_ref_out_mixer_biasgen_mid;
	/* Description -  */
	/* 0x4.12 - 0x4.15 */
	 u_int8_t sel_ref_out_mixer_biasgen_up;
	/* Description -  */
	/* 0x4.16 - 0x4.19 */
	 u_int8_t sel_ref_in_mixer_biasgen_eo;
	/* Description -  */
	/* 0x4.20 - 0x4.23 */
	 u_int8_t sel_ref_in_mixer_biasgen_down;
	/* Description -  */
	/* 0x4.24 - 0x4.27 */
	 u_int8_t sel_ref_in_mixer_biasgen_mid;
	/* Description -  */
	/* 0x4.28 - 0x4.31 */
	 u_int8_t sel_ref_in_mixer_biasgen_up;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Number of parallel resistors for peaking control (replica), p/n 
same values. */
	/* 0x8.0 - 0x8.3 */
	 u_int8_t gctrl_bin_bgn1_p;
	/* Description - Number of parallel resistors for peaking control (replica), p/n 
same values. */
	/* 0x8.4 - 0x8.7 */
	 u_int8_t gctrl_bin_bgn1_n;
	/* Description - Number of parallel resistors for peaking control (replica), p/n 
same values. */
	/* 0x8.8 - 0x8.11 */
	 u_int8_t gctrl_bin_bgn0_p;
	/* Description - Number of parallel resistors for peaking control (replica), p/n 
same values. */
	/* 0x8.12 - 0x8.15 */
	 u_int8_t gctrl_bin_bgn0_n;
	/* Description -  */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t mixer_offset_eye_scan;
	/* Description -  */
	/* 0x8.24 - 0x8.25 */
	 u_int8_t sel_amp_mixer_biasgen_eo;
	/* Description -  */
	/* 0x8.26 - 0x8.27 */
	 u_int8_t sel_amp_mixer_biasgen_down;
	/* Description -  */
	/* 0x8.28 - 0x8.29 */
	 u_int8_t sel_amp_mixer_biasgen_mid;
	/* Description -  */
	/* 0x8.30 - 0x8.31 */
	 u_int8_t sel_amp_mixer_biasgen_up;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0xc.2 - 0xc.5 */
	 u_int8_t sel_bias_en_2;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0xc.6 - 0xc.9 */
	 u_int8_t sel_bias_en_1;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0xc.10 - 0xc.13 */
	 u_int8_t sel_bias_en_0;
	/* Description - Determines peaking, higher value means less peaking. */
	/* 0xc.14 - 0xc.18 */
	 u_int8_t selgc_ref_op1_alev_ctle;
	/* Description - Determines peaking, higher value means less peaking. */
	/* 0xc.19 - 0xc.23 */
	 u_int8_t selgc_ref_op0_alev_ctle;
	/* Description - Selects which group goes to picking control.
Bit per stage. */
	/* 0xc.24 - 0xc.30 */
	 u_int8_t sel_bias2ctle;
	/* Description - 0 - Analog control
1 - Digital control */
	/* 0xc.31 - 0xc.31 */
	 u_int8_t sel_digital_gctrl;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x10.3 - 0x10.6 */
	 u_int8_t sel_gctrln_en_2;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x10.7 - 0x10.10 */
	 u_int8_t sel_gctrln_en_1;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x10.11 - 0x10.14 */
	 u_int8_t sel_gctrln_en_0;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x10.15 - 0x10.19 */
	 u_int8_t sel_bias_en_6;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x10.20 - 0x10.23 */
	 u_int8_t sel_bias_en_5;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x10.24 - 0x10.27 */
	 u_int8_t sel_bias_en_4;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x10.28 - 0x10.31 */
	 u_int8_t sel_bias_en_3;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x14.0 - 0x14.3 */
	 u_int8_t sel_gctrlp_en_3;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x14.4 - 0x14.7 */
	 u_int8_t sel_gctrlp_en_2;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x14.8 - 0x14.11 */
	 u_int8_t sel_gctrlp_en_1;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x14.12 - 0x14.15 */
	 u_int8_t sel_gctrlp_en_0;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x14.16 - 0x14.19 */
	 u_int8_t sel_gctrln_en_6;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x14.20 - 0x14.23 */
	 u_int8_t sel_gctrln_en_5;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x14.24 - 0x14.27 */
	 u_int8_t sel_gctrln_en_4;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x14.28 - 0x14.31 */
	 u_int8_t sel_gctrln_en_3;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Offset of biasgen_n0 */
	/* 0x18.0 - 0x18.4 */
	 u_int8_t crnt_bgn_offset_n0;
	/* Description - Offset of biasgen_p0 */
	/* 0x18.5 - 0x18.9 */
	 u_int8_t crnt_bgn_offset_p0;
	/* Description - Offset of biasgen_n1 */
	/* 0x18.10 - 0x18.14 */
	 u_int8_t crnt_bgn_offset_n1;
	/* Description - Offset of biasgen_p1 */
	/* 0x18.15 - 0x18.19 */
	 u_int8_t crnt_bgn_offset_p1;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x18.20 - 0x18.23 */
	 u_int8_t sel_gctrlp_en_6;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x18.24 - 0x18.27 */
	 u_int8_t sel_gctrlp_en_5;
	/* Description - CTLE stage gain.
Higher value means higher gain.
1-16 stages in parallel. */
	/* 0x18.28 - 0x18.31 */
	 u_int8_t sel_gctrlp_en_4;
};

/* Description -   */
/* Size in bytes - 36 */
struct slrp_40nm_28nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t mix90phase;
	/* Description -  */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t dp90sel;
	/* Description - datapath select, indicates the input buffer connected to the 
data path. */
	/* 0x0.12 - 0x0.12 */
	 u_int8_t dp_sel;
	/* Description - input buffer select:
0 - Active
1 - Inactive
2 - IB0
3 - IB1 */
	/* 0x0.30 - 0x0.31 */
	 u_int8_t ib_sel;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t ffe_tap3;
	/* Description -  */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t ffe_tap2;
	/* Description -  */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t ffe_tap1;
	/* Description -  */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t ffe_tap0;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t ffe_tap7;
	/* Description -  */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t ffe_tap6;
	/* Description -  */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t ffe_tap5;
	/* Description -  */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t ffe_tap4;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.8 */
	 u_int16_t ffe_tap_en;
	/* Description -  */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t mixerbias_tap_amp;
	/* Description -  */
	/* 0xc.24 - 0xc.31 */
	 u_int8_t ffe_tap8;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t slicer_offset0;
	/* Description -  */
	/* 0x10.16 - 0x10.23 */
	 u_int8_t ffe_tap_offset1;
	/* Description -  */
	/* 0x10.24 - 0x10.31 */
	 u_int8_t ffe_tap_offset0;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t mixer_offset1;
	/* Description -  */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t mixer_offset0;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.7 */
	 u_int8_t mixerbgn_refn;
	/* Description -  */
	/* 0x18.8 - 0x18.15 */
	 u_int8_t mixerbgn_refp;
	/* Description -  */
	/* 0x18.16 - 0x18.23 */
	 u_int8_t mixerbgn_inn;
	/* Description -  */
	/* 0x18.24 - 0x18.31 */
	 u_int8_t mixerbgn_inp;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.0 - 0x1c.7 */
	 u_int8_t mixer_offset_cm1;
	/* Description -  */
	/* 0x1c.8 - 0x1c.15 */
	 u_int8_t lctrl_input;
	/* Description -  */
	/* 0x1c.16 - 0x1c.23 */
	 u_int8_t slicer_gctrl;
	/* Description -  */
	/* 0x1c.24 - 0x1c.28 */
	 u_int8_t ref_mixer_vreg;
	/* Description -  */
	/* 0x1c.30 - 0x1c.30 */
	 u_int8_t sel_slicer_lctrl_l;
	/* Description -  */
	/* 0x1c.31 - 0x1c.31 */
	 u_int8_t sel_slicer_lctrl_h;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.0 - 0x20.8 */
	 u_int16_t slicer_offset_cm;
	/* Description -  */
	/* 0x20.16 - 0x20.24 */
	 u_int16_t mixer_offset_cm0;
	/* Description -  */
	/* 0x20.26 - 0x20.31 */
	 u_int8_t common_mode;
};

/* Description -   */
/* Size in bytes - 148 */
struct slrp_5nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.6 */
	 u_int8_t ctle_vos_aux;
	/* Description -  */
	/* 0x0.9 - 0x0.15 */
	 u_int8_t ctle_vos_stg1;
	/* Description - CTLE voltage offset */
	/* 0x0.18 - 0x0.24 */
	 u_int8_t ctle_vos_val;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.4 */
	 u_int8_t coarse_val;
	/* Description -  */
	/* 0x4.6 - 0x4.10 */
	 u_int8_t fine_val;
	/* Description -  */
	/* 0x4.12 - 0x4.14 */
	 u_int8_t fixed_val;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - track and hold voltage offset */
	/* 0x8.24 - 0x18.23 */
	 u_int8_t tah_vos[16];
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - adc voltage offset */
	/* 0x18.24 - 0x28.23 */
	 u_int8_t adc_vos[16];
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - adc gain voltage offset */
	/* 0x28.24 - 0x38.23 */
	 u_int8_t adc_gos[16];
};

/* Description -   */
/* Size in bytes - 52 */
struct slrp_7nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Control the RxCAL at initial or continuous phase
0x0: RXCAL IDLE
0x1: initial phase
0x2: continuous phase */
	/* 0x0.0 - 0x0.1 */
	 u_int8_t vos_phase;
	/* Description - 0x0: Continous Calibration skipped 
0x1: Continous Calibration performs ADC-VOS only
0x2: Continous Calibration performs BLW only 
0x3:Continous Calibration performs ADC-VOS and BLWC only
0x4: Continous Calibration performs ADC-GOS only
0x7: Continous Calibration performs all */
	/* 0x0.4 - 0x0.6 */
	 u_int8_t ccal_mode;
	/* Description - ADC_GAIN shift en after FCAL */
	/* 0x0.8 - 0x0.8 */
	 u_int8_t adc_gain_shift_auto;
	/* Description - enable EDGE VOS calibraion at CCAL */
	/* 0x0.9 - 0x0.9 */
	 u_int8_t edge_vos_ccal_en;
	/* Description - page revision number */
	/* 0x0.28 - 0x0.31 */
	 u_int8_t rev;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - CCAL op state:
0x0:OFF
0x1:NOP
0x2: INIT
0x3:START */
	/* 0x4.0 - 0x4.1 */
	 u_int8_t ccal_op;
	/* Description - CCAL state
0x0:IDLE
0x1:START
0x2: ON
0x3:ABORT */
	/* 0x4.4 - 0x4.5 */
	 u_int8_t ccal_state;
	/* Description - calibration error count */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t cal_error_cnt;
	/* Description - override mode control.
0 - Forced off (DFE) or manual (CTLE)
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x4.22 - 0x4.23 */
	 u_int8_t phos_override_ctrl;
	/* Description - override mode control.
0 - Forced off (DFE) or manual (CTLE)
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x4.24 - 0x4.25 */
	 u_int8_t adc_gain_override_ctrl;
	/* Description - override mode control.
0 - Forced off (DFE) or manual (CTLE)
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x4.26 - 0x4.27 */
	 u_int8_t adc_vos_override_ctrl;
	/* Description - override mode control.
0 - Forced off (DFE) or manual (CTLE)
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x4.28 - 0x4.29 */
	 u_int8_t vga_override_ctrl;
	/* Description - override mode control.
0 - Forced off (DFE) or manual (CTLE)
1 - Update the internal AE value with the external value
2 - Hold the internal AE value constant during AE adaptation
3 - Allow the variable to adapt as needed based on their 
respective sequencer */
	/* 0x4.30 - 0x4.31 */
	 u_int8_t ctle_override_ctrl;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - CTLE VOS LUT0 value for ctx0 */
	/* 0x8.0 - 0x8.5 */
	 u_int8_t ctle_ctx0_vos0;
	/* Description - CTLE VOS LUT0 value for ctx0 */
	/* 0x8.8 - 0x8.13 */
	 u_int8_t ctle_ctx0_vos1;
	/* Description - CTLE VOS LUT0 value for ctx0 */
	/* 0x8.16 - 0x8.21 */
	 u_int8_t ctle_ctx0_vos2;
	/* Description - CTLE VOS LUT0 value for ctx0 */
	/* 0x8.24 - 0x8.29 */
	 u_int8_t ctle_ctx0_vos3;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - CTLE VOS LUT0 value for ctx1 */
	/* 0xc.0 - 0xc.5 */
	 u_int8_t ctle_ctx1_vos0;
	/* Description - CTLE VOS LUT0 value for ctx1 */
	/* 0xc.8 - 0xc.13 */
	 u_int8_t ctle_ctx1_vos1;
	/* Description - CTLE VOS LUT0 value for ctx1 */
	/* 0xc.16 - 0xc.21 */
	 u_int8_t ctle_ctx1_vos2;
	/* Description - CTLE VOS LUT0 value for ctx1 */
	/* 0xc.24 - 0xc.29 */
	 u_int8_t ctle_ctx1_vos3;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - CTLE VOS LUT0 value for ctx2 */
	/* 0x10.0 - 0x10.5 */
	 u_int8_t ctle_ctx2_vos0;
	/* Description - CTLE VOS LUT0 value for ctx2 */
	/* 0x10.8 - 0x10.13 */
	 u_int8_t ctle_ctx2_vos1;
	/* Description - CTLE VOS LUT0 value for ctx2 */
	/* 0x10.16 - 0x10.21 */
	 u_int8_t ctle_ctx2_vos2;
	/* Description - CTLE VOS LUT0 value for ctx2 */
	/* 0x10.24 - 0x10.29 */
	 u_int8_t ctle_ctx2_vos3;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - VGA VOS LUT0 value of ctx0 */
	/* 0x14.0 - 0x14.5 */
	 u_int8_t vga_ctx0_vos0;
	/* Description - VGA VOS LUT0 value of ctx0 */
	/* 0x14.8 - 0x14.13 */
	 u_int8_t vga_ctx0_vos1;
	/* Description - VGA VOS LUT0 value of ctx1 */
	/* 0x14.16 - 0x14.21 */
	 u_int8_t vga_ctx1_vos0;
	/* Description - VGA VOS LUT0 value of ctx1 */
	/* 0x14.24 - 0x14.29 */
	 u_int8_t vga_ctx1_vos1;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - VGA VOS LUT0 value of ctx2 */
	/* 0x18.0 - 0x18.5 */
	 u_int8_t vga_ctx2_vos0;
	/* Description - VGA VOS LUT0 value of ctx2 */
	/* 0x18.8 - 0x18.13 */
	 u_int8_t vga_ctx2_vos1;
	/* Description - PHOS value */
	/* 0x18.25 - 0x18.29 */
	 u_int8_t phos;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - ADC VOS value */
	/* 0x1c.0 - 0x1c.7 */
	 u_int8_t adc0_vos_cal_val;
	/* Description - ADC VOS value */
	/* 0x1c.8 - 0x1c.15 */
	 u_int8_t adc1_vos_cal_val;
	/* Description - ADC VOS value */
	/* 0x1c.16 - 0x1c.23 */
	 u_int8_t adc2_vos_cal_val;
	/* Description - ADC VOS value */
	/* 0x1c.24 - 0x1c.31 */
	 u_int8_t adc3_vos_cal_val;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - ADC VOS value */
	/* 0x20.0 - 0x20.7 */
	 u_int8_t adc4_vos_cal_val;
	/* Description - ADC VOS value */
	/* 0x20.8 - 0x20.15 */
	 u_int8_t adc5_vos_cal_val;
	/* Description - ADC VOS value */
	/* 0x20.16 - 0x20.23 */
	 u_int8_t adc6_vos_cal_val;
	/* Description - ADC VOS value */
	/* 0x20.24 - 0x20.31 */
	 u_int8_t adc7_vos_cal_val;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - ADC gain VOS value */
	/* 0x24.0 - 0x24.7 */
	 u_int8_t adc0_gain_cal_val;
	/* Description - ADC gain VOS value */
	/* 0x24.8 - 0x24.15 */
	 u_int8_t adc1_gain_cal_val;
	/* Description - ADC gain VOS value */
	/* 0x24.16 - 0x24.23 */
	 u_int8_t adc2_gain_cal_val;
	/* Description - ADC gain VOS value */
	/* 0x24.24 - 0x24.31 */
	 u_int8_t adc3_gain_cal_val;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - ADC gain VOS value */
	/* 0x28.0 - 0x28.7 */
	 u_int8_t adc4_gain_cal_val;
	/* Description - ADC gain VOS value */
	/* 0x28.8 - 0x28.15 */
	 u_int8_t adc5_gain_cal_val;
	/* Description - ADC gain VOS value */
	/* 0x28.16 - 0x28.23 */
	 u_int8_t adc6_gain_cal_val;
	/* Description - ADC gain VOS value */
	/* 0x28.24 - 0x28.31 */
	 u_int8_t adc7_gain_cal_val;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - PHOS value */
	/* 0x2c.0 - 0x2c.4 */
	 u_int8_t phos0;
	/* Description - PHOS value */
	/* 0x2c.8 - 0x2c.12 */
	 u_int8_t phos1;
	/* Description - PHOS value */
	/* 0x2c.16 - 0x2c.20 */
	 u_int8_t phos2;
	/* Description - PHOS value */
	/* 0x2c.24 - 0x2c.28 */
	 u_int8_t phos3;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - PHOS value */
	/* 0x30.0 - 0x30.4 */
	 u_int8_t phos4;
	/* Description - PHOS value */
	/* 0x30.8 - 0x30.12 */
	 u_int8_t phos5;
	/* Description - PHOS value */
	/* 0x30.16 - 0x30.20 */
	 u_int8_t phos6;
	/* Description - PHOS value */
	/* 0x30.24 - 0x30.28 */
	 u_int8_t phos7;
};

/* Description -   */
/* Size in bytes - 148 */
struct slrp_data_set {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.24 - 0x94.23 */
	 u_int8_t data[148];
};

/* Description -   */
/* Size in bytes - 32 */
struct slrp_gearbox {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - One of the 32 FFE sub-channels */
	/* 0x0.0 - 0x0.4 */
	 u_int8_t ffe_sub_channel;
	/* Description - 0: Pre-cursor 3 tap index
1: Pre-cursor 2 tap index
2: Pre-cursor 1tap index
3: Main cursor tap index
4: Post-cursor 1 tap index
5: Post-cursor 2 tap index
6: Post-cursor 3 tap index
7: Post-cursor 4 tap index
8: Post-cursor 5 tap index
9: Post-cursor 6 tap index */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t ffe_tap_index;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t ctle;
	/* Description -  */
	/* 0x4.16 - 0x4.19 */
	 u_int8_t afe_trim;
	/* Description -  */
	/* 0x4.23 - 0x4.26 */
	 u_int8_t dsp_mode;
	/* Description - SNR monitor enable. */
	/* 0x4.31 - 0x4.31 */
	 u_int8_t snr_en;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - SNR symbol count
0: 2^10 blocks
1: 2^13 blocks
2: 2^16 blocks
3: 2^19 blocks
4: Default */
	/* 0x8.0 - 0x8.2 */
	 u_int8_t snr_sym_cnt;
	/* Description - The point where the error signal is generated from in the dat
apath
1: Prior to the reflection cancellor block
2: After the reflection cancellor block
3: Default */
	/* 0x8.8 - 0x8.9 */
	 u_int8_t dsp_err_gen;
	/* Description - Raw SNR Value */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t raw_snr_value;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - SNR Value in mili-dB units */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t db_snr_value;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t ffe_tap_value;
};

/* Description -   */
/* Size in bytes - 32 */
struct slrp_usr {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.14 - 0x0.17 */
	 u_int8_t termination;
	/* Description -  */
	/* 0x0.18 - 0x0.24 */
	 u_int8_t mixer90;
	/* Description -  */
	/* 0x0.25 - 0x0.31 */
	 u_int8_t mixer00;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.4 */
	 u_int8_t amp_vga_last_stage;
	/* Description -  */
	/* 0x4.8 - 0x4.12 */
	 u_int8_t amp_vga;
	/* Description -  */
	/* 0x4.20 - 0x4.20 */
	 u_int8_t offset_fine_polarity_dn;
	/* Description -  */
	/* 0x4.21 - 0x4.21 */
	 u_int8_t offset_fine_polarity_mid;
	/* Description -  */
	/* 0x4.22 - 0x4.22 */
	 u_int8_t offset_fine_polarity_up;
	/* Description -  */
	/* 0x4.23 - 0x4.23 */
	 u_int8_t offset_coarse_polarity_dn;
	/* Description -  */
	/* 0x4.24 - 0x4.24 */
	 u_int8_t offset_coarse_polarity_mid;
	/* Description -  */
	/* 0x4.25 - 0x4.25 */
	 u_int8_t offset_coarse_polarity_up;
	/* Description - Negative capacitance for downinput buffer */
	/* 0x4.26 - 0x4.27 */
	 u_int8_t neg_cap_dn;
	/* Description - Negative capacitance for middle input buffer */
	/* 0x4.28 - 0x4.29 */
	 u_int8_t neg_cap_mid;
	/* Description - Negative capacitance for up input buffer */
	/* 0x4.30 - 0x4.31 */
	 u_int8_t neg_cap_up;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.2 - 0x8.5 */
	 u_int8_t offset_fine_dn;
	/* Description -  */
	/* 0x8.6 - 0x8.9 */
	 u_int8_t offset_fine_mid;
	/* Description -  */
	/* 0x8.10 - 0x8.13 */
	 u_int8_t offset_fine_up;
	/* Description -  */
	/* 0x8.14 - 0x8.19 */
	 u_int8_t offset_coarse_dn;
	/* Description -  */
	/* 0x8.20 - 0x8.25 */
	 u_int8_t offset_coarse_mid;
	/* Description -  */
	/* 0x8.26 - 0x8.31 */
	 u_int8_t offset_coarse_up;
};

/* Description -   */
/* Size in bytes - 24 */
struct sltp_16nm {
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Value of each tap is between -96 to 96

NOTE: The total sum of all absolute taps values should be 96 
or smaller.
 */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t post_tap;
	/* Description - Value of each tap is between -96 to 96

NOTE: The total sum of all absolute taps values should be 96 
or smaller.
 */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t main_tap;
	/* Description - Value of each tap is between -96 to 96

NOTE: The total sum of all absolute taps values should be 96 
or smaller.
 */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t pre_tap;
	/* Description - Value of each tap is between -96 to 96

NOTE: The total sum of all absolute taps values should be 96 
or smaller.
 */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t pre_2_tap;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Output common mode. Values can be set in the range of (0-
30) */
	/* 0x8.0 - 0x8.4 */
	 u_int8_t ob_alev_out;
	/* Description - Output amplitude. Values can be set in the range of (10-100). */
	/* 0x8.8 - 0x8.14 */
	 u_int8_t ob_amp;
	/* Description - MSB to LSB proportion. 
Values can be set between -10 to 50. 

MSB emphasis achieved when value is between -10 to -1 
LSB emphasis achieved when value is between 1 to 50. 
When set to 0 - equal proportion. */
	/* 0x8.25 - 0x8.31 */
	 u_int8_t ob_m2lp;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Bitmask for bad 'set' status:
0: configuration_warning - taps values can't be set to serdes 
due to internal limitations. Actual TX configuration is modify 
internally with the same sum of taps weight.
11: Illegal_ob_combination - ob_m2lp, ob_amp and ob_alev 
is in legal range each, but the total combination can't be set 
to serdes due to internal limitations, the Set command is 
ignored.
12: Illegal_ob_m2lp
13: Illegal_ob_amp
14: Illegal_ob_alev_out
15: Illegal_taps

Bit 12-0 - Reserved /Unknown */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t ob_bad_stat;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - [Internal]:Values can be set in the range of (0-200). */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t regp_bfm1n;
	/* Description - [Internal]:Values can be set in the range of (0-200). */
	/* 0x10.8 - 0x10.15 */
	 u_int8_t regn_bfm1p;
	/* Description - [Internal]:Values can be set in the range of (0-200). */
	/* 0x10.16 - 0x10.23 */
	 u_int8_t obnlev;
	/* Description - [Internal]:Values can be set in the range of (0-200). */
	/* 0x10.24 - 0x10.31 */
	 u_int8_t obplev;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - [Internal]:Values can be set in the range of (0-28). */
	/* 0x14.0 - 0x14.5 */
	 u_int8_t alev_minus_bfm2;
	/* Description - [Internal]:Values can be set in the range of (0-28). */
	/* 0x14.6 - 0x14.11 */
	 u_int8_t alev_plus_bfm2;
	/* Description -  */
	/* 0x14.12 - 0x14.16 */
	 u_int8_t tx_alev;
	/* Description -  */
	/* 0x14.25 - 0x14.31 */
	 u_int8_t blev;
};

/* Description -   */
/* Size in bytes - 16 */
struct sltp_28nm_40nm {
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t ob_tap2;
	/* Description -  */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t ob_tap1;
	/* Description -  */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t ob_tap0;
	/* Description - Tx lane polarity */
	/* 0x4.24 - 0x4.24 */
	 u_int8_t polarity;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t ob_bias;
	/* Description - (ref_txcml100_reg) */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t ob_reg;
	/* Description - Concatenation of taps polarity + preemp_sel */
	/* 0x8.16 - 0x8.19 */
	 u_int8_t ob_preemp_mode;
	/* Description -  */
	/* 0x8.20 - 0x8.23 */
	 u_int8_t ob_leva;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Bitmask for bad SET status:
Bit 0 - Illegal ob_bais value
Bit 1 - Illegal ob taps polarity (distance between taps) */
	/* 0xc.29 - 0xc.30 */
	 u_int8_t ob_bad_stat;
	/* Description - OB Normalization status:
0 - No Normalization was done
1 - Normalization performed */
	/* 0xc.31 - 0xc.31 */
	 u_int8_t ob_norm;
};

/* Description -   */
/* Size in bytes - 72 */
struct sltp_5nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Bitmask for bad 'set' status:
Bit 0: tap0_is_out_of_range
Bit 1: tap1_is_out_of_range
Bit 2: tap2_is_out_of_range
Bit 3: tap3_is_out_of_range
Bit 4: tap4_is_out_of_range
Bit 5: tap5_is_out_of_range
Bit 6: tap6_is_out_of_range
Bit 7: tap7_is_out_of_range
Bit 8: tap8_is_out_of_range
Bit 9: tap9_is_out_of_range
Bit 10: tap10_is_out_of_range
Bit 11: tap11_is_out_of_range
Bit 9: sum_of_taps_is_out_of_range
Bit 10: taps_not_alinged_with_speed */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t ob_bad_stat;
	/* Description - High speed output driver amplitude settings, default = 6"d63.
 amplitude scaling = (AMP+1) / 64 */
	/* 0x0.24 - 0x0.29 */
	 u_int8_t drv_amp;
	/* Description - physical Tx lane polarity admin configuration
0: use ini default
1: no polarity flip
2: flip polarity */
	/* 0x0.30 - 0x0.31 */
	 u_int8_t ph_pol_admin;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t tap0;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t tap1;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t tap2;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t tap3;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t tap4;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t tap5;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t tap6;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t tap7;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0xc.0 - 0xc.7 */
	 u_int8_t tap8;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0xc.8 - 0xc.15 */
	 u_int8_t tap9;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t tap10;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/63.
For 200G per lane 12 taps, taps0-3 -> pre; taps4 -> main tap; 
taps5-11 -> post
Valid values for taps:
main [34,63]
pre [-16,16]
post [-16,16]
for 100G per lane 5 taps (tap0 (pre3), tap1(pre2), tap2(pre1), tap3(main), tap4(post1) )
For 50G per lane 4 taps are used (no pre3)
For 25G per lane 3 taps are used (no pre3,pre2)
Valid values for taps:
fir_main [34,63]
fir_pre1 [-23,0]
fir_pre2 [0,8]
fir_pre3 [-5,0]
fir_post1 [-21,0]

Need to guarantee that the sum of the coefficient magnitude equals sum |c(i)| <= 63.
NRZ speeds must guarantee sum|c(i)| = 63
Note: Configured taps may get effective value of +/-1 from the value that has been set. */
	/* 0xc.24 - 0xc.31 */
	 u_int8_t tap11;
};

/* Description -   */
/* Size in bytes - 24 */
struct sltp_7nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/100.
for 100G per lane 5 taps, for 50G per lane 4 taps are used (no 
pre3)
Valid values for taps:
fir_main [54,100]
fir_pre1 [-34,0]
fir_pre2 [0,12]
fir_pre3 [-6,0]
fir_post1 [-20,0]

Need to guarantee that the sum of the coefficient magnitude 
equals sum |c(i)| <= 100. */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t fir_pre2;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/100.
for 100G per lane 5 taps, for 50G per lane 4 taps are used (no 
pre3)
Valid values for taps:
fir_main [54,100]
fir_pre1 [-34,0]
fir_pre2 [0,12]
fir_pre3 [-6,0]
fir_post1 [-20,0]

Need to guarantee that the sum of the coefficient magnitude 
equals sum |c(i)| <= 100. */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t fir_pre3;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/100.
for 100G per lane 5 taps, for 50G per lane 4 taps are used (no 
pre3)
Valid values for taps:
fir_main [54,100]
fir_pre1 [-34,0]
fir_pre2 [0,12]
fir_pre3 [-6,0]
fir_post1 [-20,0]

Need to guarantee that the sum of the coefficient magnitude 
equals sum |c(i)| <= 100. */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t fir_post1;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/100.
for 100G per lane 5 taps, for 50G per lane 4 taps are used (no 
pre3)
Valid values for taps:
fir_main [54,100]
fir_pre1 [-34,0]
fir_pre2 [0,12]
fir_pre3 [-6,0]
fir_post1 [-20,0]

Need to guarantee that the sum of the coefficient magnitude 
equals sum |c(i)| <= 100. */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t fir_main;
	/* Description - Signed value for TX FIR taps.
tap scaling = fir_tap/100.
for 100G per lane 5 taps, for 50G per lane 4 taps are used (no 
pre3)
Valid values for taps:
fir_main [54,100]
fir_pre1 [-34,0]
fir_pre2 [0,12]
fir_pre3 [-6,0]
fir_post1 [-20,0]

Need to guarantee that the sum of the coefficient magnitude 
equals sum |c(i)| <= 100. */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t fir_pre1;
};

/* Description -   */
/* Size in bytes - 72 */
struct sltp_data_set {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.24 - 0x48.23 */
	 u_int8_t data[72];
};

/* Description -   */
/* Size in bytes - 24 */
struct sltp_gearbox {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t pre_tap;
	/* Description -  */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t main_tap;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t post_tap;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t inner_eye_1;
	/* Description -  */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t inner_eye_2;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.3 */
	 u_int8_t tx_swing;
};

/* Description -   */
/* Size in bytes - 72 */
struct sltp_lut_7nm {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Signed value for TX FIR constant taps.
tap scaling = fir_tap/100.

Valid values for taps:
fir_pre2 [0,12]
fir_pre3 [-6,0]
 */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t fir_pre2;
	/* Description - Signed value for TX FIR constant taps.
tap scaling = fir_tap/100.

Valid values for taps:
fir_pre2 [0,12]
fir_pre3 [-6,0]
 */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t fir_pre3;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Lookup Table values per entry */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t lut0;
	/* Description - Lookup Table values per entry */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t lut1;
	/* Description - Lookup Table values per entry */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t lut2;
	/* Description - Lookup Table values per entry */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t lut3;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Lookup Table values per entry */
	/* 0xc.0 - 0xc.7 */
	 u_int8_t lut4;
	/* Description - Lookup Table values per entry */
	/* 0xc.8 - 0xc.15 */
	 u_int8_t lut5;
	/* Description - Lookup Table values per entry */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t lut6;
	/* Description - Lookup Table values per entry */
	/* 0xc.24 - 0xc.31 */
	 u_int8_t lut7;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Lookup Table values per entry */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t lut8;
	/* Description - Lookup Table values per entry */
	/* 0x10.8 - 0x10.15 */
	 u_int8_t lut9;
	/* Description - Lookup Table values per entry */
	/* 0x10.16 - 0x10.23 */
	 u_int8_t lut10;
	/* Description - Lookup Table values per entry */
	/* 0x10.24 - 0x10.31 */
	 u_int8_t lut11;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Lookup Table values per entry */
	/* 0x14.0 - 0x14.7 */
	 u_int8_t lut12;
	/* Description - Lookup Table values per entry */
	/* 0x14.8 - 0x14.15 */
	 u_int8_t lut13;
	/* Description - Lookup Table values per entry */
	/* 0x14.16 - 0x14.23 */
	 u_int8_t lut14;
	/* Description - Lookup Table values per entry */
	/* 0x14.24 - 0x14.31 */
	 u_int8_t lut15;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Lookup Table values per entry
 */
	/* 0x18.0 - 0x18.7 */
	 u_int8_t lut16;
	/* Description - Lookup Table values per entry
 */
	/* 0x18.8 - 0x18.15 */
	 u_int8_t lut17;
	/* Description - Lookup Table values per entry
 */
	/* 0x18.16 - 0x18.23 */
	 u_int8_t lut18;
	/* Description - Lookup Table values per entry
 */
	/* 0x18.24 - 0x18.31 */
	 u_int8_t lut19;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Lookup Table values per entry
 */
	/* 0x1c.0 - 0x1c.7 */
	 u_int8_t lut20;
	/* Description - Lookup Table values per entry
 */
	/* 0x1c.8 - 0x1c.15 */
	 u_int8_t lut21;
	/* Description - Lookup Table values per entry
 */
	/* 0x1c.16 - 0x1c.23 */
	 u_int8_t lut22;
	/* Description - Lookup Table values per entry
 */
	/* 0x1c.24 - 0x1c.31 */
	 u_int8_t lut23;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Lookup Table values per entry
 */
	/* 0x20.0 - 0x20.7 */
	 u_int8_t lut24;
	/* Description - Lookup Table values per entry
 */
	/* 0x20.8 - 0x20.15 */
	 u_int8_t lut25;
	/* Description - Lookup Table values per entry
 */
	/* 0x20.16 - 0x20.23 */
	 u_int8_t lut26;
	/* Description - Lookup Table values per entry
 */
	/* 0x20.24 - 0x20.31 */
	 u_int8_t lut27;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Lookup Table values per entry
 */
	/* 0x24.0 - 0x24.7 */
	 u_int8_t lut28;
	/* Description - Lookup Table values per entry
 */
	/* 0x24.8 - 0x24.15 */
	 u_int8_t lut29;
	/* Description - Lookup Table values per entry
 */
	/* 0x24.16 - 0x24.23 */
	 u_int8_t lut30;
	/* Description - Lookup Table values per entry
 */
	/* 0x24.24 - 0x24.31 */
	 u_int8_t lut31;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - Lookup Table values per entry
 */
	/* 0x28.0 - 0x28.7 */
	 u_int8_t lut32;
	/* Description - Lookup Table values per entry
 */
	/* 0x28.8 - 0x28.15 */
	 u_int8_t lut33;
	/* Description - Lookup Table values per entry
 */
	/* 0x28.16 - 0x28.23 */
	 u_int8_t lut34;
	/* Description - Lookup Table values per entry
 */
	/* 0x28.24 - 0x28.31 */
	 u_int8_t lut35;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - Lookup Table values per entry
 */
	/* 0x2c.0 - 0x2c.7 */
	 u_int8_t lut36;
	/* Description - Lookup Table values per entry
 */
	/* 0x2c.8 - 0x2c.15 */
	 u_int8_t lut37;
	/* Description - Lookup Table values per entry
 */
	/* 0x2c.16 - 0x2c.23 */
	 u_int8_t lut38;
	/* Description - Lookup Table values per entry
 */
	/* 0x2c.24 - 0x2c.31 */
	 u_int8_t lut39;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - Lookup Table values per entry
 */
	/* 0x30.0 - 0x30.7 */
	 u_int8_t lut40;
	/* Description - Lookup Table values per entry
 */
	/* 0x30.8 - 0x30.15 */
	 u_int8_t lut41;
	/* Description - Lookup Table values per entry
 */
	/* 0x30.16 - 0x30.23 */
	 u_int8_t lut42;
	/* Description - Lookup Table values per entry
 */
	/* 0x30.24 - 0x30.31 */
	 u_int8_t lut43;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description -  */
	/* 0x34.0 - 0x34.7 */
	 u_int8_t lut44;
	/* Description - Lookup Table values per entry
 */
	/* 0x34.8 - 0x34.15 */
	 u_int8_t lut45;
	/* Description - Lookup Table values per entry
 */
	/* 0x34.16 - 0x34.23 */
	 u_int8_t lut46;
	/* Description - Lookup Table values per entry
 */
	/* 0x34.24 - 0x34.31 */
	 u_int8_t lut47;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - Lookup Table values per entry
 */
	/* 0x38.0 - 0x38.7 */
	 u_int8_t lut48;
	/* Description - Lookup Table values per entry
 */
	/* 0x38.8 - 0x38.15 */
	 u_int8_t lut49;
	/* Description - Lookup Table values per entry
 */
	/* 0x38.16 - 0x38.23 */
	 u_int8_t lut50;
	/* Description - Lookup Table values per entry
 */
	/* 0x38.24 - 0x38.31 */
	 u_int8_t lut51;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - Lookup Table values per entry
 */
	/* 0x3c.0 - 0x3c.7 */
	 u_int8_t lut52;
	/* Description - Lookup Table values per entry
 */
	/* 0x3c.8 - 0x3c.15 */
	 u_int8_t lut53;
	/* Description - Lookup Table values per entry
 */
	/* 0x3c.16 - 0x3c.23 */
	 u_int8_t lut54;
	/* Description - Lookup Table values per entry
 */
	/* 0x3c.24 - 0x3c.31 */
	 u_int8_t lut55;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - Lookup Table values per entry
 */
	/* 0x40.0 - 0x40.7 */
	 u_int8_t lut56;
	/* Description - Lookup Table values per entry
 */
	/* 0x40.8 - 0x40.15 */
	 u_int8_t lut57;
	/* Description - Lookup Table values per entry
 */
	/* 0x40.16 - 0x40.23 */
	 u_int8_t lut58;
	/* Description - Lookup Table values per entry
 */
	/* 0x40.24 - 0x40.31 */
	 u_int8_t lut59;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - Lookup Table values per entry
 */
	/* 0x44.0 - 0x44.7 */
	 u_int8_t lut60;
	/* Description - Lookup Table values per entry
 */
	/* 0x44.8 - 0x44.15 */
	 u_int8_t lut61;
	/* Description - Lookup Table values per entry
 */
	/* 0x44.16 - 0x44.23 */
	 u_int8_t lut62;
	/* Description - Lookup Table values per entry
 */
	/* 0x44.24 - 0x44.31 */
	 u_int8_t lut63;
};

/* Description -   */
/* Size in bytes - 4 */
struct ctle_calib_set {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.4 */
	 u_int8_t bgn_offset_n0;
	/* Description -  */
	/* 0x0.8 - 0x0.12 */
	 u_int8_t bgn_offset_p0;
	/* Description -  */
	/* 0x0.16 - 0x0.20 */
	 u_int8_t bgn_offset_n1;
	/* Description -  */
	/* 0x0.24 - 0x0.28 */
	 u_int8_t bgn_offset_p1;
};

/* Description -   */
/* Size in bytes - 8 */
struct int64bit {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t High;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t Low;
};

/* Description -   */
/* Size in bytes - 96 */
union mpcnt_reg_counter_set_auto {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x50.31 */
	 struct pcie_perf_counters pcie_perf_counters;
	/* Description -  */
	/* 0x0.0 - 0x44.31 */
	 struct pcie_lanes_counters pcie_lanes_counters;
	/* Description -  */
	/* 0x0.0 - 0x58.31 */
	 struct pcie_timers_states pcie_timers_states;
	/* Description -  */
	/* 0x0.0 - 0x0.31 */
	 struct pcie_physical_layer pcie_physical_layer;
	/* Description -  */
	/* 0x0.0 - 0x5c.31 */
	 struct mpcnt_RAW_page_data raw;
};

/* Description -   */
/* Size in bytes - 204 */
union pemi_page_data_auto {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_Module_Status_Samples pemi_Module_Status_Samples;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_SNR_Samples pemi_SNR_Samples;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_Laser_Monitors_Samples pemi_Laser_Monitors_Samples;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_PAM4_Level_Transition_Samples pemi_PAM4_Level_Transition_Samples;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_Pre_FEC_BER_Samples pemi_Pre_FEC_BER_Samples;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_FERC_Samples pemi_FERC_Samples;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_Module_Status_Properties pemi_Module_Status_Properties;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_SNR_Properties pemi_SNR_Properties;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_Laser_Monitors_Properties pemi_Laser_Monitors_Properties;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_PAM4_Level_Transition_Properties pemi_PAM4_Level_Transition_Properties;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_Pre_FEC_BER_Properties pemi_Pre_FEC_BER_Properties;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_FERC_Properties pemi_FERC_Properties;
	/* Description -  */
	/* 0x0.0 - 0xc8.31 */
	 struct pemi_RAW_page_data raw;
};

/* Description -   */
/* Size in bytes - 4 */
struct peucg_page_data {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - address[i] corresponding to payload_data[i] */
	/* 0x0.0 - 0x0.9 */
	 u_int16_t address;
	/* Description - per address[i] access rx/tx physical lane
0 - rx physical lane access.
1 - tx physical lane access. */
	/* 0x0.15 - 0x0.15 */
	 u_int8_t rxtx;
	/* Description - payload data to/from corresponding address to be read/written. */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t payload_data;
};

/* Description -   */
/* Size in bytes - 8 */
struct ppbmp_monitor_parameters {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - BER threshold for warning state, when the monitor state is normal and the monitored BER crosses above the warning_threshold, the monitor state will is set to warning
warning_threshold = warning_th_mantissa * 10^(-warning_th_exp)
The warning_threshold shall be within the supported range for the monitor type */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t warning_th_exp;
	/* Description - BER threshold for warning state, when the monitor state is normal and the monitored BER crosses above the warning_threshold, the monitor state will is set to warning
warning_threshold = warning_th_mantissa * 10^(-warning_th_exp)
The warning_threshold shall be within the supported range for the monitor type */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t warning_th_mantissa;
	/* Description - BER threshold for alarm state, when the monitored BER crosses above the alarm_threshold, the monitor state is set to alarm.
alarm_threshold = alarm_th_mantissa * 10^(-alarm_th_exp)
The alarm_threshold shall be within the supported range for the monitor type */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t alarm_th_exp;
	/* Description - BER threshold for alarm state, when the monitored BER crosses above the alarm_threshold, the monitor state is set to alarm.
alarm_threshold = alarm_th_mantissa * 10^(-alarm_th_exp)
The alarm_threshold shall be within the supported range for the monitor type */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t alarm_th_mantissa;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - BER threshold for normal state, when the monitored BER crosses below the normal_threshold, the monitor state is set to normal.
normal_threshold = normal_th_mantissa * 10^(-normal_th_exp)
The warning_threshold shall be within the supported range for the monitor type */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t normal_th_exp;
	/* Description - BER threshold for normal state, when the monitored BER crosses below the normal_threshold, the monitor state is set to normal.
normal_threshold = normal_th_mantissa * 10^(-normal_th_exp)
The warning_threshold shall be within the supported range for the monitor type */
	/* 0x4.24 - 0x4.27 */
	 u_int8_t normal_th_mantissa;
};

/* Description -   */
/* Size in bytes - 212 */
union ppcnt_reg_counter_set_auto {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x24.31 */
	 struct ppcnt_ib_portcntrs_attribute_grp_data ppcnt_ib_portcntrs_attribute_grp_data;
	/* Description -  */
	/* 0x0.0 - 0xac.31 */
	 struct ppcnt_ib_long_portcntrs_attribute_grp_data ppcnt_ib_long_portcntrs_attribute_grp_data;
	/* Description -  */
	/* 0x0.0 - 0x4c.31 */
	 struct ppcnt_plr_counters ppcnt_plr_counters;
	/* Description -  */
	/* 0x0.0 - 0xa4.31 */
	 struct ppcnt_rs_fec_histograms_counters ppcnt_rs_fec_histograms_counters;
	/* Description -  */
	/* 0x0.0 - 0x88.31 */
	 struct ppcnt_usr_xsr_physical_layer ppcnt_usr_xsr_physical_layer;
	/* Description -  */
	/* 0x0.0 - 0x5c.31 */
	 struct ppcnt_infiniband_packets_counter ppcnt_infiniband_packets_counter;
	/* Description -  */
	/* 0x0.0 - 0x4c.31 */
	 struct ppcnt_infiniband_general_counter ppcnt_infiniband_general_counter;
	/* Description -  */
	/* 0x0.0 - 0xa4.31 */
	 struct ppcnt_l1_general_counters ppcnt_l1_general_counters;
	/* Description -  */
	/* 0x0.0 - 0x8c.31 */
	 struct ppcnt_infiniband_packet_histograms ppcnt_infiniband_packet_histograms;
	/* Description -  */
	/* 0x0.0 - 0x2c.31 */
	 struct ppcnt_packet_type_counter ppcnt_packet_type_counter;
	/* Description -  */
	/* 0x0.0 - 0x4c.31 */
	 struct ppcnt_infiniband_vl_counter ppcnt_infiniband_vl_counter;
	/* Description -  */
	/* 0x0.0 - 0xd0.31 */
	 struct ppcnt_RAW_page_data raw;
};

/* Description -   */
/* Size in bytes - 4 */
struct pphcr_bin_range {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - low range of bin's measurement */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t low_val;
	/* Description - high range of bin's measurement */
	/* 0x0.16 - 0x0.19 */
	 u_int8_t high_val;
};

/* Description -   */
/* Size in bytes - 36 */
union ppll_reg_page_data_auto {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x20.31 */
	 struct ppll_28nm ppll_28nm;
	/* Description -  */
	/* 0x0.0 - 0x20.31 */
	 struct ppll_reg_16nm ppll_reg_16nm;
	/* Description -  */
	/* 0x0.0 - 0x20.31 */
	 struct ppll_reg_7nm ppll_reg_7nm;
	/* Description -  */
	/* 0x0.0 - 0x4.31 */
	 struct ppll_reg_5nm ppll_reg_5nm;
	/* Description -  */
	/* 0x0.0 - 0x20.31 */
	 struct ppll_data_set ppll_data_set;
};

/* Description -   */
/* Size in bytes - 80 */
struct psu_status {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.1 */
	 u_int8_t ac_status;
	/* Description -  */
	/* 0x0.4 - 0x0.5 */
	 u_int8_t dc_status;
	/* Description -  */
	/* 0x0.24 - 0x0.25 */
	 u_int8_t alert;
	/* Description -  */
	/* 0x0.28 - 0x0.31 */
	 u_int8_t present;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.1 */
	 u_int8_t fan;
	/* Description -  */
	/* 0x4.4 - 0x4.5 */
	 u_int8_t temp;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t power_consumption;
	/* Description -  */
	/* 0x8.30 - 0x8.31 */
	 u_int8_t power_cap;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.0 */
	 u_int8_t snp;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.24 - 0x28.23 */
	 char serial_number[25];
};

/* Description -   */
/* Size in bytes - 12 */
struct ref_clock_stat_db {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.23 */
	 u_int32_t measured_freq;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.23 */
	 u_int32_t min_freq;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.23 */
	 u_int32_t max_freq;
	/* Description -  */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t max_delta_freq;
};

/* Description -   */
/* Size in bytes - 44 */
union sllm_reg_page_data_auto {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x28.31 */
	 struct sllm_16nm sllm_16nm;
	/* Description -  */
	/* 0x0.0 - 0x28.31 */
	 struct sllm_usr sllm_usr;
	/* Description -  */
	/* 0x0.0 - 0x20.31 */
	 struct sllm_7nm sllm_7nm;
	/* Description -  */
	/* 0x0.0 - 0x28.31 */
	 struct sllm_data_set sllm_data_set;
};

/* Description -   */
/* Size in bytes - 72 */
union slreg_reg_page_data_auto {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x20.31 */
	 struct slreg_16nm slreg_16nm;
	/* Description -  */
	/* 0x0.0 - 0x44.31 */
	 struct slreg_usr slreg_usr;
	/* Description -  */
	/* 0x0.0 - 0x20.31 */
	 struct slreg_7nm slreg_7nm;
	/* Description -  */
	/* 0x0.0 - 0x44.31 */
	 struct slreg_data_set slreg_data_set;
};

/* Description -   */
/* Size in bytes - 164 */
union slrg_reg_page_data_auto {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x20.31 */
	 struct slrg_40nm_28nm slrg_40nm_28nm;
	/* Description -  */
	/* 0x0.0 - 0x20.31 */
	 struct slrg_16nm slrg_16nm;
	/* Description -  */
	/* 0x0.0 - 0x14.31 */
	 struct slrg_7nm slrg_7nm;
	/* Description -  */
	/* 0x0.0 - 0xa0.31 */
	 struct slrg_7nm_testing slrg_7nm_testing;
	/* Description -  */
	/* 0x0.0 - 0xa0.31 */
	 struct slrg_data_set slrg_data_set;
};

/* Description -   */
/* Size in bytes - 88 */
union slrip_reg_page_data_auto {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x24.31 */
	 struct slrip_16nm slrip_16nm;
	/* Description -  */
	/* 0x0.0 - 0x54.31 */
	 struct slrip_7nm slrip_7nm;
	/* Description -  */
	/* 0x0.0 - 0x54.31 */
	 struct slrip_5nm slrip_5nm;
	/* Description -  */
	/* 0x0.0 - 0x54.31 */
	 struct slrip_data_set slrip_data_set;
};

/* Description -   */
/* Size in bytes - 148 */
union slrp_reg_page_data_auto {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x20.31 */
	 struct slrp_40nm_28nm slrp_40nm_28nm;
	/* Description -  */
	/* 0x0.0 - 0x18.31 */
	 struct slrp_16nm slrp_16nm;
	/* Description -  */
	/* 0x0.0 - 0x1c.31 */
	 struct slrp_gearbox slrp_gearbox;
	/* Description -  */
	/* 0x0.0 - 0x1c.31 */
	 struct slrp_usr slrp_usr;
	/* Description -  */
	/* 0x0.0 - 0x30.31 */
	 struct slrp_7nm slrp_7nm;
	/* Description -  */
	/* 0x0.0 - 0x90.31 */
	 struct slrp_5nm slrp_5nm;
	/* Description -  */
	/* 0x0.0 - 0x90.31 */
	 struct slrp_data_set slrp_data_set;
};

/* Description -   */
/* Size in bytes - 72 */
union sltp_reg_page_data_auto {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0xc.31 */
	 struct sltp_28nm_40nm sltp_28nm_40nm;
	/* Description -  */
	/* 0x0.0 - 0x14.31 */
	 struct sltp_16nm sltp_16nm;
	/* Description -  */
	/* 0x0.0 - 0x14.31 */
	 struct sltp_gearbox sltp_gearbox;
	/* Description -  */
	/* 0x0.0 - 0x14.31 */
	 struct sltp_7nm sltp_7nm;
	/* Description -  */
	/* 0x0.0 - 0x44.31 */
	 struct sltp_lut_7nm sltp_lut_7nm;
	/* Description -  */
	/* 0x0.0 - 0x44.31 */
	 struct sltp_5nm sltp_5nm;
	/* Description -  */
	/* 0x0.0 - 0x44.31 */
	 struct sltp_data_set sltp_data_set;
};

/* Description -   */
/* Size in bytes - 48 */
struct CableInfo_Payload_Addr_0_47 {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t CDRTXRXLossIndicator;
	/* Description -  */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t RevisionComplaince;
	/* Description -  */
	/* 0x0.24 - 0x0.31 */
	 u_int8_t Identifier;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t VoltageAlarmAndWarning;
	/* Description -  */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t TemperatureAlarmandWarning;
	/* Description -  */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t TXRXLOLIndicator;
	/* Description -  */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t AdaptiveEqualizationFault;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t TXBiasAlarmAndWarningHigh;
	/* Description -  */
	/* 0x8.8 - 0x8.23 */
	 u_int16_t RXPowerAlarmAndWarning;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.8 - 0xc.23 */
	 u_int16_t TXPowerAlarmAndWarning;
	/* Description -  */
	/* 0xc.24 - 0xc.31 */
	 u_int8_t TXBiasAlarmAndWarningLow;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t DiagDeviceTemperature;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t DiagSupplyVoltage;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.0 - 0x20.15 */
	 u_int16_t DiagRX1Power;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description -  */
	/* 0x24.0 - 0x24.15 */
	 u_int16_t DiagRX3Power;
	/* Description -  */
	/* 0x24.16 - 0x24.31 */
	 u_int16_t DiagRX2Power;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.0 - 0x28.15 */
	 u_int16_t DiagTX1Bias;
	/* Description -  */
	/* 0x28.16 - 0x28.31 */
	 u_int16_t DiagRX4Power;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description -  */
	/* 0x2c.0 - 0x2c.15 */
	 u_int16_t DiagTX3Bias;
	/* Description -  */
	/* 0x2c.16 - 0x2c.31 */
	 u_int16_t DiagTX2Bias;
};

/* Description -   */
/* Size in bytes - 48 */
struct CableInfo_Payload_Addr_128_167 {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t SpecCompliance0;
	/* Description -  */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t Connector;
	/* Description -  */
	/* 0x0.16 - 0x0.17 */
	 u_int8_t ExtPowerClass;
	/* Description -  */
	/* 0x0.18 - 0x0.19 */
	 u_int8_t CdrPresent;
	/* Description -  */
	/* 0x0.22 - 0x0.23 */
	 u_int8_t PowerClass;
	/* Description -  */
	/* 0x0.24 - 0x0.31 */
	 u_int8_t Identifier;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t SpecCompliance4;
	/* Description -  */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t SpecCompliance3;
	/* Description -  */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t SpecCompliance2;
	/* Description -  */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t SpecCompliance1;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t Encoding;
	/* Description -  */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t SpecCompliance7;
	/* Description -  */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t SpecCompliance6;
	/* Description -  */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t SpecCompliance5;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - 2 meter */
	/* 0xc.0 - 0xc.7 */
	 u_int8_t LengthOM3;
	/* Description - km */
	/* 0xc.8 - 0xc.15 */
	 u_int8_t LengthSMFiber;
	/* Description -  */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t ExtendedRateSelect;
	/* Description -  */
	/* 0xc.24 - 0xc.31 */
	 u_int8_t BRNominal;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t DeviceTech;
	/* Description - 1 meter */
	/* 0x10.8 - 0x10.15 */
	 u_int8_t LengthCopperOrActive;
	/* Description - 1 meter */
	/* 0x10.16 - 0x10.23 */
	 u_int8_t LengthOM1;
	/* Description - 1 meter */
	/* 0x10.24 - 0x10.31 */
	 u_int8_t LengthOM2;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.24 - 0x24.23 */
	 char VendorName[17];
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description -  */
	/* 0x24.0 - 0x24.23 */
	 u_int32_t VendorOUI;
	/* Description -  */
	/* 0x24.24 - 0x24.31 */
	 u_int8_t ExtendedModuleCodes;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.0 - 0x2c.31 */
	 u_int64_t NotUsed;
};

/* Description -   */
/* Size in bytes - 48 */
struct CableInfo_Payload_Addr_168_211 {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.24 - 0x10.23 */
	 char VendorPN[17];
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t Attenuation_5g;
	/* Description -  */
	/* 0x10.8 - 0x10.15 */
	 u_int8_t Attenuation_2_5g;
	/* Description -  */
	/* 0x10.24 - 0x14.7 */
	 char VendorRev[3];
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.16 - 0x14.23 */
	 u_int8_t Attenuation_12g;
	/* Description -  */
	/* 0x14.24 - 0x14.31 */
	 u_int8_t Attenuation_7g;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.23 */
	 u_int32_t QSFPOptions;
	/* Description -  */
	/* 0x18.24 - 0x18.31 */
	 u_int8_t EthComCodesExt;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.24 - 0x2c.23 */
	 char VendorSN[17];
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description -  */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t NotUsed;
};

/* Description -   */
/* Size in bytes - 48 */
struct CableInfo_Payload_Addr_212_255 {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.24 - 0x8.23 */
	 char DateCode[9];
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t NominalBr_250;
	/* Description -  */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t DDMIType;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.24 - 0x1c.23 */
	 char MlnxSFGSN[17];
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description -  */
	/* 0x24.0 - 0x24.7 */
	 u_int8_t MlnxVendorByte;
	/* Description -  */
	/* 0x24.8 - 0x24.15 */
	 u_int8_t MlnxRevision;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.16 - 0x28.31 */
	 u_int16_t MellanoxCap;
};

/* Description -   */
/* Size in bytes - 32 */
struct CableInfo_Payload_Addr_48_79 {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t DiagTX1Power;
	/* Description -  */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t DiagTX4Bias;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t DiagTX3Power;
	/* Description -  */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t DiagTX2Power;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t ReservedSet4_1;
	/* Description -  */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t DiagTX4Power;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t ReservedSet4_2;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t ReservedSet5_1;
	/* Description -  */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t ReservedSet4_3;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t ReservedSet5_2;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t VendorSpecific_1;
	/* Description -  */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t ReservedSet5_3;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t VendorSpecific_2;
};

/* Description -   */
/* Size in bytes - 48 */
struct CableInfo_Payload_Addr_80_127 {
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.8 - 0x4.11 */
	 u_int8_t TXDisable;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.16 - 0xc.18 */
	 u_int8_t HighPower;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.8 - 0x10.15 */
	 u_int8_t CdrControl;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.16 - 0x20.23 */
	 u_int8_t QSFPConnectivity;
};

/* Description -   */
/* Size in bytes - 48 */
struct CableInfo_Payload_Page_3_Addr_128_175 {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t LowTempAlarm;
	/* Description -  */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t HighTempAlarm;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t LowTempWarning;
	/* Description -  */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t HighTempWarning;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t LowVccAlarm;
	/* Description -  */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t HighVccAlarm;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t LowVccWarning;
	/* Description -  */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t HighVccWarning;
};

/* Description -   */
/* Size in bytes - 48 */
struct CableInfo_Payload_Page_3_Addr_212_255 {
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.16 - 0x10.19 */
	 u_int8_t OutputAmpCap;
	/* Description -  */
	/* 0x10.20 - 0x10.21 */
	 u_int8_t OutputEmpType;
	/* Description -  */
	/* 0x10.24 - 0x10.27 */
	 u_int8_t OutputEmpCap;
	/* Description -  */
	/* 0x10.28 - 0x10.31 */
	 u_int8_t InputEqCap;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t InputEq;
	/* Description -  */
	/* 0x14.16 - 0x14.23 */
	 u_int8_t TXAdaptiveEqualizationFreeze;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t OutputAmp;
	/* Description -  */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t OutputEmp;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.16 - 0x1c.23 */
	 u_int8_t AdaptiveEqControl;
};

/* Description -   */
/* Size in bytes - 48 */
struct CableInfo_Payload_Page_E9_Addr_128_175 {
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0xc.31 */
	 u_int16_t max_rssi_lane[4];
	/* Description -  */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t number_of_resets;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x14.31 */
	 u_int16_t min_rssi_lane[4];
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t max_temp_module;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t max_temp_vcsel;
	/* Description -  */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t min_temp_module;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.0 - 0x20.7 */
	 u_int8_t min_temp_vd;
	/* Description -  */
	/* 0x20.8 - 0x20.15 */
	 u_int8_t max_temp_vd;
	/* Description -  */
	/* 0x20.16 - 0x20.31 */
	 u_int16_t min_temp_vcsel;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description -  */
	/* 0x24.0 - 0x24.15 */
	 u_int16_t vcsel_temp_hist_0_40;
	/* Description -  */
	/* 0x24.16 - 0x24.23 */
	 u_int8_t min_temp_tia;
	/* Description -  */
	/* 0x24.24 - 0x24.31 */
	 u_int8_t max_temp_tia;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.0 - 0x28.15 */
	 u_int16_t vcsel_temp_hist_55_70;
	/* Description -  */
	/* 0x28.16 - 0x28.31 */
	 u_int16_t vcsel_temp_hist_40_55;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description -  */
	/* 0x2c.0 - 0x2c.15 */
	 u_int16_t vcsel_temp_hist_85_100;
	/* Description -  */
	/* 0x2c.16 - 0x2c.31 */
	 u_int16_t vcsel_temp_hist_70_85;
};

/* Description -   */
/* Size in bytes - 36 */
struct CableInfo_Payload_Page_E9_Addr_176_211 {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.16 - 0x8.15 */
	 u_int16_t bias_counter[4];
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.16 - 0x10.15 */
	 u_int16_t mod_counter[4];
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t min_vcc_tx;
	/* Description -  */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t max_vcc_tx;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t min_vcc_rx;
	/* Description -  */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t max_vcc_rx;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t min_vcc_bu;
	/* Description -  */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t max_vcc_bu;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t min_vcc_sd;
	/* Description -  */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t max_vcc_sd;
};

/* Description -   */
/* Size in bytes - 44 */
struct CableInfo_Payload_Page_F0_Addr_128_171 {
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.24 - 0x2c.23 */
	 char FWVersion[5];
};

/* Description -   */
/* Size in bytes - 248 */
struct DDLatchedFlagInfo {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Valid for CMIS based modules only
Latched modules Datapath fw fault flag */
	/* 0x0.22 - 0x0.22 */
	 u_int8_t dp_fw_fault;
	/* Description - Valid for CMIS based modules only
Latched module fw fault flag */
	/* 0x0.23 - 0x0.23 */
	 u_int8_t mod_fw_fault;
	/* Description - Latched VCC flags of module
Bit 0: high_vcc_alarm
Bit 1: low_vcc_alarm
Bit 2: high_vcc_warning
Bit 3: low_vcc_warning */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t vcc_flags;
	/* Description - Latched temperature flags of module
Bit 0: high_temp_alarm
Bit 1: low_temp_alarm
Bit 2: high_temp_warning
Bit 3: low_temp_warning */
	/* 0x0.28 - 0x0.31 */
	 u_int8_t temp_flags;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Reserved for SFP
Bitmask for latched Tx adaptive equalization fault flag per 
lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t tx_ad_eq_fault;
	/* Description - Bitmask for latched Tx cdr loss of lock flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t tx_cdr_lol;
	/* Description - Reserved for SFP
Bitmask for latched Tx loss of signal flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t tx_los;
	/* Description - Bitmask for latched Tx fault flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t tx_fault;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Bitmask for latched Tx power low warning flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t tx_power_lo_war;
	/* Description - Bitmask for latched Tx power high warning flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t tx_power_hi_war;
	/* Description - Bitmask for latched Tx power low alarm flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t tx_power_lo_al;
	/* Description - Bitmask for latched Tx power high alarm flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t tx_power_hi_al;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Bitmask for latched Tx bias low warning flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0xc.0 - 0xc.7 */
	 u_int8_t tx_bias_lo_war;
	/* Description - Bitmask for latched Tx bias high warning flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0xc.8 - 0xc.15 */
	 u_int8_t tx_bias_hi_war;
	/* Description - Bitmask for latched Tx bias low alarm flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t tx_bias_lo_al;
	/* Description - Bitmask for latched Tx bias high alarm flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0xc.24 - 0xc.31 */
	 u_int8_t tx_bias_hi_al;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Bitmask for latched Rx cdr loss of lock flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x10.16 - 0x10.23 */
	 u_int8_t rx_cdr_lol;
	/* Description - Bitmask for latched Rx loss of signal flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x10.24 - 0x10.31 */
	 u_int8_t rx_los;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Bitmask for latched Rx power low warning flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x14.0 - 0x14.7 */
	 u_int8_t rx_power_lo_war;
	/* Description - Bitmask for latched Rx power high warning flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x14.8 - 0x14.15 */
	 u_int8_t rx_power_hi_war;
	/* Description - Bitmask for latched Rx power low alarm flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x14.16 - 0x14.23 */
	 u_int8_t rx_power_lo_al;
	/* Description - Bitmask for latched Rx power high alarm flag per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x14.24 - 0x14.31 */
	 u_int8_t rx_power_hi_al;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Bitmask for latched rx output valid change per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x18.0 - 0x18.7 */
	 u_int8_t rx_output_valid_change;
	/* Description - Bitmask for latched rx input valid change per lane.
Bit 0 - lane 0 ... Bit 7 - lane 7 */
	/* 0x18.8 - 0x18.15 */
	 u_int8_t rx_input_valid_change;
};

/* Description -  page in DiagnostiData MAD */
/* Size in bytes - 28 */
struct DDLinkDownInfo {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t down_blame;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t local_reason_opcode;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t remote_reason_opcode;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.7 */
	 u_int8_t e2e_reason_opcode;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t ber_exp;
	/* Description -  */
	/* 0x10.8 - 0x10.11 */
	 u_int8_t ber_mantissa;
	/* Description -  */
	/* 0x10.16 - 0x10.23 */
	 u_int8_t last_ber_exp;
	/* Description -  */
	/* 0x10.24 - 0x10.27 */
	 u_int8_t last_ber_mantissa;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.7 */
	 u_int8_t max_ber_exp;
	/* Description -  */
	/* 0x14.8 - 0x14.11 */
	 u_int8_t max_ber_mantissa;
	/* Description -  */
	/* 0x14.16 - 0x14.23 */
	 u_int8_t min_ber_exp;
	/* Description -  */
	/* 0x14.24 - 0x14.27 */
	 u_int8_t min_ber_mantissa;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t num_of_ber_alarams;
};

/* Description -   */
/* Size in bytes - 248 */
struct DDLinkUpInfo {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - invalid port access severity
0 - No down command / unknown
1 - BMC force linkup
2 - WOL force linkup

3 - ASN.1 force link up */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t up_reason_mng;
	/* Description - invalid port access severity
0 - No down command / unknown
1 - Up by at least one of the hosts */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t up_reason_drv;
	/* Description - invalid port access severity
0 - No down command / unknown
1 - Keep link up on boot 
2 - Keep link up Eth/IB
3 - Keep link up on standby */
	/* 0x0.16 - 0x0.19 */
	 u_int8_t up_reason_pwr;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Time in msec to link up from disable until phy up state.
While the phy manager did not reach phy up state the timer 
will return 0.
The timer resets to 0 in one of the following cases:
1. When moving to disable or rx disable state.
2. When moving from active or phy up to polling state, while 
working at force mode. */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t time_to_link_up;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Indicates if fast link-up was performed in the link: 
0: Unknown
1: Fast Link-UP was performed. 
2: Regular link-up flow was performed due to changes in 
cable
3: Regular link-up flow was performed due to changes in pro
tocol (speed or FEC)
4: Regular link-up flow was performed due to a non-fastboot
able FW version (PCNR is not supported)
5: Regular link-up performed due to MLPN flow
6: Regular link-up performed due to PCNR.tuning_override 
configuration while port was in "down" state.
7: Invalid fastboot data struct (0xCAFECAFE magic value is 
not present. For example, SW reset was executed before fin
ish saving data during PCNR flow)
8 - fast link-up timeout
9 - fast link-up flaps issue
10 - fast link-up failed during link-up */
	/* 0x8.0 - 0x8.3 */
	 u_int8_t fast_link_up_status;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Time in msec to link up from phy up until active state.
While the phy manager did not reach active state the timer 
will return 0.
The timer resets to 0 in one of the following cases:
1. When moving to disable or rx disable state.
2. When moving from active or phy up to polling state, while 
working at force mode. */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t time_to_link_up_phy_up_to_active;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Time in msec to link up from signal detect until phy up state.
While the phy manager did not reach phy up state the timer 
will return 0.
The timer resets to 0 in one of the following cases:
1. When moving to disable or rx disable state.
2. When moving from active or phy up to polling state, while 
working at force mode. */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t time_to_link_up_sd_to_phy_up;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Time in msec to link up from disable until signal detect state.
While the phy manager did not reach signal detect state the 
timer will return 0.
The timer resets to 0 in one of the following cases:
1. When moving to disable or rx disable state.
2. When moving from active or phy up to polling state, while 
working at force mode.
Internal: for HDR/EDR devices the timers: time_to_link_up_
disable_to_sd, time_to_link_up_disable_to_pd will return 
the same value. */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t time_to_link_up_disable_to_sd;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Time in msec to link up from disable until protocol detect 
state.
While the phy manager did not reach protocol detect state the 
timer will return 0.
The timer resets to 0 in one of the following cases:
1. When moving to disable or rx disable state.
2. When moving from active or phy up to polling state, while 
working at force mode.
Internal: for HDR/EDR devices the timers: time_to_link_up_
disable_to_sd, time_to_link_up_disable_to_pd will return 
the same value. */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t time_to_link_up_disable_to_pd;
};

/* Description -   */
/* Size in bytes - 248 */
struct DDModuleInfo {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - QSFP:
Ethernet Compliance Codes bit mask (10/40G/100G)
Byte131 per SFF-8636 
Bit 7 - Extended Specification Compliance valid
Bit 6 - 10GBASE-LRM
Bit 5 - 10GBASE-LR
Bit 4 - 10GBASE-SR
Bit 3 - 40GBASE-CR4
Bit 2 - 40GBASE-SR4
Bit 1 - 40GBASE-LR4
Bit 0 - 40G Active Cable (XLPPI)

SFP : 
10G Ethernet Compliance Codes
Byte3 per SFF-8472:
Bit 7 - 10G Base-ER 
Bit 6 - 10G Base-LRM 
Bit 5 - 10G Base-LR 
Bit 4 - 10G Base-SR

CMIS based (QSFP-DD/ SFP-DD / OSFP)
Byte 87 - Module Media Interface */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t ethernet_compliance_code;
	/* Description - Extended Specification Compliance Codes 
for SFP:
byte 36 per SFF-8472

for QSFP:
byte192 per SFF-8636 (QSFP28) 

for CMIS (SFP-DD / QSFP-DD/ OSFP):
Byte 86 - Host Electrical Interface */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t ext_ethernet_compliance_code;
	/* Description - Reserved for SFP. 

For QSFP:
Byte113 per SFF-8636

For CMIS based modules:
0 - Unspecified
1 - QSFP-DD to QSFP-DD
2 - QSFP-DD to 2xQSFP or 2xQSFP-DD (depopulated / 4 
lanes)
3 - QSFP-DD to 4xSFP-DD or 4xQSFP (depopulated / 2 lanes)
4 - QSFP-DD to 8xSFP
5 - QSFP-DD (depopulated / 4 lanes) to QSFP or QSFP-DD 
(depopulated / 4 lanes)
6 - QSFP-DD (depopulated / 4 lanes) to 2xQSFP(depopulated / 
2 lanes) or 2xSFP-DD
7 - QSFP-DD (depopulated / 4 lanes) to 4xSFP
8 - SFP-DD(/ 2 lane module) to SFP-DD
9 - SFP-DD(/ 2 lane module) to 2xSFP

Note: QSFP-DD can refer to OSFP/QSFP and SFP-DD can 
refer to DSFP/QSFP(2 lanes) form factor according to identi
fier on near side */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t cable_breakout;
	/* Description - QSFP: 
Byte 147 per SFF-8636.

SFP:
SFP+ Cable Technology: 
byte8 per SFF-8472:
Bit 3 - Active Cable
Bit 2 - Passive Cable

CMIS based (QSFP-DD / OSFP/ SFP-DD):
Byte 212 */
	/* 0x0.24 - 0x0.31 */
	 u_int8_t cable_technology;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Module maximum power consumption for SFP/QSFP:
0 - Power Class 0 (1.0 W max)
1 - Power Class 1 (1.5 W max)
2 - Power Class 2 (2.0 W max)
3 - Power Class 3 (2.5 W max)
4 - Power Class 4 (3.5 W max)
5 - Power Class 5 (4.0 W max)
6 - Power Class 6 (4.5 W max)
7 - Power Class 7 (5.0 W max)
8 - Power Class 8 (power from max_power field)

Module maximum power consumption for SFP-DD:
0 - Power Class 0 (0.5 W max)
1 - Power Class 1 (1.0 W max)
2 - Power Class 2 (1.5 W max)
3 - Power Class 3 (2.0 W max)
4 - Power Class 4 (3.5 W max)
5 - Power Class 5 (5.0 W max)
6 - reserved
7 - reserved
8 - Power Class 8 (power from max_power field)

Module maximum power consumption for QSFP-DD/OSFP:
1 - Power Class 1 (1.5 W max)
2 - Power Class 2 (3.5 W max)
3 - Power Class 3 (7.0 W max)
4 - Power Class 4 (8.0 W max)
5 - Power Class 5 (10 W max)
6 - Power Class 6 (12 W max)
7 - Power Class 7 (14 W max)
8 - Power Class 8 (power from max_power field)
 */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t cable_power_class;
	/* Description - 0 - QSFP28
1 - QSFP+
2 - SFP28/SFP+
3 - QSA (QSFP->SFP)
4 - Backplane
5 - SFP-DD
6 - QSFP-DD
7 - QSFP_CMIS
8 - OSFP
9 - C2C
10 - DSFP
11 - QSFP_Split_Cable */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t cable_identifier;
	/* Description - Cable length in 1m units.

For CMIS modules:
bits 6:7 represent cable_length_multiplier for calculating 
cable length
00 - 0.1 multiplier (0.1 to 6.3m)
01- 1 multiplier (1 to 63m)
10 - 10 multiplier (10 to 630m)
11 - 100 multiplier (100 to 6300m)

bits 0:5 represent cable_length_value for calculating cable 
length.

length is calculated with cable_length_value * cable_length_
multiplier */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t cable_length;
	/* Description - Cable vendor:
0 - Other 
1 - Mellanox
2 - Known OUI
 */
	/* 0x4.24 - 0x4.27 */
	 u_int8_t cable_vendor;
	/* Description - Cable/module type:
0 - Unidentified
1 - Active cable (active copper / optics)
2 - Optical Module (separated).
3 - Passive copper cable
4 - Cable unplugged
5 - Twisted pair
 */
	/* 0x4.28 - 0x4.31 */
	 u_int8_t cable_type;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t cable_tx_equalization;
	/* Description - 


for CMIS (QSFP-DD/ SFP-DD/ OSFP) field will represent Rx 
pre-emphasis.
 */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t cable_rx_emphasis;
	/* Description - Reserved for SFP
 */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t cable_rx_amp;
	/* Description - Reserved for SFP, QSFP
Byte 201 for CMIS (QSFP-DD/ SFP-DD/ OSFP)
Other Cable ignore field. */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t max_power;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Reserved for SFP */
	/* 0xc.0 - 0xc.7 */
	 u_int8_t cable_attenuation_5g;
	/* Description - Reserved for SFP */
	/* 0xc.8 - 0xc.15 */
	 u_int8_t cable_attenuation_7g;
	/* Description - Reserved for SFP */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t cable_attenuation_12g;
	/* Description - Valid only for CMIS (QSFP-DD/ SFP-DD/ OSFP)
Other Cable ignore field. */
	/* 0xc.24 - 0xc.31 */
	 u_int8_t cable_attenuation_25g;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Reserved for SFP

Bit 0 - TX CDR on/off on channel 0 
Bit 1 - TX CDR on/off on channel 1 
Bit 2 - TX CDR on/off on channel 2 
Bit 3 - TX CDR on/off on channel 3 
Bit 4 - TX CDR on/off on channel 4 
Bit 5 - TX CDR on/off on channel 5 
Bit 6 - TX CDR on/off on channel 6 
Bit 7 - TX CDR on/off on channel 7 

CDR on - when bit is set.
CDR off - when bit is clear.
 */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t tx_cdr_state;
	/* Description - Reserved for SFP

Bit 0 - RX CDR on/off on channel 0 
Bit 1 - RX CDR on/off on channel 1 
Bit 2 - RX CDR on/off on channel 2 
Bit 3 - RX CDR on/off on channel 3
Bit 4 - RX CDR on/off on channel 4 
Bit 5 - RX CDR on/off on channel 5 
Bit 6 - RX CDR on/off on channel 6 
Bit 7 - RX CDR on/off on channel 7 

CDR on - when bit is set.
CDR off - when bit is clear.
 */
	/* 0x10.8 - 0x10.15 */
	 u_int8_t rx_cdr_state;
	/* Description - 0 - No CDR
1 - Build-in CDR with on/off control 
2 - Build-in CDR without on/off control */
	/* 0x10.16 - 0x10.19 */
	 u_int8_t tx_cdr_cap;
	/* Description - 0 - No CDR
1 - Build-in CDR with on/off control 
2 - Build-in CDR without on/off control */
	/* 0x10.20 - 0x10.23 */
	 u_int8_t rx_cdr_cap;
	/* Description - Valid only for CMIS (QSFP-DD/ SFP-DD/ OSFP)
Rx post-emphasis. */
	/* 0x10.24 - 0x10.31 */
	 u_int8_t cable_rx_post_emphasis;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.24 - 0x24.23 */
	 char vendor_name[17];
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description -  */
	/* 0x24.24 - 0x34.23 */
	 char vendor_pn[17];
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description -  */
	/* 0x34.24 - 0x38.23 */
	 char vendor_rev[5];
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description -  */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t fw_version;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description -  */
	/* 0x3c.24 - 0x4c.23 */
	 char vendor_sn[17];
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - Internally measured supply voltage in 100uV */
	/* 0x4c.0 - 0x4c.15 */
	 u_int16_t voltage;
	/* Description - module temperature in 1/256 C */
	/* 0x4c.16 - 0x4c.31 */
	 u_int16_t temperature;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description - RX measured power channel 1.
measured in dBm/uW according to module_info_ext value */
	/* 0x50.0 - 0x50.15 */
	 u_int16_t rx_power_lane1;
	/* Description - RX measured power channel 0.
measured in dBm/uW according to module_info_ext value */
	/* 0x50.16 - 0x50.31 */
	 u_int16_t rx_power_lane0;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description - RX measured power channel 3.
measured in dBm/uW according to module_info_ext value */
	/* 0x54.0 - 0x54.15 */
	 u_int16_t rx_power_lane3;
	/* Description - RX measured power channel 2.
measured in dBm/uW according to module_info_ext value */
	/* 0x54.16 - 0x54.31 */
	 u_int16_t rx_power_lane2;
/*---------------- DWORD[22] (Offset 0x58) ----------------*/
	/* Description - RX measured power channel 5.
measured in dBm/uW according to module_info_ext value */
	/* 0x58.0 - 0x58.15 */
	 u_int16_t rx_power_lane5;
	/* Description - RX measured power channel 4.
measured in dBm/uW according to module_info_ext value */
	/* 0x58.16 - 0x58.31 */
	 u_int16_t rx_power_lane4;
/*---------------- DWORD[23] (Offset 0x5c) ----------------*/
	/* Description - RX measured power channel 7.
measured in dBm/uW according to module_info_ext value */
	/* 0x5c.0 - 0x5c.15 */
	 u_int16_t rx_power_lane7;
	/* Description - RX measured power channel 6.
measured in dBm/uW according to module_info_ext value */
	/* 0x5c.16 - 0x5c.31 */
	 u_int16_t rx_power_lane6;
/*---------------- DWORD[24] (Offset 0x60) ----------------*/
	/* Description - TX measured power channel 1.
measured in dBm/uW according to module_info_ext value */
	/* 0x60.0 - 0x60.15 */
	 u_int16_t tx_power_lane1;
	/* Description - TX measured power channel 0.
measured in dBm/uW according to module_info_ext value */
	/* 0x60.16 - 0x60.31 */
	 u_int16_t tx_power_lane0;
/*---------------- DWORD[25] (Offset 0x64) ----------------*/
	/* Description - TX measured power channel 3.
measured in dBm/uW according to module_info_ext value */
	/* 0x64.0 - 0x64.15 */
	 u_int16_t tx_power_lane3;
	/* Description - TX measured power channel 2.
measured in dBm/uW according to module_info_ext value */
	/* 0x64.16 - 0x64.31 */
	 u_int16_t tx_power_lane2;
/*---------------- DWORD[26] (Offset 0x68) ----------------*/
	/* Description - TX measured power channel 5.
measured in dBm/uW according to module_info_ext value */
	/* 0x68.0 - 0x68.15 */
	 u_int16_t tx_power_lane5;
	/* Description - TX measured power channel 4.
measured in dBm/uW according to module_info_ext value */
	/* 0x68.16 - 0x68.31 */
	 u_int16_t tx_power_lane4;
/*---------------- DWORD[27] (Offset 0x6c) ----------------*/
	/* Description - TX measured power channel 7.
measured in dBm/uW according to module_info_ext value */
	/* 0x6c.0 - 0x6c.15 */
	 u_int16_t tx_power_lane7;
	/* Description - TX measured power channel 6.
measured in dBm/uW according to module_info_ext value */
	/* 0x6c.16 - 0x6c.31 */
	 u_int16_t tx_power_lane6;
/*---------------- DWORD[28] (Offset 0x70) ----------------*/
	/* Description - TX measured bias current on channel 1 in 2uA */
	/* 0x70.0 - 0x70.15 */
	 u_int16_t tx_bias_lane1;
	/* Description - TX measured bias current on channel 0 in 2uA */
	/* 0x70.16 - 0x70.31 */
	 u_int16_t tx_bias_lane0;
/*---------------- DWORD[29] (Offset 0x74) ----------------*/
	/* Description - TX measured bias current on channel 3 in 2uA */
	/* 0x74.0 - 0x74.15 */
	 u_int16_t tx_bias_lane3;
	/* Description - TX measured bias current on channel 2 in 2uA */
	/* 0x74.16 - 0x74.31 */
	 u_int16_t tx_bias_lane2;
/*---------------- DWORD[30] (Offset 0x78) ----------------*/
	/* Description - TX measured bias current on channel 5 in 2uA */
	/* 0x78.0 - 0x78.15 */
	 u_int16_t tx_bias_lane5;
	/* Description - TX measured bias current on channel 4 in 2uA */
	/* 0x78.16 - 0x78.31 */
	 u_int16_t tx_bias_lane4;
/*---------------- DWORD[31] (Offset 0x7c) ----------------*/
	/* Description - TX measured bias current on channel 7 in 2uA */
	/* 0x7c.0 - 0x7c.15 */
	 u_int16_t tx_bias_lane7;
	/* Description - TX measured bias current on channel 6 in 2uA */
	/* 0x7c.16 - 0x7c.31 */
	 u_int16_t tx_bias_lane6;
/*---------------- DWORD[32] (Offset 0x80) ----------------*/
	/* Description - Alarm low temperature threshold in 1/256 C */
	/* 0x80.0 - 0x80.15 */
	 u_int16_t temperature_low_th;
	/* Description - Alarm high temperature threshold in 1/256 C */
	/* 0x80.16 - 0x80.31 */
	 u_int16_t temperature_high_th;
/*---------------- DWORD[33] (Offset 0x84) ----------------*/
	/* Description - Alarm low Voltage threshold in 100uV */
	/* 0x84.0 - 0x84.15 */
	 u_int16_t voltage_low_th;
	/* Description - Alarm high Voltage threshold in 100uV */
	/* 0x84.16 - 0x84.31 */
	 u_int16_t voltage_high_th;
/*---------------- DWORD[34] (Offset 0x88) ----------------*/
	/* Description - Alarm low RX Power threshold in dBm. 
Taking only from channel 0. */
	/* 0x88.0 - 0x88.15 */
	 u_int16_t rx_power_low_th;
	/* Description - Alarm high RX Power threshold in dBm. 
Taking only from channel 0. */
	/* 0x88.16 - 0x88.31 */
	 u_int16_t rx_power_high_th;
/*---------------- DWORD[35] (Offset 0x8c) ----------------*/
	/* Description - Alarm low TX Power threshold in dBm. 
Taking only from channel 0. */
	/* 0x8c.0 - 0x8c.15 */
	 u_int16_t tx_power_low_th;
	/* Description - Alarm high TX Power threshold in dBm. 
Taking only from channel 0. */
	/* 0x8c.16 - 0x8c.31 */
	 u_int16_t tx_power_high_th;
/*---------------- DWORD[36] (Offset 0x90) ----------------*/
	/* Description - Alarm low TX Bias current threshold in 2 uA. */
	/* 0x90.0 - 0x90.15 */
	 u_int16_t tx_bias_low_th;
	/* Description - Alarm high TX Bias current threshold in 2 uA. */
	/* 0x90.16 - 0x90.31 */
	 u_int16_t tx_bias_high_th;
/*---------------- DWORD[37] (Offset 0x94) ----------------*/
	/* Description - Nominal laser wavelength in nm */
	/* 0x94.0 - 0x94.15 */
	 u_int16_t wavelength;
	/* Description - SMF link length
SFP per byte 14,15.
QSFP per byte 142
for CMIS based modules, per byte 132

bit 9:8 - 00 length base in 1 km units
bit 9:8 - 01 length base in 100m units
bits 7:0 - length base */
	/* 0x94.16 - 0x94.25 */
	 u_int16_t smf_length;
	/* Description - set in case of Linear Direct Drive module */
	/* 0x94.27 - 0x94.27 */
	 u_int8_t did_cap;
	/* Description - rx power measurement type
0 - OMA
1 - Average power */
	/* 0x94.28 - 0x94.28 */
	 u_int8_t rx_power_type;
	/* Description - Valid for CMIS modules only.
Module state:
0 - reserved
1 - LowPwr state
2 - PwrUp state
3 - Ready state
4 - PwrDn state
5 - Fault state */
	/* 0x94.29 - 0x94.31 */
	 u_int8_t module_st;
/*---------------- DWORD[38] (Offset 0x98) ----------------*/
	/* Description - Byte 164 of SFF-8636
For CMIS modules IB Protocols. */
	/* 0x98.0 - 0x98.7 */
	 u_int8_t ib_compliance_code;
	/* Description - Valid for CMIS modules only.
According to current Active set, value of Module Media Inter
face byte */
	/* 0x98.16 - 0x98.23 */
	 u_int8_t active_set_media_compliance_code;
	/* Description - Valid for CMIS modules only.
According to current Active set, value of Host Electrical Inter
face byte */
	/* 0x98.24 - 0x98.31 */
	 u_int8_t active_set_host_compliance_code;
/*---------------- DWORD[39] (Offset 0x9c) ----------------*/
	/* Description - Bitmask of width of IB Protocols */
	/* 0x9c.0 - 0x9c.5 */
	 u_int8_t ib_width;
	/* Description - monitoring capabilities mask
Bit 0 - temperature monitoring implemented
Bit 1 - voltage monitoring implemented
Bit 2 - tx power monitoring implemented
Bit 3 - rx power monitoring implemented
Bit 4 - tx bias monitoring implemented */
	/* 0x9c.8 - 0x9c.15 */
	 u_int8_t monitor_cap_mask;
	/* Description - Nominal bit rate in units of 100Mb/s */
	/* 0x9c.16 - 0x9c.23 */
	 u_int8_t nbr_100;
	/* Description - Nominal bit rate in units of 250Mb/s */
	/* 0x9c.24 - 0x9c.31 */
	 u_int8_t nbr_250;
/*---------------- DWORD[40] (Offset 0xa0) ----------------*/
	/* Description - DataPath state for lane7 */
	/* 0xa0.0 - 0xa0.3 */
	 u_int8_t dp_st_lane7;
	/* Description - DataPath state for lane6 */
	/* 0xa0.4 - 0xa0.7 */
	 u_int8_t dp_st_lane6;
	/* Description - DataPath state for lane5 */
	/* 0xa0.8 - 0xa0.11 */
	 u_int8_t dp_st_lane5;
	/* Description - DataPath state for lane4 */
	/* 0xa0.12 - 0xa0.15 */
	 u_int8_t dp_st_lane4;
	/* Description - DataPath state for lane3 */
	/* 0xa0.16 - 0xa0.19 */
	 u_int8_t dp_st_lane3;
	/* Description - DataPath state for lane2 */
	/* 0xa0.20 - 0xa0.23 */
	 u_int8_t dp_st_lane2;
	/* Description - DataPath state for lane1 */
	/* 0xa0.24 - 0xa0.27 */
	 u_int8_t dp_st_lane1;
	/* Description - DataPath state for lane0 */
	/* 0xa0.28 - 0xa0.31 */
	 u_int8_t dp_st_lane0;
/*---------------- DWORD[41] (Offset 0xa4) ----------------*/
	/* Description - OM5 fiber length supported in units of 2m */
	/* 0xa4.0 - 0xa4.7 */
	 u_int8_t length_om5;
	/* Description - OM4 fiber length supported in units of 2m
SFP in units of 10m */
	/* 0xa4.8 - 0xa4.15 */
	 u_int8_t length_om4;
	/* Description - OM3 fiber length supported in units of 2m
SFP in units of 10m */
	/* 0xa4.16 - 0xa4.23 */
	 u_int8_t length_om3;
	/* Description - OM2 fiber length supported in units of 1m
SFP in units of 10m */
	/* 0xa4.24 - 0xa4.31 */
	 u_int8_t length_om2;
/*---------------- DWORD[42] (Offset 0xa8) ----------------*/
	/* Description - memory map revision */
	/* 0xa8.0 - 0xa8.7 */
	 u_int8_t memory_map_rev;
	/* Description - 16-bit integer value for the laser wavelength tolerance in nm 
divided by 200 (units of 0.005nm). */
	/* 0xa8.8 - 0xa8.23 */
	 u_int16_t wavelength_tolerance;
	/* Description - OM1 fiber length supported in units of 10m */
	/* 0xa8.24 - 0xa8.31 */
	 u_int8_t length_om1;
/*---------------- DWORD[43] (Offset 0xac) ----------------*/
	/* Description - memory map compliance in ASCII.
SFF-8472 / SFF-8636/ CMIS */
	/* 0xac.0 - 0xac.31 */
	 u_int32_t memory_map_compliance;
/*---------------- DWORD[44] (Offset 0xb0) ----------------*/
	/* Description - ASCII code for vendor's date code.
63:48- 2 digit for date code year, 00 = year 2000
47:32 - 2 digit for date code month.
31:16 - 2 digit for day of the month code.
15:0 - 2 digit LOT code. */
	/* 0xb0.0 - 0xb4.31 */
	 u_int64_t date_code;
/*---------------- DWORD[46] (Offset 0xb8) ----------------*/
	/* Description - vendor oui */
	/* 0xb8.0 - 0xb8.23 */
	 u_int32_t vendor_oui;
	/* Description - connector type based on SFF-8024 */
	/* 0xb8.24 - 0xb8.31 */
	 u_int8_t connector_type;
/*---------------- DWORD[47] (Offset 0xbc) ----------------*/
	/* Description - Rx output status indication per lane */
	/* 0xbc.0 - 0xbc.7 */
	 u_int8_t rx_output_valid;
	/* Description - Rx input status indication per lane */
	/* 0xbc.8 - 0xbc.15 */
	 u_int8_t rx_input_valid;
	/* Description - Defines which Tx input lanes must be frequency synchronous.
0: Tx_input_lanes_1_8
1: Tx_input_lanes_1_4_and_5-8
2: Tx_input_lanes_1_2_and_3_4_and_5_6_and_7_8
3: Lanes_may_be_asynchronous_in_frequency */
	/* 0xbc.16 - 0xbc.17 */
	 u_int8_t tx_input_freq_sync;
/*---------------- DWORD[48] (Offset 0xc0) ----------------*/
	/* Description - Relevant for CMIS modules only
Error Code response for ConrolSet configuration of DataPath.
0x0: ConfigUndefined
0x1: ConfigSuccess
0x2: ConfigRejected
0x3: ConfigRejectedInvalidAppSel
0x4: ConfigRejectedInvalidDataPath
0x5: ConfigRejectedInvalidSI
0x6: ConfigRejectedLanesInUse
0x7: ConfigRejectedPartialDataPath
0xC: ConfigInProgress */
	/* 0xc0.0 - 0xc0.3 */
	 u_int8_t error_code;
	/* Description - Relevant for CMIS modules only */
	/* 0xc0.4 - 0xc0.7 */
	 u_int8_t cdr_vendor;
	/* Description - Maximum length of allowed fiber in meters */
	/* 0xc0.16 - 0xc0.31 */
	 u_int16_t max_fiber_length;
};

/* Description -   */
/* Size in bytes - 56 */
struct DDOperationInfo {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t pd_fsm_state;
	/* Description -  */
	/* 0x0.16 - 0x0.19 */
	 u_int8_t neg_mode_active;
	/* Description -  */
	/* 0x0.20 - 0x0.23 */
	 u_int8_t proto_active;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t phy_hst_fsm_state;
	/* Description -  */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t ib_phy_fsm_state;
	/* Description -  */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t eth_an_fsm_state;
	/* Description -  */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t phy_mngr_fsm_state;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t phy_manager_link_enabled;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t core_to_phy_link_enabled;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t cable_proto_cap;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t link_active;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.3 */
	 u_int8_t loopback_mode;
	/* Description -  */
	/* 0x18.16 - 0x18.23 */
	 u_int8_t retran_mode_request;
	/* Description -  */
	/* 0x18.24 - 0x18.31 */
	 u_int8_t retran_mode_active;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t fec_mode_request;
	/* Description -  */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t fec_mode_active;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.0 - 0x20.3 */
	 u_int8_t eth_100g_fec_support;
	/* Description -  */
	/* 0x20.4 - 0x20.7 */
	 u_int8_t eth_25g_50g_fec_support;
	/* Description -  */
	/* 0x20.16 - 0x20.31 */
	 u_int16_t profile_fec_in_use;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description -  */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t pd_link_enabled;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t phy_hst_link_enabled;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description -  */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t eth_an_link_enabled;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description -  */
	/* 0x30.0 - 0x30.3 */
	 u_int8_t psi_fsm_state;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description -  */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t cable_proto_cap_ext;
};

/* Description -   */
/* Size in bytes - 96 */
struct DDPCIPerfCounters {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t life_time_counter_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t life_time_counter_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Number of transitions to recovery due to 
Framing errors and CRC (dlp and tlp) errors. */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t rx_errors;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Number of transitions to recovery due to 
EIEOS and TS errors. */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t tx_errors;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Number of transitions to recovery due to get
ting EIEOS */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t l0_to_recovery_eieos;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Number of transitions to recovery due to get
ting TS */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t l0_to_recovery_ts;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Number of transitions to recovery due to iden
tifying framing errors at gen3/4. */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t l0_to_recovery_framing;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Number of transitions to recovery due to link 
retrain request from data link */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t l0_to_recovery_retrain;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Number of transitions to recovery due to iden
tifying CRC DLLP errors */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t crc_error_dllp;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Number of transitions to recovery due to iden
tifying CRC TLP errors */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t crc_error_tlp;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - The number of packets dropped due to lack of 
PCIe buffers or receive path from NIC port 
toward the hosts. */
	/* 0x28.0 - 0x2c.31 */
	 u_int64_t tx_overflow_buffer_pkt;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - The percentage of time within the last second 
that the NIC had outbound non-posted read 
requests but could not perform the operation 
due to insufficient non-posted credits.
Supported only when MCAM.pcie_out
bound_stalled ==1. */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t outbound_stalled_reads;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - The percentage of time within the last second 
that the NIC had outbound posted writes 
requests but could not perform the operation 
due to insufficient posted credits.
Supported only when MCAM.pcie_out
bound_stalled ==1. */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t outbound_stalled_writes;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - The number of events where out
bound_stalled_reads was above a threshold.
The threshold is configured by out
bound_stalled_reads_th in MPEGC.
Supported only when MCAM.pcie_out
bound_stalled ==1. */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t outbound_stalled_reads_events;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - The number of events where out
bound_stalled_writes was above a threshold.
The threshold is configured by out
bound_stalled_writes_th in MPEGC.
Supported only when MCAM.pcie_out
bound_stalled ==1. */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t outbound_stalled_writes_events;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - The number of packets marked due to lack of 
PCIe buffers or receive path from NIC port 
toward the hosts.
Supported only if MCAM.mark_tx_action_cqe 
or MCAM.mark_tx_action_cnp are set to '1'. */
	/* 0x40.0 - 0x44.31 */
	 u_int64_t tx_overflow_buffer_marked_pkt;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - Effective_BER = 
effective_ber_coef*10^(-effective_ber_magnitude) */
	/* 0x48.0 - 0x48.3 */
	 u_int8_t effective_ber_coef;
	/* Description - Effective_BER = 
effective_ber_coef*10^(-effective_ber_magnitude) */
	/* 0x48.8 - 0x48.15 */
	 u_int8_t effective_ber_magnitude;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - [Internal] BER timer since last cleared 
cleared by clr bit in MPCNT */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t time_since_last_clear_high;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description - [Internal] BER timer since last cleared 
cleared by clr bit in MPCNT */
	/* 0x50.0 - 0x50.31 */
	 u_int32_t time_since_last_clear_low;
};

/* Description -  page in DiagnostiData MAD */
/* Size in bytes - 32 */
struct DDPageIdentification {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x1c.31 */
	 u_int32_t pages_group[8];
};

/* Description -  page in DiagnostiData MAD */
/* Size in bytes - 112 */
struct DDPhyInfo {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t port_notifications;
	/* Description -  */
	/* 0x0.24 - 0x0.31 */
	 u_int8_t remote_device_type;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t lp_ib_revision;
	/* Description -  */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t ib_revision;
	/* Description -  */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t num_of_negotiation_attempts;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t phy_manger_disable_mask;
	/* Description -  */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t hw_link_phy_state;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t pcs_phy_state;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t lp_proto_enabled;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t lp_fec_mode_request;
	/* Description -  */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t lp_fec_mode_support;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t ib_last_link_down_reason;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.0 - 0x1c.7 */
	 u_int8_t eth_last_link_down_lane_3;
	/* Description -  */
	/* 0x1c.8 - 0x1c.15 */
	 u_int8_t eth_last_link_down_lane_2;
	/* Description -  */
	/* 0x1c.16 - 0x1c.23 */
	 u_int8_t eth_last_link_down_lane_1;
	/* Description -  */
	/* 0x1c.24 - 0x1c.31 */
	 u_int8_t eth_last_link_down_lane_0;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description -  */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t speed_deg_db;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.0 - 0x28.23 */
	 u_int32_t degrade_grade_lane_0;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description -  */
	/* 0x2c.0 - 0x2c.23 */
	 u_int32_t degrade_grade_lane_1;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description -  */
	/* 0x30.0 - 0x30.23 */
	 u_int32_t degrade_grade_lane_2;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description -  */
	/* 0x34.0 - 0x34.23 */
	 u_int32_t degrade_grade_lane_3;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description -  */
	/* 0x48.0 - 0x48.7 */
	 u_int8_t kr_startup_fsm_lane_3;
	/* Description -  */
	/* 0x48.8 - 0x48.15 */
	 u_int8_t kr_startup_fsm_lane_2;
	/* Description -  */
	/* 0x48.16 - 0x48.23 */
	 u_int8_t kr_startup_fsm_lane_1;
	/* Description -  */
	/* 0x48.24 - 0x48.31 */
	 u_int8_t kr_startup_fsm_lane_0;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description -  */
	/* 0x50.0 - 0x50.31 */
	 u_int32_t eth_an_debug_indication;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description -  */
	/* 0x54.0 - 0x54.15 */
	 u_int16_t ib_phy_fsm_state_trace;
/*---------------- DWORD[22] (Offset 0x58) ----------------*/
	/* Description -  */
	/* 0x58.0 - 0x58.15 */
	 u_int16_t kr_startup_debug_indications_1;
	/* Description -  */
	/* 0x58.16 - 0x58.31 */
	 u_int16_t kr_startup_debug_indications_0;
/*---------------- DWORD[23] (Offset 0x5c) ----------------*/
	/* Description -  */
	/* 0x5c.0 - 0x5c.15 */
	 u_int16_t kr_startup_debug_indications_3;
	/* Description -  */
	/* 0x5c.16 - 0x5c.31 */
	 u_int16_t kr_startup_debug_indications_2;
/*---------------- DWORD[26] (Offset 0x68) ----------------*/
	/* Description -  */
	/* 0x68.0 - 0x68.3 */
	 u_int8_t irisc_status;
/*---------------- DWORD[27] (Offset 0x6c) ----------------*/
	/* Description -  */
	/* 0x6c.0 - 0x6c.31 */
	 u_int32_t stamping_reason;
};

/* Description -  page in DiagnostiData MAD */
/* Size in bytes - 200 */
struct DDPhysCounters {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0xbc.31 */
	 u_int64_t counter[24];
/*---------------- DWORD[48] (Offset 0xc0) ----------------*/
	/* Description -  */
	/* 0xc0.0 - 0xc0.31 */
	 u_int32_t counter24;
/*---------------- DWORD[49] (Offset 0xc4) ----------------*/
	/* Description -  */
	/* 0xc4.0 - 0xc4.31 */
	 u_int32_t counter25;
};

/* Description -  page in DiagnostiData MAD */
/* Size in bytes - 216 */
struct DDTroubleShootingInfo {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t group_opcode;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t status_opcode;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t user_feedback_index;
	/* Description -  */
	/* 0x8.16 - 0x8.31 */
	 u_int16_t user_feedback_data;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.24 - 0xd8.23 */
	 char status_message[205];
};

/* Description -  page 241 in DiagnostiData MAD */
/* Size in bytes - 248 */
struct DD_InfiniBandGeneralCounter {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Total number of data in Qword (8 Bytes), received on the port.
This counter takes into account the packet alignment.
Supported only when indicated by PCAM.

Note: xmit and rcv counters may count differently (L1 layer based for TX, L2 layer based for RX). */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t port_rcv_data_qword_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Total number of data in Qword (8 Bytes), received on the port.
This counter takes into account the packet alignment.
Supported only when indicated by PCAM.

Note: xmit and rcv counters may count differently (L1 layer based for TX, L2 layer based for RX). */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t port_rcv_data_qword_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Total number of data in Qword (8 Bytes), transmitted on the port.
This counter takes into account the packet alignment.
Supported only when indicated by PCAM.

Notes: 
1. xmit and rcv counters may count differently (L1 layer based for TX, L2 layer based for RX).
2. The counter is not supported for SDR speed. */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t port_xmit_data_qword_high;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Total number of data in Qword (8 Bytes), transmitted on the port.
This counter takes into account the packet alignment.
Supported only when indicated by PCAM.

Notes: 
1. xmit and rcv counters may count differently (L1 layer based for TX, L2 layer based for RX).
2. The counter is not supported for SDR speed. */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t port_xmit_data_qword_low;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - The total number of packets that were dropped since it contained errors. Reasons for this include:
1. dropped due to MPR mismatch.
Supported only when indicated by PCAM. */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t rq_general_error_high;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - The total number of packets that were dropped since it contained errors. Reasons for this include:
1. dropped due to MPR mismatch.
Supported only when indicated by PCAM. */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t rq_general_error_low;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - TBD */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t port_xmit_ebp_high;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - TBD */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t port_xmit_ebp_low;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - TBD */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t port_sw_hoq_lifetime_limit_discards_high;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - TBD */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t port_sw_hoq_lifetime_limit_discards_low;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - TBD */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t dqs2llu_xmit_wait_arb_global_high;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - TBD */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t dqs2llu_xmit_wait_arb_global_low;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - TBD */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t grxb_fecn_mark_high;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - TBD */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t grxb_fecn_mark_low;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - TBD */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t general_transmit_discard_external_contain_high;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - TBD */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t general_transmit_discard_external_contain_low;
};

/* Description -  page ??? in DiagnostiData MAD */
/* Size in bytes - 80 */
struct DD_PLR_Counters {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x4.31 */
	 u_int64_t plr_rcv_codes;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0xc.31 */
	 u_int64_t plr_rcv_code_err;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x14.31 */
	 u_int64_t plr_rcv_uncorrectable_code;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x1c.31 */
	 u_int64_t plr_xmit_codes;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.0 - 0x24.31 */
	 u_int64_t plr_xmit_retry_codes;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.0 - 0x2c.31 */
	 u_int64_t plr_xmit_retry_events;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description -  */
	/* 0x30.0 - 0x34.31 */
	 u_int64_t plr_sync_events;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description -  */
	/* 0x38.0 - 0x3c.31 */
	 u_int64_t hi_retransmission_rate;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description -  */
	/* 0x40.0 - 0x44.31 */
	 u_int64_t plr_xmit_retry_codes_within_t_sec_max;
};

/* Description -  page ??? in DiagnostiData MAD */
/* Size in bytes - 132 */
struct DD_PhyStatisticalCounters {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x4.31 */
	 u_int64_t time_since_last_clear;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0xc.31 */
	 u_int64_t phy_received_bits;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x14.31 */
	 u_int64_t phy_symbol_errors;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x1c.31 */
	 u_int64_t phy_corrected_bits;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.0 - 0x24.31 */
	 u_int64_t phy_raw_errors_lane0;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.0 - 0x2c.31 */
	 u_int64_t phy_raw_errors_lane1;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description -  */
	/* 0x30.0 - 0x34.31 */
	 u_int64_t phy_raw_errors_lane2;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description -  */
	/* 0x38.0 - 0x3c.31 */
	 u_int64_t phy_raw_errors_lane3;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description -  */
	/* 0x40.0 - 0x44.31 */
	 u_int64_t phy_raw_errors_lane4;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description -  */
	/* 0x48.0 - 0x4c.31 */
	 u_int64_t phy_raw_errors_lane5;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description -  */
	/* 0x50.0 - 0x54.31 */
	 u_int64_t phy_raw_errors_lane6;
/*---------------- DWORD[22] (Offset 0x58) ----------------*/
	/* Description -  */
	/* 0x58.0 - 0x5c.31 */
	 u_int64_t phy_raw_errors_lane7;
/*---------------- DWORD[24] (Offset 0x60) ----------------*/
	/* Description -  */
	/* 0x60.0 - 0x60.3 */
	 u_int8_t raw_ber_coef;
	/* Description -  */
	/* 0x60.8 - 0x60.15 */
	 u_int8_t raw_ber_magnitude;
/*---------------- DWORD[25] (Offset 0x64) ----------------*/
	/* Description -  */
	/* 0x64.0 - 0x64.3 */
	 u_int8_t effective_ber_coef;
	/* Description -  */
	/* 0x64.8 - 0x64.15 */
	 u_int8_t effective_ber_magnitude;
/*---------------- DWORD[26] (Offset 0x68) ----------------*/
	/* Description -  */
	/* 0x68.0 - 0x68.3 */
	 u_int8_t symbol_ber_coef;
	/* Description -  */
	/* 0x68.8 - 0x68.15 */
	 u_int8_t symbol_ber_magnitude;
/*---------------- DWORD[27] (Offset 0x6c) ----------------*/
	/* Description -  */
	/* 0x6c.0 - 0x6c.3 */
	 u_int8_t raw_ber_coef_lane1;
	/* Description -  */
	/* 0x6c.8 - 0x6c.15 */
	 u_int8_t raw_ber_magnitude_lane1;
	/* Description -  */
	/* 0x6c.16 - 0x6c.19 */
	 u_int8_t raw_ber_coef_lane0;
	/* Description -  */
	/* 0x6c.24 - 0x6c.31 */
	 u_int8_t raw_ber_magnitude_lane0;
/*---------------- DWORD[28] (Offset 0x70) ----------------*/
	/* Description -  */
	/* 0x70.0 - 0x70.3 */
	 u_int8_t raw_ber_coef_lane3;
	/* Description -  */
	/* 0x70.8 - 0x70.15 */
	 u_int8_t raw_ber_magnitude_lane3;
	/* Description -  */
	/* 0x70.16 - 0x70.19 */
	 u_int8_t raw_ber_coef_lane2;
	/* Description -  */
	/* 0x70.24 - 0x70.31 */
	 u_int8_t raw_ber_magnitude_lane2;
/*---------------- DWORD[29] (Offset 0x74) ----------------*/
	/* Description -  */
	/* 0x74.0 - 0x74.3 */
	 u_int8_t raw_ber_coef_lane5;
	/* Description -  */
	/* 0x74.8 - 0x74.15 */
	 u_int8_t raw_ber_magnitude_lane5;
	/* Description -  */
	/* 0x74.16 - 0x74.19 */
	 u_int8_t raw_ber_coef_lane4;
	/* Description -  */
	/* 0x74.24 - 0x74.31 */
	 u_int8_t raw_ber_magnitude_lane4;
/*---------------- DWORD[30] (Offset 0x78) ----------------*/
	/* Description -  */
	/* 0x78.0 - 0x78.3 */
	 u_int8_t raw_ber_coef_lane7;
	/* Description -  */
	/* 0x78.8 - 0x78.15 */
	 u_int8_t raw_ber_magnitude_lane7;
	/* Description -  */
	/* 0x78.16 - 0x78.19 */
	 u_int8_t raw_ber_coef_lane6;
	/* Description -  */
	/* 0x78.24 - 0x78.31 */
	 u_int8_t raw_ber_magnitude_lane6;
/*---------------- DWORD[31] (Offset 0x7c) ----------------*/
	/* Description -  */
	/* 0x7c.0 - 0x80.31 */
	 u_int64_t phy_effective_errors;
};

/* Description -  page 247 in DiagnostiData MAD */
/* Size in bytes - 128 */
struct DD_RS_Histograms {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x7c.31 */
	 u_int64_t hist[16];
};

/* Description -   */
/* Size in bytes - 96 */
struct DD_pcie_lanes_counters {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t life_time_counter_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t life_time_counter_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Number of errors detected on logical lane 0 */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t error_counter_lane0;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Number of errors detected on logical lane 1 */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t error_counter_lane1;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Number of errors detected on logical lane 2 */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t error_counter_lane2;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Number of errors detected on logical lane 3 */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t error_counter_lane3;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Number of errors detected on logical lane 4 */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t error_counter_lane4;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Number of errors detected on logical lane 5 */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t error_counter_lane5;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Number of errors detected on logical lane 6 */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t error_counter_lane6;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Number of errors detected on logical lane 7 */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t error_counter_lane7;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - Number of errors detected on logical lane 8 */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t error_counter_lane8;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - Number of errors detected on logical lane 9 */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t error_counter_lane9;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - Number of errors detected on logical lane 10 */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t error_counter_lane10;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - Number of errors detected on logical lane 11 */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t error_counter_lane11;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - Number of errors detected on logical lane 12 */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t error_counter_lane12;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - Number of errors detected on logical lane 13 */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t error_counter_lane13;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - Number of errors detected on logical lane 14 */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t error_counter_lane14;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - Number of errors detected on logical lane 15 */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t error_counter_lane15;
};

/* Description -   */
/* Size in bytes - 96 */
struct DD_pcie_timers_states {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t life_time_counter_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - [Internal] Life time counter - can't be cleared. */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t life_time_counter_low;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Time form start until FW boot image starts running 
in usec. 
Note: can't be cleared. */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t time_to_boot_image_start;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Time form start until FW pci_link image starts run
ning in usec. */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t time_to_link_image;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Time it took FW to do calibration in usec. */
	/* 0x10.0 - 0x10.31 */
	 u_int32_t calibration_time;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Time form start until FW handle first prest */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t time_to_first_perst;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Time form start until first transition to 
LTSSM.Detect_Q */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t time_to_detect_state;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Time form start until first transition to LTSSM.L0 */
	/* 0x1c.0 - 0x1c.31 */
	 u_int32_t time_to_l0;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Time form start until crs is enabled */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t time_to_crs_en;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Time form start until FW plastic image starts run
ning in usec. */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t time_to_plastic_image_start;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - Time form start until FW iron image starts running 
in usec. */
	/* 0x28.0 - 0x28.31 */
	 u_int32_t time_to_iron_image_start;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - Number of persts arrived */
	/* 0x2c.0 - 0x2c.31 */
	 u_int32_t perst_handler;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - Number of times LTSSM entered L1 flow */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t times_in_l1;
/*---------------- DWORD[13] (Offset 0x34) ----------------*/
	/* Description - Number of times LTSSM entered L23 flow */
	/* 0x34.0 - 0x34.31 */
	 u_int32_t times_in_l23;
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description - Number of moves for DL_active to DL_down */
	/* 0x38.0 - 0x38.31 */
	 u_int32_t dl_down;
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description - Number of configuration requests that FW handled 
in less then 1 usec */
	/* 0x3c.0 - 0x3c.31 */
	 u_int32_t config_cycle1usec;
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description - Number of configuration requests that FW handled 
within 2 to 7 usec */
	/* 0x40.0 - 0x40.31 */
	 u_int32_t config_cycle2to7usec;
/*---------------- DWORD[17] (Offset 0x44) ----------------*/
	/* Description - Number of configuration requests that FW handled 
within 8 to 15 usec */
	/* 0x44.0 - 0x44.31 */
	 u_int32_t config_cycle8to15usec;
/*---------------- DWORD[18] (Offset 0x48) ----------------*/
	/* Description - Number of configuration requests that FW handled 
within 16 to 63 usec */
	/* 0x48.0 - 0x48.31 */
	 u_int32_t config_cycle16to63usec;
/*---------------- DWORD[19] (Offset 0x4c) ----------------*/
	/* Description - Number of configuration requests that FW handled 
took more than 64 usec */
	/* 0x4c.0 - 0x4c.31 */
	 u_int32_t config_cycle64usec;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description - Number of correctable error msg sent */
	/* 0x50.0 - 0x50.31 */
	 u_int32_t correctable_err_msg_sent;
/*---------------- DWORD[21] (Offset 0x54) ----------------*/
	/* Description - Number of Non-Fatal error msg sent */
	/* 0x54.0 - 0x54.31 */
	 u_int32_t non_fatal_err_msg_sent;
/*---------------- DWORD[22] (Offset 0x58) ----------------*/
	/* Description - Number of Fatal error msg sent */
	/* 0x58.0 - 0x58.31 */
	 u_int32_t fatal_err_msg_sent;
};

/* Description -   */
/* Size in bytes - 64 */
struct SMP_CableInfo {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t address;
	/* Description -  */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t page_number;
	/* Description - slave adddr */
	/* 0x0.24 - 0x0.31 */
	 u_int8_t device_address;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t size;
	/* Description -  */
	/* 0x4.30 - 0x4.30 */
	 u_int8_t pw_clr;
	/* Description -  */
	/* 0x4.31 - 0x4.31 */
	 u_int8_t pw_v;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t password;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t Reserved1;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.24 - 0x40.23 */
	 u_int8_t Byte[48];
};

/* Description -   */
/* Size in bytes - 64 */
struct SMP_EyeOpen {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t LinkWidthActive;
	/* Description -  */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t Reserved1;
	/* Description -  */
	/* 0x0.16 - 0x0.19 */
	 u_int8_t AutoNegoState;
	/* Description -  */
	/* 0x0.20 - 0x0.31 */
	 u_int16_t Reserved0;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t HighAmplitude_Lane0;
	/* Description -  */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t LowAmplitude_Lane0;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t PositiveBound_Lane0;
	/* Description -  */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t NegativeBound_Lane0;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.7 */
	 u_int8_t SelectedOptionTX_Lane0;
	/* Description -  */
	/* 0xc.8 - 0xc.15 */
	 u_int8_t SelectedOptionRX_Lane0;
	/* Description -  */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t AmpCalibration_Lane0;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t HighAmplitude_Lane1;
	/* Description -  */
	/* 0x10.16 - 0x10.23 */
	 u_int8_t LowAmplitude_Lane1;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.7 */
	 u_int8_t PositiveBound_Lane1;
	/* Description -  */
	/* 0x14.16 - 0x14.23 */
	 u_int8_t NegativeBound_Lane1;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.7 */
	 u_int8_t SelectedOptionTX_Lane1;
	/* Description -  */
	/* 0x18.8 - 0x18.15 */
	 u_int8_t SelectedOptionRX_Lane1;
	/* Description -  */
	/* 0x18.16 - 0x18.23 */
	 u_int8_t AmpCalibration_Lane1;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.0 - 0x1c.7 */
	 u_int8_t HighAmplitude_Lane2;
	/* Description -  */
	/* 0x1c.16 - 0x1c.23 */
	 u_int8_t LowAmplitude_Lane2;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.0 - 0x20.7 */
	 u_int8_t PositiveBound_Lane2;
	/* Description -  */
	/* 0x20.16 - 0x20.23 */
	 u_int8_t NegativeBound_Lane2;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description -  */
	/* 0x24.0 - 0x24.7 */
	 u_int8_t SelectedOptionTX_Lane2;
	/* Description -  */
	/* 0x24.8 - 0x24.15 */
	 u_int8_t SelectedOptionRX_Lane2;
	/* Description -  */
	/* 0x24.16 - 0x24.23 */
	 u_int8_t AmpCalibration_Lane2;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description -  */
	/* 0x28.0 - 0x28.7 */
	 u_int8_t HighAmplitude_Lane3;
	/* Description -  */
	/* 0x28.16 - 0x28.23 */
	 u_int8_t LowAmplitude_Lane3;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description -  */
	/* 0x2c.0 - 0x2c.7 */
	 u_int8_t PositiveBound_Lane3;
	/* Description -  */
	/* 0x2c.16 - 0x2c.23 */
	 u_int8_t NegativeBound_Lane3;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description -  */
	/* 0x30.0 - 0x30.7 */
	 u_int8_t SelectedOptionTX_Lane3;
	/* Description -  */
	/* 0x30.8 - 0x30.15 */
	 u_int8_t SelectedOptionRX_Lane3;
	/* Description -  */
	/* 0x30.16 - 0x30.23 */
	 u_int8_t AmpCalibration_Lane3;
};

/* Description -   */
/* Size in bytes - 4 */
struct SMP_LossyLinkConfig {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t Ignore_Credits_Mask;
	/* Description -  */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t Ignore_Buffer_Overrun_Mask;
};

/* Description -   */
/* Size in bytes - 4 */
struct SMP_MAD_AttrMod_CableInfo {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.15 */
	 u_int16_t PortSelect;
	/* Description -  */
	/* 0x0.16 - 0x0.30 */
	 u_int16_t Reserved;
	/* Description -  */
	/* 0x0.31 - 0x0.31 */
	 u_int8_t BitLock;
};

/* Description -   */
/* Size in bytes - 4 */
struct SMP_MAD_AttrMod_EyeOpen {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t PortSelect;
	/* Description -  */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t GroupLane;
};

/* Description -   */
/* Size in bytes - 16 */
struct SMP_TemperatureSensing {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - tss (RO) - device internal temperature sensing is supported. */
	/* 0x0.0 - 0x0.0 */
	 u_int8_t tss;
	/* Description - stgs (RO) - shutdown temperature notification via GPIO pin is supported. If stge (see below) is set,
then GPIO11 will be asserted once the maximum allowed operating temperature of the device is
exceeded. */
	/* 0x0.1 - 0x0.1 */
	 u_int8_t stgs;
	/* Description - stge (R/W) - if set to 1, then shutdown temperature notification via GPIO pin is enabled. */
	/* 0x0.2 - 0x0.2 */
	 u_int8_t stge;
	/* Description - wtts (RO) - warning temperature trap notification is supported. If wtte (see below) is set, then the
device will send a TemperatureSensing trap once a user-defined temperature threshold is reached. */
	/* 0x0.3 - 0x0.3 */
	 u_int8_t wtts;
	/* Description - wtte (R/W) - if set to 1, then warning temperature trap notification is enabled. */
	/* 0x0.4 - 0x0.4 */
	 u_int8_t wtte;
	/* Description - wtgs (RO) - warning temperature notification via GPIO pin is supported. If wtge (see below) is set,
then GPIO13 will be asserted once a user-defined temperature threshold is reached. */
	/* 0x0.5 - 0x0.5 */
	 u_int8_t wtgs;
	/* Description - wtge (R/W) - if set to 1, then warning temperature notification via GPIO pin is enabled. */
	/* 0x0.6 - 0x0.6 */
	 u_int8_t wtge;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - current_temp (RO) - the current device temperature in C. */
	/* 0x4.0 - 0x4.10 */
	 u_int16_t current_temp;
	/* Description - max_temp (R/W) - the maximum temperature reached by the device in C */
	/* 0x4.16 - 0x4.26 */
	 u_int16_t max_temp;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - overtemp_warning_threshold_hi (R/W) - if the device reaches this temperature threshold, then it
in an over-temperature warning state. If enabled, GPIO13 and/or a trap will be issued. */
	/* 0x8.0 - 0x8.10 */
	 u_int16_t overtemp_warning_threshold_hi;
	/* Description - overtemp_warning_threshold_lo (R/W) - if the device reaches this temperature threshold, then it 
in an over-temperature warning state. If enabled, GPIO13 and/or a trap will be issued. */
	/* 0x8.16 - 0x8.26 */
	 u_int16_t overtemp_warning_threshold_lo;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - ws (RO) - If set to 1, this bit indicates that the device is in the over-temperature warning state. */
	/* 0xc.0 - 0xc.0 */
	 u_int8_t ws;
	/* Description - wga (R/W) - If set (by the device) to 1, this bit indicates that GPIO13 has been asserted to indicate
an over-temperature warning state. If wgm=1 (see below), then writing 0 to this bit deasserts
GPIO13. */
	/* 0xc.1 - 0xc.1 */
	 u_int8_t wga;
	/* Description - wgp (R/W) - over-temperature warning GPIO polarity. If wgp=1, then GPIO13 will be asserted
high (1) in case of an over-temperature warning state; if wgp=0, then GPIO13 will be asserted low
(0). */
	/* 0xc.2 - 0xc.2 */
	 u_int8_t wgp;
	/* Description - wgm (R/W) - over-temperature warning GPIO mode. 
0x0 - GPIO13 will remain asserted as long as the device is in the over-temperature warning state;
0x1 - GPIO13 is asserted to indicate an over-temperature warning state, it will remain asserted until wga is cleared.
0x2 - reserved
0x3 - reserved */
	/* 0xc.3 - 0xc.4 */
	 u_int8_t wgm;
};

/* Description -   */
/* Size in bytes - 156 */
struct VendorSpec_PhyConfig {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.1 */
	 u_int8_t PortMode;
	/* Description -  */
	/* 0x0.7 - 0x0.7 */
	 u_int8_t MasterPort;
	/* Description -  */
	/* 0x0.8 - 0x0.8 */
	 u_int8_t Sloop;
	/* Description -  */
	/* 0x0.12 - 0x0.15 */
	 u_int8_t SerDesParamsLinkSpeeds;
	/* Description -  */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t PortCommand;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.11 */
	 u_int16_t TxPolarity;
	/* Description -  */
	/* 0x4.16 - 0x4.17 */
	 u_int8_t TxReserveLane;
	/* Description -  */
	/* 0x4.18 - 0x4.18 */
	 u_int8_t TXReverseSub0;
	/* Description -  */
	/* 0x4.20 - 0x4.20 */
	 u_int8_t TXReverseSub1;
	/* Description -  */
	/* 0x4.22 - 0x4.22 */
	 u_int8_t TXReverseSub2;
	/* Description -  */
	/* 0x4.24 - 0x4.24 */
	 u_int8_t ClusterEnable;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.11 */
	 u_int16_t SerDesParameterLanesEnable;
};

/* Description -  0x9007 */
/* Size in bytes - 12 */
struct fore_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Fan speed is below the low limit defined in MFSL register. 
Each bit relates to a single tachometer and indicates the spe
cific tachometer reading is below the threshold. */
	/* 0x0.16 - 0x0.31 */
	 u_int16_t fan_under_limit;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Fan speed is above the high limit defined in MFSL register. 
Each bit relates to a single tachometer and indicates the spe
cific tachometer reading is above the threshold. */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t fan_over_limit;
};

/* Description -  0x9001 */
/* Size in bytes - 8 */
struct mfcr_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Controls the frequency of the PWM signal.
Supported frequencies are:
0x0: 11Hz 
0x1: 14.7Hz
0x2: 22.1Hz
0x3 - 0111111: Reserved
0x40: 1.4KHz
0x41: 5KHz
0x42: 20KHz
0x43: 22.5KHz
0x44: 25KHz
0x45 - 0x7F: Reserved */
	/* 0x0.0 - 0x0.6 */
	 u_int8_t pwm_frequency;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Indicates which of the PWM control is active (bit per PWM) */
	/* 0x4.0 - 0x4.4 */
	 u_int8_t pwm_active;
	/* Description - Indicates which of the tachometer is active (bit per tachome
ter) */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t tacho_active;
};

/* Description -  0x903B */
/* Size in bytes - 44 */
struct mfnr_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.4 */
	 u_int8_t fan_index;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.24 - 0x1c.23 */
	 char serial_number[25];
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.24 - 0x2c.23 */
	 char part_number[17];
};

/* Description -  0x9004 */
/* Size in bytes - 12 */
struct mfsl_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.0 */
	 u_int8_t ie;
	/* Description -  */
	/* 0x0.2 - 0x0.3 */
	 u_int8_t ee;
	/* Description -  */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t tacho;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t tach_min;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t tach_max;
};

/* Description -  0x9003 */
/* Size in bytes - 8 */
struct mfsm_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t tacho;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t rpm;
};

/* Description -   */
/* Size in bytes - 104 */
struct mpcnt_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Performance counter group.
0: PCIE_performance_counters

 
3: PCIE_physical_layer_indications */
	/* 0x0.0 - 0x0.5 */
	 u_int8_t grp;
	/* Description - the node within each depth. */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t node;
	/* Description - PCIe index number (Internal domain index)
Reserved when access is from the host */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t pcie_index;
	/* Description - depth level of the DUT of some hierarchy */
	/* 0x0.24 - 0x0.29 */
	 u_int8_t depth;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Clear counters. Setting the clr bit will reset the counter value for all counters in the counter group. This bit can be set for both Set() and Get() operation. */
	/* 0x4.31 - 0x4.31 */
	 u_int8_t clr;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Counter set as described in
Table 295, "PCIe Performance Counters Data Layout," on page 468 */
	/* 0x8.0 - 0x64.31 */
	 union mpcnt_reg_counter_set_auto page_data;
};

/* Description -   */
/* Size in bytes - 44 */
struct mpein_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - the node within each depth. */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t node;
	/* Description - PCIe index number (Internal domain index)
Reserved when access is from the host, but can be used when 
operating in Socket-Direct mode. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t pcie_index;
	/* Description - depth level of the DUT of some hierarchy */
	/* 0x0.24 - 0x0.29 */
	 u_int8_t depth;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t capability_mask;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Max Link Speed:
Bit 0: 2.5G - (Gen1)
Bit 1: 5G - (Gen2)
Bit 2: 8G - (Gen3)
Bit 4: 16G - (Gen4)
Bit 5: 32G (Gen5) */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t link_speed_enabled;
	/* Description - Maximum Link Width enabled:
0: 1x
1: 2x
2: 4x
3: 8x
4: 16x */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t link_width_enabled;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Current Link Speed:
Bit 0: 2.5G (Gen1)
Bit 1: 5G (Gen2)
Bit 2: 8G (Gen3)
Bit 4: 16G (Gen4)
Bit 5: 32G (Gen5) */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t link_speed_active;
	/* Description - Negotiated Link Width, pcie_link_width active:
0 - 1x
1 - 2x
2 - 4x
3 - 8x
4 - 16x */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t link_width_active;
	/* Description - The physical lane position of logical lane0 */
	/* 0xc.24 - 0xc.31 */
	 u_int8_t lane0_physical_position;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Number of Total Virtual Functions (for all PFs) */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t num_of_vfs;
	/* Description - Number of Physical Functions (PFs) */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t num_of_pfs;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Bus Device Function - only for function0 */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t bdf0;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Reversal mode of the link:
0 - straight 
1 - reversal

Note: together with lane0_physical_position provide the physi
cal lane. */
	/* 0x18.0 - 0x18.0 */
	 u_int8_t lane_reversal;
	/* Description - Indicates the specific type of this PCI Express Function. Note 
that different Functions in a multi-Function device can gener
ally be of different types.
0 - PCI Express Endpoint port
4 - Root Port of PCI Express Root Complex
5 - PCI Express Upstream port
6 - PCI Express Downstream port */
	/* 0x18.12 - 0x18.15 */
	 u_int8_t port_type;
	/* Description - Indicates the status of PCI power consumption limitations.
0: PCI power report could not be read.
1: Sufficient power reported.
2: Insufficient power reported.
3-7: Reserved */
	/* 0x18.16 - 0x18.18 */
	 u_int8_t pwr_status;
	/* Description - Max payload size in bytes:
0 - 128B
1 - 256B
2 - 512B
3 - 1024B
4 - 2048B
5 - 4096B */
	/* 0x18.24 - 0x18.27 */
	 u_int8_t max_payload_size;
	/* Description - Max read request size in bytes:
0 - 128B
1 - 256B
2 - 512B
3 - 1024B
4 - 2048B
5 - 4096B */
	/* 0x18.28 - 0x18.31 */
	 u_int8_t max_read_request_size;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - Power reported by the PCI device. The units are in Watts.
0: Power is unknown. */
	/* 0x1c.0 - 0x1c.11 */
	 u_int16_t pci_power;
	/* Description - Peer Max Link Speed:
Bit 0: 2.5G - (Gen1)
Bit 1: 5G - (Gen2)
Bit 2: 8G - (Gen3)
Bit 4: 16G - (Gen4)
Bit 5: 32G (Gen5) */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t link_peer_max_speed;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - [Internal] Indicates the status of the PCIE state machine:
0x00 - Disable TS1
0x01 - Disable Ack
0x02 - Disable Wait
0x10 - RESET
0x20 - Loop Back Master Active
0x21 - Loop Back Master Exit
0x31 - Loop Back Slave Entry
0x32 - Loop Back Slave Align
0x33 - Loop Back Slave EB Threshold
0x34 - Loop Back Slave Active
0x35 - Loop Back Slave Idle
0x36 - Loop Back Slave Exit
0x40 - Detect Quiet
0x41 - Detect Active 1
0x42 - Detect Active 2
0x50 - Polling Active 
0x51 - Polling Compliance Entry 
0x52 - Polling Compliance 
0x53 - Polling Compliance Exit
0x54 - Polling Config
0x60 - Config Width Start
0x61 - Config Width Ack
0x62 - Config Lane Wait
0x63 - Config Lane Ack
0x64 - Config Complete
0x65 - Config Idle
0x70 - L0_UP
0x71:0x7F - L0s 
0x80 - L1 ENTER
0x81 - L1 ACTIVE
0x90 - L1 EXIT
0xA0 - Recover Receiver Lock 
0xA1 - Recover Speed 
0xA2 - Recover Config 
0xA2 - Recover Idle 
0xA5 - Recover ESpeed 
0xA8 - Recover Equalization Phase 0
0xA9 - Recover Equalization Phase 1
0xAA - Recover Equalization Phase 2
0xAB - Recover Equalization Phase 3
0xAC - Recover Equalization Idle
0xB0 - Force TS1
0xC0 - Force TS2
0xD0 - Force IDLE
0xE0 - Force COMP
0xF0 - Force disable */
	/* 0x24.8 - 0x24.15 */
	 u_int8_t port_state;
	/* Description - device_status bit mask:
Bit 0: Correctable_error
Bit 1: Non_Fatal_Error_detection
Bit 2: Fatal_Error_detected
Bit 3: Unsupported_request_detected
Bit 4: AUX_power 
Bit 5: Transaction_Pending */
	/* 0x24.16 - 0x24.31 */
	 u_int16_t device_status;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - [Internal] receiver detect result bit mask per lane */
	/* 0x28.0 - 0x28.15 */
	 u_int16_t receiver_detect_result;
};

/* Description -   */
/* Size in bytes - 16 */
struct mpir_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t host_buses;
	/* Description -  */
	/* 0x0.8 - 0x0.15 */
	 u_int8_t node;
	/* Description -  */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t pcie_index;
	/* Description -  */
	/* 0x0.24 - 0x0.29 */
	 u_int8_t depth;
	/* Description -  */
	/* 0x0.31 - 0x0.31 */
	 u_int8_t sdm;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t subordinate_bus;
	/* Description -  */
	/* 0x4.8 - 0x4.15 */
	 u_int8_t secondary_bus;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.3 - 0x8.7 */
	 u_int8_t device;
	/* Description -  */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t bus;
	/* Description -  */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t local_port;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.12 */
	 u_int16_t slot_number;
	/* Description -  */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t num_con_devices;
	/* Description -  */
	/* 0xc.31 - 0xc.31 */
	 u_int8_t slot_cap;
};

/* Description -   */
/* Size in bytes - 24 */
struct mrcs_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Ref Clock Statistics */
	/* 0x0.0 - 0x14.31 */
	 struct ref_clock_stat_db ref_clock_stat[2];
};

/* Description -  0x9021 */
/* Size in bytes - 128 */
struct msgi_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.24 - 0x18.23 */
	 char serial_number[25];
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.24 - 0x34.23 */
	 char part_number[21];
/*---------------- DWORD[14] (Offset 0x38) ----------------*/
	/* Description -  */
	/* 0x38.24 - 0x3c.23 */
	 char revision[5];
/*---------------- DWORD[15] (Offset 0x3c) ----------------*/
	/* Description -  */
	/* 0x3c.24 - 0x40.23 */
	 char manufacturing_date[5];
/*---------------- DWORD[16] (Offset 0x40) ----------------*/
	/* Description -  */
	/* 0x40.24 - 0x80.23 */
	 char product_name[65];
};

/* Description -  0x900D */
/* Size in bytes - 160 */
struct msps_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x4c.31 */
	 struct psu_status psu0;
/*---------------- DWORD[20] (Offset 0x50) ----------------*/
	/* Description -  */
	/* 0x50.0 - 0x9c.31 */
	 struct psu_status psu1;
};

/* Description -  0x9009 */
/* Size in bytes - 8 */
struct mtcap_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.6 */
	 u_int8_t sensor_count;
};

/* Description -  0x900A */
/* Size in bytes - 32 */
struct mtmp_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.6 */
	 u_int8_t sensor_index;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t temperature;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t max_temperature;
	/* Description -  */
	/* 0x8.30 - 0x8.30 */
	 u_int8_t mtr;
	/* Description -  */
	/* 0x8.31 - 0x8.31 */
	 u_int8_t mte;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t temperature_threshold_hi;
	/* Description -  */
	/* 0xc.30 - 0xc.31 */
	 u_int8_t tee;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t temperature_threshold_lo;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.24 - 0x1c.23 */
	 char sensor_name_hi[5];
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.24 - 0x20.23 */
	 char sensor_name_lo[5];
};

/* Description -  0x900B */
/* Size in bytes - 16 */
struct mtwe_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.31 */
	 u_int32_t sensor_warning0;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.31 */
	 u_int32_t sensor_warning1;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t sensor_warning2;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t sensor_warning3;
};

/* Description -  0x902e */
/* Size in bytes - 16 */
struct mvcap_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x4.31 */
	 u_int64_t sensor_map;
};

/* Description -  0x900C */
/* Size in bytes - 24 */
struct mvcr_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.6 */
	 u_int8_t sensor_index;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t voltage_sensor_value;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t current_sensor_value;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x14.31 */
	 u_int64_t sensor_name;
};

/* Description -   */
/* Size in bytes - 80 */
struct pcam_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Access Register ID groups. 0: RegID_0x5000_to_0x507F Values 1-255 are Reserved */
	/* 0x0.0 - 0x0.7 */
	 u_int8_t access_reg_group;
	/* Description - Feature list mask index: 0: enhanced_features Values 1 - 255 are Reserved */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t feature_group;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Supported port’s access register bitmaks. Based on access_reg_group index. When bit is set, the register is supported in the device. */
	/* 0x8.0 - 0x14.31 */
	 u_int8_t port_access_reg_cap_mask[128];
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - Supported port’s enhanced features. Based on feature_group index. When bit is set, the feature is supported in the device */
	/* 0x28.0 - 0x34.31 */
	 u_int8_t feature_cap_mask[128];
};

/* Description -   */
/* Size in bytes - 256 */
struct pddr_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Supported only when indicated by PCAM 
0: Network_port
1: Near_End_Port - (For Retimer/Gearbox - Host side)
2: Internal_IC_LR_Port 
3: Far_End_Port - (For Retimer/Gearbox - Line side)
4: USR_main
5: USR_tile
Other values are reserved. */
	/* 0x0.4 - 0x0.7 */
	 u_int8_t port_type;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type. determines the way local_port is 
interpreted:
0: Local_port_number
1: IB_or_label_port_number
 */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number.
If dev is set to 1, device index number.
0: main die
1-8: tile index number */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - page select index:
0: Operational_info_page
1: Troubleshooting_info_page
2: Phy_info_page - [Internal]
3: Module_info_page
4: port_events_page - [internal]
5: device_events_page - [internal]
6: link_down_info - [EMC only]
7: link_down_events - [internal]
8: Link_up_info - [Internal]
9: Module_latched_flag_info_page
10: link_down_info_ext
11: link_partner_info_page
0xFE: mng_debug_page
0xFF: phy_debug_page */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t page_select;
	/* Description - Module info extended configurations.
resolution for rx_power and tx_power in module info page
0: dbm
1: uW */
	/* 0x4.29 - 0x4.30 */
	 u_int8_t module_info_ext;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Table  1406, "Operation Info Page Layout," on page  1683
Table  1448, "Troubleshooting info Page layout," on page  1742
Table  1440, "Phy info page layout," on page  1714
Table  1446, "Module Info Page Layout," on page  1729
Table  1454, "Port events Page Layout," on page  1747
Table  1456, "Device events Page Layout," on page  1751
Table  1442, "Link Down Info Page layout," on page  1725
Table  1444, "Link down events page layout," on page  1728
Table  1458, "Link Up Info Page Layout," on page  1757
Table  1460, "Module Latched Flag Info Page Layout," on 
page  1760
Table  1462, "phy debug page layout," on page  1763
Table  1464, "Mng debug page layout," on page  1765
Table  1468, "link down info ext for 16nm LR layout," on 
page  1770 */
	/* 0x8.24 - 0xd4.23 */
	 u_int8_t page_data[204];
};

/* Description -   */
/* Size in bytes - 256 */
struct pemi_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - The status of the page reading:
1: read operation was successful.
2: the page is not supported. */
	/* 0x0.0 - 0x0.2 */
	 u_int8_t status;
	/* Description - Extended configurations for the resolution for rx_power 
and tx_power in the Module Status pages
0: dBm
1: uW */
	/* 0x0.4 - 0x0.5 */
	 u_int8_t module_info_ext;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type. determines the way local_port is 
interpreted:
0: Local_port_number
1: IB_or_label_port_number
3: Out_of_band_or_PCI - [Internal] */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - The user can  select if to read a sampled data page or a 
properties page.

Sampled data pages:
0: Module_Status_Samples
1: SNR_Samples
2: Laser_Monitors_Samples
3: PAM4_Level_Transition_Samples
4: Pre_FEC_BER_Samples
5: FERC_Samples
16: Module_Status_Properties
17: SNR_Properties
18: Laser_Monitors_Properties
19: PAM4_Level_Transition_Properties
20: Pre_FEC_BER_Properties
21: FERC_Properties */
	/* 0x4.0 - 0x4.4 */
	 u_int8_t page_select;
	/* Description - Group capability mask:
Bit 0: Module_Status
Bit 1: SNR
Bit 2: Laser_Monitors
bit 3: PAM4_Level_Transition
bit 4: Pre_FEC_BER
bit 5: FERC */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t group_cap_mask;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Page data:
Table 1488, "Module Status Samples Page- Layout," 
on page 1736
Table 1492, "SNR Samples page - Layout," on 
page 1740
Table 1500, "Laser Monitors Samples page - Layout," 
on page 1746
Table 1496, "PAM4 Level Transition Samples Page - 
Layout," on page 1743
Table 1504, "Pre-FEC BER Samples Page - Layout," 
on page 1750
Table 1508, "FERC Samples page - Layout," on 
page 1753
Table 1490, "Module Status Properties page - Layout," 
on page 1738
Table 1494, "SNR Properties page - Layout," on 
page 1742
Table 1502, "Laser Monitors Properties page - Lay
out," on page 1748
Table 1498, "PAM4 Level Transition Properties Page - 
Layout," on page 1745
Table 1506, "Pre-FEC BER Properties Page - Layout," 
on page 1751
Table 1510, "FERC Properties page - Layout," on 
page 1754 */
	/* 0x8.0 - 0xd0.31 */
	 union pemi_page_data_auto page_data;
};

/* Description -   */
/* Size in bytes - 200 */
struct peucg_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - 0 - Success
1 - bad address param */
	/* 0x0.0 - 0x0.2 */
	 u_int8_t status;
	/* Description - lane number to read/write */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type. determines the way local_port is 
interpreted:
0 - Local port number
1 - IB / label port number
3 - Out of Band/ PCI. */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - if unit set to '0' Local port number.
if unit set to '1' PLL index number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - Unit of CfgSpace to read/write:
0 - ports lane (DLN)
1 - common pll (CLN) */
	/* 0x0.24 - 0x0.24 */
	 u_int8_t unit;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - specifies the enum from init file to access.
not relevant when db is '0'. */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t enum_init;
	/* Description - when set restore init DataBase to default fw values */
	/* 0x4.16 - 0x4.16 */
	 u_int8_t clr;
	/* Description - 0 - read/write are done from/to hw CfgSpace
1 - read/write are done from/to init DataBase. */
	/* 0x4.17 - 0x4.17 */
	 u_int8_t db;
	/* Description - number of payload_data to read/write.
max payload size of 47 */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t payload_size;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Data base start index of init array to access.
Array will be accessed from db_index up to db_index + pay
load_size. addresses are ignored in this mode.
Not relevant if db bit is '0' */
	/* 0x8.0 - 0x8.9 */
	 u_int16_t db_index;
	/* Description - number of entries for the specified enum_init.
not relevant when db is '0' */
	/* 0x8.16 - 0x8.25 */
	 u_int16_t num_of_entries;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - page data for index <i>
See Table  1267, "PEUCG - Page Data Layout," on page  1552 */
	/* 0xc.0 - 0xc4.31 */
	 struct peucg_page_data page_data[47];
};

/* Description -   */
/* Size in bytes - 28 */
struct pmcr_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - when set, configuration of override values will be copied to 
ports database.
See PGMR for port database grouping.
Note: relevant fields that can be copied to database are:
rx_amp, rx_emp, rx_post_emp, tx_eq in NDR devices. */
	/* 0x0.0 - 0x0.0 */
	 u_int8_t c_db;
	/* Description - Valid for CMIS modules.
error code response on override value. */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t error_code_response;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Local port number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - Valid only for CMIS (QSFP-DD / SFP-DD / OSFP) compliant 
modules.
If Control Set 1 not implemented or non CMIS module ignore 
field.
0 - Auto (default)
1 - Use Control Set 0
2 - Use Control Set 1 */
	/* 0x0.24 - 0x0.25 */
	 u_int8_t cs_sel;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Module CDR override control:
0 - Auto (default)
1 - Keep the module configuration
2 - Override */
	/* 0x4.0 - 0x4.1 */
	 u_int8_t cdr_override_cntl;
	/* Description - Valid only in case CDR is configured to override mode by 
cdr_override_cntl: 
0 - RX OFF, TX OFF
1 - RX ON , TX OFF
2 - RX OFF, TX ON
3 - RX ON, TX ON */
	/* 0x4.8 - 0x4.11 */
	 u_int8_t cdr_override_value;
	/* Description - In HCA, valid based on PCAM feature capabilities. 
Module TX_DISABLE override control:
0 - Auto (default)
1 - Keep the module configuration
2 - Override */
	/* 0x4.16 - 0x4.17 */
	 u_int8_t tx_disable_override_cntl;
	/* Description - Valid only in case TX_DISABLE is configured to override mode 
by tx_disable_override_cntl: 
0 - TX_DISABLE is low (i.e. TX is enabled)
 */
	/* 0x4.24 - 0x4.25 */
	 u_int8_t tx_disable_override_value;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Module RX amplitude override control:
0 - Auto (default)
1 - Keep the module configuration
2 - Override */
	/* 0x8.0 - 0x8.1 */
	 u_int8_t rx_amp_override_cntl;
	/* Description - Valid only in case RX amplitude is configured to override mode 
by rx_amp_override_cntl */
	/* 0x8.8 - 0x8.11 */
	 u_int8_t rx_amp_override_value;
	/* Description - Valid only in case RX _LOS is configured to override mode by 
rx_los_override_admin */
	/* 0x8.16 - 0x8.17 */
	 u_int8_t rx_los_override_cntl;
	/* Description - Module RX _LOS override control:
0 - Auto (default)
1 - Keep the module configuration
2 - Override */
	/* 0x8.24 - 0x8.25 */
	 u_int8_t rx_los_override_admin;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Module RX emphasis override control:
0 - Auto (default)
1 - Keep the module configuration
2 - Override */
	/* 0xc.0 - 0xc.1 */
	 u_int8_t rx_emp_override_cntl;
	/* Description - For CMIS modules, pre emphasis equalization value.
For SFF modules, emphasis equalization value.
Valid only in case RX emphasis is configured to override mode 
by rx_emp_override_cntl */
	/* 0xc.8 - 0xc.11 */
	 u_int8_t rx_emp_override_value;
	/* Description - Module RX emphasis override control:
0 - Auto (default)
1 - Keep the module configuration
2 - Override */
	/* 0xc.16 - 0xc.17 */
	 u_int8_t rx_post_emp_override_cntl;
	/* Description - Valid for CMIS modules only.
Post emphasis equalization value.
Valid only in case RX emphasis is configured to override mode 
by rx_post_emp_override_cntl */
	/* 0xc.24 - 0xc.27 */
	 u_int8_t rx_post_emp_override_value;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Module TX equalization override control:
0 - Auto (default)
1 - Keep the module configuration
2 - Override */
	/* 0x10.0 - 0x10.1 */
	 u_int8_t tx_equ_override_cntl;
	/* Description - Valid only in case TX equalization is configured to override 
mode by tx_equ_override_cntl. */
	/* 0x10.8 - 0x10.11 */
	 u_int8_t tx_equ_override_value;
	/* Description - 0 - disable adaptive Tx Equailization
1 - enable adaptive Tx equalization
Valid only in case TX equalization is configured to override 
mode by tx_adaptive_override_cntrl. */
	/* 0x10.17 - 0x10.17 */
	 u_int8_t tx_adaptive_override_value;
	/* Description - Module adaptive tuning flow override control:
0 - Auto (default)
1 - Keep the module configuration
2 - override */
	/* 0x10.24 - 0x10.25 */
	 u_int8_t tx_adaptive_override_cntrl;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Module Rate Select override control:
0 - Auto (default)
1 - Use Module's Rate Select value
2 - Override */
	/* 0x14.0 - 0x14.1 */
	 u_int8_t rs_override_cntl;
	/* Description - Valid only in case Rate Select is configured to override mode 
by rs_override_cntl: 
For QSFP modules: Bits 1,0 RX , Bits 3,2 TX ; 
0 - MSB Low, LSB Low
1 - MSB Low , LSB High
2 - MSB High, LSB Low
3 - MSB High , LSB High

For SFP module Bit 0 is RS0 Bit 2 is RS1. Bits 1,3 are 
Reserved

 */
	/* 0x14.8 - 0x14.11 */
	 u_int8_t rs_override_value;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Module Application select override control:
0 - Auto (default)
1 - Use Module's Default application value
2 - Override */
	/* 0x18.0 - 0x18.1 */
	 u_int8_t ap_sel_override_cntrl;
	/* Description - Application Select from the applications list advertised by the 
module. Up to 15 applications available.

Values range from 1 to 15.

Note: application can be set with default SI values defined by 
the module or SI defined by the host */
	/* 0x18.8 - 0x18.11 */
	 u_int8_t ap_sel_override_value;
	/* Description - Valid only for CMIS (QSFP-DD / SFP-DD / OSFP) compliant 
modules.
If not CMIS module ignore field.
Module Signal Integrity override control:
0 - Auto (default)
1 - Override with Module's Default applications SI values
2 - Override with Hosts SI values */
	/* 0x18.24 - 0x18.25 */
	 u_int8_t si_override_cntrl;
};

/* Description -   */
/* Size in bytes - 44 */
struct pmdr_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Local port number [9:8] */
	/* 0x0.0 - 0x0.1 */
	 u_int8_t lp_msb;
	/* Description - 0 if there is no MCM tile arch */
	/* 0x0.12 - 0x0.12 */
	 u_int8_t mcm_tile_valid;
	/* Description - 0 if there is no gearbox arch */
	/* 0x0.13 - 0x0.13 */
	 u_int8_t gb_valid;
	/* Description - Port number access type. determines the way local_port is 
interpreted:
0 - Local port number
1 - IB / label port number
3 - Out of band / PCI */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - 0 - 16nm products */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t version;
	/* Description - 0 - Invalid
1 - Valid
2 - Bad Param (Values are not ready yet - during polling)
3 - Invalid index of local_port or label_port */
	/* 0x0.28 - 0x0.31 */
	 u_int8_t status;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Logical cluster port 4x */
	/* 0x4.0 - 0x4.1 */
	 u_int8_t clp_1x;
	/* Description - Logical cluster port 1x */
	/* 0x4.4 - 0x4.5 */
	 u_int8_t clp_4x;
	/* Description - Cluster number */
	/* 0x4.8 - 0x4.14 */
	 u_int8_t cluster;
	/* Description -  */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t module;
	/* Description -  */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t pport;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.6 */
	 u_int8_t ib_port;
	/* Description - lane mask of active lanes on module */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t module_lane_mask;
	/* Description -  */
	/* 0x8.16 - 0x8.18 */
	 u_int8_t swid;
	/* Description - Number of ports the label port is split to.
0 - split to 1
1 - split to 2
2 - split to 4 */
	/* 0x8.24 - 0x8.26 */
	 u_int8_t split;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.3 */
	 u_int8_t sd_lane_mask_rx;
	/* Description -  */
	/* 0xc.4 - 0xc.7 */
	 u_int8_t sd_lane_mask_tx;
	/* Description - LR serdes 4x RX */
	/* 0xc.8 - 0xc.9 */
	 u_int8_t sd_4x_rx;
	/* Description - LR serdes 4x TX */
	/* 0xc.10 - 0xc.11 */
	 u_int8_t sd_4x_tx;
	/* Description - USR serdes 4x RX
00b - no USR serdes
01b - serdes physical rx maps to 0-3
10b - serdes physical rx maps to 4-7 */
	/* 0xc.12 - 0xc.13 */
	 u_int8_t usr_sd_4x_rx;
	/* Description - USR serdes 4x TX
00b - no USR serdes
01b - serdes physical tx maps to 0-3
10b - serdes physical tx maps to 4-7 */
	/* 0xc.14 - 0xc.15 */
	 u_int8_t usr_sd_4x_tx;
	/* Description - Local port index for the label port chosen (in case pnat field 
is '1'). */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t local_port_query;
	/* Description - Label port index for the local port chosen (in case pnat field 
is '0'). */
	/* 0xc.24 - 0xc.30 */
	 u_int8_t label_port_query;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Number of the Gearbox the local_port is related to.
valid only when gb_valid is 1 */
	/* 0x10.0 - 0x10.6 */
	 u_int8_t gearbox_die_num;
	/* Description -  */
	/* 0x10.8 - 0x10.12 */
	 u_int8_t tile_pport;
	/* Description - Number of the MCM Tile the local_port is related to.
valid only when mcm_tile_valid is 1
 */
	/* 0x10.16 - 0x10.23 */
	 u_int8_t mcm_tile_num;
	/* Description -  */
	/* 0x10.24 - 0x10.27 */
	 u_int8_t tile_cluster;
	/* Description - Reserved for HCA 
Slot_index 
Slot_index = 0 represent the onboard (motherboard). 
In case of non modular system only slot_index = 0 is avail
able. */
	/* 0x10.28 - 0x10.31 */
	 u_int8_t slot_index;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Physical Rx lane number of Rx lane x logical lane */
	/* 0x14.0 - 0x14.2 */
	 u_int8_t lane0_physical_rx;
	/* Description - Physical Rx lane number of Rx lane x logical lane */
	/* 0x14.3 - 0x14.5 */
	 u_int8_t lane1_physical_rx;
	/* Description - Physical Rx lane number of Rx lane x logical lane */
	/* 0x14.6 - 0x14.8 */
	 u_int8_t lane2_physical_rx;
	/* Description - Physical Rx lane number of Rx lane x logical lane */
	/* 0x14.9 - 0x14.11 */
	 u_int8_t lane3_physical_rx;
	/* Description - Physical Rx lane number of Rx lane x logical lane */
	/* 0x14.12 - 0x14.14 */
	 u_int8_t lane4_physical_rx;
	/* Description - Physical Rx lane number of Rx lane x logical lane */
	/* 0x14.15 - 0x14.17 */
	 u_int8_t lane5_physical_rx;
	/* Description - Physical Rx lane number of Rx lane x logical lane */
	/* 0x14.18 - 0x14.20 */
	 u_int8_t lane6_physical_rx;
	/* Description - Physical Rx lane number of Rx lane x logical lane */
	/* 0x14.21 - 0x14.23 */
	 u_int8_t lane7_physical_rx;
	/* Description - number of VL of the port */
	/* 0x14.27 - 0x14.31 */
	 u_int8_t vl_num;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Physical Tx lane number of Tx lane x logical lane */
	/* 0x18.0 - 0x18.2 */
	 u_int8_t lane0_physical_tx;
	/* Description - Physical Tx lane number of Tx lane x logical lane */
	/* 0x18.3 - 0x18.5 */
	 u_int8_t lane1_physical_tx;
	/* Description - Physical Tx lane number of Tx lane x logical lane */
	/* 0x18.6 - 0x18.8 */
	 u_int8_t lane2_physical_tx;
	/* Description - Physical Tx lane number of Tx lane x logical lane */
	/* 0x18.9 - 0x18.11 */
	 u_int8_t lane3_physical_tx;
	/* Description - Physical Tx lane number of Tx lane x logical lane */
	/* 0x18.12 - 0x18.14 */
	 u_int8_t lane4_physical_tx;
	/* Description - Physical Tx lane number of Tx lane x logical lane */
	/* 0x18.15 - 0x18.17 */
	 u_int8_t lane5_physical_tx;
	/* Description - Physical Tx lane number of Tx lane x logical lane */
	/* 0x18.18 - 0x18.20 */
	 u_int8_t lane6_physical_tx;
	/* Description - Physical Tx lane number of Tx lane x logical lane */
	/* 0x18.21 - 0x18.23 */
	 u_int8_t lane7_physical_tx;
	/* Description - pll group of pll that port uses */
	/* 0x18.24 - 0x18.31 */
	 u_int8_t pll_index;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x1c.0 - 0x1c.3 */
	 u_int8_t VL0_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x1c.4 - 0x1c.7 */
	 u_int8_t VL1_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x1c.8 - 0x1c.11 */
	 u_int8_t VL2_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x1c.12 - 0x1c.15 */
	 u_int8_t VL3_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x1c.16 - 0x1c.19 */
	 u_int8_t VL4_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x1c.20 - 0x1c.23 */
	 u_int8_t VL5_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x1c.24 - 0x1c.27 */
	 u_int8_t VL6_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x1c.28 - 0x1c.31 */
	 u_int8_t VL7_lane_map;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x20.0 - 0x20.3 */
	 u_int8_t VL8_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x20.4 - 0x20.7 */
	 u_int8_t VL9_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x20.8 - 0x20.11 */
	 u_int8_t VL10_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x20.12 - 0x20.15 */
	 u_int8_t VL11_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x20.16 - 0x20.19 */
	 u_int8_t VL12_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x20.20 - 0x20.23 */
	 u_int8_t VL13_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x20.24 - 0x20.27 */
	 u_int8_t VL14_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x20.28 - 0x20.31 */
	 u_int8_t VL15_lane_map;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x24.0 - 0x24.3 */
	 u_int8_t VL16_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x24.4 - 0x24.7 */
	 u_int8_t VL17_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x24.8 - 0x24.11 */
	 u_int8_t VL18_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x24.12 - 0x24.15 */
	 u_int8_t VL19_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x24.16 - 0x24.19 */
	 u_int8_t VL20_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x24.20 - 0x24.23 */
	 u_int8_t VL21_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x24.24 - 0x24.27 */
	 u_int8_t VL22_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x24.28 - 0x24.31 */
	 u_int8_t VL23_lane_map;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x28.0 - 0x28.3 */
	 u_int8_t VL24_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x28.4 - 0x28.7 */
	 u_int8_t VL25_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x28.8 - 0x28.11 */
	 u_int8_t VL26_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x28.12 - 0x28.15 */
	 u_int8_t VL27_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x28.16 - 0x28.19 */
	 u_int8_t VL28_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x28.20 - 0x28.23 */
	 u_int8_t VL29_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x28.24 - 0x28.27 */
	 u_int8_t VL30_lane_map;
	/* Description - logical lane number that maps to VL_x lane */
	/* 0x28.28 - 0x28.31 */
	 u_int8_t VL31_lane_map;
};

/* Description -  0x5025 */
/* Size in bytes - 44 */
struct ppamp_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t opamp_group_type;
	/* Description -  */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t opamp_group;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.11 */
	 u_int16_t num_of_indices;
	/* Description -  */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t start_index;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.11 */
	 u_int16_t max_num_of_indices;
	/* Description -  */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t max_opamp_group;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.16 - 0x2c.15 */
	 u_int16_t index_data[16];
};

/* Description -   */
/* Size in bytes - 48 */
struct ppbmp_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Monitor Parameters Group
0x0: Raw_BER_RS - Pre-FEC monitor parameters for RS-FEC links
0x1: Raw_BER_FC - Pre-FEC monitor parameters for FC-FEC links
0x2: Effective_BER - Post FEC monitor parameters
0x5: Symbol_BER - BER after all phy correction mechanism: post FEC + PLR monitor parameters */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t monitor_group;
	/* Description - For HCA supported only when indicated by PCAM 
0 - Network Port
1 - Near-End Port (For Retimer/Gearbox - Host side)
2 - Internal IC LR Port 
3 - Far-End Port (For Retimer/Gearbox - Line side)
4 - USR Main
5 - USR Tile
Other values are reserved. */
	/* 0x0.4 - 0x0.7 */
	 u_int8_t port_type;
	/* Description - configures what RS-FECs are affected by the monitoring group when monitor_group RS-FEC links is chosen
0 - all RS-FECs.
1 - RS-FEC (528, 514)
2 - RS-FEC (544,514)
3 - ELL (272,257+1) */
	/* 0x0.8 - 0x0.10 */
	 u_int8_t rs_fec_group;
	/* Description - When set, group_profile field will set local_port group.
Else, group_profile field will be ignore in set operation */
	/* 0x0.11 - 0x0.11 */
	 u_int8_t grp_prf_set;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type. determines the way local_port is interpreted:
0 - Local port number
1 - IB port number
[Internal] 3 - Out of band / PCI */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - local_port */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - Group profile port is mapped to.
when group_profile is set, */
	/* 0x0.24 - 0x0.26 */
	 u_int8_t grp_prf;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - See Table 1663, "PPBMP - Monitor Parameters Layout," on page 2029 */
	/* 0x4.0 - 0x8.31 */
	 struct ppbmp_monitor_parameters monitor_parameters;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.23 */
	 u_int32_t time_window;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t sampling_rate;
};

/* Description -   */
/* Size in bytes - 220 */
struct ppcnt_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Performance counter group.
Group 63 indicates all groups (include all per priority/TC/Receive Buffer counters). Only valid on Set() operation with clr bit set.
0x0: IEEE_802_3_Counters
0x1: RFC_2863_Counters
0x2: RFC_2819_Counters
0x3: RFC_3635_Counters
0x5: Ethernet_Extended_Counters
0x6: Ethernet_Discard_Counters 
0x8: Link_Level_Retransmission_Counters - [Internal]
0x10: Per_Priority_Counters - 
0x11: Per_Traffic_Class_Counters - 
0x12: Physical_Layer_Counters
0x13: Per_Traffic_Class_Congestion_Counters
0x15: Per_Receive_Buffer_Counters - [Internal]
0x16: Physical_Layer_Statistical_Counters
0x19: Out_of_Band_Port_Counters - Note: This group is valid only for OOB ports - [Internal]
0x20: InfiniBand_Port_Counters
0x21: InfiniBand_Extended_Port_Counters
0x22: PLR_counters_group
0x23: RS_FEC_Histogram_group
0x24: USR_XSR_Physical_layer_counters_group - [Internal]
0x25: InfiniBand_pkts_counters
0x26: InfiniBand_General_Counters
s 
0x27: L1_General_Counters
0x28: InfiniBand_Packet_Size_Histogram
0x29: Packet_type_Counters
0x2A: InfiniBand_vl_Counters */
	/* 0x0.0 - 0x0.5 */
	 u_int8_t grp;
	/* Description - Supported only when indicated by PCAM on FPGA based NICs:
0 - Network Port
1 - Near-End Port (For Retimer/Gearbox - Host side)
2 - Internal IC LR Port 
3 - Far-End Port (For Retimer/Gearbox - Line side) */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t port_type;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type:
0: Local_port_number
1: IB_port_number
2: host_port_number
3: OOB_port_number - Internal

Note - pnat=2 is supported for "Per Traffic Class Congestion Counters" and "Per Traffic Class Counters" groups. */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number. 
Note:
when lp_gl = 0, 255 indicates all ports on the device, and is only allowed for Set() operation.
when lp_gl = 1, the index is a global port number */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - For HCA: must be always 0.
Switch partition ID to associate port with.
Switch partitions are numbered from 0 to 7 inclusively.
Switch partition 254 indicates stacking ports.
Switch partition 255 indicates all switch partitions.
Only valid on Set() operation with local_port=255. */
	/* 0x0.24 - 0x0.31 */
	 u_int8_t swid;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Priority index for per priority counter sets, valid values: 0-7
For Spectrum-2 and on at tx side range can be 0 .. cap_max_tclass_data-1, see QGCR.tx_cnt_tclass

Traffic class index for per traffic class counter set, valid values: 
For Switches, valid values: 0 .. cap_max_tclass_data-1 

For HCA, valid values: 0.. HCA_CAP.max_tc

Otherwise must be 0.

 */
	/* 0x4.0 - 0x4.4 */
	 u_int8_t prio_tc;
	/* Description - Supported only when indicated by PCAM: PPCNT_grp_profile_supported (bit 73).
The group profile index. Relevant only if the clr bit is set.
0: Will reset the counter value for all counters in the counter group.
Else: Will point to the corresponding bit-map profile in the PPCGP register. The bit map will return the specific counters that will be reset in the group.
NOTE: The grp_profile index is not supported for the following counters groups:
1. 0x12: Physical_Layer_Counters2. 0x16: Physical_Layer_Statistical_Counters3. 0x22: PLR_counters_group */
	/* 0x4.5 - 0x4.7 */
	 u_int8_t grp_profile;
	/* Description - Reserved for non-planarized port.
Plane port index of the aggregated port. A value of 0 refers to the aggregated port only. */
	/* 0x4.8 - 0x4.11 */
	 u_int8_t plane_ind;
	/* Description - counters_cap is supported if PCAM.feature_cap_mask bit 85 is set.
When set, each counter in the group will show in bit 0 if the counter is supported.
'0' - not supported
'1' - supported
Note: To know which PPCNT groups are supported per device, listed in table TBD or PCAM fields with PPCNT can be queried. */
	/* 0x4.29 - 0x4.29 */
	 u_int8_t counters_cap;
	/* Description - Local Port global variable
0: local_port port 255 = all ports of the device.
1: local_port index indicates Local port number. */
	/* 0x4.30 - 0x4.30 */
	 u_int8_t lp_gl;
	/* Description - Clear counters. Setting the clr bit will reset the counter value for all counters in the counter group. This bit can be set for both Set() and Get() operation.

NOTE: Clearing a certain group's counters can influence another group's counters value. */
	/* 0x4.31 - 0x4.31 */
	 u_int8_t clr;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Counter set as described in
Table 1311, "Ethernet IEEE 802.3 Counters Group Data Layout," on page 1647
Table 1313, "Ethernet RFC 2863 Counter Group Data Layout," on page 1652
Table 1315, "Ethernet RFC 2819 Counter Group Data Layout," on page 1655
Table 1317, "Ethernet RFC 3635 Counter Group Data Layout," on page 1660
Table 1319, "Ethernet Extended Counter Group Data Layout," on page 1664
Table 1322, "Ethernet Discard Counter Group Fields," on page 1669
Table 1333, "Link Level Retransmission Counter Group Data Layout," on page 1682
Table 1323, "Ethernet Per Priority Group Data Layout," on page 1671
Table 1327, "Ethernet Per Traffic Class Group data layout," on page 1679
Table 1339, "Physical Layer Counters Data Layout," on page 1690
Table 1329, "Ethernet Per Traffic Class Congestion Group data layout," on page 1680
Table 1331, "Ethernet Per Receive Buffer Group data layout," on page 1681
Table 1343, "Physical Layer Statistical Counters Data Layout," on page 1700
Table 1325, "Ethernet OOB Port Counters Data Layout," on page 1675 - [Internal]
Table 1335, "InfiniBand PortCounters Attribute Group Data Layout," on page 1684
Table 1337, "InfiniBand Extended PortCounters Attribute Group Data Layout," on page 1686
Table 1345, "PLR Counters Data Layout," on page 1705 
Table 1347, "RS-Histograms Data Layout," on page 1707
Table 1341, "USR_XSR Physical Layer Counters Data Layout," on page 1696
Table 1349, "InfiniBand Packets Counters Data Layout," on page 1708
Table 1351, "InfiniBand General Counters Data Layout," on page 1710
Table 1359, "L1 General Counters Data Layout," on page 1720
Table 1353, "InfiniBand Packet size histograms Counters Data Layout," on page 1713
Table 1357, "Packet Type Counters Data Layout," on page 1718
Table 1355, "InfiniBand VL Counters Data Layout," on page 1716 */
	/* 0x8.0 - 0xd8.31 */
	 union ppcnt_reg_counter_set_auto counter_set;
};

/* Description -   */
/* Size in bytes - 80 */
struct pphcr_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Support of histogram bins configuration. 
In case this bit is cleared, the port doesn't support configu
ration of the histogram bins, for the specific hist_type. */
	/* 0x0.0 - 0x0.0 */
	 u_int8_t we;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type:
0: Local_port_number
1: IB_port_number */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - local_port */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - 0 - invalid (Link down / unsupported) 
1 - KP4 RS-FEC (544,514) errors 
2 - LL RS-FEC (271,257) / (272,257+1) errors
3 - KR4 RS-FEC (528,514) errors */
	/* 0x0.28 - 0x0.31 */
	 u_int8_t active_hist_type;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - 0: According to active link
1: KP4 RS-FEC (544,514) errors 
2: LL RS-FEC (271,257) / (272,257+1) errors
3: KR4 RS-FEC (528,514) errors */
	/* 0x4.0 - 0x4.3 */
	 u_int8_t hist_type;
	/* Description - Available number of bins 
 */
	/* 0x4.16 - 0x4.23 */
	 u_int8_t num_of_bins;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - Lowest measurement/low limit of the histogram 
Example:
In case of hist_type = 1, represent KP4 RS FEC symbol 
errors(= 0)
In case of hist_type = 2, represent LL RS FEC symbol errors 
( = 0)
 */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t hist_min_measurement;
	/* Description - Highest measurement/high limit of the histogram:
Example:
In case of hist_type = 1, represent KP4 RS FEC symbol 
errors ( = 15)
In case of hist_type = 2, represent LL RS FEC symbol errors 
( = 7) */
	/* 0x8.16 - 0x8.23 */
	 u_int8_t hist_max_measurement;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Valid only if we (write enable) = 1 
Ignored on GET 
Write mask for the bin_range array. 
If bit X is set, bin_range [X] write should be execute
Else if bit X is clear, ignored value in written to bin_range [X] */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t bin_range_write_mask;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - Write to bin_range[x] is applicable only if we = 1 & the cor
responding bits in bin_range_write_mask is set.
Mapping of measurement units to a bin
See Table 1154, "PPHCR - Port Phy Bin Range Histo
gram Configuration Layout," on page 1483 */
	/* 0x10.0 - 0x4c.31 */
	 struct pphcr_bin_range bin_range[16];
};

/* Description -   */
/* Size in bytes - 40 */
struct ppll_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - 0: products_28nm
1: products_16nm
4: products_7nm */
	/* 0x0.0 - 0x0.3 */
	 u_int8_t version;
	/* Description - number of PLL in the PLL group */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t num_plls;
	/* Description - number of PCI and OOB pll in the device.
network PLL are calculated according to num_pll_groups - 
pci_oob_pll */
	/* 0x0.12 - 0x0.15 */
	 u_int8_t pci_oob_pll;
	/* Description - PLL group index */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t pll_group;
	/* Description - total number of PLL groups in the device */
	/* 0x0.24 - 0x0.31 */
	 u_int8_t num_pll_groups;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Table  1078, "PPLL - Phy PLL Status Register Layout for 
28nm," on page  1346
Table  1082, "PPLL - Phy PLL Status Register Layout for 
16nm," on page  1347
Table  1086, "PPLL - Phy PLL Status Register Layout for 7nm," 
on page  1349 */
	/* 0x4.0 - 0x24.31 */
	 union ppll_reg_page_data_auto page_data;
};

/* Description -   */
/* Size in bytes - 28 */
struct prtl_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type. 
0 - Local port number
1 - IB / label port number
 */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description -  */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description -  */
	/* 0x0.31 - 0x0.31 */
	 u_int8_t rtt_support;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t latency_accuracy;
	/* Description -  */
	/* 0x4.16 - 0x4.19 */
	 u_int8_t latency_res;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.15 */
	 u_int16_t local_phy_latency;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t local_mod_dp_latency;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.23 */
	 u_int32_t round_trip_latency;
};

/* Description -  0x5029 */
/* Size in bytes - 44 */
struct ptas_reg {
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Number height grade measurement repetitions */
	/* 0x4.0 - 0x4.7 */
	 u_int8_t num_of_repetitions;
	/* Description - 0 - Average
1 - MInimum
2 - Median */
	/* 0x4.8 - 0x4.11 */
	 u_int8_t repetitions_mode;
	/* Description -  */
	/* 0x4.16 - 0x4.31 */
	 u_int16_t algorithm_options;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t phase_grade_weight;
	/* Description -  */
	/* 0x8.8 - 0x8.15 */
	 u_int8_t height_grade_weight;
	/* Description - 0 - Reserved
1 - Reserved
2 - EO */
	/* 0x8.16 - 0x8.19 */
	 u_int8_t phase_grade_type;
	/* Description - 0 - BER Bath
1 - 1s ratio
2 - EO
3 - 3 - 1s ratio + NDEO */
	/* 0x8.20 - 0x8.23 */
	 u_int8_t height_grade_type;
	/* Description -  */
	/* 0x8.24 - 0x8.31 */
	 u_int8_t grade_version;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.15 */
	 u_int16_t adaptive_tap_measure_bits;
	/* Description -  */
	/* 0xc.16 - 0xc.31 */
	 u_int16_t gisim_measure_bits;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t ber_bath_mid_error_threshold;
	/* Description -  */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t ber_bath_high_error_threshold;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t one_ratio_high_threshold;
	/* Description -  */
	/* 0x14.16 - 0x14.31 */
	 u_int16_t ber_bath_low_error_threshold;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.15 */
	 u_int16_t one_ratio_low_mid_threshold;
	/* Description -  */
	/* 0x18.16 - 0x18.31 */
	 u_int16_t one_ratio_high_mid_threshold;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t ndeo_error_threshold;
	/* Description -  */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t one_ratio_low_threshold;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description -  */
	/* 0x20.0 - 0x20.7 */
	 u_int8_t mix90_phase_for_voltage_bath;
	/* Description -  */
	/* 0x20.16 - 0x20.31 */
	 u_int16_t mixer_offset_step_size;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description -  */
	/* 0x24.0 - 0x24.15 */
	 u_int16_t mixer_offset_end;
	/* Description -  */
	/* 0x24.16 - 0x24.31 */
	 u_int16_t mixer_offset_start;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - BER test time in 1msec units. */
	/* 0x28.0 - 0x28.10 */
	 u_int16_t ber_test_time;
};

/* Description -   */
/* Size in bytes - 64 */
struct ptys_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Protocol Mask. Indicates which of the protocol data is valid
Bit 0: InfiniBand
Bit 1: Reserved
Bit 2: Ethernet */
	/* 0x0.0 - 0x0.2 */
	 u_int8_t proto_mask;
	/* Description - Supported only when indicated by PCAM 
0: Network_Port
1: Near-End_Port - (For Gearbox - Host side)
2: Internal_IC_Port 
3: Far-End_Port - (For Gearbox - Line side)

Other values are reserved. */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t port_type;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type. determines the way local_port is 
interpreted:
0: Local_port_number
1: Label_port_number
3: Out_of_band */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - When AN is disabled, use aba TX set. 
 */
	/* 0x0.24 - 0x0.24 */
	 u_int8_t force_tx_aba_param;
	/* Description - Auto Negotiation disable capability:
0 - Device does not support AN disable
1 - Device Supports  AN disable */
	/* 0x0.29 - 0x0.29 */
	 u_int8_t an_disable_cap;
	/* Description - Auto Negotiation disable:
0 - Normal operation 
1 - Disable AN.
Note: In Ethernet port, when Disabling AN, the "eth_pro
to_admin" bit mask must comply to single speed rate set.
In IB port, when Disabling AN, the "ib_proto_admin" bit mask 
must comply to single speed rate set.
It's recommended to validate the FEC override bits in PPLM 
when operating with AN. 

 */
	/* 0x0.30 - 0x0.30 */
	 u_int8_t an_disable_admin;
	/* Description - THIS BIT MUST BE TIED TO 1!
This is old capability bit that address AN_DISABLE capability 
with only one enabled protocol. */
	/* 0x0.31 - 0x0.31 */
	 u_int8_t reserved_high;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Port data rate in resolution of 100 Mb/s (data_rate_oper * 100 
Mb/s)
Value 0x0 indicates this field is not supported. */
	/* 0x4.0 - 0x4.15 */
	 u_int16_t data_rate_oper;
	/* Description - Port maxium data rate in resolution of 1 Gb/s 
(data_rate_oper * 1 Gb/s)
Value 0x0 indicates this field is not supported.
 */
	/* 0x4.16 - 0x4.27 */
	 u_int16_t max_port_rate;
	/* Description - Auto Negotiation status: 
0 - Status is unavailable
1 - AN completed successfully 
2 - AN performed but failed
3 - AN was not performed, link is up 
4 - AN was not performed, link is down */
	/* 0x4.28 - 0x4.31 */
	 u_int8_t an_status;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - For HCA: See also PCAM.feature_cap_mask bit 13 for 
Extended Ethernet protocol support.
Extended Ethernet port speed/protocols supported (bit
mask):
Bit 0 - SGMII_100M
Bit 1 - 1000BASE-X / SGMII
Bit 3 - 5GBASE-R
Bit 4 - XFI / XAUI-1 // 10G
Bit 5 - XLAUI-4/XLPPI-4 // 40G 
Bit 6 - 25GAUI-1/ 25GBASE-CR / KR 
Bit 7 - 50GAUI-2 / LAUI-2/ 50GBASE-CR2/KR2 
Bit 8 - 50GAUI-1 / LAUI-1/ 50GBASE-CR / KR
Bit 9 - CAUI-4 / 100GBASE-CR4 / KR4
Bit 10 - 100GAUI-2 / 100GBASE-CR2 / KR2 
Bit 11 - 100GAUI-1 / 100GBASE-CR / KR
Bit 12 - 200GAUI-4 / 200GBASE-CR4/KR4
Bit 13 - 200GAUI-2 / 200GBASE-CR2/KR2
Bit 14 - Reserved [internal] Placeholder for 200GAUI-1
Bit 15 - 400GAUI-8
Bit 16 - 400GAUI-4
Bit 17 - Reserved [internal] Placeholder for 400GAUI-2
Bit 18 - Reserved [internal] Placeholder for 400GAUI-1
Bit 19 - 800GAUI-8
Other - Reserved */
	/* 0x8.0 - 0x8.31 */
	 u_int32_t ext_eth_proto_capability;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Ethernet port speed/protocols supported (bitmask)
Bit 31 - 50GBase-KR2
Bit 30 - 50GBase-CR2
Bit 29 - 25GBase-SR
Bit 28 - 25GBase-KR
Bit 27 - 25GBase-CR
Bit 26 - 10GBase-T 
Bit 25 - 1000Base-T
[Internal] Bit 24 - 100Base-TX
Bit 23 - 100GBase LR4/ER4
Bit 22 - 100GBase KR4
Bit 21 - 100GBase SR4
Bit 20 - 100GBase CR4
Bit 19 - 50GBase-KR4
Bit 18 - 50GBase-SR2
Bit 16 - 40GBase LR4/ER4
Bit 15 - 40GBase SR4
Bit 14 - 10GBase ER/LR
Bit 13 - 10GBase SR
Bit 12 - 10GBase CR
Bit 10 - 10Base-T
Bit 9 - SGMII_100Base
[Internal] Bit 8 - 56GBase *R4
Bit 7 - 40GBase KR4
Bit 6 - 40GBase CR4
[internal] Bit 5 - 20GBase-KR2
Bit 4 - 10GBase KR
Bit 3 - 10GBase KX4
Bit 2 - 10GBase-CX4
Bit 1 - 1000Base KX
Bit 0 - SGMII */
	/* 0xc.0 - 0xc.31 */
	 u_int32_t eth_proto_capability;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - InfiniBand port speed supported (bitmask)
ib_link_speed <= ib_proto_capability[7:0]
Bit 0: SDR
Bit 1: DDR
Bit 2: QDR
Bit 3: FDR10
Bit 4: FDR
Bit 5: EDR
Bit 6: HDR
Bit 7: NDR */
	/* 0x10.0 - 0x10.15 */
	 u_int16_t ib_proto_capability;
	/* Description - ib_link_width <= ib_proto_capability
Bit 0 - 1x
Bit 1 - 2x
Bit 2 - 4x
Bit 3 - 8x
Bit 4 - 12x */
	/* 0x10.16 - 0x10.31 */
	 u_int16_t ib_link_width_capability;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - Ethernet port extended speed/protocols bitmask
NOTE: This field and "eth_proto_admin" are mutual exclu
sive, meaning that only one of the field can be set on write 
command. */
	/* 0x14.0 - 0x14.31 */
	 u_int32_t ext_eth_proto_admin;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - Ethernet port speed/protocols bitmask */
	/* 0x18.0 - 0x18.31 */
	 u_int32_t eth_proto_admin;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description - InfiniBand port speed bitmask */
	/* 0x1c.0 - 0x1c.15 */
	 u_int16_t ib_proto_admin;
	/* Description - InfiniBand port link width bitmask
 */
	/* 0x1c.16 - 0x1c.31 */
	 u_int16_t ib_link_width_admin;
/*---------------- DWORD[8] (Offset 0x20) ----------------*/
	/* Description - Ethernet port extended speed/protocols bitmask */
	/* 0x20.0 - 0x20.31 */
	 u_int32_t ext_eth_proto_oper;
/*---------------- DWORD[9] (Offset 0x24) ----------------*/
	/* Description - Ethernet port speed/protocols bitmask */
	/* 0x24.0 - 0x24.31 */
	 u_int32_t eth_proto_oper;
/*---------------- DWORD[10] (Offset 0x28) ----------------*/
	/* Description - InfiniBand port speed bitmask */
	/* 0x28.0 - 0x28.15 */
	 u_int16_t ib_proto_oper;
	/* Description - InfiniBand port link width bitmask
 */
	/* 0x28.16 - 0x28.31 */
	 u_int16_t ib_link_width_oper;
/*---------------- DWORD[11] (Offset 0x2c) ----------------*/
	/* Description - Connector type indication
0: No_connector_or_unknown 
1: PORT_NONE - None
2: PORT_TP - Twisted Pair
3: PORT_AUI - AUI
4: PORT_BNC - BNC
5: PORT_MII - MII
6: PORT_FIBRE - FIBRE
7: PORT_DA - Direct Attach Copper
8: PORT_OTHER - Other */
	/* 0x2c.0 - 0x2c.3 */
	 u_int8_t connector_type;
	/* Description - Ethernet Force mode options when AN disable is set.
0 - auto, keep normal operation
1 - Do Force KR Startup LT flow
2 - Do not do Force KR Startup LT flow

Note: Ignored when an_disable_admin is not set
Force KR Flow is possible for PAM4 links only */
	/* 0x2c.28 - 0x2c.29 */
	 u_int8_t force_kr_frames_admin;
	/* Description - 0 - device does not support Force KR Startup LT flow
1 - device supports Force KR Startup LT flow

Note: Ignored when an_disable_admin is not set
Force KR Flow is possible for PAM4 links only */
	/* 0x2c.30 - 0x2c.30 */
	 u_int8_t force_kr_frames_cap;
/*---------------- DWORD[12] (Offset 0x30) ----------------*/
	/* Description - Ethernet port's link partner advertised protocols. Returns the 
protocols that were advertised by the link partner during 
auto-negotiation.
 */
	/* 0x30.0 - 0x30.31 */
	 u_int32_t eth_proto_lp_advertise;
};

/* Description -   */
/* Size in bytes - 268 */
struct pucg_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - lane number to read/write */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description - Port number access type. determines the way local_port is inter
preted:
0 - Local port number
1 - IB / label port number
3 - Out of Band/ PCI. */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - if unit set to '0' Local port number.
if unit set to '1' PLL index number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - Unit of CfgSpace to read/write:
0 - ports lane (DLN)
1 - common pll (CLN) */
	/* 0x0.24 - 0x0.24 */
	 u_int8_t unit;
	/* Description - 0 - read
1 - write */
	/* 0x0.25 - 0x0.25 */
	 u_int8_t transaction;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Start address of CfgSpace to be written/ read */
	/* 0x4.0 - 0x4.9 */
	 u_int16_t address;
	/* Description - read/write size in 16 bit sizes */
	/* 0x4.24 - 0x4.31 */
	 u_int8_t payload_size;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - per address[i] access rx/tx physical lane
0 - rx physical lane access.
1 - tx physical lane access. */
	/* 0x8.0 - 0x14.31 */
	 u_int32_t rxtx_mask[4];
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - read/write payload data from start address with increments of 1 in 
the address. */
	/* 0x18.16 - 0x10c.15 */
	 u_int16_t payload_data[122];
};

/* Description -  0x503b */
/* Size in bytes - 44 */
struct slcct_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description -  */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description -  */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description -  */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t version;
	/* Description -  */
	/* 0x0.28 - 0x0.31 */
	 u_int8_t status;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.4 */
	 u_int8_t conf_index;
	/* Description -  */
	/* 0x4.8 - 0x4.11 */
	 u_int8_t num_of_idx;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x28.31 */
	 struct ctle_calib_set ctle_calib_set[9];
};

/* Description -   */
/* Size in bytes - 36 */
struct slcdr_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - physical lane number. */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description - Port number access type. determines the way local_port is 
interpreted:
0 - Local port number
1 - IB / label port number
 */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - 4 - 7nm products */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t version;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.7 */
	 u_int8_t cdr_offset;
	/* Description - CDR Operation */
	/* 0x8.16 - 0x8.18 */
	 u_int8_t cdr_op;
	/* Description - CDR AE Interface State */
	/* 0x8.20 - 0x8.21 */
	 u_int8_t cdr_aeintf_state;
	/* Description - CDR State */
	/* 0x8.24 - 0x8.25 */
	 u_int8_t cdr_state;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.4 */
	 u_int8_t dco_fine;
	/* Description -  */
	/* 0xc.8 - 0xc.11 */
	 u_int8_t dco_coarse;
	/* Description -  */
	/* 0xc.12 - 0xc.12 */
	 u_int8_t dco_coarse_tune_valid;
	/* Description -  */
	/* 0xc.13 - 0xc.13 */
	 u_int8_t dco_fine_tune_valid;
	/* Description -  */
	/* 0xc.14 - 0xc.14 */
	 u_int8_t cdr_initialized;
	/* Description - CDR FLL Enabled */
	/* 0xc.16 - 0xc.16 */
	 u_int8_t cdr_fll_en;
	/* Description - CDR PLL Enabled */
	/* 0xc.17 - 0xc.17 */
	 u_int8_t cdr_pll_en;
	/* Description - CDR Sequence Enabled */
	/* 0xc.18 - 0xc.18 */
	 u_int8_t cdr_seq_en;
	/* Description - CDR Sequence Aborted */
	/* 0xc.19 - 0xc.19 */
	 u_int8_t cdr_seq_abort_en;
	/* Description - CDR FLL locked, fravg < fravg_lock_th (coarse, fine, frest) */
	/* 0xc.20 - 0xc.20 */
	 u_int8_t cdr_fll_locked;
	/* Description - CDR PLL unlocked after achieving lock, fravg >= pll_un
lock_th */
	/* 0xc.21 - 0xc.21 */
	 u_int8_t cdr_pll_unlocked;
	/* Description - CDR error */
	/* 0xc.22 - 0xc.22 */
	 u_int8_t cdr_error;
	/* Description - CDR Error Counter. */
	/* 0xc.24 - 0xc.27 */
	 u_int8_t cdr_error_cnt;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.11 */
	 u_int16_t frest;
	/* Description -  */
	/* 0x10.16 - 0x10.26 */
	 u_int16_t frdot;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - CDR frequency average status */
	/* 0x14.0 - 0x14.15 */
	 u_int16_t fravg;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.0 */
	 u_int8_t bg_valid;
	/* Description -  */
	/* 0x18.2 - 0x18.2 */
	 u_int8_t pll_a_clk_valid;
	/* Description -  */
	/* 0x18.3 - 0x18.3 */
	 u_int8_t pll_b_clk_valid;
	/* Description - DLN mgmt_clk_en request */
	/* 0x18.4 - 0x18.4 */
	 u_int8_t mgmt_clk_en_req;
	/* Description - DLN pll_clk_en request */
	/* 0x18.5 - 0x18.5 */
	 u_int8_t pll_clk_en_req;
	/* Description -  */
	/* 0x18.16 - 0x18.19 */
	 u_int8_t rcal_val;
	/* Description -  */
	/* 0x18.20 - 0x18.23 */
	 u_int8_t rcal_tx_n_val;
	/* Description -  */
	/* 0x18.24 - 0x18.27 */
	 u_int8_t rcal_tx_p_val;
/*---------------- DWORD[7] (Offset 0x1c) ----------------*/
	/* Description -  */
	/* 0x1c.4 - 0x1c.4 */
	 u_int8_t tx_dco_cal_idle;
	/* Description -  */
	/* 0x1c.5 - 0x1c.5 */
	 u_int8_t tx_cal_idle;
	/* Description -  */
	/* 0x1c.7 - 0x1c.7 */
	 u_int8_t tx_pll_clk_valid_error_flag;
	/* Description -  */
	/* 0x1c.15 - 0x1c.15 */
	 u_int8_t rx_pll_clk_valid_error_flag;
	/* Description -  */
	/* 0x1c.16 - 0x1c.19 */
	 u_int8_t tx_cal_n_val;
	/* Description -  */
	/* 0x1c.20 - 0x1c.23 */
	 u_int8_t tx_cal_p_val;
	/* Description -  */
	/* 0x1c.24 - 0x1c.27 */
	 u_int8_t rx_rcal_val;
	/* Description -  */
	/* 0x1c.28 - 0x1c.31 */
	 u_int8_t rx_term_rcal_val;
};

/* Description -   */
/* Size in bytes - 48 */
struct sllm_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - copy to FW Data-Base. */
	/* 0x0.0 - 0x0.0 */
	 u_int8_t c_db;
	/* Description - For HCA supported only when indicated by PCAM 
0 - Network Port
1 - Near-End Port (For Retimer/Gearbox - Host side)
2 - Internal IC LR Port 
3 - Far-End Port (For Retimer/Gearbox - Line side)
4 - USR Main
5 - USR Tile
Other values are reserved. */
	/* 0x0.4 - 0x0.7 */
	 u_int8_t port_type;
	/* Description - physical lane number. */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type. determines the way local_port is 
interpreted:
0 - Local port number
1 - IB / label port number
 */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - 3 - 16nm products
4 - 7nm products */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t version;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Table  1192, "SLLM - Serdes Lane Link Maintenance Register 
Layout for 16nm," on page  1485
Table  1194, "SLLM - Serdes Lane Link Maintenance Register 
Layout for USR," on page  1487
Table  1196, "SLLM - Serdes Lane Link Maintenance Register 
Layout for 7nm," on page  1488 */
	/* 0x4.0 - 0x2c.31 */
	 union sllm_reg_page_data_auto page_data;
};

/* Description -   */
/* Size in bytes - 40 */
struct slpmu_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - For HCA supported only when indicated by PCAM 
0 - Network Port
1 - Near-End Port (For Retimer/Gearbox - Host side)
2 - Internal IC LR Port 
3 - F7ar-End Port (For Retimer/Gearbox - Line side)
4 - USR Main
5 - USR Tile
Other values are reserved. */
	/* 0x0.4 - 0x0.7 */
	 u_int8_t port_type;
	/* Description - physical lane number. */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description - Choose between rx lane or tx lane or PLL index for the PMU 
measurement
0 - rx
1 - tx
2 - pll index
Rx and Tx of the same lane use the same resource therefore 
cannot be measured in parallel. */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t type;
	/* Description - Port number access type. determines the way local_port is 
interpreted:
0 - Local port number
1 - IB / label port number
 */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - if type set to '0' or '1' Local port number.
if type set to '2' PLL index number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - 4 - 7nm products */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t version;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.10 */
	 u_int16_t pmu_out;
	/* Description -  */
	/* 0x4.12 - 0x4.12 */
	 u_int8_t pmu_pass;
	/* Description -  */
	/* 0x4.13 - 0x4.13 */
	 u_int8_t pmu_valid;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description -  */
	/* 0x8.0 - 0x8.0 */
	 u_int8_t pmu_en;
	/* Description -  */
	/* 0x8.1 - 0x8.1 */
	 u_int8_t pmu_chopper_en;
	/* Description -  */
	/* 0x8.3 - 0x8.3 */
	 u_int8_t pmu_rd_mode;
	/* Description -  */
	/* 0x8.4 - 0x8.7 */
	 u_int8_t pmu_sel;
	/* Description -  */
	/* 0x8.8 - 0x8.8 */
	 u_int8_t pmu_rail_en;
	/* Description -  */
	/* 0x8.9 - 0x8.9 */
	 u_int8_t pmu_rail_high;
	/* Description -  */
	/* 0x8.10 - 0x8.10 */
	 u_int8_t pmu_rail_cal_en;
	/* Description -  */
	/* 0x8.11 - 0x8.11 */
	 u_int8_t pmu_leveldet_en;
	/* Description -  */
	/* 0x8.12 - 0x8.14 */
	 u_int8_t pmu_res_ctrl;
	/* Description -  */
	/* 0x8.15 - 0x8.15 */
	 u_int8_t pmu_ckdiv2;
	/* Description -  */
	/* 0x8.16 - 0x8.16 */
	 u_int8_t pmu_en_ovrd;
	/* Description -  */
	/* 0x8.20 - 0x8.20 */
	 u_int8_t pmu_start;
	/* Description -  */
	/* 0x8.21 - 0x8.21 */
	 u_int8_t pmu_start_ovrd;
	/* Description -  */
	/* 0x8.22 - 0x8.22 */
	 u_int8_t pmu_load;
	/* Description -  */
	/* 0x8.23 - 0x8.23 */
	 u_int8_t pmu_load_ovrd;
	/* Description -  */
	/* 0x8.24 - 0x8.27 */
	 u_int8_t pmu_bias_time;
	/* Description -  */
	/* 0x8.28 - 0x8.28 */
	 u_int8_t pmu_fs_sel;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description -  */
	/* 0xc.0 - 0xc.10 */
	 u_int16_t pmu_th_min;
	/* Description -  */
	/* 0xc.16 - 0xc.26 */
	 u_int16_t pmu_th_max;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description -  */
	/* 0x10.0 - 0x10.2 */
	 u_int8_t tx_atest_sel;
	/* Description -  */
	/* 0x10.3 - 0x10.7 */
	 u_int8_t rx_atest_sel;
	/* Description -  */
	/* 0x10.8 - 0x10.10 */
	 u_int8_t rx_bias_atest_sel;
	/* Description -  */
	/* 0x10.11 - 0x10.12 */
	 u_int8_t rx_tah_atest_sel;
	/* Description -  */
	/* 0x10.16 - 0x10.18 */
	 u_int8_t tx_clkrcv_atest_sel;
	/* Description -  */
	/* 0x10.19 - 0x10.21 */
	 u_int8_t rx_clkrcv_atest_sel;
	/* Description -  */
	/* 0x10.22 - 0x10.25 */
	 u_int8_t tx_rvdd_atest_sel;
	/* Description -  */
	/* 0x10.26 - 0x10.29 */
	 u_int8_t rx_rvdd_atest_sel;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description -  */
	/* 0x14.0 - 0x14.2 */
	 u_int8_t tx_bias_atest_sel;
	/* Description -  */
	/* 0x14.3 - 0x14.6 */
	 u_int8_t tx_clkbuf_atest_sel;
	/* Description -  */
	/* 0x14.7 - 0x14.10 */
	 u_int8_t tx_txpll_atest_sel;
	/* Description -  */
	/* 0x14.11 - 0x14.13 */
	 u_int8_t tx_cal_adc_atest_sel;
	/* Description -  */
	/* 0x14.16 - 0x14.18 */
	 u_int8_t rx_term_atest_sel;
	/* Description -  */
	/* 0x14.20 - 0x14.24 */
	 u_int8_t rx_vga_atest_sel;
	/* Description -  */
	/* 0x14.28 - 0x14.30 */
	 u_int8_t rx_ctle_atest_sel;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description -  */
	/* 0x18.0 - 0x18.2 */
	 u_int8_t rx_dco_atest_sel;
	/* Description -  */
	/* 0x18.4 - 0x18.8 */
	 u_int8_t rx_adc_atest_sel;
	/* Description -  */
	/* 0x18.12 - 0x18.13 */
	 u_int8_t rx_calcomp_atest_sel;
	/* Description -  */
	/* 0x18.16 - 0x18.16 */
	 u_int8_t atest_en;
	/* Description -  */
	/* 0x18.17 - 0x18.17 */
	 u_int8_t atest_amp_byp;
	/* Description -  */
	/* 0x18.21 - 0x18.27 */
	 u_int8_t atest_sel;
};

/* Description -   */
/* Size in bytes - 76 */
struct slreg_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - Eye Index.
0 - Upper
1 - Mid
2 - Lower
3 - Composite */
	/* 0x0.0 - 0x0.1 */
	 u_int8_t eidx;
	/* Description - For HCA supported only when indicated by PCAM 
0 - Network Port
1 - Near-End Port (For Retimer/Gearbox - Host side)
2 - Internal IC LR Port 
3 - Far-End Port (For Retimer/Gearbox - Line side)
4 - USR Main
5 - USR Tile
Other values are reserved. */
	/* 0x0.4 - 0x0.7 */
	 u_int8_t port_type;
	/* Description - physical lane number. */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type. determines the way local_port is 
interpreted:
0 - Local port number
1 - IB / label port number
3 - Out of band / PCI */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - 0 - 16nm products
4 - 7nm */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t version;
	/* Description - 0 - Invalid
1 - Valid
 */
	/* 0x0.28 - 0x0.31 */
	 u_int8_t status;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Table  1160, "SLREG - Serdes Lane Receive Eye Grade Regis
ter Layout for 16nm," on page  1452
Table  1164, "SLREG - Serdes Lane Receive Grade Register 
Layout for USR," on page  1459
Table  1162, "SLREG - Serdes Lane Receive Grade Register 
Layout for 7nm," on page  1454 */
	/* 0x4.0 - 0x48.31 */
	 union slreg_reg_page_data_auto page_data;
};

/* Description -   */
/* Size in bytes - 168 */
struct slrg_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - set 1 for test mode page.
relevant for 7nm version only, lane field is ignored in test 
mode */
	/* 0x0.0 - 0x0.0 */
	 u_int8_t test_mode;
	/* Description - For HCA supported only when indicated by PCAM 
0 - Network Port
1 - Near-End Port (For Retimer/Gearbox - Host side)
2 - Internal IC LR Port 
3 - Far-End Port (For Retimer/Gearbox - Line side)
4 - USR Main
5 - USR Tile
Other values are reserved. */
	/* 0x0.4 - 0x0.7 */
	 u_int8_t port_type;
	/* Description - Physical lane number */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type. 
0 - Local port number
1 - IB / label port number
 */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - 0 - 40nm products
1 - 28nm products
3 - 16nm products
4 - 7nm products */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t version;
	/* Description - 0 - Invalid
1 - Valid
 */
	/* 0x0.28 - 0x0.31 */
	 u_int8_t status;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Table  1060, "SLRG - Serdes Lane Receive Grade Register Lay
out for 40nm and 28nm," on page  1329
Table  1062, "SLRG - Serdes Lane Receive Grade Register Lay
out for 16nm," on page  1331
Table  1064, "SLRG - Serdes Lane Receive Grade Register Lay
out for 7nm," on page  1333
Table  1066, "SLRG - Serdes Lane Receive Grade Register Lay
out for 7nm Testing," on page  1334 */
	/* 0x4.0 - 0xa4.31 */
	 union slrg_reg_page_data_auto page_data;
};

/* Description -   */
/* Size in bytes - 92 */
struct slrip_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - For HCA supported only when indicated by PCAM 
0 - Network Port
1 - Near-End Port (For Retimer/Gearbox - Host side)
2 - Internal IC LR Port 
3 - Far-End Port (For Retimer/Gearbox - Line side)
4 - USR Main
5 - USR Tile
Other values are reserved. */
	/* 0x0.4 - 0x0.7 */
	 u_int8_t port_type;
	/* Description - physical lane number. */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type:
0 - Local port number
1 - IB Port number
3 - Out of band / PCI */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - 0 - 16nm products
4 - 7nm */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t version;
	/* Description - 0 - Invalid
1 - Valid */
	/* 0x0.28 - 0x0.31 */
	 u_int8_t status;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Table  1180, "[Internal] SLRIP - Serdes Lane Receive Input 
Buffer Parameters Register Layout," on page  1471
Table  1182, "[Internal] SLRIP - Serdes Lane Receive Parame
ters Register Layout for 7nm," on page  1473 */
	/* 0x4.0 - 0x58.31 */
	 union slrip_reg_page_data_auto page_data;
};

/* Description -   */
/* Size in bytes - 152 */
struct slrp_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - For HCA supported only when indicated by PCAM 
0 - Network Port
1 - Near-End Port (For Retimer/Gearbox - Host side)
2 - Internal IC LR Port 
3 - Far-End Port (For Retimer/Gearbox - Line side)
4 - USR Main
5 - USR Tile
Other values are reserved. */
	/* 0x0.4 - 0x0.7 */
	 u_int8_t port_type;
	/* Description - Physical lane number
 */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type. 
0 - Local port number
1 - IB / label port number
 */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - 0 - 40nm products
1 - 28nm products
3 - 16nm products
4 - 7nm */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t version;
	/* Description - 0 - Invalid
1 - Valid */
	/* 0x0.28 - 0x0.31 */
	 u_int8_t status;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Table  1036, "[Internal] Serdes Lane Receive Parameters Reg
ister Layout for 40nm and 28nm," on page  1305
Table  1038, "[Internal] Serdes Lane Receive Parameters Reg
ister Layout for 16nm," on page  1307
Table  1040, "[Internal] Serdes Lane Receive Parameters Reg
ister Layout For Gearbox," on page  1312
Table  1042, "[Internal] SLRP - Serdes Lane Receive Parame
ters Register Layout for USR," on page  1313
Table  1044, "[Internal] SLRP - Serdes Lane Receive Parame
ters Register Layout for 7nm," on page  1315 */
	/* 0x4.0 - 0x94.31 */
	 union slrp_reg_page_data_auto page_data;
};

/* Description -   */
/* Size in bytes - 28 */
struct slsir_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - For HCA supported only when indicated by PCAM 
0 - Network Port
1 - Near-End Port (For Retimer/Gearbox - Host side)
2 - Internal IC LR Port 
3 - Far-End Port (For Retimer/Gearbox - Line side)
4 - USR Main
5 - USR Tile
Other values are reserved. */
	/* 0x0.4 - 0x0.7 */
	 u_int8_t port_type;
	/* Description - physical lane number. */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description - Local port number [9:8] */
	/* 0x0.12 - 0x0.13 */
	 u_int8_t lp_msb;
	/* Description - Port number access type. determines the way local_port is 
interpreted:
0 - Local port number
1 - IB / label port number
 */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - 4 - 7nm products */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t version;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description -  */
	/* 0x4.0 - 0x4.0 */
	 u_int8_t imem_chksm_error;
	/* Description -  */
	/* 0x4.1 - 0x4.1 */
	 u_int8_t cdr_error;
	/* Description -  */
	/* 0x4.2 - 0x4.2 */
	 u_int8_t feq_adc_overload;
	/* Description -  */
	/* 0x4.3 - 0x4.3 */
	 u_int8_t peq_adc_overload;
	/* Description -  */
	/* 0x4.4 - 0x4.4 */
	 u_int8_t nop_dsovf_error;
	/* Description -  */
	/* 0x4.5 - 0x4.5 */
	 u_int8_t nop_dsunf_error;
	/* Description -  */
	/* 0x4.6 - 0x4.6 */
	 u_int8_t nop_rsovf_error;
	/* Description -  */
	/* 0x4.7 - 0x4.7 */
	 u_int8_t nop_rsunf_error;
/*---------------- DWORD[2] (Offset 0x8) ----------------*/
	/* Description - 0x0:  IDDQ
0x1:  SLEEP
0x2:  SPEED_CHANGE
0x3:  POWERUP
0x4:  UGL_TX_POWERUP
0x5:  CAL_DONE_WAIT1
0x6:  CAL_ABORT
0x7:  CAL_DONE_WAIT0
0x8:  CAL_DONE
0x9:  DATA_READY
0xA: DATA_EN_RDY
0xB: DATA_EN */
	/* 0x8.0 - 0x8.3 */
	 u_int8_t tx_ugl_state;
	/* Description -  */
	/* 0x8.16 - 0x8.18 */
	 u_int8_t rx_eq_ugl_state;
	/* Description -  */
	/* 0x8.21 - 0x8.23 */
	 u_int8_t rx_cal_ugl_state;
	/* Description -  */
	/* 0x8.24 - 0x8.25 */
	 u_int8_t rx_eom_ugl_state;
	/* Description - 0x0: IDDQ
0x1: SLEEP
0X2: SPEED_CHANGE
0X3: POWERUP
0X4: CAL
0X5: WAIT_TERM
0X6: DATA_EN_RDY
0X7: DATA_EN
0X8: CDR_EN
0X9: ACTIVE
0XA: EQ
0XB: EOM */
	/* 0x8.28 - 0x8.31 */
	 u_int8_t rx_ugl_state;
/*---------------- DWORD[3] (Offset 0xc) ----------------*/
	/* Description - Receiver detect iteration counter (Wrap around) */
	/* 0xc.0 - 0xc.7 */
	 u_int8_t rd_iter_cnt;
	/* Description - Signal detect iterations (Wrap around) */
	/* 0xc.8 - 0xc.15 */
	 u_int8_t sd_iter_cnt;
	/* Description - Signal detect hits counter */
	/* 0xc.16 - 0xc.23 */
	 u_int8_t sd_hits_cnt;
/*---------------- DWORD[4] (Offset 0x10) ----------------*/
	/* Description - rx init done counter */
	/* 0x10.0 - 0x10.7 */
	 u_int8_t rx_init_done_cnt;
	/* Description - rx init abort counter */
	/* 0x10.8 - 0x10.15 */
	 u_int8_t rx_init_abort_cnt;
	/* Description - AE state
0: AE_STATE_RESET
1: AE_STATE_INIT
2: AE_STATE_IDLE
3: AE_STATE_HALT
4: AE_STATE_RXINIT
5: AE_STATE_RXINIT_DONE
6: AE_STATE_RXINIT_ABORT
7: AE_STATE_CDR_SEQ
8: AE_STATE_CDR_SEQ_DONE
9: AE_STATE_CDR_SEQ_ABORT
10: AE_STATE_CAL
11: AE_STATE_CAL_DONE
12: AE_STATE_CAL_ABORT
13: AE_STATE_FEQTRN
14: AE_STATE_PEQTRN
15: AE_STATE_EQTRN_DONE
16: AE_STATE_EQTRN_ABORT
17: AE_STATE_EOM
18: AE_STATE_EOM_DONE
19: AE_STATE_EOM_ABORT
20: AE_STATE_RAMP
21: AE_STATE_RAMP_ABORT
22: AE_STATE_MARGIN
23: AE_STATE_MARGIN_YIELD
24: AE_STATE_MARGIN_DONE */
	/* 0x10.16 - 0x10.20 */
	 u_int8_t ae_state;
/*---------------- DWORD[5] (Offset 0x14) ----------------*/
	/* Description - cal done counter */
	/* 0x14.0 - 0x14.7 */
	 u_int8_t cal_done_cnt;
	/* Description - cal abort counter */
	/* 0x14.8 - 0x14.15 */
	 u_int8_t cal_abort_cnt;
	/* Description - cdr done counter */
	/* 0x14.16 - 0x14.23 */
	 u_int8_t cdr_done_cnt;
	/* Description - cdr abort counter */
	/* 0x14.24 - 0x14.31 */
	 u_int8_t cdr_abort_cnt;
/*---------------- DWORD[6] (Offset 0x18) ----------------*/
	/* Description - eom done counter */
	/* 0x18.0 - 0x18.7 */
	 u_int8_t eom_done_cnt;
	/* Description - eom abort counter */
	/* 0x18.8 - 0x18.15 */
	 u_int8_t eom_abort_cnt;
	/* Description - eq done counter */
	/* 0x18.16 - 0x18.23 */
	 u_int8_t eq_done_cnt;
	/* Description - eq abort counter */
	/* 0x18.24 - 0x18.31 */
	 u_int8_t eq_abort_cnt;
};

/* Description -   */
/* Size in bytes - 76 */
struct sltp_reg {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description - copy transmitter parameters to Data Base. 
 */
	/* 0x0.0 - 0x0.0 */
	 u_int8_t c_db;
	/* Description - For HCA supported only when indicated by PCAM 
0 - Network Port
1 - Near-End Port (For Retimer/Gearbox - Host side)
2 - Internal IC LR Port 
3 - Far-End Port (For Retimer/Gearbox - Line side)
Other values are reserved. */
	/* 0x0.1 - 0x0.3 */
	 u_int8_t port_type;
	/* Description - Reserved for PCIe.
The lane speed for TX settings:
0 - SDR / Gen1 (PCIe)
1 - DDR / Gen2 (PCIe)
2 - QDR / Gen3 (PCIe)
3 - FDR10 (10GE / 40GE)
4 - FDR (56GE) / Gen4 (PCIe)
5 - EDR (25GE / 50GE / 100GE) / Gen5 (PCIe)
6 - HDR (50GE / 200GE / 400GE)
7 - NDR /100GE / 200GE / 400GE / 800GE (53.125 Gbd / 
106.25Gb/s)
8-9 - Reserved
10 - 1GE
11 - 2.5GE (XAUI)
12 - 50GE-KR4
13-15 - Reserved */
	/* 0x0.4 - 0x0.7 */
	 u_int8_t lane_speed;
	/* Description - Physical lane number */
	/* 0x0.8 - 0x0.11 */
	 u_int8_t lane;
	/* Description - set configuration mode for 7nm/5nm product.
0 - when set, tx taps are configured from
Table  1054, "SLTP - Serdes Lane Transmit Parameters Register Lay
out for 7nm," on page  1323 page and fields.
LUT table fields are ignored

1 - when set, tx taps are configured from
Table  1056, "SLTP - Serdes Lane Transmit Parameters Register Lay
out for LUT 7nm," on page  1325 page fields.
7nm_fir_taps page fields are ignored. */
	/* 0x0.12 - 0x0.12 */
	 u_int8_t conf_mod;
	/* Description - configures Tx parameter set policy
0 - Tx parameters will be set according to best possible con
figuration chosen by the system
1 - When set Tx parameters will be set according to Data Base 
only and will not be overridden by training */
	/* 0x0.13 - 0x0.13 */
	 u_int8_t tx_policy;
	/* Description - Port number access type. determines the way local_port is 
interpreted:
0 - Local port number
1 - IB / label port number
3 - PCI / Out of Band */
	/* 0x0.14 - 0x0.15 */
	 u_int8_t pnat;
	/* Description - Local port number. */
	/* 0x0.16 - 0x0.23 */
	 u_int8_t local_port;
	/* Description - 0 - 40nm products
1 - 28nm products
3 - 16nm products
4 - 7nm products */
	/* 0x0.24 - 0x0.27 */
	 u_int8_t version;
	/* Description - 0 - Invalid
1 - Valid */
	/* 0x0.28 - 0x0.31 */
	 u_int8_t status;
/*---------------- DWORD[1] (Offset 0x4) ----------------*/
	/* Description - Table  1048, "SLTP - Serdes Lane Transmit Parameters Regis
ter Layout for 28nm and 40nm," on page  1320
Table  1050, "SLTP - Serdes Lane Transmit Parameters Regis
ter Layout for 16nm," on page  1321
Table  1052, "[Internal] Serdes Lane Transmit Parameters 
Register Layout For Gearbox," on page  1323
Table  1054, "SLTP - Serdes Lane Transmit Parameters Regis
ter Layout for 7nm," on page  1323
Table  1056, "SLTP - Serdes Lane Transmit Parameters Regis
ter Layout for LUT 7nm," on page  1325 */
	/* 0x4.0 - 0x48.31 */
	 union sltp_reg_page_data_auto page_data;
};

/* Description -   */
/* Size in bytes - 16777216 */
union PACKETS_INTERNAL {
/*---------------- DWORD[0] (Offset 0x0) ----------------*/
	/* Description -  */
	/* 0x0.0 - 0x0.31 */
	 struct SMP_LossyLinkConfig SMP_LossyLinkConfig;
	/* Description -  */
	/* 0x0.0 - 0x98.31 */
	 struct VendorSpec_PhyConfig VendorSpec_PhyConfig;
	/* Description -  */
	/* 0x0.0 - 0xc.31 */
	 struct SMP_TemperatureSensing SMP_TemperatureSensing;
	/* Description -  */
	/* 0x0.0 - 0x2c.31 */
	 struct CableInfo_Payload_Addr_212_255 CableInfo_Payload_Addr_212_255;
	/* Description -  */
	/* 0x0.0 - 0x2c.31 */
	 struct CableInfo_Payload_Addr_168_211 CableInfo_Payload_Addr_168_211;
	/* Description -  */
	/* 0x0.0 - 0x2c.31 */
	 struct CableInfo_Payload_Addr_128_167 CableInfo_Payload_Addr_128_167;
	/* Description -  */
	/* 0x0.0 - 0x2c.31 */
	 struct CableInfo_Payload_Addr_0_47 CableInfo_Payload_Addr_0_47;
	/* Description -  */
	/* 0x0.0 - 0x1c.31 */
	 struct CableInfo_Payload_Addr_48_79 CableInfo_Payload_Addr_48_79;
	/* Description -  */
	/* 0x0.0 - 0x2c.31 */
	 struct CableInfo_Payload_Addr_80_127 CableInfo_Payload_Addr_80_127;
	/* Description -  */
	/* 0x0.0 - 0x2c.31 */
	 struct CableInfo_Payload_Page_3_Addr_212_255 CableInfo_Payload_Page_3_Addr_212_255;
	/* Description -  */
	/* 0x0.0 - 0x2c.31 */
	 struct CableInfo_Payload_Page_3_Addr_128_175 CableInfo_Payload_Page_3_Addr_128_175;
	/* Description -  */
	/* 0x0.0 - 0x28.31 */
	 struct CableInfo_Payload_Page_F0_Addr_128_171 CableInfo_Payload_Page_F0_Addr_128_171;
	/* Description -  */
	/* 0x0.0 - 0x2c.31 */
	 struct CableInfo_Payload_Page_E9_Addr_128_175 CableInfo_Payload_Page_E9_Addr_128_175;
	/* Description -  */
	/* 0x0.0 - 0x20.31 */
	 struct CableInfo_Payload_Page_E9_Addr_176_211 CableInfo_Payload_Page_E9_Addr_176_211;
	/* Description -  */
	/* 0x0.0 - 0x0.31 */
	 struct SMP_MAD_AttrMod_CableInfo SMP_MAD_AttrMod_CableInfo;
	/* Description -  */
	/* 0x0.0 - 0x3c.31 */
	 struct SMP_CableInfo SMP_CableInfo;
	/* Description -  */
	/* 0x0.0 - 0x0.31 */
	 struct SMP_MAD_AttrMod_EyeOpen MAD_SMP_AttrMod_EyeOpen;
	/* Description -  */
	/* 0x0.0 - 0x3c.31 */
	 struct SMP_EyeOpen SMP_EyeOpen;
	/* Description - page in DiagnostiData MAD */
	/* 0x0.0 - 0x1c.31 */
	 struct DDPageIdentification DDPageIdentification;
	/* Description - page in DiagnostiData MAD */
	/* 0x0.0 - 0xc4.31 */
	 struct DDPhysCounters DDPhysCounters;
	/* Description - page in DiagnostiData MAD */
	/* 0x0.0 - 0x5c.31 */
	 struct DDPCIPerfCounters DDPCIPerfCounters;
	/* Description - page 4 in DiagnostiData MAD */
	/* 0x0.0 - 0x5c.31 */
	 struct DD_pcie_timers_states DD_pcie_timers_states;
	/* Description - page 3 in DiagnostiData MAD */
	/* 0x0.0 - 0x5c.31 */
	 struct DD_pcie_lanes_counters DD_pcie_lanes_counters;
	/* Description - page in DiagnostiData MAD */
	/* 0x0.0 - 0xd4.31 */
	 struct DDTroubleShootingInfo DDTroubleShootingInfo;
	/* Description - page in DiagnostiData MAD */
	/* 0x0.0 - 0x34.31 */
	 struct DDOperationInfo DDOperationInfo;
	/* Description - page in DiagnostiData MAD */
	/* 0x0.0 - 0x6c.31 */
	 struct DDPhyInfo DDPhyInfo;
	/* Description - Table 1171 - Module Info Page Layout */
	/* 0x0.0 - 0xf4.31 */
	 struct DDModuleInfo DDModuleInfo;
	/* Description - page in DiagnostiData MAD */
	/* 0x0.0 - 0x18.31 */
	 struct DDLinkDownInfo DDLinkDownInfo;
	/* Description - page 242 in DiagnostiData MAD */
	/* 0x0.0 - 0xf4.31 */
	 struct DDLinkUpInfo DDLinkUpInfo;
	/* Description - page in DiagnostiData MAD */
	/* 0x0.0 - 0xf4.31 */
	 struct DDLatchedFlagInfo DDLatchedFlagInfo;
	/* Description - page 247 in DiagnostiData MAD */
	/* 0x0.0 - 0x7c.31 */
	 struct DD_RS_Histograms DD_RS_Histograms;
	/* Description - page ??? in DiagnostiData MAD */
	/* 0x0.0 - 0x4c.31 */
	 struct DD_PLR_Counters DD_PLR_Counters;
	/* Description - page ??? in DiagnostiData MAD */
	/* 0x0.0 - 0x80.31 */
	 struct DD_PhyStatisticalCounters DD_PhyStatisticalCounters;
	/* Description - page 241 in DiagnostiData MAD */
	/* 0x0.0 - 0xf4.31 */
	 struct DD_InfiniBandGeneralCounter DD_InfiniBandGeneralCounter;
	/* Description - 0x9001 */
	/* 0x0.0 - 0x4.31 */
	 struct mfcr_reg mfcr_reg;
	/* Description - 0x9003 */
	/* 0x0.0 - 0x4.31 */
	 struct mfsm_reg mfsm_reg;
	/* Description - 0x9004 */
	/* 0x0.0 - 0x8.31 */
	 struct mfsl_reg mfsl_reg;
	/* Description - 0x9007 */
	/* 0x0.0 - 0x8.31 */
	 struct fore_reg fore_reg;
	/* Description - 0x903B */
	/* 0x0.0 - 0x28.31 */
	 struct mfnr_reg mfnr_reg;
	/* Description - 0x9009 */
	/* 0x0.0 - 0x4.31 */
	 struct mtcap_reg mtcap_reg;
	/* Description - 0x900A */
	/* 0x0.0 - 0x1c.31 */
	 struct mtmp_reg mtmp_reg;
	/* Description - 0x900B */
	/* 0x0.0 - 0xc.31 */
	 struct mtwe_reg mtwe_reg;
	/* Description - 0x902e */
	/* 0x0.0 - 0xc.31 */
	 struct mvcap_reg mvcap_reg;
	/* Description - 0x900C */
	/* 0x0.0 - 0x14.31 */
	 struct mvcr_reg mvcr_reg;
	/* Description - 0x900D */
	/* 0x0.0 - 0x9c.31 */
	 struct msps_reg msps_reg;
	/* Description - 0x9021 */
	/* 0x0.0 - 0x7c.31 */
	 struct msgi_reg msgi_reg;
	/* Description - 0x5028 */
	/* 0x0.0 - 0xa4.31 */
	 struct slrg_reg slrg_reg;
	/* Description - 0x5026 */
	/* 0x0.0 - 0x94.31 */
	 struct slrp_reg slrp_reg;
	/* Description - 0x5027 */
	/* 0x0.0 - 0x48.31 */
	 struct sltp_reg sltp_reg;
	/* Description - 0x5029 */
	/* 0x0.0 - 0x28.31 */
	 struct ptas_reg ptas_reg;
	/* Description -  */
	/* 0x0.0 - 0x28.31 */
	 struct pmdr_reg pmdr_reg;
	/* Description - 0x5030 */
	/* 0x0.0 - 0x24.31 */
	 struct ppll_reg ppll_reg;
	/* Description - 0x5050 */
	/* 0x0.0 - 0x28.31 */
	 struct mpein_reg mpein_reg;
	/* Description - 0x9059 */
	/* 0x0.0 - 0xc.31 */
	 struct mpir_reg mpir_reg;
	/* Description - 0x503A */
	/* 0x0.0 - 0x58.31 */
	 struct slrip_reg slrip_reg;
	/* Description - 0x5042 */
	/* 0x0.0 - 0x48.31 */
	 struct slreg_reg slreg_reg;
	/* Description - 0x503b */
	/* 0x0.0 - 0x28.31 */
	 struct slcct_reg slcct_reg;
	/* Description - 0x505b */
	/* 0x0.0 - 0x2c.31 */
	 struct sllm_reg sllm_reg;
	/* Description - 0x5025 */
	/* 0x0.0 - 0x28.31 */
	 struct ppamp_reg ppamp_reg;
	/* Description - Table 1152 - PPHCR - Port Phy Histogram Configuration Register Layout */
	/* 0x0.0 - 0x4c.31 */
	 struct pphcr_reg pphcr_reg;
	/* Description - Table 1285 - SLCDR - SerDes Lane CDR Register Layout */
	/* 0x0.0 - 0x20.31 */
	 struct slcdr_reg slcdr_reg;
	/* Description - Table 1423 - SLPMU - SerDes Lane Parametric Measurement Unit Layout */
	/* 0x0.0 - 0x24.31 */
	 struct slpmu_reg slpmu_reg;
	/* Description - Table 1419 - SLSIR - Serdes Lane Status Info Register */
	/* 0x0.0 - 0x18.31 */
	 struct slsir_reg slsir_reg;
	/* Description - Table 1425 - PEUCG - Ports Extended UPHY CfgSpace Gateway Layout */
	/* 0x0.0 - 0xc4.31 */
	 struct peucg_reg peucg_reg;
	/* Description - Table 1427 - PEUCG - Page Data Layout */
	/* 0x0.0 - 0x0.31 */
	 struct peucg_page_data peucg_page_data;
	/* Description - Table 1421 - PUCG - Ports UPHY CfgSpace Gateway Layout */
	/* 0x0.0 - 0x108.31 */
	 struct pucg_reg pucg_reg;
	/* Description -  */
	/* 0x0.0 - 0x18.31 */
	 struct pmcr_reg pmcr_reg;
	/* Description -  */
	/* 0x0.0 - 0x3c.31 */
	 struct ptys_reg ptys_reg;
	/* Description -  */
	/* 0x0.0 - 0xfc.31 */
	 struct pddr_reg pddr_reg;
	/* Description -  */
	/* 0x0.0 - 0xfc.31 */
	 struct pemi_reg pemi_reg;
	/* Description -  */
	/* 0x0.0 - 0x4c.31 */
	 struct pcam_reg pcam_reg;
	/* Description -  */
	/* 0x0.0 - 0x18.31 */
	 struct prtl_reg prtl_reg;
	/* Description -  */
	/* 0x0.0 - 0x2c.31 */
	 struct ppbmp_reg ppbmp_reg;
	/* Description -  */
	/* 0x0.0 - 0x14.31 */
	 struct mrcs_reg mrcs_reg;
	/* Description -  */
	/* 0x0.0 - 0x64.31 */
	 struct mpcnt_reg mpcnt_reg;
	/* Description -  */
	/* 0x0.0 - 0xd8.31 */
	 struct ppcnt_reg ppcnt_reg;
};


/*================= PACK/UNPACK/PRINT FUNCTIONS ======================*/
/* pll_28nm */
void pll_28nm_pack(const struct pll_28nm *ptr_struct, u_int8_t *ptr_buff);
void pll_28nm_unpack(struct pll_28nm *ptr_struct, const u_int8_t *ptr_buff);
void pll_28nm_print(const struct pll_28nm *ptr_struct, FILE *file, int indent_level);
int pll_28nm_size(void);
#define PLL_28NM_SIZE    (0x8)
void pll_28nm_dump(const struct pll_28nm *ptr_struct, FILE *file);
/* pll_status_data */
void pll_status_data_pack(const struct pll_status_data *ptr_struct, u_int8_t *ptr_buff);
void pll_status_data_unpack(struct pll_status_data *ptr_struct, const u_int8_t *ptr_buff);
void pll_status_data_print(const struct pll_status_data *ptr_struct, FILE *file, int indent_level);
int pll_status_data_size(void);
#define PLL_STATUS_DATA_SIZE    (0x8)
void pll_status_data_dump(const struct pll_status_data *ptr_struct, FILE *file);
/* slrg_lane_measure_info */
void slrg_lane_measure_info_pack(const struct slrg_lane_measure_info *ptr_struct, u_int8_t *ptr_buff);
void slrg_lane_measure_info_unpack(struct slrg_lane_measure_info *ptr_struct, const u_int8_t *ptr_buff);
void slrg_lane_measure_info_print(const struct slrg_lane_measure_info *ptr_struct, FILE *file, int indent_level);
int slrg_lane_measure_info_size(void);
#define SLRG_LANE_MEASURE_INFO_SIZE    (0x14)
void slrg_lane_measure_info_dump(const struct slrg_lane_measure_info *ptr_struct, FILE *file);
/* mpcnt_RAW_page_data */
void mpcnt_RAW_page_data_pack(const struct mpcnt_RAW_page_data *ptr_struct, u_int8_t *ptr_buff);
void mpcnt_RAW_page_data_unpack(struct mpcnt_RAW_page_data *ptr_struct, const u_int8_t *ptr_buff);
void mpcnt_RAW_page_data_print(const struct mpcnt_RAW_page_data *ptr_struct, FILE *file, int indent_level);
int mpcnt_RAW_page_data_size(void);
#define MPCNT_RAW_PAGE_DATA_SIZE    (0x60)
void mpcnt_RAW_page_data_dump(const struct mpcnt_RAW_page_data *ptr_struct, FILE *file);
/* pcie_lanes_counters */
void pcie_lanes_counters_pack(const struct pcie_lanes_counters *ptr_struct, u_int8_t *ptr_buff);
void pcie_lanes_counters_unpack(struct pcie_lanes_counters *ptr_struct, const u_int8_t *ptr_buff);
void pcie_lanes_counters_print(const struct pcie_lanes_counters *ptr_struct, FILE *file, int indent_level);
int pcie_lanes_counters_size(void);
#define PCIE_LANES_COUNTERS_SIZE    (0x48)
void pcie_lanes_counters_dump(const struct pcie_lanes_counters *ptr_struct, FILE *file);
/* pcie_perf_counters */
void pcie_perf_counters_pack(const struct pcie_perf_counters *ptr_struct, u_int8_t *ptr_buff);
void pcie_perf_counters_unpack(struct pcie_perf_counters *ptr_struct, const u_int8_t *ptr_buff);
void pcie_perf_counters_print(const struct pcie_perf_counters *ptr_struct, FILE *file, int indent_level);
int pcie_perf_counters_size(void);
#define PCIE_PERF_COUNTERS_SIZE    (0x54)
void pcie_perf_counters_dump(const struct pcie_perf_counters *ptr_struct, FILE *file);
/* pcie_physical_layer */
void pcie_physical_layer_pack(const struct pcie_physical_layer *ptr_struct, u_int8_t *ptr_buff);
void pcie_physical_layer_unpack(struct pcie_physical_layer *ptr_struct, const u_int8_t *ptr_buff);
void pcie_physical_layer_print(const struct pcie_physical_layer *ptr_struct, FILE *file, int indent_level);
int pcie_physical_layer_size(void);
#define PCIE_PHYSICAL_LAYER_SIZE    (0x4)
void pcie_physical_layer_dump(const struct pcie_physical_layer *ptr_struct, FILE *file);
/* pcie_timers_states */
void pcie_timers_states_pack(const struct pcie_timers_states *ptr_struct, u_int8_t *ptr_buff);
void pcie_timers_states_unpack(struct pcie_timers_states *ptr_struct, const u_int8_t *ptr_buff);
void pcie_timers_states_print(const struct pcie_timers_states *ptr_struct, FILE *file, int indent_level);
int pcie_timers_states_size(void);
#define PCIE_TIMERS_STATES_SIZE    (0x5c)
void pcie_timers_states_dump(const struct pcie_timers_states *ptr_struct, FILE *file);
/* pemi_FERC_Properties */
void pemi_FERC_Properties_pack(const struct pemi_FERC_Properties *ptr_struct, u_int8_t *ptr_buff);
void pemi_FERC_Properties_unpack(struct pemi_FERC_Properties *ptr_struct, const u_int8_t *ptr_buff);
void pemi_FERC_Properties_print(const struct pemi_FERC_Properties *ptr_struct, FILE *file, int indent_level);
int pemi_FERC_Properties_size(void);
#define PEMI_FERC_PROPERTIES_SIZE    (0xcc)
void pemi_FERC_Properties_dump(const struct pemi_FERC_Properties *ptr_struct, FILE *file);
/* pemi_FERC_Samples */
void pemi_FERC_Samples_pack(const struct pemi_FERC_Samples *ptr_struct, u_int8_t *ptr_buff);
void pemi_FERC_Samples_unpack(struct pemi_FERC_Samples *ptr_struct, const u_int8_t *ptr_buff);
void pemi_FERC_Samples_print(const struct pemi_FERC_Samples *ptr_struct, FILE *file, int indent_level);
int pemi_FERC_Samples_size(void);
#define PEMI_FERC_SAMPLES_SIZE    (0xcc)
void pemi_FERC_Samples_dump(const struct pemi_FERC_Samples *ptr_struct, FILE *file);
/* pemi_Laser_Monitors_Properties */
void pemi_Laser_Monitors_Properties_pack(const struct pemi_Laser_Monitors_Properties *ptr_struct, u_int8_t *ptr_buff);
void pemi_Laser_Monitors_Properties_unpack(struct pemi_Laser_Monitors_Properties *ptr_struct, const u_int8_t *ptr_buff);
void pemi_Laser_Monitors_Properties_print(const struct pemi_Laser_Monitors_Properties *ptr_struct, FILE *file, int indent_level);
int pemi_Laser_Monitors_Properties_size(void);
#define PEMI_LASER_MONITORS_PROPERTIES_SIZE    (0xcc)
void pemi_Laser_Monitors_Properties_dump(const struct pemi_Laser_Monitors_Properties *ptr_struct, FILE *file);
/* pemi_Laser_Monitors_Samples */
void pemi_Laser_Monitors_Samples_pack(const struct pemi_Laser_Monitors_Samples *ptr_struct, u_int8_t *ptr_buff);
void pemi_Laser_Monitors_Samples_unpack(struct pemi_Laser_Monitors_Samples *ptr_struct, const u_int8_t *ptr_buff);
void pemi_Laser_Monitors_Samples_print(const struct pemi_Laser_Monitors_Samples *ptr_struct, FILE *file, int indent_level);
int pemi_Laser_Monitors_Samples_size(void);
#define PEMI_LASER_MONITORS_SAMPLES_SIZE    (0xcc)
void pemi_Laser_Monitors_Samples_dump(const struct pemi_Laser_Monitors_Samples *ptr_struct, FILE *file);
/* pemi_Module_Status_Properties */
void pemi_Module_Status_Properties_pack(const struct pemi_Module_Status_Properties *ptr_struct, u_int8_t *ptr_buff);
void pemi_Module_Status_Properties_unpack(struct pemi_Module_Status_Properties *ptr_struct, const u_int8_t *ptr_buff);
void pemi_Module_Status_Properties_print(const struct pemi_Module_Status_Properties *ptr_struct, FILE *file, int indent_level);
int pemi_Module_Status_Properties_size(void);
#define PEMI_MODULE_STATUS_PROPERTIES_SIZE    (0xcc)
void pemi_Module_Status_Properties_dump(const struct pemi_Module_Status_Properties *ptr_struct, FILE *file);
/* pemi_Module_Status_Samples */
void pemi_Module_Status_Samples_pack(const struct pemi_Module_Status_Samples *ptr_struct, u_int8_t *ptr_buff);
void pemi_Module_Status_Samples_unpack(struct pemi_Module_Status_Samples *ptr_struct, const u_int8_t *ptr_buff);
void pemi_Module_Status_Samples_print(const struct pemi_Module_Status_Samples *ptr_struct, FILE *file, int indent_level);
int pemi_Module_Status_Samples_size(void);
#define PEMI_MODULE_STATUS_SAMPLES_SIZE    (0xcc)
void pemi_Module_Status_Samples_dump(const struct pemi_Module_Status_Samples *ptr_struct, FILE *file);
/* pemi_PAM4_Level_Transition_Properties */
void pemi_PAM4_Level_Transition_Properties_pack(const struct pemi_PAM4_Level_Transition_Properties *ptr_struct, u_int8_t *ptr_buff);
void pemi_PAM4_Level_Transition_Properties_unpack(struct pemi_PAM4_Level_Transition_Properties *ptr_struct, const u_int8_t *ptr_buff);
void pemi_PAM4_Level_Transition_Properties_print(const struct pemi_PAM4_Level_Transition_Properties *ptr_struct, FILE *file, int indent_level);
int pemi_PAM4_Level_Transition_Properties_size(void);
#define PEMI_PAM4_LEVEL_TRANSITION_PROPERTIES_SIZE    (0xcc)
void pemi_PAM4_Level_Transition_Properties_dump(const struct pemi_PAM4_Level_Transition_Properties *ptr_struct, FILE *file);
/* pemi_PAM4_Level_Transition_Samples */
void pemi_PAM4_Level_Transition_Samples_pack(const struct pemi_PAM4_Level_Transition_Samples *ptr_struct, u_int8_t *ptr_buff);
void pemi_PAM4_Level_Transition_Samples_unpack(struct pemi_PAM4_Level_Transition_Samples *ptr_struct, const u_int8_t *ptr_buff);
void pemi_PAM4_Level_Transition_Samples_print(const struct pemi_PAM4_Level_Transition_Samples *ptr_struct, FILE *file, int indent_level);
int pemi_PAM4_Level_Transition_Samples_size(void);
#define PEMI_PAM4_LEVEL_TRANSITION_SAMPLES_SIZE    (0xcc)
void pemi_PAM4_Level_Transition_Samples_dump(const struct pemi_PAM4_Level_Transition_Samples *ptr_struct, FILE *file);
/* pemi_Pre_FEC_BER_Properties */
void pemi_Pre_FEC_BER_Properties_pack(const struct pemi_Pre_FEC_BER_Properties *ptr_struct, u_int8_t *ptr_buff);
void pemi_Pre_FEC_BER_Properties_unpack(struct pemi_Pre_FEC_BER_Properties *ptr_struct, const u_int8_t *ptr_buff);
void pemi_Pre_FEC_BER_Properties_print(const struct pemi_Pre_FEC_BER_Properties *ptr_struct, FILE *file, int indent_level);
int pemi_Pre_FEC_BER_Properties_size(void);
#define PEMI_PRE_FEC_BER_PROPERTIES_SIZE    (0xcc)
void pemi_Pre_FEC_BER_Properties_dump(const struct pemi_Pre_FEC_BER_Properties *ptr_struct, FILE *file);
/* pemi_Pre_FEC_BER_Samples */
void pemi_Pre_FEC_BER_Samples_pack(const struct pemi_Pre_FEC_BER_Samples *ptr_struct, u_int8_t *ptr_buff);
void pemi_Pre_FEC_BER_Samples_unpack(struct pemi_Pre_FEC_BER_Samples *ptr_struct, const u_int8_t *ptr_buff);
void pemi_Pre_FEC_BER_Samples_print(const struct pemi_Pre_FEC_BER_Samples *ptr_struct, FILE *file, int indent_level);
int pemi_Pre_FEC_BER_Samples_size(void);
#define PEMI_PRE_FEC_BER_SAMPLES_SIZE    (0xcc)
void pemi_Pre_FEC_BER_Samples_dump(const struct pemi_Pre_FEC_BER_Samples *ptr_struct, FILE *file);
/* pemi_RAW_page_data */
void pemi_RAW_page_data_pack(const struct pemi_RAW_page_data *ptr_struct, u_int8_t *ptr_buff);
void pemi_RAW_page_data_unpack(struct pemi_RAW_page_data *ptr_struct, const u_int8_t *ptr_buff);
void pemi_RAW_page_data_print(const struct pemi_RAW_page_data *ptr_struct, FILE *file, int indent_level);
int pemi_RAW_page_data_size(void);
#define PEMI_RAW_PAGE_DATA_SIZE    (0xcc)
void pemi_RAW_page_data_dump(const struct pemi_RAW_page_data *ptr_struct, FILE *file);
/* pemi_SNR_Properties */
void pemi_SNR_Properties_pack(const struct pemi_SNR_Properties *ptr_struct, u_int8_t *ptr_buff);
void pemi_SNR_Properties_unpack(struct pemi_SNR_Properties *ptr_struct, const u_int8_t *ptr_buff);
void pemi_SNR_Properties_print(const struct pemi_SNR_Properties *ptr_struct, FILE *file, int indent_level);
int pemi_SNR_Properties_size(void);
#define PEMI_SNR_PROPERTIES_SIZE    (0xcc)
void pemi_SNR_Properties_dump(const struct pemi_SNR_Properties *ptr_struct, FILE *file);
/* pemi_SNR_Samples */
void pemi_SNR_Samples_pack(const struct pemi_SNR_Samples *ptr_struct, u_int8_t *ptr_buff);
void pemi_SNR_Samples_unpack(struct pemi_SNR_Samples *ptr_struct, const u_int8_t *ptr_buff);
void pemi_SNR_Samples_print(const struct pemi_SNR_Samples *ptr_struct, FILE *file, int indent_level);
int pemi_SNR_Samples_size(void);
#define PEMI_SNR_SAMPLES_SIZE    (0xcc)
void pemi_SNR_Samples_dump(const struct pemi_SNR_Samples *ptr_struct, FILE *file);
/* ppcnt_RAW_page_data */
void ppcnt_RAW_page_data_pack(const struct ppcnt_RAW_page_data *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_RAW_page_data_unpack(struct ppcnt_RAW_page_data *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_RAW_page_data_print(const struct ppcnt_RAW_page_data *ptr_struct, FILE *file, int indent_level);
int ppcnt_RAW_page_data_size(void);
#define PPCNT_RAW_PAGE_DATA_SIZE    (0xd4)
void ppcnt_RAW_page_data_dump(const struct ppcnt_RAW_page_data *ptr_struct, FILE *file);
/* ppcnt_ib_long_portcntrs_attribute_grp_data */
void ppcnt_ib_long_portcntrs_attribute_grp_data_pack(const struct ppcnt_ib_long_portcntrs_attribute_grp_data *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_ib_long_portcntrs_attribute_grp_data_unpack(struct ppcnt_ib_long_portcntrs_attribute_grp_data *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_ib_long_portcntrs_attribute_grp_data_print(const struct ppcnt_ib_long_portcntrs_attribute_grp_data *ptr_struct, FILE *file, int indent_level);
int ppcnt_ib_long_portcntrs_attribute_grp_data_size(void);
#define PPCNT_IB_LONG_PORTCNTRS_ATTRIBUTE_GRP_DATA_SIZE    (0xb0)
void ppcnt_ib_long_portcntrs_attribute_grp_data_dump(const struct ppcnt_ib_long_portcntrs_attribute_grp_data *ptr_struct, FILE *file);
/* ppcnt_ib_portcntrs_attribute_grp_data */
void ppcnt_ib_portcntrs_attribute_grp_data_pack(const struct ppcnt_ib_portcntrs_attribute_grp_data *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_ib_portcntrs_attribute_grp_data_unpack(struct ppcnt_ib_portcntrs_attribute_grp_data *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_ib_portcntrs_attribute_grp_data_print(const struct ppcnt_ib_portcntrs_attribute_grp_data *ptr_struct, FILE *file, int indent_level);
int ppcnt_ib_portcntrs_attribute_grp_data_size(void);
#define PPCNT_IB_PORTCNTRS_ATTRIBUTE_GRP_DATA_SIZE    (0x28)
void ppcnt_ib_portcntrs_attribute_grp_data_dump(const struct ppcnt_ib_portcntrs_attribute_grp_data *ptr_struct, FILE *file);
/* ppcnt_infiniband_general_counter */
void ppcnt_infiniband_general_counter_pack(const struct ppcnt_infiniband_general_counter *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_infiniband_general_counter_unpack(struct ppcnt_infiniband_general_counter *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_infiniband_general_counter_print(const struct ppcnt_infiniband_general_counter *ptr_struct, FILE *file, int indent_level);
int ppcnt_infiniband_general_counter_size(void);
#define PPCNT_INFINIBAND_GENERAL_COUNTER_SIZE    (0x50)
void ppcnt_infiniband_general_counter_dump(const struct ppcnt_infiniband_general_counter *ptr_struct, FILE *file);
/* ppcnt_infiniband_packet_histograms */
void ppcnt_infiniband_packet_histograms_pack(const struct ppcnt_infiniband_packet_histograms *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_infiniband_packet_histograms_unpack(struct ppcnt_infiniband_packet_histograms *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_infiniband_packet_histograms_print(const struct ppcnt_infiniband_packet_histograms *ptr_struct, FILE *file, int indent_level);
int ppcnt_infiniband_packet_histograms_size(void);
#define PPCNT_INFINIBAND_PACKET_HISTOGRAMS_SIZE    (0x90)
void ppcnt_infiniband_packet_histograms_dump(const struct ppcnt_infiniband_packet_histograms *ptr_struct, FILE *file);
/* ppcnt_infiniband_packets_counter */
void ppcnt_infiniband_packets_counter_pack(const struct ppcnt_infiniband_packets_counter *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_infiniband_packets_counter_unpack(struct ppcnt_infiniband_packets_counter *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_infiniband_packets_counter_print(const struct ppcnt_infiniband_packets_counter *ptr_struct, FILE *file, int indent_level);
int ppcnt_infiniband_packets_counter_size(void);
#define PPCNT_INFINIBAND_PACKETS_COUNTER_SIZE    (0x60)
void ppcnt_infiniband_packets_counter_dump(const struct ppcnt_infiniband_packets_counter *ptr_struct, FILE *file);
/* ppcnt_infiniband_vl_counter */
void ppcnt_infiniband_vl_counter_pack(const struct ppcnt_infiniband_vl_counter *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_infiniband_vl_counter_unpack(struct ppcnt_infiniband_vl_counter *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_infiniband_vl_counter_print(const struct ppcnt_infiniband_vl_counter *ptr_struct, FILE *file, int indent_level);
int ppcnt_infiniband_vl_counter_size(void);
#define PPCNT_INFINIBAND_VL_COUNTER_SIZE    (0x50)
void ppcnt_infiniband_vl_counter_dump(const struct ppcnt_infiniband_vl_counter *ptr_struct, FILE *file);
/* ppcnt_l1_general_counters */
void ppcnt_l1_general_counters_pack(const struct ppcnt_l1_general_counters *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_l1_general_counters_unpack(struct ppcnt_l1_general_counters *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_l1_general_counters_print(const struct ppcnt_l1_general_counters *ptr_struct, FILE *file, int indent_level);
int ppcnt_l1_general_counters_size(void);
#define PPCNT_L1_GENERAL_COUNTERS_SIZE    (0xa8)
void ppcnt_l1_general_counters_dump(const struct ppcnt_l1_general_counters *ptr_struct, FILE *file);
/* ppcnt_packet_type_counter */
void ppcnt_packet_type_counter_pack(const struct ppcnt_packet_type_counter *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_packet_type_counter_unpack(struct ppcnt_packet_type_counter *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_packet_type_counter_print(const struct ppcnt_packet_type_counter *ptr_struct, FILE *file, int indent_level);
int ppcnt_packet_type_counter_size(void);
#define PPCNT_PACKET_TYPE_COUNTER_SIZE    (0x30)
void ppcnt_packet_type_counter_dump(const struct ppcnt_packet_type_counter *ptr_struct, FILE *file);
/* ppcnt_plr_counters */
void ppcnt_plr_counters_pack(const struct ppcnt_plr_counters *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_plr_counters_unpack(struct ppcnt_plr_counters *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_plr_counters_print(const struct ppcnt_plr_counters *ptr_struct, FILE *file, int indent_level);
int ppcnt_plr_counters_size(void);
#define PPCNT_PLR_COUNTERS_SIZE    (0x50)
void ppcnt_plr_counters_dump(const struct ppcnt_plr_counters *ptr_struct, FILE *file);
/* ppcnt_rs_fec_histograms_counters */
void ppcnt_rs_fec_histograms_counters_pack(const struct ppcnt_rs_fec_histograms_counters *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_rs_fec_histograms_counters_unpack(struct ppcnt_rs_fec_histograms_counters *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_rs_fec_histograms_counters_print(const struct ppcnt_rs_fec_histograms_counters *ptr_struct, FILE *file, int indent_level);
int ppcnt_rs_fec_histograms_counters_size(void);
#define PPCNT_RS_FEC_HISTOGRAMS_COUNTERS_SIZE    (0xa8)
void ppcnt_rs_fec_histograms_counters_dump(const struct ppcnt_rs_fec_histograms_counters *ptr_struct, FILE *file);
/* ppcnt_usr_xsr_physical_layer */
void ppcnt_usr_xsr_physical_layer_pack(const struct ppcnt_usr_xsr_physical_layer *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_usr_xsr_physical_layer_unpack(struct ppcnt_usr_xsr_physical_layer *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_usr_xsr_physical_layer_print(const struct ppcnt_usr_xsr_physical_layer *ptr_struct, FILE *file, int indent_level);
int ppcnt_usr_xsr_physical_layer_size(void);
#define PPCNT_USR_XSR_PHYSICAL_LAYER_SIZE    (0x8c)
void ppcnt_usr_xsr_physical_layer_dump(const struct ppcnt_usr_xsr_physical_layer *ptr_struct, FILE *file);
/* ppll_28nm */
void ppll_28nm_pack(const struct ppll_28nm *ptr_struct, u_int8_t *ptr_buff);
void ppll_28nm_unpack(struct ppll_28nm *ptr_struct, const u_int8_t *ptr_buff);
void ppll_28nm_print(const struct ppll_28nm *ptr_struct, FILE *file, int indent_level);
int ppll_28nm_size(void);
#define PPLL_28NM_SIZE    (0x24)
void ppll_28nm_dump(const struct ppll_28nm *ptr_struct, FILE *file);
/* ppll_data_set */
void ppll_data_set_pack(const struct ppll_data_set *ptr_struct, u_int8_t *ptr_buff);
void ppll_data_set_unpack(struct ppll_data_set *ptr_struct, const u_int8_t *ptr_buff);
void ppll_data_set_print(const struct ppll_data_set *ptr_struct, FILE *file, int indent_level);
int ppll_data_set_size(void);
#define PPLL_DATA_SET_SIZE    (0x24)
void ppll_data_set_dump(const struct ppll_data_set *ptr_struct, FILE *file);
/* ppll_reg_16nm */
void ppll_reg_16nm_pack(const struct ppll_reg_16nm *ptr_struct, u_int8_t *ptr_buff);
void ppll_reg_16nm_unpack(struct ppll_reg_16nm *ptr_struct, const u_int8_t *ptr_buff);
void ppll_reg_16nm_print(const struct ppll_reg_16nm *ptr_struct, FILE *file, int indent_level);
int ppll_reg_16nm_size(void);
#define PPLL_REG_16NM_SIZE    (0x24)
void ppll_reg_16nm_dump(const struct ppll_reg_16nm *ptr_struct, FILE *file);
/* ppll_reg_5nm */
void ppll_reg_5nm_pack(const struct ppll_reg_5nm *ptr_struct, u_int8_t *ptr_buff);
void ppll_reg_5nm_unpack(struct ppll_reg_5nm *ptr_struct, const u_int8_t *ptr_buff);
void ppll_reg_5nm_print(const struct ppll_reg_5nm *ptr_struct, FILE *file, int indent_level);
int ppll_reg_5nm_size(void);
#define PPLL_REG_5NM_SIZE    (0x8)
void ppll_reg_5nm_dump(const struct ppll_reg_5nm *ptr_struct, FILE *file);
/* ppll_reg_7nm */
void ppll_reg_7nm_pack(const struct ppll_reg_7nm *ptr_struct, u_int8_t *ptr_buff);
void ppll_reg_7nm_unpack(struct ppll_reg_7nm *ptr_struct, const u_int8_t *ptr_buff);
void ppll_reg_7nm_print(const struct ppll_reg_7nm *ptr_struct, FILE *file, int indent_level);
int ppll_reg_7nm_size(void);
#define PPLL_REG_7NM_SIZE    (0x24)
void ppll_reg_7nm_dump(const struct ppll_reg_7nm *ptr_struct, FILE *file);
/* sllm_16nm */
void sllm_16nm_pack(const struct sllm_16nm *ptr_struct, u_int8_t *ptr_buff);
void sllm_16nm_unpack(struct sllm_16nm *ptr_struct, const u_int8_t *ptr_buff);
void sllm_16nm_print(const struct sllm_16nm *ptr_struct, FILE *file, int indent_level);
int sllm_16nm_size(void);
#define SLLM_16NM_SIZE    (0x2c)
void sllm_16nm_dump(const struct sllm_16nm *ptr_struct, FILE *file);
/* sllm_7nm */
void sllm_7nm_pack(const struct sllm_7nm *ptr_struct, u_int8_t *ptr_buff);
void sllm_7nm_unpack(struct sllm_7nm *ptr_struct, const u_int8_t *ptr_buff);
void sllm_7nm_print(const struct sllm_7nm *ptr_struct, FILE *file, int indent_level);
int sllm_7nm_size(void);
#define SLLM_7NM_SIZE    (0x24)
void sllm_7nm_dump(const struct sllm_7nm *ptr_struct, FILE *file);
/* sllm_data_set */
void sllm_data_set_pack(const struct sllm_data_set *ptr_struct, u_int8_t *ptr_buff);
void sllm_data_set_unpack(struct sllm_data_set *ptr_struct, const u_int8_t *ptr_buff);
void sllm_data_set_print(const struct sllm_data_set *ptr_struct, FILE *file, int indent_level);
int sllm_data_set_size(void);
#define SLLM_DATA_SET_SIZE    (0x2c)
void sllm_data_set_dump(const struct sllm_data_set *ptr_struct, FILE *file);
/* sllm_usr */
void sllm_usr_pack(const struct sllm_usr *ptr_struct, u_int8_t *ptr_buff);
void sllm_usr_unpack(struct sllm_usr *ptr_struct, const u_int8_t *ptr_buff);
void sllm_usr_print(const struct sllm_usr *ptr_struct, FILE *file, int indent_level);
int sllm_usr_size(void);
#define SLLM_USR_SIZE    (0x2c)
void sllm_usr_dump(const struct sllm_usr *ptr_struct, FILE *file);
/* slreg_16nm */
void slreg_16nm_pack(const struct slreg_16nm *ptr_struct, u_int8_t *ptr_buff);
void slreg_16nm_unpack(struct slreg_16nm *ptr_struct, const u_int8_t *ptr_buff);
void slreg_16nm_print(const struct slreg_16nm *ptr_struct, FILE *file, int indent_level);
int slreg_16nm_size(void);
#define SLREG_16NM_SIZE    (0x24)
void slreg_16nm_dump(const struct slreg_16nm *ptr_struct, FILE *file);
/* slreg_7nm */
void slreg_7nm_pack(const struct slreg_7nm *ptr_struct, u_int8_t *ptr_buff);
void slreg_7nm_unpack(struct slreg_7nm *ptr_struct, const u_int8_t *ptr_buff);
void slreg_7nm_print(const struct slreg_7nm *ptr_struct, FILE *file, int indent_level);
int slreg_7nm_size(void);
#define SLREG_7NM_SIZE    (0x24)
void slreg_7nm_dump(const struct slreg_7nm *ptr_struct, FILE *file);
/* slreg_data_set */
void slreg_data_set_pack(const struct slreg_data_set *ptr_struct, u_int8_t *ptr_buff);
void slreg_data_set_unpack(struct slreg_data_set *ptr_struct, const u_int8_t *ptr_buff);
void slreg_data_set_print(const struct slreg_data_set *ptr_struct, FILE *file, int indent_level);
int slreg_data_set_size(void);
#define SLREG_DATA_SET_SIZE    (0x48)
void slreg_data_set_dump(const struct slreg_data_set *ptr_struct, FILE *file);
/* slreg_usr */
void slreg_usr_pack(const struct slreg_usr *ptr_struct, u_int8_t *ptr_buff);
void slreg_usr_unpack(struct slreg_usr *ptr_struct, const u_int8_t *ptr_buff);
void slreg_usr_print(const struct slreg_usr *ptr_struct, FILE *file, int indent_level);
int slreg_usr_size(void);
#define SLREG_USR_SIZE    (0x48)
void slreg_usr_dump(const struct slreg_usr *ptr_struct, FILE *file);
/* slrg_16nm */
void slrg_16nm_pack(const struct slrg_16nm *ptr_struct, u_int8_t *ptr_buff);
void slrg_16nm_unpack(struct slrg_16nm *ptr_struct, const u_int8_t *ptr_buff);
void slrg_16nm_print(const struct slrg_16nm *ptr_struct, FILE *file, int indent_level);
int slrg_16nm_size(void);
#define SLRG_16NM_SIZE    (0x24)
void slrg_16nm_dump(const struct slrg_16nm *ptr_struct, FILE *file);
/* slrg_40nm_28nm */
void slrg_40nm_28nm_pack(const struct slrg_40nm_28nm *ptr_struct, u_int8_t *ptr_buff);
void slrg_40nm_28nm_unpack(struct slrg_40nm_28nm *ptr_struct, const u_int8_t *ptr_buff);
void slrg_40nm_28nm_print(const struct slrg_40nm_28nm *ptr_struct, FILE *file, int indent_level);
int slrg_40nm_28nm_size(void);
#define SLRG_40NM_28NM_SIZE    (0x24)
void slrg_40nm_28nm_dump(const struct slrg_40nm_28nm *ptr_struct, FILE *file);
/* slrg_7nm */
void slrg_7nm_pack(const struct slrg_7nm *ptr_struct, u_int8_t *ptr_buff);
void slrg_7nm_unpack(struct slrg_7nm *ptr_struct, const u_int8_t *ptr_buff);
void slrg_7nm_print(const struct slrg_7nm *ptr_struct, FILE *file, int indent_level);
int slrg_7nm_size(void);
#define SLRG_7NM_SIZE    (0x18)
void slrg_7nm_dump(const struct slrg_7nm *ptr_struct, FILE *file);
/* slrg_7nm_testing */
void slrg_7nm_testing_pack(const struct slrg_7nm_testing *ptr_struct, u_int8_t *ptr_buff);
void slrg_7nm_testing_unpack(struct slrg_7nm_testing *ptr_struct, const u_int8_t *ptr_buff);
void slrg_7nm_testing_print(const struct slrg_7nm_testing *ptr_struct, FILE *file, int indent_level);
int slrg_7nm_testing_size(void);
#define SLRG_7NM_TESTING_SIZE    (0xa4)
void slrg_7nm_testing_dump(const struct slrg_7nm_testing *ptr_struct, FILE *file);
/* slrg_data_set */
void slrg_data_set_pack(const struct slrg_data_set *ptr_struct, u_int8_t *ptr_buff);
void slrg_data_set_unpack(struct slrg_data_set *ptr_struct, const u_int8_t *ptr_buff);
void slrg_data_set_print(const struct slrg_data_set *ptr_struct, FILE *file, int indent_level);
int slrg_data_set_size(void);
#define SLRG_DATA_SET_SIZE    (0xa4)
void slrg_data_set_dump(const struct slrg_data_set *ptr_struct, FILE *file);
/* slrip_16nm */
void slrip_16nm_pack(const struct slrip_16nm *ptr_struct, u_int8_t *ptr_buff);
void slrip_16nm_unpack(struct slrip_16nm *ptr_struct, const u_int8_t *ptr_buff);
void slrip_16nm_print(const struct slrip_16nm *ptr_struct, FILE *file, int indent_level);
int slrip_16nm_size(void);
#define SLRIP_16NM_SIZE    (0x28)
void slrip_16nm_dump(const struct slrip_16nm *ptr_struct, FILE *file);
/* slrip_5nm */
void slrip_5nm_pack(const struct slrip_5nm *ptr_struct, u_int8_t *ptr_buff);
void slrip_5nm_unpack(struct slrip_5nm *ptr_struct, const u_int8_t *ptr_buff);
void slrip_5nm_print(const struct slrip_5nm *ptr_struct, FILE *file, int indent_level);
int slrip_5nm_size(void);
#define SLRIP_5NM_SIZE    (0x58)
void slrip_5nm_dump(const struct slrip_5nm *ptr_struct, FILE *file);
/* slrip_7nm */
void slrip_7nm_pack(const struct slrip_7nm *ptr_struct, u_int8_t *ptr_buff);
void slrip_7nm_unpack(struct slrip_7nm *ptr_struct, const u_int8_t *ptr_buff);
void slrip_7nm_print(const struct slrip_7nm *ptr_struct, FILE *file, int indent_level);
int slrip_7nm_size(void);
#define SLRIP_7NM_SIZE    (0x58)
void slrip_7nm_dump(const struct slrip_7nm *ptr_struct, FILE *file);
/* slrip_data_set */
void slrip_data_set_pack(const struct slrip_data_set *ptr_struct, u_int8_t *ptr_buff);
void slrip_data_set_unpack(struct slrip_data_set *ptr_struct, const u_int8_t *ptr_buff);
void slrip_data_set_print(const struct slrip_data_set *ptr_struct, FILE *file, int indent_level);
int slrip_data_set_size(void);
#define SLRIP_DATA_SET_SIZE    (0x58)
void slrip_data_set_dump(const struct slrip_data_set *ptr_struct, FILE *file);
/* slrp_16nm */
void slrp_16nm_pack(const struct slrp_16nm *ptr_struct, u_int8_t *ptr_buff);
void slrp_16nm_unpack(struct slrp_16nm *ptr_struct, const u_int8_t *ptr_buff);
void slrp_16nm_print(const struct slrp_16nm *ptr_struct, FILE *file, int indent_level);
int slrp_16nm_size(void);
#define SLRP_16NM_SIZE    (0x1c)
void slrp_16nm_dump(const struct slrp_16nm *ptr_struct, FILE *file);
/* slrp_40nm_28nm */
void slrp_40nm_28nm_pack(const struct slrp_40nm_28nm *ptr_struct, u_int8_t *ptr_buff);
void slrp_40nm_28nm_unpack(struct slrp_40nm_28nm *ptr_struct, const u_int8_t *ptr_buff);
void slrp_40nm_28nm_print(const struct slrp_40nm_28nm *ptr_struct, FILE *file, int indent_level);
int slrp_40nm_28nm_size(void);
#define SLRP_40NM_28NM_SIZE    (0x24)
void slrp_40nm_28nm_dump(const struct slrp_40nm_28nm *ptr_struct, FILE *file);
/* slrp_5nm */
void slrp_5nm_pack(const struct slrp_5nm *ptr_struct, u_int8_t *ptr_buff);
void slrp_5nm_unpack(struct slrp_5nm *ptr_struct, const u_int8_t *ptr_buff);
void slrp_5nm_print(const struct slrp_5nm *ptr_struct, FILE *file, int indent_level);
int slrp_5nm_size(void);
#define SLRP_5NM_SIZE    (0x94)
void slrp_5nm_dump(const struct slrp_5nm *ptr_struct, FILE *file);
/* slrp_7nm */
void slrp_7nm_pack(const struct slrp_7nm *ptr_struct, u_int8_t *ptr_buff);
void slrp_7nm_unpack(struct slrp_7nm *ptr_struct, const u_int8_t *ptr_buff);
void slrp_7nm_print(const struct slrp_7nm *ptr_struct, FILE *file, int indent_level);
int slrp_7nm_size(void);
#define SLRP_7NM_SIZE    (0x34)
void slrp_7nm_dump(const struct slrp_7nm *ptr_struct, FILE *file);
/* slrp_data_set */
void slrp_data_set_pack(const struct slrp_data_set *ptr_struct, u_int8_t *ptr_buff);
void slrp_data_set_unpack(struct slrp_data_set *ptr_struct, const u_int8_t *ptr_buff);
void slrp_data_set_print(const struct slrp_data_set *ptr_struct, FILE *file, int indent_level);
int slrp_data_set_size(void);
#define SLRP_DATA_SET_SIZE    (0x94)
void slrp_data_set_dump(const struct slrp_data_set *ptr_struct, FILE *file);
/* slrp_gearbox */
void slrp_gearbox_pack(const struct slrp_gearbox *ptr_struct, u_int8_t *ptr_buff);
void slrp_gearbox_unpack(struct slrp_gearbox *ptr_struct, const u_int8_t *ptr_buff);
void slrp_gearbox_print(const struct slrp_gearbox *ptr_struct, FILE *file, int indent_level);
int slrp_gearbox_size(void);
#define SLRP_GEARBOX_SIZE    (0x20)
void slrp_gearbox_dump(const struct slrp_gearbox *ptr_struct, FILE *file);
/* slrp_usr */
void slrp_usr_pack(const struct slrp_usr *ptr_struct, u_int8_t *ptr_buff);
void slrp_usr_unpack(struct slrp_usr *ptr_struct, const u_int8_t *ptr_buff);
void slrp_usr_print(const struct slrp_usr *ptr_struct, FILE *file, int indent_level);
int slrp_usr_size(void);
#define SLRP_USR_SIZE    (0x20)
void slrp_usr_dump(const struct slrp_usr *ptr_struct, FILE *file);
/* sltp_16nm */
void sltp_16nm_pack(const struct sltp_16nm *ptr_struct, u_int8_t *ptr_buff);
void sltp_16nm_unpack(struct sltp_16nm *ptr_struct, const u_int8_t *ptr_buff);
void sltp_16nm_print(const struct sltp_16nm *ptr_struct, FILE *file, int indent_level);
int sltp_16nm_size(void);
#define SLTP_16NM_SIZE    (0x18)
void sltp_16nm_dump(const struct sltp_16nm *ptr_struct, FILE *file);
/* sltp_28nm_40nm */
void sltp_28nm_40nm_pack(const struct sltp_28nm_40nm *ptr_struct, u_int8_t *ptr_buff);
void sltp_28nm_40nm_unpack(struct sltp_28nm_40nm *ptr_struct, const u_int8_t *ptr_buff);
void sltp_28nm_40nm_print(const struct sltp_28nm_40nm *ptr_struct, FILE *file, int indent_level);
int sltp_28nm_40nm_size(void);
#define SLTP_28NM_40NM_SIZE    (0x10)
void sltp_28nm_40nm_dump(const struct sltp_28nm_40nm *ptr_struct, FILE *file);
/* sltp_5nm */
void sltp_5nm_pack(const struct sltp_5nm *ptr_struct, u_int8_t *ptr_buff);
void sltp_5nm_unpack(struct sltp_5nm *ptr_struct, const u_int8_t *ptr_buff);
void sltp_5nm_print(const struct sltp_5nm *ptr_struct, FILE *file, int indent_level);
int sltp_5nm_size(void);
#define SLTP_5NM_SIZE    (0x48)
void sltp_5nm_dump(const struct sltp_5nm *ptr_struct, FILE *file);
/* sltp_7nm */
void sltp_7nm_pack(const struct sltp_7nm *ptr_struct, u_int8_t *ptr_buff);
void sltp_7nm_unpack(struct sltp_7nm *ptr_struct, const u_int8_t *ptr_buff);
void sltp_7nm_print(const struct sltp_7nm *ptr_struct, FILE *file, int indent_level);
int sltp_7nm_size(void);
#define SLTP_7NM_SIZE    (0x18)
void sltp_7nm_dump(const struct sltp_7nm *ptr_struct, FILE *file);
/* sltp_data_set */
void sltp_data_set_pack(const struct sltp_data_set *ptr_struct, u_int8_t *ptr_buff);
void sltp_data_set_unpack(struct sltp_data_set *ptr_struct, const u_int8_t *ptr_buff);
void sltp_data_set_print(const struct sltp_data_set *ptr_struct, FILE *file, int indent_level);
int sltp_data_set_size(void);
#define SLTP_DATA_SET_SIZE    (0x48)
void sltp_data_set_dump(const struct sltp_data_set *ptr_struct, FILE *file);
/* sltp_gearbox */
void sltp_gearbox_pack(const struct sltp_gearbox *ptr_struct, u_int8_t *ptr_buff);
void sltp_gearbox_unpack(struct sltp_gearbox *ptr_struct, const u_int8_t *ptr_buff);
void sltp_gearbox_print(const struct sltp_gearbox *ptr_struct, FILE *file, int indent_level);
int sltp_gearbox_size(void);
#define SLTP_GEARBOX_SIZE    (0x18)
void sltp_gearbox_dump(const struct sltp_gearbox *ptr_struct, FILE *file);
/* sltp_lut_7nm */
void sltp_lut_7nm_pack(const struct sltp_lut_7nm *ptr_struct, u_int8_t *ptr_buff);
void sltp_lut_7nm_unpack(struct sltp_lut_7nm *ptr_struct, const u_int8_t *ptr_buff);
void sltp_lut_7nm_print(const struct sltp_lut_7nm *ptr_struct, FILE *file, int indent_level);
int sltp_lut_7nm_size(void);
#define SLTP_LUT_7NM_SIZE    (0x48)
void sltp_lut_7nm_dump(const struct sltp_lut_7nm *ptr_struct, FILE *file);
/* ctle_calib_set */
void ctle_calib_set_pack(const struct ctle_calib_set *ptr_struct, u_int8_t *ptr_buff);
void ctle_calib_set_unpack(struct ctle_calib_set *ptr_struct, const u_int8_t *ptr_buff);
void ctle_calib_set_print(const struct ctle_calib_set *ptr_struct, FILE *file, int indent_level);
int ctle_calib_set_size(void);
#define CTLE_CALIB_SET_SIZE    (0x4)
void ctle_calib_set_dump(const struct ctle_calib_set *ptr_struct, FILE *file);
/* int64bit */
void int64bit_pack(const struct int64bit *ptr_struct, u_int8_t *ptr_buff);
void int64bit_unpack(struct int64bit *ptr_struct, const u_int8_t *ptr_buff);
void int64bit_print(const struct int64bit *ptr_struct, FILE *file, int indent_level);
int int64bit_size(void);
#define INT64BIT_SIZE    (0x8)
void int64bit_dump(const struct int64bit *ptr_struct, FILE *file);
/* mpcnt_reg_counter_set_auto */
void mpcnt_reg_counter_set_auto_pack(const union mpcnt_reg_counter_set_auto *ptr_struct, u_int8_t *ptr_buff);
void mpcnt_reg_counter_set_auto_unpack(union mpcnt_reg_counter_set_auto *ptr_struct, const u_int8_t *ptr_buff);
void mpcnt_reg_counter_set_auto_print(const union mpcnt_reg_counter_set_auto *ptr_struct, FILE *file, int indent_level);
int mpcnt_reg_counter_set_auto_size(void);
#define MPCNT_REG_COUNTER_SET_AUTO_SIZE    (0x60)
void mpcnt_reg_counter_set_auto_dump(const union mpcnt_reg_counter_set_auto *ptr_struct, FILE *file);
/* pemi_page_data_auto */
void pemi_page_data_auto_pack(const union pemi_page_data_auto *ptr_struct, u_int8_t *ptr_buff);
void pemi_page_data_auto_unpack(union pemi_page_data_auto *ptr_struct, const u_int8_t *ptr_buff);
void pemi_page_data_auto_print(const union pemi_page_data_auto *ptr_struct, FILE *file, int indent_level);
int pemi_page_data_auto_size(void);
#define PEMI_PAGE_DATA_AUTO_SIZE    (0xcc)
void pemi_page_data_auto_dump(const union pemi_page_data_auto *ptr_struct, FILE *file);
/* peucg_page_data */
void peucg_page_data_pack(const struct peucg_page_data *ptr_struct, u_int8_t *ptr_buff);
void peucg_page_data_unpack(struct peucg_page_data *ptr_struct, const u_int8_t *ptr_buff);
void peucg_page_data_print(const struct peucg_page_data *ptr_struct, FILE *file, int indent_level);
int peucg_page_data_size(void);
#define PEUCG_PAGE_DATA_SIZE    (0x4)
void peucg_page_data_dump(const struct peucg_page_data *ptr_struct, FILE *file);
/* ppbmp_monitor_parameters */
void ppbmp_monitor_parameters_pack(const struct ppbmp_monitor_parameters *ptr_struct, u_int8_t *ptr_buff);
void ppbmp_monitor_parameters_unpack(struct ppbmp_monitor_parameters *ptr_struct, const u_int8_t *ptr_buff);
void ppbmp_monitor_parameters_print(const struct ppbmp_monitor_parameters *ptr_struct, FILE *file, int indent_level);
int ppbmp_monitor_parameters_size(void);
#define PPBMP_MONITOR_PARAMETERS_SIZE    (0x8)
void ppbmp_monitor_parameters_dump(const struct ppbmp_monitor_parameters *ptr_struct, FILE *file);
/* ppcnt_reg_counter_set_auto */
void ppcnt_reg_counter_set_auto_pack(const union ppcnt_reg_counter_set_auto *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_reg_counter_set_auto_unpack(union ppcnt_reg_counter_set_auto *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_reg_counter_set_auto_print(const union ppcnt_reg_counter_set_auto *ptr_struct, FILE *file, int indent_level);
int ppcnt_reg_counter_set_auto_size(void);
#define PPCNT_REG_COUNTER_SET_AUTO_SIZE    (0xd4)
void ppcnt_reg_counter_set_auto_dump(const union ppcnt_reg_counter_set_auto *ptr_struct, FILE *file);
/* pphcr_bin_range */
void pphcr_bin_range_pack(const struct pphcr_bin_range *ptr_struct, u_int8_t *ptr_buff);
void pphcr_bin_range_unpack(struct pphcr_bin_range *ptr_struct, const u_int8_t *ptr_buff);
void pphcr_bin_range_print(const struct pphcr_bin_range *ptr_struct, FILE *file, int indent_level);
int pphcr_bin_range_size(void);
#define PPHCR_BIN_RANGE_SIZE    (0x4)
void pphcr_bin_range_dump(const struct pphcr_bin_range *ptr_struct, FILE *file);
/* ppll_reg_page_data_auto */
void ppll_reg_page_data_auto_pack(const union ppll_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff);
void ppll_reg_page_data_auto_unpack(union ppll_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff);
void ppll_reg_page_data_auto_print(const union ppll_reg_page_data_auto *ptr_struct, FILE *file, int indent_level);
int ppll_reg_page_data_auto_size(void);
#define PPLL_REG_PAGE_DATA_AUTO_SIZE    (0x24)
void ppll_reg_page_data_auto_dump(const union ppll_reg_page_data_auto *ptr_struct, FILE *file);
/* psu_status */
void psu_status_pack(const struct psu_status *ptr_struct, u_int8_t *ptr_buff);
void psu_status_unpack(struct psu_status *ptr_struct, const u_int8_t *ptr_buff);
void psu_status_print(const struct psu_status *ptr_struct, FILE *file, int indent_level);
int psu_status_size(void);
#define PSU_STATUS_SIZE    (0x50)
void psu_status_dump(const struct psu_status *ptr_struct, FILE *file);
/* ref_clock_stat_db */
void ref_clock_stat_db_pack(const struct ref_clock_stat_db *ptr_struct, u_int8_t *ptr_buff);
void ref_clock_stat_db_unpack(struct ref_clock_stat_db *ptr_struct, const u_int8_t *ptr_buff);
void ref_clock_stat_db_print(const struct ref_clock_stat_db *ptr_struct, FILE *file, int indent_level);
int ref_clock_stat_db_size(void);
#define REF_CLOCK_STAT_DB_SIZE    (0xc)
void ref_clock_stat_db_dump(const struct ref_clock_stat_db *ptr_struct, FILE *file);
/* sllm_reg_page_data_auto */
void sllm_reg_page_data_auto_pack(const union sllm_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff);
void sllm_reg_page_data_auto_unpack(union sllm_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff);
void sllm_reg_page_data_auto_print(const union sllm_reg_page_data_auto *ptr_struct, FILE *file, int indent_level);
int sllm_reg_page_data_auto_size(void);
#define SLLM_REG_PAGE_DATA_AUTO_SIZE    (0x2c)
void sllm_reg_page_data_auto_dump(const union sllm_reg_page_data_auto *ptr_struct, FILE *file);
/* slreg_reg_page_data_auto */
void slreg_reg_page_data_auto_pack(const union slreg_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff);
void slreg_reg_page_data_auto_unpack(union slreg_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff);
void slreg_reg_page_data_auto_print(const union slreg_reg_page_data_auto *ptr_struct, FILE *file, int indent_level);
int slreg_reg_page_data_auto_size(void);
#define SLREG_REG_PAGE_DATA_AUTO_SIZE    (0x48)
void slreg_reg_page_data_auto_dump(const union slreg_reg_page_data_auto *ptr_struct, FILE *file);
/* slrg_reg_page_data_auto */
void slrg_reg_page_data_auto_pack(const union slrg_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff);
void slrg_reg_page_data_auto_unpack(union slrg_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff);
void slrg_reg_page_data_auto_print(const union slrg_reg_page_data_auto *ptr_struct, FILE *file, int indent_level);
int slrg_reg_page_data_auto_size(void);
#define SLRG_REG_PAGE_DATA_AUTO_SIZE    (0xa4)
void slrg_reg_page_data_auto_dump(const union slrg_reg_page_data_auto *ptr_struct, FILE *file);
/* slrip_reg_page_data_auto */
void slrip_reg_page_data_auto_pack(const union slrip_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff);
void slrip_reg_page_data_auto_unpack(union slrip_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff);
void slrip_reg_page_data_auto_print(const union slrip_reg_page_data_auto *ptr_struct, FILE *file, int indent_level);
int slrip_reg_page_data_auto_size(void);
#define SLRIP_REG_PAGE_DATA_AUTO_SIZE    (0x58)
void slrip_reg_page_data_auto_dump(const union slrip_reg_page_data_auto *ptr_struct, FILE *file);
/* slrp_reg_page_data_auto */
void slrp_reg_page_data_auto_pack(const union slrp_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff);
void slrp_reg_page_data_auto_unpack(union slrp_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff);
void slrp_reg_page_data_auto_print(const union slrp_reg_page_data_auto *ptr_struct, FILE *file, int indent_level);
int slrp_reg_page_data_auto_size(void);
#define SLRP_REG_PAGE_DATA_AUTO_SIZE    (0x94)
void slrp_reg_page_data_auto_dump(const union slrp_reg_page_data_auto *ptr_struct, FILE *file);
/* sltp_reg_page_data_auto */
void sltp_reg_page_data_auto_pack(const union sltp_reg_page_data_auto *ptr_struct, u_int8_t *ptr_buff);
void sltp_reg_page_data_auto_unpack(union sltp_reg_page_data_auto *ptr_struct, const u_int8_t *ptr_buff);
void sltp_reg_page_data_auto_print(const union sltp_reg_page_data_auto *ptr_struct, FILE *file, int indent_level);
int sltp_reg_page_data_auto_size(void);
#define SLTP_REG_PAGE_DATA_AUTO_SIZE    (0x48)
void sltp_reg_page_data_auto_dump(const union sltp_reg_page_data_auto *ptr_struct, FILE *file);
/* CableInfo_Payload_Addr_0_47 */
void CableInfo_Payload_Addr_0_47_pack(const struct CableInfo_Payload_Addr_0_47 *ptr_struct, u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_0_47_unpack(struct CableInfo_Payload_Addr_0_47 *ptr_struct, const u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_0_47_print(const struct CableInfo_Payload_Addr_0_47 *ptr_struct, FILE *file, int indent_level);
int CableInfo_Payload_Addr_0_47_size(void);
#define CABLEINFO_PAYLOAD_ADDR_0_47_SIZE    (0x30)
void CableInfo_Payload_Addr_0_47_dump(const struct CableInfo_Payload_Addr_0_47 *ptr_struct, FILE *file);
/* CableInfo_Payload_Addr_128_167 */
void CableInfo_Payload_Addr_128_167_pack(const struct CableInfo_Payload_Addr_128_167 *ptr_struct, u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_128_167_unpack(struct CableInfo_Payload_Addr_128_167 *ptr_struct, const u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_128_167_print(const struct CableInfo_Payload_Addr_128_167 *ptr_struct, FILE *file, int indent_level);
int CableInfo_Payload_Addr_128_167_size(void);
#define CABLEINFO_PAYLOAD_ADDR_128_167_SIZE    (0x30)
void CableInfo_Payload_Addr_128_167_dump(const struct CableInfo_Payload_Addr_128_167 *ptr_struct, FILE *file);
/* CableInfo_Payload_Addr_168_211 */
void CableInfo_Payload_Addr_168_211_pack(const struct CableInfo_Payload_Addr_168_211 *ptr_struct, u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_168_211_unpack(struct CableInfo_Payload_Addr_168_211 *ptr_struct, const u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_168_211_print(const struct CableInfo_Payload_Addr_168_211 *ptr_struct, FILE *file, int indent_level);
int CableInfo_Payload_Addr_168_211_size(void);
#define CABLEINFO_PAYLOAD_ADDR_168_211_SIZE    (0x30)
void CableInfo_Payload_Addr_168_211_dump(const struct CableInfo_Payload_Addr_168_211 *ptr_struct, FILE *file);
/* CableInfo_Payload_Addr_212_255 */
void CableInfo_Payload_Addr_212_255_pack(const struct CableInfo_Payload_Addr_212_255 *ptr_struct, u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_212_255_unpack(struct CableInfo_Payload_Addr_212_255 *ptr_struct, const u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_212_255_print(const struct CableInfo_Payload_Addr_212_255 *ptr_struct, FILE *file, int indent_level);
int CableInfo_Payload_Addr_212_255_size(void);
#define CABLEINFO_PAYLOAD_ADDR_212_255_SIZE    (0x30)
void CableInfo_Payload_Addr_212_255_dump(const struct CableInfo_Payload_Addr_212_255 *ptr_struct, FILE *file);
/* CableInfo_Payload_Addr_48_79 */
void CableInfo_Payload_Addr_48_79_pack(const struct CableInfo_Payload_Addr_48_79 *ptr_struct, u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_48_79_unpack(struct CableInfo_Payload_Addr_48_79 *ptr_struct, const u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_48_79_print(const struct CableInfo_Payload_Addr_48_79 *ptr_struct, FILE *file, int indent_level);
int CableInfo_Payload_Addr_48_79_size(void);
#define CABLEINFO_PAYLOAD_ADDR_48_79_SIZE    (0x20)
void CableInfo_Payload_Addr_48_79_dump(const struct CableInfo_Payload_Addr_48_79 *ptr_struct, FILE *file);
/* CableInfo_Payload_Addr_80_127 */
void CableInfo_Payload_Addr_80_127_pack(const struct CableInfo_Payload_Addr_80_127 *ptr_struct, u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_80_127_unpack(struct CableInfo_Payload_Addr_80_127 *ptr_struct, const u_int8_t *ptr_buff);
void CableInfo_Payload_Addr_80_127_print(const struct CableInfo_Payload_Addr_80_127 *ptr_struct, FILE *file, int indent_level);
int CableInfo_Payload_Addr_80_127_size(void);
#define CABLEINFO_PAYLOAD_ADDR_80_127_SIZE    (0x30)
void CableInfo_Payload_Addr_80_127_dump(const struct CableInfo_Payload_Addr_80_127 *ptr_struct, FILE *file);
/* CableInfo_Payload_Page_3_Addr_128_175 */
void CableInfo_Payload_Page_3_Addr_128_175_pack(const struct CableInfo_Payload_Page_3_Addr_128_175 *ptr_struct, u_int8_t *ptr_buff);
void CableInfo_Payload_Page_3_Addr_128_175_unpack(struct CableInfo_Payload_Page_3_Addr_128_175 *ptr_struct, const u_int8_t *ptr_buff);
void CableInfo_Payload_Page_3_Addr_128_175_print(const struct CableInfo_Payload_Page_3_Addr_128_175 *ptr_struct, FILE *file, int indent_level);
int CableInfo_Payload_Page_3_Addr_128_175_size(void);
#define CABLEINFO_PAYLOAD_PAGE_3_ADDR_128_175_SIZE    (0x30)
void CableInfo_Payload_Page_3_Addr_128_175_dump(const struct CableInfo_Payload_Page_3_Addr_128_175 *ptr_struct, FILE *file);
/* CableInfo_Payload_Page_3_Addr_212_255 */
void CableInfo_Payload_Page_3_Addr_212_255_pack(const struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, u_int8_t *ptr_buff);
void CableInfo_Payload_Page_3_Addr_212_255_unpack(struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, const u_int8_t *ptr_buff);
void CableInfo_Payload_Page_3_Addr_212_255_print(const struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, FILE *file, int indent_level);
int CableInfo_Payload_Page_3_Addr_212_255_size(void);
#define CABLEINFO_PAYLOAD_PAGE_3_ADDR_212_255_SIZE    (0x30)
void CableInfo_Payload_Page_3_Addr_212_255_dump(const struct CableInfo_Payload_Page_3_Addr_212_255 *ptr_struct, FILE *file);
/* CableInfo_Payload_Page_E9_Addr_128_175 */
void CableInfo_Payload_Page_E9_Addr_128_175_pack(const struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, u_int8_t *ptr_buff);
void CableInfo_Payload_Page_E9_Addr_128_175_unpack(struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, const u_int8_t *ptr_buff);
void CableInfo_Payload_Page_E9_Addr_128_175_print(const struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, FILE *file, int indent_level);
int CableInfo_Payload_Page_E9_Addr_128_175_size(void);
#define CABLEINFO_PAYLOAD_PAGE_E9_ADDR_128_175_SIZE    (0x30)
void CableInfo_Payload_Page_E9_Addr_128_175_dump(const struct CableInfo_Payload_Page_E9_Addr_128_175 *ptr_struct, FILE *file);
/* CableInfo_Payload_Page_E9_Addr_176_211 */
void CableInfo_Payload_Page_E9_Addr_176_211_pack(const struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, u_int8_t *ptr_buff);
void CableInfo_Payload_Page_E9_Addr_176_211_unpack(struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, const u_int8_t *ptr_buff);
void CableInfo_Payload_Page_E9_Addr_176_211_print(const struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, FILE *file, int indent_level);
int CableInfo_Payload_Page_E9_Addr_176_211_size(void);
#define CABLEINFO_PAYLOAD_PAGE_E9_ADDR_176_211_SIZE    (0x24)
void CableInfo_Payload_Page_E9_Addr_176_211_dump(const struct CableInfo_Payload_Page_E9_Addr_176_211 *ptr_struct, FILE *file);
/* CableInfo_Payload_Page_F0_Addr_128_171 */
void CableInfo_Payload_Page_F0_Addr_128_171_pack(const struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, u_int8_t *ptr_buff);
void CableInfo_Payload_Page_F0_Addr_128_171_unpack(struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, const u_int8_t *ptr_buff);
void CableInfo_Payload_Page_F0_Addr_128_171_print(const struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, FILE *file, int indent_level);
int CableInfo_Payload_Page_F0_Addr_128_171_size(void);
#define CABLEINFO_PAYLOAD_PAGE_F0_ADDR_128_171_SIZE    (0x2c)
void CableInfo_Payload_Page_F0_Addr_128_171_dump(const struct CableInfo_Payload_Page_F0_Addr_128_171 *ptr_struct, FILE *file);
/* DDLatchedFlagInfo */
void DDLatchedFlagInfo_pack(const struct DDLatchedFlagInfo *ptr_struct, u_int8_t *ptr_buff);
void DDLatchedFlagInfo_unpack(struct DDLatchedFlagInfo *ptr_struct, const u_int8_t *ptr_buff);
void DDLatchedFlagInfo_print(const struct DDLatchedFlagInfo *ptr_struct, FILE *file, int indent_level);
int DDLatchedFlagInfo_size(void);
#define DDLATCHEDFLAGINFO_SIZE    (0xf8)
void DDLatchedFlagInfo_dump(const struct DDLatchedFlagInfo *ptr_struct, FILE *file);
/* DDLinkDownInfo */
void DDLinkDownInfo_pack(const struct DDLinkDownInfo *ptr_struct, u_int8_t *ptr_buff);
void DDLinkDownInfo_unpack(struct DDLinkDownInfo *ptr_struct, const u_int8_t *ptr_buff);
void DDLinkDownInfo_print(const struct DDLinkDownInfo *ptr_struct, FILE *file, int indent_level);
int DDLinkDownInfo_size(void);
#define DDLINKDOWNINFO_SIZE    (0x1c)
void DDLinkDownInfo_dump(const struct DDLinkDownInfo *ptr_struct, FILE *file);
/* DDLinkUpInfo */
void DDLinkUpInfo_pack(const struct DDLinkUpInfo *ptr_struct, u_int8_t *ptr_buff);
void DDLinkUpInfo_unpack(struct DDLinkUpInfo *ptr_struct, const u_int8_t *ptr_buff);
void DDLinkUpInfo_print(const struct DDLinkUpInfo *ptr_struct, FILE *file, int indent_level);
int DDLinkUpInfo_size(void);
#define DDLINKUPINFO_SIZE    (0xf8)
void DDLinkUpInfo_dump(const struct DDLinkUpInfo *ptr_struct, FILE *file);
/* DDModuleInfo */
void DDModuleInfo_pack(const struct DDModuleInfo *ptr_struct, u_int8_t *ptr_buff);
void DDModuleInfo_unpack(struct DDModuleInfo *ptr_struct, const u_int8_t *ptr_buff);
void DDModuleInfo_print(const struct DDModuleInfo *ptr_struct, FILE *file, int indent_level);
int DDModuleInfo_size(void);
#define DDMODULEINFO_SIZE    (0xf8)
void DDModuleInfo_dump(const struct DDModuleInfo *ptr_struct, FILE *file);
/* DDOperationInfo */
void DDOperationInfo_pack(const struct DDOperationInfo *ptr_struct, u_int8_t *ptr_buff);
void DDOperationInfo_unpack(struct DDOperationInfo *ptr_struct, const u_int8_t *ptr_buff);
void DDOperationInfo_print(const struct DDOperationInfo *ptr_struct, FILE *file, int indent_level);
int DDOperationInfo_size(void);
#define DDOPERATIONINFO_SIZE    (0x38)
void DDOperationInfo_dump(const struct DDOperationInfo *ptr_struct, FILE *file);
/* DDPCIPerfCounters */
void DDPCIPerfCounters_pack(const struct DDPCIPerfCounters *ptr_struct, u_int8_t *ptr_buff);
void DDPCIPerfCounters_unpack(struct DDPCIPerfCounters *ptr_struct, const u_int8_t *ptr_buff);
void DDPCIPerfCounters_print(const struct DDPCIPerfCounters *ptr_struct, FILE *file, int indent_level);
int DDPCIPerfCounters_size(void);
#define DDPCIPERFCOUNTERS_SIZE    (0x60)
void DDPCIPerfCounters_dump(const struct DDPCIPerfCounters *ptr_struct, FILE *file);
/* DDPageIdentification */
void DDPageIdentification_pack(const struct DDPageIdentification *ptr_struct, u_int8_t *ptr_buff);
void DDPageIdentification_unpack(struct DDPageIdentification *ptr_struct, const u_int8_t *ptr_buff);
void DDPageIdentification_print(const struct DDPageIdentification *ptr_struct, FILE *file, int indent_level);
int DDPageIdentification_size(void);
#define DDPAGEIDENTIFICATION_SIZE    (0x20)
void DDPageIdentification_dump(const struct DDPageIdentification *ptr_struct, FILE *file);
/* DDPhyInfo */
void DDPhyInfo_pack(const struct DDPhyInfo *ptr_struct, u_int8_t *ptr_buff);
void DDPhyInfo_unpack(struct DDPhyInfo *ptr_struct, const u_int8_t *ptr_buff);
void DDPhyInfo_print(const struct DDPhyInfo *ptr_struct, FILE *file, int indent_level);
int DDPhyInfo_size(void);
#define DDPHYINFO_SIZE    (0x70)
void DDPhyInfo_dump(const struct DDPhyInfo *ptr_struct, FILE *file);
/* DDPhysCounters */
void DDPhysCounters_pack(const struct DDPhysCounters *ptr_struct, u_int8_t *ptr_buff);
void DDPhysCounters_unpack(struct DDPhysCounters *ptr_struct, const u_int8_t *ptr_buff);
void DDPhysCounters_print(const struct DDPhysCounters *ptr_struct, FILE *file, int indent_level);
int DDPhysCounters_size(void);
#define DDPHYSCOUNTERS_SIZE    (0xc8)
void DDPhysCounters_dump(const struct DDPhysCounters *ptr_struct, FILE *file);
/* DDTroubleShootingInfo */
void DDTroubleShootingInfo_pack(const struct DDTroubleShootingInfo *ptr_struct, u_int8_t *ptr_buff);
void DDTroubleShootingInfo_unpack(struct DDTroubleShootingInfo *ptr_struct, const u_int8_t *ptr_buff);
void DDTroubleShootingInfo_print(const struct DDTroubleShootingInfo *ptr_struct, FILE *file, int indent_level);
int DDTroubleShootingInfo_size(void);
#define DDTROUBLESHOOTINGINFO_SIZE    (0xd8)
void DDTroubleShootingInfo_dump(const struct DDTroubleShootingInfo *ptr_struct, FILE *file);
/* DD_InfiniBandGeneralCounter */
void DD_InfiniBandGeneralCounter_pack(const struct DD_InfiniBandGeneralCounter *ptr_struct, u_int8_t *ptr_buff);
void DD_InfiniBandGeneralCounter_unpack(struct DD_InfiniBandGeneralCounter *ptr_struct, const u_int8_t *ptr_buff);
void DD_InfiniBandGeneralCounter_print(const struct DD_InfiniBandGeneralCounter *ptr_struct, FILE *file, int indent_level);
int DD_InfiniBandGeneralCounter_size(void);
#define DD_INFINIBANDGENERALCOUNTER_SIZE    (0xf8)
void DD_InfiniBandGeneralCounter_dump(const struct DD_InfiniBandGeneralCounter *ptr_struct, FILE *file);
/* DD_PLR_Counters */
void DD_PLR_Counters_pack(const struct DD_PLR_Counters *ptr_struct, u_int8_t *ptr_buff);
void DD_PLR_Counters_unpack(struct DD_PLR_Counters *ptr_struct, const u_int8_t *ptr_buff);
void DD_PLR_Counters_print(const struct DD_PLR_Counters *ptr_struct, FILE *file, int indent_level);
int DD_PLR_Counters_size(void);
#define DD_PLR_COUNTERS_SIZE    (0x50)
void DD_PLR_Counters_dump(const struct DD_PLR_Counters *ptr_struct, FILE *file);
/* DD_PhyStatisticalCounters */
void DD_PhyStatisticalCounters_pack(const struct DD_PhyStatisticalCounters *ptr_struct, u_int8_t *ptr_buff);
void DD_PhyStatisticalCounters_unpack(struct DD_PhyStatisticalCounters *ptr_struct, const u_int8_t *ptr_buff);
void DD_PhyStatisticalCounters_print(const struct DD_PhyStatisticalCounters *ptr_struct, FILE *file, int indent_level);
int DD_PhyStatisticalCounters_size(void);
#define DD_PHYSTATISTICALCOUNTERS_SIZE    (0x84)
void DD_PhyStatisticalCounters_dump(const struct DD_PhyStatisticalCounters *ptr_struct, FILE *file);
/* DD_RS_Histograms */
void DD_RS_Histograms_pack(const struct DD_RS_Histograms *ptr_struct, u_int8_t *ptr_buff);
void DD_RS_Histograms_unpack(struct DD_RS_Histograms *ptr_struct, const u_int8_t *ptr_buff);
void DD_RS_Histograms_print(const struct DD_RS_Histograms *ptr_struct, FILE *file, int indent_level);
int DD_RS_Histograms_size(void);
#define DD_RS_HISTOGRAMS_SIZE    (0x80)
void DD_RS_Histograms_dump(const struct DD_RS_Histograms *ptr_struct, FILE *file);
/* DD_pcie_lanes_counters */
void DD_pcie_lanes_counters_pack(const struct DD_pcie_lanes_counters *ptr_struct, u_int8_t *ptr_buff);
void DD_pcie_lanes_counters_unpack(struct DD_pcie_lanes_counters *ptr_struct, const u_int8_t *ptr_buff);
void DD_pcie_lanes_counters_print(const struct DD_pcie_lanes_counters *ptr_struct, FILE *file, int indent_level);
int DD_pcie_lanes_counters_size(void);
#define DD_PCIE_LANES_COUNTERS_SIZE    (0x60)
void DD_pcie_lanes_counters_dump(const struct DD_pcie_lanes_counters *ptr_struct, FILE *file);
/* DD_pcie_timers_states */
void DD_pcie_timers_states_pack(const struct DD_pcie_timers_states *ptr_struct, u_int8_t *ptr_buff);
void DD_pcie_timers_states_unpack(struct DD_pcie_timers_states *ptr_struct, const u_int8_t *ptr_buff);
void DD_pcie_timers_states_print(const struct DD_pcie_timers_states *ptr_struct, FILE *file, int indent_level);
int DD_pcie_timers_states_size(void);
#define DD_PCIE_TIMERS_STATES_SIZE    (0x60)
void DD_pcie_timers_states_dump(const struct DD_pcie_timers_states *ptr_struct, FILE *file);
/* SMP_CableInfo */
void SMP_CableInfo_pack(const struct SMP_CableInfo *ptr_struct, u_int8_t *ptr_buff);
void SMP_CableInfo_unpack(struct SMP_CableInfo *ptr_struct, const u_int8_t *ptr_buff);
void SMP_CableInfo_print(const struct SMP_CableInfo *ptr_struct, FILE *file, int indent_level);
int SMP_CableInfo_size(void);
#define SMP_CABLEINFO_SIZE    (0x40)
void SMP_CableInfo_dump(const struct SMP_CableInfo *ptr_struct, FILE *file);
/* SMP_EyeOpen */
void SMP_EyeOpen_pack(const struct SMP_EyeOpen *ptr_struct, u_int8_t *ptr_buff);
void SMP_EyeOpen_unpack(struct SMP_EyeOpen *ptr_struct, const u_int8_t *ptr_buff);
void SMP_EyeOpen_print(const struct SMP_EyeOpen *ptr_struct, FILE *file, int indent_level);
int SMP_EyeOpen_size(void);
#define SMP_EYEOPEN_SIZE    (0x40)
void SMP_EyeOpen_dump(const struct SMP_EyeOpen *ptr_struct, FILE *file);
/* SMP_LossyLinkConfig */
void SMP_LossyLinkConfig_pack(const struct SMP_LossyLinkConfig *ptr_struct, u_int8_t *ptr_buff);
void SMP_LossyLinkConfig_unpack(struct SMP_LossyLinkConfig *ptr_struct, const u_int8_t *ptr_buff);
void SMP_LossyLinkConfig_print(const struct SMP_LossyLinkConfig *ptr_struct, FILE *file, int indent_level);
int SMP_LossyLinkConfig_size(void);
#define SMP_LOSSYLINKCONFIG_SIZE    (0x4)
void SMP_LossyLinkConfig_dump(const struct SMP_LossyLinkConfig *ptr_struct, FILE *file);
/* SMP_MAD_AttrMod_CableInfo */
void SMP_MAD_AttrMod_CableInfo_pack(const struct SMP_MAD_AttrMod_CableInfo *ptr_struct, u_int8_t *ptr_buff);
void SMP_MAD_AttrMod_CableInfo_unpack(struct SMP_MAD_AttrMod_CableInfo *ptr_struct, const u_int8_t *ptr_buff);
void SMP_MAD_AttrMod_CableInfo_print(const struct SMP_MAD_AttrMod_CableInfo *ptr_struct, FILE *file, int indent_level);
int SMP_MAD_AttrMod_CableInfo_size(void);
#define SMP_MAD_ATTRMOD_CABLEINFO_SIZE    (0x4)
void SMP_MAD_AttrMod_CableInfo_dump(const struct SMP_MAD_AttrMod_CableInfo *ptr_struct, FILE *file);
/* SMP_MAD_AttrMod_EyeOpen */
void SMP_MAD_AttrMod_EyeOpen_pack(const struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, u_int8_t *ptr_buff);
void SMP_MAD_AttrMod_EyeOpen_unpack(struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, const u_int8_t *ptr_buff);
void SMP_MAD_AttrMod_EyeOpen_print(const struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, FILE *file, int indent_level);
int SMP_MAD_AttrMod_EyeOpen_size(void);
#define SMP_MAD_ATTRMOD_EYEOPEN_SIZE    (0x4)
void SMP_MAD_AttrMod_EyeOpen_dump(const struct SMP_MAD_AttrMod_EyeOpen *ptr_struct, FILE *file);
/* SMP_TemperatureSensing */
void SMP_TemperatureSensing_pack(const struct SMP_TemperatureSensing *ptr_struct, u_int8_t *ptr_buff);
void SMP_TemperatureSensing_unpack(struct SMP_TemperatureSensing *ptr_struct, const u_int8_t *ptr_buff);
void SMP_TemperatureSensing_print(const struct SMP_TemperatureSensing *ptr_struct, FILE *file, int indent_level);
int SMP_TemperatureSensing_size(void);
#define SMP_TEMPERATURESENSING_SIZE    (0x10)
void SMP_TemperatureSensing_dump(const struct SMP_TemperatureSensing *ptr_struct, FILE *file);
/* VendorSpec_PhyConfig */
void VendorSpec_PhyConfig_pack(const struct VendorSpec_PhyConfig *ptr_struct, u_int8_t *ptr_buff);
void VendorSpec_PhyConfig_unpack(struct VendorSpec_PhyConfig *ptr_struct, const u_int8_t *ptr_buff);
void VendorSpec_PhyConfig_print(const struct VendorSpec_PhyConfig *ptr_struct, FILE *file, int indent_level);
int VendorSpec_PhyConfig_size(void);
#define VENDORSPEC_PHYCONFIG_SIZE    (0x9c)
void VendorSpec_PhyConfig_dump(const struct VendorSpec_PhyConfig *ptr_struct, FILE *file);
/* fore_reg */
void fore_reg_pack(const struct fore_reg *ptr_struct, u_int8_t *ptr_buff);
void fore_reg_unpack(struct fore_reg *ptr_struct, const u_int8_t *ptr_buff);
void fore_reg_print(const struct fore_reg *ptr_struct, FILE *file, int indent_level);
int fore_reg_size(void);
#define FORE_REG_SIZE    (0xc)
void fore_reg_dump(const struct fore_reg *ptr_struct, FILE *file);
/* mfcr_reg */
void mfcr_reg_pack(const struct mfcr_reg *ptr_struct, u_int8_t *ptr_buff);
void mfcr_reg_unpack(struct mfcr_reg *ptr_struct, const u_int8_t *ptr_buff);
void mfcr_reg_print(const struct mfcr_reg *ptr_struct, FILE *file, int indent_level);
int mfcr_reg_size(void);
#define MFCR_REG_SIZE    (0x8)
void mfcr_reg_dump(const struct mfcr_reg *ptr_struct, FILE *file);
/* mfnr_reg */
void mfnr_reg_pack(const struct mfnr_reg *ptr_struct, u_int8_t *ptr_buff);
void mfnr_reg_unpack(struct mfnr_reg *ptr_struct, const u_int8_t *ptr_buff);
void mfnr_reg_print(const struct mfnr_reg *ptr_struct, FILE *file, int indent_level);
int mfnr_reg_size(void);
#define MFNR_REG_SIZE    (0x2c)
void mfnr_reg_dump(const struct mfnr_reg *ptr_struct, FILE *file);
/* mfsl_reg */
void mfsl_reg_pack(const struct mfsl_reg *ptr_struct, u_int8_t *ptr_buff);
void mfsl_reg_unpack(struct mfsl_reg *ptr_struct, const u_int8_t *ptr_buff);
void mfsl_reg_print(const struct mfsl_reg *ptr_struct, FILE *file, int indent_level);
int mfsl_reg_size(void);
#define MFSL_REG_SIZE    (0xc)
void mfsl_reg_dump(const struct mfsl_reg *ptr_struct, FILE *file);
/* mfsm_reg */
void mfsm_reg_pack(const struct mfsm_reg *ptr_struct, u_int8_t *ptr_buff);
void mfsm_reg_unpack(struct mfsm_reg *ptr_struct, const u_int8_t *ptr_buff);
void mfsm_reg_print(const struct mfsm_reg *ptr_struct, FILE *file, int indent_level);
int mfsm_reg_size(void);
#define MFSM_REG_SIZE    (0x8)
void mfsm_reg_dump(const struct mfsm_reg *ptr_struct, FILE *file);
/* mpcnt_reg */
void mpcnt_reg_pack(const struct mpcnt_reg *ptr_struct, u_int8_t *ptr_buff);
void mpcnt_reg_unpack(struct mpcnt_reg *ptr_struct, const u_int8_t *ptr_buff);
void mpcnt_reg_print(const struct mpcnt_reg *ptr_struct, FILE *file, int indent_level);
int mpcnt_reg_size(void);
#define MPCNT_REG_SIZE    (0x68)
void mpcnt_reg_dump(const struct mpcnt_reg *ptr_struct, FILE *file);
/* mpein_reg */
void mpein_reg_pack(const struct mpein_reg *ptr_struct, u_int8_t *ptr_buff);
void mpein_reg_unpack(struct mpein_reg *ptr_struct, const u_int8_t *ptr_buff);
void mpein_reg_print(const struct mpein_reg *ptr_struct, FILE *file, int indent_level);
int mpein_reg_size(void);
#define MPEIN_REG_SIZE    (0x2c)
void mpein_reg_dump(const struct mpein_reg *ptr_struct, FILE *file);
/* mpir_reg */
void mpir_reg_pack(const struct mpir_reg *ptr_struct, u_int8_t *ptr_buff);
void mpir_reg_unpack(struct mpir_reg *ptr_struct, const u_int8_t *ptr_buff);
void mpir_reg_print(const struct mpir_reg *ptr_struct, FILE *file, int indent_level);
int mpir_reg_size(void);
#define MPIR_REG_SIZE    (0x10)
void mpir_reg_dump(const struct mpir_reg *ptr_struct, FILE *file);
/* mrcs_reg */
void mrcs_reg_pack(const struct mrcs_reg *ptr_struct, u_int8_t *ptr_buff);
void mrcs_reg_unpack(struct mrcs_reg *ptr_struct, const u_int8_t *ptr_buff);
void mrcs_reg_print(const struct mrcs_reg *ptr_struct, FILE *file, int indent_level);
int mrcs_reg_size(void);
#define MRCS_REG_SIZE    (0x18)
void mrcs_reg_dump(const struct mrcs_reg *ptr_struct, FILE *file);
/* msgi_reg */
void msgi_reg_pack(const struct msgi_reg *ptr_struct, u_int8_t *ptr_buff);
void msgi_reg_unpack(struct msgi_reg *ptr_struct, const u_int8_t *ptr_buff);
void msgi_reg_print(const struct msgi_reg *ptr_struct, FILE *file, int indent_level);
int msgi_reg_size(void);
#define MSGI_REG_SIZE    (0x80)
void msgi_reg_dump(const struct msgi_reg *ptr_struct, FILE *file);
/* msps_reg */
void msps_reg_pack(const struct msps_reg *ptr_struct, u_int8_t *ptr_buff);
void msps_reg_unpack(struct msps_reg *ptr_struct, const u_int8_t *ptr_buff);
void msps_reg_print(const struct msps_reg *ptr_struct, FILE *file, int indent_level);
int msps_reg_size(void);
#define MSPS_REG_SIZE    (0xa0)
void msps_reg_dump(const struct msps_reg *ptr_struct, FILE *file);
/* mtcap_reg */
void mtcap_reg_pack(const struct mtcap_reg *ptr_struct, u_int8_t *ptr_buff);
void mtcap_reg_unpack(struct mtcap_reg *ptr_struct, const u_int8_t *ptr_buff);
void mtcap_reg_print(const struct mtcap_reg *ptr_struct, FILE *file, int indent_level);
int mtcap_reg_size(void);
#define MTCAP_REG_SIZE    (0x8)
void mtcap_reg_dump(const struct mtcap_reg *ptr_struct, FILE *file);
/* mtmp_reg */
void mtmp_reg_pack(const struct mtmp_reg *ptr_struct, u_int8_t *ptr_buff);
void mtmp_reg_unpack(struct mtmp_reg *ptr_struct, const u_int8_t *ptr_buff);
void mtmp_reg_print(const struct mtmp_reg *ptr_struct, FILE *file, int indent_level);
int mtmp_reg_size(void);
#define MTMP_REG_SIZE    (0x20)
void mtmp_reg_dump(const struct mtmp_reg *ptr_struct, FILE *file);
/* mtwe_reg */
void mtwe_reg_pack(const struct mtwe_reg *ptr_struct, u_int8_t *ptr_buff);
void mtwe_reg_unpack(struct mtwe_reg *ptr_struct, const u_int8_t *ptr_buff);
void mtwe_reg_print(const struct mtwe_reg *ptr_struct, FILE *file, int indent_level);
int mtwe_reg_size(void);
#define MTWE_REG_SIZE    (0x10)
void mtwe_reg_dump(const struct mtwe_reg *ptr_struct, FILE *file);
/* mvcap_reg */
void mvcap_reg_pack(const struct mvcap_reg *ptr_struct, u_int8_t *ptr_buff);
void mvcap_reg_unpack(struct mvcap_reg *ptr_struct, const u_int8_t *ptr_buff);
void mvcap_reg_print(const struct mvcap_reg *ptr_struct, FILE *file, int indent_level);
int mvcap_reg_size(void);
#define MVCAP_REG_SIZE    (0x10)
void mvcap_reg_dump(const struct mvcap_reg *ptr_struct, FILE *file);
/* mvcr_reg */
void mvcr_reg_pack(const struct mvcr_reg *ptr_struct, u_int8_t *ptr_buff);
void mvcr_reg_unpack(struct mvcr_reg *ptr_struct, const u_int8_t *ptr_buff);
void mvcr_reg_print(const struct mvcr_reg *ptr_struct, FILE *file, int indent_level);
int mvcr_reg_size(void);
#define MVCR_REG_SIZE    (0x18)
void mvcr_reg_dump(const struct mvcr_reg *ptr_struct, FILE *file);
/* pcam_reg */
void pcam_reg_pack(const struct pcam_reg *ptr_struct, u_int8_t *ptr_buff);
void pcam_reg_unpack(struct pcam_reg *ptr_struct, const u_int8_t *ptr_buff);
void pcam_reg_print(const struct pcam_reg *ptr_struct, FILE *file, int indent_level);
int pcam_reg_size(void);
#define PCAM_REG_SIZE    (0x50)
void pcam_reg_dump(const struct pcam_reg *ptr_struct, FILE *file);
/* pddr_reg */
void pddr_reg_pack(const struct pddr_reg *ptr_struct, u_int8_t *ptr_buff);
void pddr_reg_unpack(struct pddr_reg *ptr_struct, const u_int8_t *ptr_buff);
void pddr_reg_print(const struct pddr_reg *ptr_struct, FILE *file, int indent_level);
int pddr_reg_size(void);
#define PDDR_REG_SIZE    (0x100)
void pddr_reg_dump(const struct pddr_reg *ptr_struct, FILE *file);
/* pemi_reg */
void pemi_reg_pack(const struct pemi_reg *ptr_struct, u_int8_t *ptr_buff);
void pemi_reg_unpack(struct pemi_reg *ptr_struct, const u_int8_t *ptr_buff);
void pemi_reg_print(const struct pemi_reg *ptr_struct, FILE *file, int indent_level);
int pemi_reg_size(void);
#define PEMI_REG_SIZE    (0x100)
void pemi_reg_dump(const struct pemi_reg *ptr_struct, FILE *file);
/* peucg_reg */
void peucg_reg_pack(const struct peucg_reg *ptr_struct, u_int8_t *ptr_buff);
void peucg_reg_unpack(struct peucg_reg *ptr_struct, const u_int8_t *ptr_buff);
void peucg_reg_print(const struct peucg_reg *ptr_struct, FILE *file, int indent_level);
int peucg_reg_size(void);
#define PEUCG_REG_SIZE    (0xc8)
void peucg_reg_dump(const struct peucg_reg *ptr_struct, FILE *file);
/* pmcr_reg */
void pmcr_reg_pack(const struct pmcr_reg *ptr_struct, u_int8_t *ptr_buff);
void pmcr_reg_unpack(struct pmcr_reg *ptr_struct, const u_int8_t *ptr_buff);
void pmcr_reg_print(const struct pmcr_reg *ptr_struct, FILE *file, int indent_level);
int pmcr_reg_size(void);
#define PMCR_REG_SIZE    (0x1c)
void pmcr_reg_dump(const struct pmcr_reg *ptr_struct, FILE *file);
/* pmdr_reg */
void pmdr_reg_pack(const struct pmdr_reg *ptr_struct, u_int8_t *ptr_buff);
void pmdr_reg_unpack(struct pmdr_reg *ptr_struct, const u_int8_t *ptr_buff);
void pmdr_reg_print(const struct pmdr_reg *ptr_struct, FILE *file, int indent_level);
int pmdr_reg_size(void);
#define PMDR_REG_SIZE    (0x2c)
void pmdr_reg_dump(const struct pmdr_reg *ptr_struct, FILE *file);
/* ppamp_reg */
void ppamp_reg_pack(const struct ppamp_reg *ptr_struct, u_int8_t *ptr_buff);
void ppamp_reg_unpack(struct ppamp_reg *ptr_struct, const u_int8_t *ptr_buff);
void ppamp_reg_print(const struct ppamp_reg *ptr_struct, FILE *file, int indent_level);
int ppamp_reg_size(void);
#define PPAMP_REG_SIZE    (0x2c)
void ppamp_reg_dump(const struct ppamp_reg *ptr_struct, FILE *file);
/* ppbmp_reg */
void ppbmp_reg_pack(const struct ppbmp_reg *ptr_struct, u_int8_t *ptr_buff);
void ppbmp_reg_unpack(struct ppbmp_reg *ptr_struct, const u_int8_t *ptr_buff);
void ppbmp_reg_print(const struct ppbmp_reg *ptr_struct, FILE *file, int indent_level);
int ppbmp_reg_size(void);
#define PPBMP_REG_SIZE    (0x30)
void ppbmp_reg_dump(const struct ppbmp_reg *ptr_struct, FILE *file);
/* ppcnt_reg */
void ppcnt_reg_pack(const struct ppcnt_reg *ptr_struct, u_int8_t *ptr_buff);
void ppcnt_reg_unpack(struct ppcnt_reg *ptr_struct, const u_int8_t *ptr_buff);
void ppcnt_reg_print(const struct ppcnt_reg *ptr_struct, FILE *file, int indent_level);
int ppcnt_reg_size(void);
#define PPCNT_REG_SIZE    (0xdc)
void ppcnt_reg_dump(const struct ppcnt_reg *ptr_struct, FILE *file);
/* pphcr_reg */
void pphcr_reg_pack(const struct pphcr_reg *ptr_struct, u_int8_t *ptr_buff);
void pphcr_reg_unpack(struct pphcr_reg *ptr_struct, const u_int8_t *ptr_buff);
void pphcr_reg_print(const struct pphcr_reg *ptr_struct, FILE *file, int indent_level);
int pphcr_reg_size(void);
#define PPHCR_REG_SIZE    (0x50)
void pphcr_reg_dump(const struct pphcr_reg *ptr_struct, FILE *file);
/* ppll_reg */
void ppll_reg_pack(const struct ppll_reg *ptr_struct, u_int8_t *ptr_buff);
void ppll_reg_unpack(struct ppll_reg *ptr_struct, const u_int8_t *ptr_buff);
void ppll_reg_print(const struct ppll_reg *ptr_struct, FILE *file, int indent_level);
int ppll_reg_size(void);
#define PPLL_REG_SIZE    (0x28)
void ppll_reg_dump(const struct ppll_reg *ptr_struct, FILE *file);
/* prtl_reg */
void prtl_reg_pack(const struct prtl_reg *ptr_struct, u_int8_t *ptr_buff);
void prtl_reg_unpack(struct prtl_reg *ptr_struct, const u_int8_t *ptr_buff);
void prtl_reg_print(const struct prtl_reg *ptr_struct, FILE *file, int indent_level);
int prtl_reg_size(void);
#define PRTL_REG_SIZE    (0x1c)
void prtl_reg_dump(const struct prtl_reg *ptr_struct, FILE *file);
/* ptas_reg */
void ptas_reg_pack(const struct ptas_reg *ptr_struct, u_int8_t *ptr_buff);
void ptas_reg_unpack(struct ptas_reg *ptr_struct, const u_int8_t *ptr_buff);
void ptas_reg_print(const struct ptas_reg *ptr_struct, FILE *file, int indent_level);
int ptas_reg_size(void);
#define PTAS_REG_SIZE    (0x2c)
void ptas_reg_dump(const struct ptas_reg *ptr_struct, FILE *file);
/* ptys_reg */
void ptys_reg_pack(const struct ptys_reg *ptr_struct, u_int8_t *ptr_buff);
void ptys_reg_unpack(struct ptys_reg *ptr_struct, const u_int8_t *ptr_buff);
void ptys_reg_print(const struct ptys_reg *ptr_struct, FILE *file, int indent_level);
int ptys_reg_size(void);
#define PTYS_REG_SIZE    (0x40)
void ptys_reg_dump(const struct ptys_reg *ptr_struct, FILE *file);
/* pucg_reg */
void pucg_reg_pack(const struct pucg_reg *ptr_struct, u_int8_t *ptr_buff);
void pucg_reg_unpack(struct pucg_reg *ptr_struct, const u_int8_t *ptr_buff);
void pucg_reg_print(const struct pucg_reg *ptr_struct, FILE *file, int indent_level);
int pucg_reg_size(void);
#define PUCG_REG_SIZE    (0x10c)
void pucg_reg_dump(const struct pucg_reg *ptr_struct, FILE *file);
/* slcct_reg */
void slcct_reg_pack(const struct slcct_reg *ptr_struct, u_int8_t *ptr_buff);
void slcct_reg_unpack(struct slcct_reg *ptr_struct, const u_int8_t *ptr_buff);
void slcct_reg_print(const struct slcct_reg *ptr_struct, FILE *file, int indent_level);
int slcct_reg_size(void);
#define SLCCT_REG_SIZE    (0x2c)
void slcct_reg_dump(const struct slcct_reg *ptr_struct, FILE *file);
/* slcdr_reg */
void slcdr_reg_pack(const struct slcdr_reg *ptr_struct, u_int8_t *ptr_buff);
void slcdr_reg_unpack(struct slcdr_reg *ptr_struct, const u_int8_t *ptr_buff);
void slcdr_reg_print(const struct slcdr_reg *ptr_struct, FILE *file, int indent_level);
int slcdr_reg_size(void);
#define SLCDR_REG_SIZE    (0x24)
void slcdr_reg_dump(const struct slcdr_reg *ptr_struct, FILE *file);
/* sllm_reg */
void sllm_reg_pack(const struct sllm_reg *ptr_struct, u_int8_t *ptr_buff);
void sllm_reg_unpack(struct sllm_reg *ptr_struct, const u_int8_t *ptr_buff);
void sllm_reg_print(const struct sllm_reg *ptr_struct, FILE *file, int indent_level);
int sllm_reg_size(void);
#define SLLM_REG_SIZE    (0x30)
void sllm_reg_dump(const struct sllm_reg *ptr_struct, FILE *file);
/* slpmu_reg */
void slpmu_reg_pack(const struct slpmu_reg *ptr_struct, u_int8_t *ptr_buff);
void slpmu_reg_unpack(struct slpmu_reg *ptr_struct, const u_int8_t *ptr_buff);
void slpmu_reg_print(const struct slpmu_reg *ptr_struct, FILE *file, int indent_level);
int slpmu_reg_size(void);
#define SLPMU_REG_SIZE    (0x28)
void slpmu_reg_dump(const struct slpmu_reg *ptr_struct, FILE *file);
/* slreg_reg */
void slreg_reg_pack(const struct slreg_reg *ptr_struct, u_int8_t *ptr_buff);
void slreg_reg_unpack(struct slreg_reg *ptr_struct, const u_int8_t *ptr_buff);
void slreg_reg_print(const struct slreg_reg *ptr_struct, FILE *file, int indent_level);
int slreg_reg_size(void);
#define SLREG_REG_SIZE    (0x4c)
void slreg_reg_dump(const struct slreg_reg *ptr_struct, FILE *file);
/* slrg_reg */
void slrg_reg_pack(const struct slrg_reg *ptr_struct, u_int8_t *ptr_buff);
void slrg_reg_unpack(struct slrg_reg *ptr_struct, const u_int8_t *ptr_buff);
void slrg_reg_print(const struct slrg_reg *ptr_struct, FILE *file, int indent_level);
int slrg_reg_size(void);
#define SLRG_REG_SIZE    (0xa8)
void slrg_reg_dump(const struct slrg_reg *ptr_struct, FILE *file);
/* slrip_reg */
void slrip_reg_pack(const struct slrip_reg *ptr_struct, u_int8_t *ptr_buff);
void slrip_reg_unpack(struct slrip_reg *ptr_struct, const u_int8_t *ptr_buff);
void slrip_reg_print(const struct slrip_reg *ptr_struct, FILE *file, int indent_level);
int slrip_reg_size(void);
#define SLRIP_REG_SIZE    (0x5c)
void slrip_reg_dump(const struct slrip_reg *ptr_struct, FILE *file);
/* slrp_reg */
void slrp_reg_pack(const struct slrp_reg *ptr_struct, u_int8_t *ptr_buff);
void slrp_reg_unpack(struct slrp_reg *ptr_struct, const u_int8_t *ptr_buff);
void slrp_reg_print(const struct slrp_reg *ptr_struct, FILE *file, int indent_level);
int slrp_reg_size(void);
#define SLRP_REG_SIZE    (0x98)
void slrp_reg_dump(const struct slrp_reg *ptr_struct, FILE *file);
/* slsir_reg */
void slsir_reg_pack(const struct slsir_reg *ptr_struct, u_int8_t *ptr_buff);
void slsir_reg_unpack(struct slsir_reg *ptr_struct, const u_int8_t *ptr_buff);
void slsir_reg_print(const struct slsir_reg *ptr_struct, FILE *file, int indent_level);
int slsir_reg_size(void);
#define SLSIR_REG_SIZE    (0x1c)
void slsir_reg_dump(const struct slsir_reg *ptr_struct, FILE *file);
/* sltp_reg */
void sltp_reg_pack(const struct sltp_reg *ptr_struct, u_int8_t *ptr_buff);
void sltp_reg_unpack(struct sltp_reg *ptr_struct, const u_int8_t *ptr_buff);
void sltp_reg_print(const struct sltp_reg *ptr_struct, FILE *file, int indent_level);
int sltp_reg_size(void);
#define SLTP_REG_SIZE    (0x4c)
void sltp_reg_dump(const struct sltp_reg *ptr_struct, FILE *file);
/* PACKETS_INTERNAL */
void PACKETS_INTERNAL_pack(const union PACKETS_INTERNAL *ptr_struct, u_int8_t *ptr_buff);
void PACKETS_INTERNAL_unpack(union PACKETS_INTERNAL *ptr_struct, const u_int8_t *ptr_buff);
void PACKETS_INTERNAL_print(const union PACKETS_INTERNAL *ptr_struct, FILE *file, int indent_level);
int PACKETS_INTERNAL_size(void);
#define PACKETS_INTERNAL_SIZE    (0x1000000)
void PACKETS_INTERNAL_dump(const union PACKETS_INTERNAL *ptr_struct, FILE *file);


#ifdef __cplusplus
}
#endif

#endif // INTERNAL_PACKETS_LAYOUTS_H
